Package: alabaster.base
Title: Save Bioconductor Objects to File
Version: 1.12.1
Date: 2026-06-30
Authors@R: person("Aaron", "Lun", role=c("aut", "cre"), email="infinite.monkeys.with.keyboards@gmail.com")
License: MIT + file LICENSE
Description: 
    Save Bioconductor data structures into file artifacts, and load them back into memory.
    This is a more robust and portable alternative to serialization of such objects into RDS files.
    Each artifact is associated with metadata for further interpretation;
    downstream applications can enrich this metadata with context-specific properties.
Imports: alabaster.schemas, methods, utils, S4Vectors, rhdf5 (>=
        2.47.6), jsonlite, jsonvalidate, Rcpp
Suggests: BiocStyle, rmarkdown, knitr, testthat, digest, Matrix,
        alabaster.matrix
LinkingTo: Rcpp, assorthead (>= 1.1.2), Rhdf5lib
VignetteBuilder: knitr
SystemRequirements: C++17, GNU make
RoxygenNote: 7.3.3
Encoding: UTF-8
biocViews: DataRepresentation, DataImport
URL: https://github.com/ArtifactDB/alabaster.base
BugReports: https://github.com/ArtifactDB/alabaster.base/issues
git_url: https://git.bioconductor.org/packages/alabaster.base
git_branch: RELEASE_3_23
git_last_commit: 4898f21
git_last_commit_date: 2026-06-29
Repository: Bioconductor 3.23
Date/Publication: 2026-07-02
NeedsCompilation: yes
Packaged: 2026-07-02 20:19:13 UTC; biocbuild
Author: Aaron Lun [aut, cre]
Maintainer: Aaron Lun <infinite.monkeys.with.keyboards@gmail.com>

#' Read a base list from disk
#'
#' Read a \link{list} from its on-disk representation.
#' This is usually not directly called by users, but is instead called by dispatch in \code{\link{readObject}}.
#'
#' @param path String containing a path to a directory, itself created with the list method for \code{\link{stageObject}}. 
#' @param metadata Named list containing metadata for the object, see \code{\link{readObjectFile}} for details.
#' @param simple_list.parallel Whether to perform reading and parsing in parallel for greater speed.
#' Only relevant for lists stored in the JSON format.
#' @param ... Further arguments to be passed to \code{\link{altReadObject}} for complex child objects.
#' 
#' @return 
#' The list represented by \code{path}.
#'
#' @author Aaron Lun
#'
#' @details
#' The \pkg{uzuki2} specification (see \url{https://github.com/ArtifactDB/uzuki2}) allows length-1 vectors to be stored as-is or as a scalar.
#' If the file stores a length-1 vector as-is, \code{readBaseList} will read the list element as a length-1 vector with the \link{AsIs} class.
#' If the file stores a length-1 vector as a scalar, \code{readBaseList} will read the list element as a length-1 vector without this class.
#' This allows downstream users to distinguish between the storage modes in the rare cases that it is necessary.
#'
#' @seealso
#' \code{"\link{stageObject,list-method}"}, for the staging method.
#'
#' @examples
#' library(S4Vectors)
#' ll <- list(A=1, B=LETTERS, C=DataFrame(X=letters))
#'
#' tmp <- tempfile()
#' saveObject(ll, tmp)
#' readObject(tmp)
#'
#' @export
#' @aliases loadBaseList
readBaseList <- function(path, metadata, simple_list.parallel=TRUE, ...) {
    all.children <- list()
    child.path <- file.path(path, "other_contents")
    if (file.exists(child.path)) {
        all.dirs <- list.files(child.path)
        all.children <- vector("list", length(all.children))
        for (n in all.dirs) {
            all.children[[as.integer(n) + 1L]] <- altReadObject(file.path(child.path, n), simple_list.parallel=simple_list.parallel, ...)
        }
    }

    path <- path.expand(path) # protect C code from ~/.
    format <- metadata$simple_list$format
    if (is.null(format) || format == "hdf5") {
        lpath <- file.path(path, "list_contents.h5")
        output <- load_list_hdf5(lpath, "simple_list", all.children)
    } else {
        lpath <- file.path(path, "list_contents.json.gz")
        output <- load_list_json(lpath, all.children, simple_list.parallel)
    }

    output
}

#######################################
########### OLD STUFF HERE ############
#######################################

#' @export
loadBaseList <- function(info, project, parallel=TRUE) {
    children <- info$simple_list$children
    for (i in seq_along(children)) {
        child.meta <- acquireMetadata(project, children[[i]]$resource$path) 
        children[[i]] <- altLoadObject(child.meta, project=project)
    }

    lpath <- acquireFile(project, info$path)

    output <- NULL
    if ("hdf5_simple_list" %in% names(info)) {
        output <- load_list_hdf5(lpath, info$hdf5_simple_list$group, children)
    } else {
        comp <- info$json_simple_list$compression
        if (!is.null(comp) && !(comp %in% c("none", "gzip"))) {
            stop("only uncompressed or Gzip-compressed JSON lists are supported")
        }
        output <- load_list_json(lpath, children, parallel)
    }

    # Need to replace any Rfc3339's with POSIXct objects for back-compatibility.
    # This is done manually because the C++ code already uses Rfc3339 and I don't
    # want to have to compile a separate version just to handle the old case.
    to_posix <- function(x) {
        if (is.list(x) && class(x)[1] == "list") {
            lapply(x, to_posix)
        } else if (is.Rfc3339(x)) {
            as.POSIXct(x)
        } else {
            x
        }
    }

    to_posix(output)
}

# This tests the staging and loading of base lists.
# library(testthat); library(alabaster.base); source("test-list.R")

library(S4Vectors)

vals <- list(
    A = 1:5,
    B = (1:5) * 0.5, # numeric...
    C = LETTERS[1:5],
    D1 = factor(LETTERS[1:5], LETTERS),
    D2 = factor(LETTERS[1:5], rev(LETTERS), ordered=TRUE),
    E = c(Sys.Date(), Sys.Date() - 1, Sys.Date() + 1)
)

test_that("lists handle complex types correctly", {
    tmp <- tempfile()
    dir.create(tmp)

    info <- stageObject(vals, tmp, path="stuff")
    expect_identical(length(info$simple_list$children), 0L) 
    expect_identical(info$json_simple_list$compression, "gzip")

    resource <- writeMetadata(info, tmp)
    expect_true(file.exists(file.path(tmp, resource$path)))

    roundtrip <- loadBaseList(info, tmp)
    expect_identical(roundtrip, vals)

    # Preserve non-alphabetical ordering.
    rvals <- rev(vals)
    info <- stageObject(rvals, tmp, path="stuff2")
    roundtrip <- loadBaseList(info, tmp)
    expect_identical(roundtrip, rvals)

    # Works in the new world.
    tmp2 <- tempfile()
    saveObject(vals, tmp2)
    expect_identical(readObject(tmp2), vals)

    tmp2 <- tempfile()
    saveObject(rvals, tmp2)
    expect_identical(readObject(tmp2), rvals)
})

test_that("list format switch works as expected", {
    expect_identical(saveBaseListFormat(), "json.gz")
    expect_identical(saveBaseListFormat("hdf5"), "json.gz")
    expect_identical(saveBaseListFormat(), "hdf5")
    expect_identical(saveBaseListFormat(NULL), "hdf5")
    expect_identical(saveBaseListFormat(), "json.gz")
})

test_that("lists work in HDF5 mode", {
    old <- saveBaseListFormat("hdf5")
    on.exit(saveBaseListFormat(old))

    tmp <- tempfile()
    dir.create(tmp)

    info <- stageObject(vals, tmp, path="stuff")
    expect_identical(length(info$simple_list$children), 0L) 

    attrs <- rhdf5::h5readAttributes(file.path(tmp, "stuff/list.h5"), "contents/data/2/data")
    expect_null(attrs[["missing-value-placeholder"]]) # no missing values... yet.

    attrs <- rhdf5::h5readAttributes(file.path(tmp, "stuff/list.h5"), "contents/data/3")
    expect_identical(attrs$uzuki_type, "factor")

    resource <- writeMetadata(info, tmp)
    expect_true(file.exists(file.path(tmp, resource$path)))

    roundtrip <- loadBaseList(info, tmp)
    expect_identical(roundtrip, vals)

    # Preserve non-alphabetical ordering.
    rvals <- rev(vals)
    info <- stageObject(rvals, tmp, path="stuff2")
    roundtrip <- loadBaseList(info, tmp)
    expect_identical(roundtrip, rvals)

    # Works in the new world.
    tmp2 <- tempfile()
    saveObject(vals, tmp2)
    expect_identical(readObject(tmp2), vals)

    tmp2 <- tempfile()
    saveObject(rvals, tmp2)
    expect_identical(readObject(tmp2), rvals)
})

test_that("S4 Lists can also be staged", {
    tmp <- tempfile()
    dir.create(tmp)

    library(S4Vectors)
    vals <- List(
        A = 1:5,
        B = (1:5) * 0.5,
        C = LETTERS[1:5]
    )

    info <- stageObject(vals, tmp, path="stuff")
    roundtrip <- loadBaseList(info, tmp)
    expect_identical(roundtrip, as.list(vals))

    # Works in the new world.
    tmp2 <- tempfile()
    saveObject(vals, tmp2)
    expect_identical(readObject(tmp2), as.list(vals))
})

test_that("names are properly supported", {
    tmp <- tempfile()
    dir.create(tmp)

    vals <- list(
        X = setNames((1:5) * 0.5, LETTERS[1:5]),
        Y = setNames(factor(letters[6:15]), 1:10)
    )

    info <- stageObject(vals, tmp, path="stuff")
    expect_match(info[["$schema"]], "json_simple_list")
    resource <- writeMetadata(info, tmp)
    expect_true(file.exists(file.path(tmp, resource$path)))

    roundtrip <- loadBaseList(info, tmp)
    expect_identical(roundtrip, vals)

    tmp2 <- tempfile()
    saveObject(vals, tmp2)
    expect_identical(readObject(tmp2), vals)

    # Works in HDF5 mode.
    old <- saveBaseListFormat("hdf5")
    on.exit(saveBaseListFormat(old))

    info <- stageObject(vals, tmp, path="hstuff")
    resource <- writeMetadata(info, tmp)
    expect_match(info[["$schema"]], "hdf5_simple_list")

    roundtrip <- loadBaseList(info, tmp)
    expect_identical(roundtrip, vals)

    tmp2 <- tempfile()
    saveObject(vals, tmp2)
    expect_identical(readObject(tmp2), vals)
})

test_that("data.frames cause dispatch to external objects", {
    tmp <- tempfile()
    dir.create(tmp)

    vals <- list(
        X = data.frame(X1 = runif(2), X2 = rnorm(2), X3 = LETTERS[1:2]),
        Y = list(data.frame(Y1 = runif(5), Y2 = letters[1:5], row.names=as.character(5:1))),
        Z = data.frame(Z1 = runif(5), row.names=c("alpha", "bravo", "charlie", "delta", "echo"))
    )

    info <- stageObject(vals, tmp, path="stuff")
    expect_match(info[["$schema"]], "json_simple_list")
    resource <- writeMetadata(info, tmp)
    expect_true(file.exists(file.path(tmp, resource$path)))

    roundtrip <- loadBaseList(info, tmp)
    roundtrip$X <- as.data.frame(roundtrip$X)
    roundtrip$Y[[1]] <- as.data.frame(roundtrip$Y[[1]])
    roundtrip$Z <- as.data.frame(roundtrip$Z)

    expect_equal(roundtrip, vals)

    tmp2 <- tempfile()
    saveObject(vals, tmp2)
    roundtrip <- readObject(tmp2)
    roundtrip$X <- as.data.frame(roundtrip$X)
    roundtrip$Y[[1]] <- as.data.frame(roundtrip$Y[[1]])
    roundtrip$Z <- as.data.frame(roundtrip$Z)
    expect_identical(roundtrip, vals)

    # Works in HDF5 mode.
    old <- saveBaseListFormat("hdf5")
    on.exit(saveBaseListFormat(old))

    info <- stageObject(vals, tmp, path="hstuff")
    resource <- writeMetadata(info, tmp)
    expect_match(info[["$schema"]], "hdf5_simple_list")

    roundtrip <- loadBaseList(info, tmp)
    roundtrip$X <- as.data.frame(roundtrip$X)
    roundtrip$Y[[1]] <- as.data.frame(roundtrip$Y[[1]])
    roundtrip$Z <- as.data.frame(roundtrip$Z)

    expect_equal(roundtrip, vals) # still equality, not identity, because DF's are saved as CSVs right now.

    tmp2 <- tempfile()
    saveObject(vals, tmp2)
    roundtrip <- readObject(tmp2)
    roundtrip$X <- as.data.frame(roundtrip$X)
    roundtrip$Y[[1]] <- as.data.frame(roundtrip$Y[[1]])
    roundtrip$Z <- as.data.frame(roundtrip$Z)
    expect_identical(roundtrip, vals)
})

test_that("unnamed lists are properly supported", {
    tmp <- tempfile()
    dir.create(tmp)

    vals <- list("A", 1.5, 2.3, list("C", list(DataFrame(X=1:10)), 3.5), (2:6)*1.5)

    info <- stageObject(vals, tmp, path="stuff")
    expect_match(info[["$schema"]], "json_simple_list")
    expect_identical(length(info$simple_list$children), 1L) 

    resource <- writeMetadata(info, tmp)
    expect_true(file.exists(file.path(tmp, resource$path)))

    roundtrip <- loadBaseList(info, tmp)
    expect_identical(roundtrip, vals)

    tmp2 <- tempfile()
    saveObject(vals, tmp2)
    expect_identical(readObject(tmp2), vals)

    # Works in HDF5 mode.
    old <- saveBaseListFormat("hdf5")
    on.exit(saveBaseListFormat(old))

    info <- stageObject(vals, tmp, path="hstuff")
    resource <- writeMetadata(info, tmp)
    expect_match(info[["$schema"]], "hdf5_simple_list")

    roundtrip <- loadBaseList(info, tmp)
    expect_identical(roundtrip, vals)

    tmp2 <- tempfile()
    saveObject(vals, tmp2)
    expect_identical(readObject(tmp2), vals)
})

test_that("partially named or duplicate named lists fail", {
    tmp <- tempfile()
    dir.create(tmp)

    expect_error(stageObject(list(1, A=2), dir=tmp, path="whee"), "non-empty")
    expect_error(stageObject(list(A=1, A=2), dir=tmp, path="whee2"), "multiple instances of 'A'")
})

test_that("external references work correctly", {
    tmp <- tempfile()
    dir.create(tmp)

    vals <- list(
        A = 1:5,
        B = list(
            C = DataFrame(X = 1:10),
            D = DataFrame(Y = 2:5)
        ),
        E = DataFrame(Z = runif(5))
    )

    info <- stageObject(vals, tmp, path="stuff")
    expect_identical(length(info$simple_list$children), 3L) 
    expect_match(info[["$schema"]], "json_simple_list")

    roundtrip <- loadBaseList(info, tmp)
    expect_equal(roundtrip, vals)

    tmp2 <- tempfile()
    saveObject(vals, tmp2)
    expect_identical(readObject(tmp2), vals)

    # Works in HDF5 mode.
    old <- saveBaseListFormat("hdf5")
    on.exit(saveBaseListFormat(old))

    info <- stageObject(vals, tmp, path="hstuff")
    resource <- writeMetadata(info, tmp)
    expect_match(info[["$schema"]], "hdf5_simple_list")

    roundtrip <- loadBaseList(info, tmp)
    expect_equal(roundtrip, vals) # still equality, not identity, because DF's are saved as CSVs right now.

    tmp2 <- tempfile()
    saveObject(vals, tmp2)
    expect_identical(readObject(tmp2), vals)
})

test_that("external references work correctly with lots of objects", {
    tmp <- tempfile()
    dir.create(tmp)

    # We use lots of objects to check that the sorting order is reproduced;
    # this is not always safe to assume, as the directories in other_content
    # are sorted by string and not number, e.g., 10 sorts before 2.
    vals <- list()
    for (i in 1:20) {
        vals[[i]] <- DataFrame(X = i)
    }

    tmp <- tempfile()
    saveObject(vals, tmp)
    expect_identical(readObject(tmp), vals)

    # Same result with HDF5.
    tmp2 <- tempfile()
    saveObject(vals, tmp2, list.format="hdf5")
    expect_identical(readObject(tmp2), vals)
})

test_that("we handle lists with NAs", {
    vals <- list(
        A=NA, 
        B1=c(1,2,3,NA), 
        B2=c(4L, 5L, NA), 
        C=c("A", "B", NA), 
        D=factor(c("A", NA, "C"), c("a", "A", "b", "B", "c", "C"))
    )

    tmp <- tempfile()
    dir.create(tmp)
    info <- stageObject(vals, tmp, path="stuff")
    expect_match(info[["$schema"]], "json_simple_list")

    resource <- writeMetadata(info, tmp)
    expect_true(file.exists(file.path(tmp, resource$path)))

    roundtrip <- loadBaseList(info, tmp)
    expect_equal(roundtrip, vals)

    tmp2 <- tempfile()
    saveObject(vals, tmp2)
    expect_identical(readObject(tmp2), vals)

    # More difficult NAs.
    vals$C <- c(vals$C, "NA")

    tmp <- tempfile()
    dir.create(tmp)
    info <- stageObject(vals, tmp, path="stuff")

    resource <- writeMetadata(info, tmp)
    expect_true(file.exists(file.path(tmp, resource$path)))

    roundtrip <- loadBaseList(info, tmp)
    expect_equal(roundtrip, vals)

    tmp2 <- tempfile()
    saveObject(vals, tmp2)
    expect_identical(readObject(tmp2), vals)

    # Works in HDF5 mode.
    old <- saveBaseListFormat("hdf5")
    on.exit(saveBaseListFormat(old))

    tmp <- tempfile()
    dir.create(tmp)
    info <- stageObject(vals, tmp, path="hstuff")
    resource <- writeMetadata(info, tmp)
    expect_match(info[["$schema"]], "hdf5_simple_list")

    attrs <- rhdf5::h5readAttributes(file.path(tmp, "hstuff/list.h5"), "contents/data/1/data")
    place <- attrs[["missing-value-placeholder"]]
    expect_true(is.na(place) && !is.nan(place))
    attrs <- rhdf5::h5readAttributes(file.path(tmp, "hstuff/list.h5"), "contents/data/3/data")
    expect_identical(attrs[["missing-value-placeholder"]], "_NA")
    attrs <- rhdf5::h5readAttributes(file.path(tmp, "hstuff/list.h5"), "contents/data/4/data")
    place <- attrs[["missing-value-placeholder"]]
    expect_identical(place, -1L)

    roundtrip <- loadBaseList(info, tmp)
    expect_identical(roundtrip, vals)

    tmp2 <- tempfile()
    saveObject(vals, tmp2)
    expect_identical(readObject(tmp2), vals)

    # Avoid unnecessary NA attributes for NaNs, unless they're mixed in with NAs.
    revals <- list(A=c(NaN, 1.0, 3, NaN), B=c(NaN, 1.0, NA, NaN))

    tmp <- tempfile()
    dir.create(tmp)
    info <- stageObject(revals, tmp, path="hstuff2")
    resource <- writeMetadata(info, tmp)

    attrs <- rhdf5::h5readAttributes(file.path(tmp, "hstuff2/list.h5"), "contents/data/0/data")
    place <- attrs[["missing-value-placeholder"]]
    expect_null(place) # avoid saving an unnecessary placeholder.
    attrs <- rhdf5::h5readAttributes(file.path(tmp, "hstuff2/list.h5"), "contents/data/1/data")
    place <- attrs[["missing-value-placeholder"]]
    expect_identical(place, Inf)

    roundtrip <- loadBaseList(info, tmp)
    expect_identical(roundtrip, revals)

    tmp2 <- tempfile()
    saveObject(vals, tmp2)
    expect_identical(readObject(tmp2), vals)
})

test_that("we handle lists with minimum integers", {
    vals <- list(A=c(1L,2L,3L,NA))

    tmp <- tempfile()
    dir.create(tmp)

    info <- stageObject(vals, tmp, path="stuff")
    expect_match(info[["$schema"]], "json_simple_list")

    fpath <- file.path(tmp, info$path)
    x <- jsonlite::fromJSON(fpath, simplifyVector=FALSE)
    x$values[[1]]$values[4] <- -2^31
    write(jsonlite::toJSON(x, auto_unbox=TRUE), file=gzfile(fpath))

    roundtrip <- loadBaseList(info, tmp)
    expect_equal(roundtrip$A, c(1,2,3,-2^31))

    tmp2 <- tempfile()
    saveObject(vals, tmp2)
    expect_identical(readObject(tmp2), vals)

    # Works for HDF5.
    old <- saveBaseListFormat("hdf5")
    on.exit(saveBaseListFormat(old))

    info <- stageObject(vals, tmp, path="stuff2")
    fpath <- file.path(tmp, info$path)
    rhdf5::h5deleteAttribute(fpath, "contents/data/0/data", "missing-value-placeholder")

    roundtrip <- loadBaseList(info, tmp)
    expect_equal(roundtrip$A, c(1,2,3,-2^31))

    tmp2 <- tempfile()
    saveObject(vals, tmp2)
    expect_identical(readObject(tmp2), vals)
})

test_that("loaders work correctly from HDF5 with non-default placeholders", {
    vals <- list(a=c(1,2,3), b=c(4L, 5L, 6L), c=c(7, 8, NaN))

    old <- saveBaseListFormat("hdf5")
    on.exit(saveBaseListFormat(old))

    tmp <- tempfile()
    dir.create(tmp)
    info <- stageObject(vals, tmp, path="hstuff2")
    resource <- writeMetadata(info, tmp)

    fpath <- file.path(tmp, info$path)
    addMissingPlaceholderAttributeForHdf5(fpath, "contents/data/0/data", 1)
    addMissingPlaceholderAttributeForHdf5(fpath, "contents/data/1/data", 5L)
    addMissingPlaceholderAttributeForHdf5(fpath, "contents/data/2/data", NaN)

    roundtrip <- loadBaseList(info, tmp)
    expect_identical(roundtrip$a, c(NA, 2, 3))
    expect_identical(roundtrip$b, c(4L, NA, 6L))
    expect_identical(roundtrip$c, c(7, 8, NA))

    tmp2 <- tempfile()
    saveObject(vals, tmp2)
    expect_identical(readObject(tmp2), vals)
})

test_that("we handle the various float specials", {
    vals <- list(XXX=c(1.2, Inf, 2.3, -Inf, 3.4, NaN, 4.5, NA))

    tmp <- tempfile()
    dir.create(tmp)
    info <- stageObject(vals, tmp, path="stuff")
    expect_match(info[["$schema"]], "json_simple_list")

    resource <- writeMetadata(info, tmp)
    expect_true(file.exists(file.path(tmp, resource$path)))

    roundtrip <- loadBaseList(info, tmp)
    expect_equal(roundtrip, vals)

    tmp2 <- tempfile()
    saveObject(vals, tmp2)
    expect_identical(readObject(tmp2), vals)

    # Same for HDF5.
    old <- saveBaseListFormat("hdf5")
    on.exit(saveBaseListFormat(old))

    info <- stageObject(vals, tmp, path="hstuff")
    resource <- writeMetadata(info, tmp)
    expect_match(info[["$schema"]], "hdf5_simple_list")

    roundtrip <- loadBaseList(info, tmp)
    expect_identical(roundtrip, vals)

    tmp2 <- tempfile()
    saveObject(vals, tmp2)
    expect_identical(readObject(tmp2), vals)
})

test_that("we handle lists with NULLs", {
    vals <- list(NULL, list(list(NULL), NULL))

    tmp <- tempfile()
    dir.create(tmp)
    info <- stageObject(vals, tmp, path="whee")
    expect_match(info[["$schema"]], "json_simple_list")

    resource <- writeMetadata(info, tmp)
    expect_true(file.exists(file.path(tmp, resource$path)))

    roundtrip <- loadBaseList(info, tmp)
    expect_identical(roundtrip, vals)

    tmp2 <- tempfile()
    saveObject(vals, tmp2)
    expect_identical(readObject(tmp2), vals)

    # Works in HDF5 mode.
    old <- saveBaseListFormat("hdf5")
    on.exit(saveBaseListFormat(old))

    info <- stageObject(vals, tmp, path="hstuff")
    resource <- writeMetadata(info, tmp)
    expect_match(info[["$schema"]], "hdf5_simple_list")

    roundtrip <- loadBaseList(info, tmp)
    expect_identical(roundtrip, vals)

    tmp2 <- tempfile()
    saveObject(vals, tmp2)
    expect_identical(readObject(tmp2), vals)
})

test_that("we handle lists with times", {
    now <- as.POSIXct(round(Sys.time()), tz="")
    vals <- list(now, list(list(now + 10000), c(X=now + 400000, Y=now + 1000000)))
    to_posix <- function(x, fun) {
        if (is.list(x)) {
            lapply(x, to_posix, fun=fun)
        } else {
            fun(x)
        }
    }

    tmp <- tempfile()
    dir.create(tmp)
    info <- stageObject(vals, tmp, path="whee")
    expect_match(info[["$schema"]], "json_simple_list")

    roundtrip <- loadBaseList(info, tmp)
    expect_equal(roundtrip, vals)

    tmp2 <- tempfile()
    saveObject(vals, tmp2)
    reloaded <- readObject(tmp2)
    expect_s3_class(reloaded[[1]], "Rfc3339")
    expect_equal(to_posix(reloaded, as.POSIXct), vals)

    # Works in HDF5 mode.
    old <- saveBaseListFormat("hdf5")
    on.exit(saveBaseListFormat(old))

    info <- stageObject(vals, tmp, path="hstuff")
    resource <- writeMetadata(info, tmp)
    expect_match(info[["$schema"]], "hdf5_simple_list")

    roundtrip <- loadBaseList(info, tmp)
    expect_equal(roundtrip, vals)

    tmp2 <- tempfile()
    saveObject(vals, tmp2)
    reloaded <- readObject(tmp2)
    expect_equal(to_posix(reloaded, as.POSIXct), vals)

    # Works with POSIXlt objects, though these lose some precision when they go to POSIXct on back-conversion.
    now2 <- as.POSIXlt(now, tz="")
    vals2 <- list(now2, list(list(now2 + 10000), c(X=now2 + 400000, Y=now2 + 1000000)))

    info2 <- stageObject(vals, tmp, path="whee2")
    roundtrip2 <- loadBaseList(info2, tmp)
    expect_equal(to_posix(roundtrip2, as.POSIXlt), vals2)

    tmp2 <- tempfile()
    saveObject(vals, tmp2)
    reloaded <- readObject(tmp2)
    expect_equal(to_posix(reloaded, as.POSIXlt), vals2)
})

test_that("lists correctly distinguish between scalars and length-1 vectors", {
    ll <- list(
        A1 = 1L,
        A2 = I(2L),
        B1 = 1.5,
        B2 = I(2.5),
        C1 = "foo",
        C2 = I("bar"),
        D1 = TRUE,
        D2 = I(FALSE),
        E1 = Sys.Date(),
        E2 = I(Sys.Date()),
        F1 = as.Rfc3339(Sys.time()),
        F2 = I(as.Rfc3339(Sys.time()))
    )

    tmp <- tempfile()
    saveObject(ll, tmp)
    reloaded <- readObject(tmp)
    expect_equal(ll, reloaded)

    # Checking that the values are indeed scalar.
    y <- jsonlite::fromJSON(file.path(tmp, "list_contents.json.gz"), simplifyVector=FALSE)
    expect_type(y$values[[1]]$values, "integer")
    expect_type(y$values[[2]]$values, "list")
    expect_type(y$values[[3]]$values, "double")
    expect_type(y$values[[4]]$values, "list")
    expect_type(y$values[[5]]$values, "character")
    expect_type(y$values[[6]]$values, "list")
    expect_type(y$values[[7]]$values, "logical")
    expect_type(y$values[[8]]$values, "list")
    expect_type(y$values[[9]]$values, "character")
    expect_type(y$values[[10]]$values, "list")
    expect_type(y$values[[11]]$values, "character")
    expect_type(y$values[[12]]$values, "list")

    # Same for HDF5.
    tmp2 <- tempfile()
    saveObject(ll, tmp2, list.format="hdf5")
    reloaded2 <- readObject(tmp2)
    expect_equal(ll, reloaded2)

    # Checking that the values are indeed scalar.
    fhandle <- rhdf5::H5Fopen(file.path(tmp2, "list_contents.h5"))
    ghandle <- rhdf5::H5Gopen(fhandle, "simple_list")
    dhandle <- rhdf5::H5Gopen(ghandle, "data")
    peek_at_shape <- function(name) {
        ihandle <- rhdf5::H5Gopen(dhandle, name)
        on.exit(rhdf5::H5Gclose(ihandle), add=TRUE, after=FALSE)
        xhandle <- rhdf5::H5Dopen(ihandle, "data")
        on.exit(rhdf5::H5Dclose(xhandle), add=TRUE, after=FALSE)
        shandle <- rhdf5::H5Dget_space(xhandle)
        on.exit(rhdf5::H5Sclose(shandle), add=TRUE, after=FALSE)
        rhdf5::H5Sget_simple_extent_dims(shandle)$size
    }
    expect_identical(peek_at_shape("0"), integer(0))
    expect_identical(peek_at_shape("1"), 1L)
    expect_identical(peek_at_shape("2"), integer(0))
    expect_identical(peek_at_shape("3"), 1L)
    expect_identical(peek_at_shape("4"), integer(0))
    expect_identical(peek_at_shape("5"), 1L)
    expect_identical(peek_at_shape("6"), integer(0))
    expect_identical(peek_at_shape("7"), 1L)
    expect_identical(peek_at_shape("8"), integer(0))
    expect_identical(peek_at_shape("9"), 1L)
    expect_identical(peek_at_shape("10"), integer(0))
    expect_identical(peek_at_shape("11"), 1L)
})

test_that("lists work correctly in legacy mode (JSON)", {
    tmp <- tempfile()
    dir.create(tmp)
    info <- stageObject(vals, tmp, path="stuff", .version=1)
    writeMetadata(info, tmp)

    roundtrip <- loadBaseList(info, tmp)
    expect_identical(roundtrip, vals)
})

test_that("lists work correctly in legacy mode (HDF5)", {
    old <- saveBaseListFormat("hdf5")
    on.exit(saveBaseListFormat(old))

    tmp <- tempfile()
    dir.create(tmp)
    info <- stageObject(vals, tmp, path="stuff", .version=1)
    writeMetadata(info, tmp)

    roundtrip <- loadBaseList(info, tmp)
    expect_identical(roundtrip, vals)

    # Where it gets really fun is with the NA/NaN mixtures.
    vals$F <- c(NA, 1:5)
    vals$G <- c(NA, NaN, 0.5)

    info <- stageObject(vals, tmp, path="stuff2", .version=2)
    writeMetadata(info, tmp)
    roundtrip <- loadBaseList(info, tmp)
    expect_identical(roundtrip, vals)

    attrs <- rhdf5::h5readAttributes(file.path(tmp, "stuff2/list.h5"), "contents/data/6/data")
    expect_identical(attrs[["missing-value-placeholder"]], NA_integer_)
    attrs <- rhdf5::h5readAttributes(file.path(tmp, "stuff2/list.h5"), "contents/data/7/data")
    expect_identical(attrs[["missing-value-placeholder"]], NA_real_) # still relying on the payloads.
})

test_that("lists convert package versions to strings", {
    vals <- list(foo = as.package_version(c("1.0", "1.0.0", "1.2.1")), bar = package_version("1.2.3.4"))

    tmp <- tempfile()
    dir.create(tmp)

    saveObject(vals, file.path(tmp, "gunk"))
    reloaded <- readObject(file.path(tmp, "gunk"))
    expect_identical(reloaded, lapply(vals, as.character))

    saveObject(vals, file.path(tmp, "gunk.h5"), list.format="hdf5")
    reloaded <- readObject(file.path(tmp, "gunk.h5"))
    expect_identical(reloaded, lapply(vals, as.character))
})

test_that("lists work in VLS mode", {
    tmp <- tempfile()
    dir.create(tmp)

    x <- list(u=runif(5), w=c("A", "BC", "DEFG"), x=TRUE, y=list(a=c("HIJKL", "MNOP", "QRS", "TU", "V")), z=2:10)
    saveObject(x, file.path(tmp, "basic"), list.format="hdf5", list.character.vls=TRUE)
    reloaded <- readObject(file.path(tmp, "basic")) 
    expect_identical(x, reloaded)

    copy <- x
    copy$w[3] <- NA
    saveObject(copy, file.path(tmp, "with_missing"), list.format="hdf5", list.character.vls=TRUE)
    reloaded <- readObject(file.path(tmp, "with_missing")) 
    expect_identical(copy, reloaded)

    copy <- x
    names(copy$w) <- seq_along(copy$w)
    saveObject(copy, file.path(tmp, "named"), list.format="hdf5", list.character.vls=TRUE)
    reloaded <- readObject(file.path(tmp, "named")) 
    expect_identical(copy, reloaded)

    copy <- x
    copy$w <- c(copy$w, strrep("XXXXX", 100))
    saveObject(copy, file.path(tmp, "auto"), list.format="hdf5", list.character.vls=NULL)
    reloaded <- readObject(file.path(tmp, "auto")) 
    expect_identical(copy, reloaded)

    copy <- x
    copy$w <- "ABCDEFGHIJK"
    saveObject(copy, file.path(tmp, "scalar"), list.format="hdf5", list.character.vls=TRUE)
    reloaded <- readObject(file.path(tmp, "scalar")) 
    expect_identical(copy, reloaded)

    copy <- x
    copy$w <- I("ABCDEFGHIJK")
    saveObject(copy, file.path(tmp, "not_scalar"), list.format="hdf5", list.character.vls=TRUE)
    reloaded <- readObject(file.path(tmp, "not_scalar")) 
    expect_identical(copy, reloaded)
})

#' Find missing values
#'
#' Find missing (\code{NA}) values.
#' This is smart enough to distinguish them from NaN values in numeric \code{x}.
#' For all other types, it just calls \code{\link{is.na}} or \code{\link{anyNA}}.
#'
#' @param x Vector or array of atomic values.
#'
#' @return 
#' For \code{anyMissing}, a logical scalar indicating whether any \code{NA} values were present in \code{x}.
#'
#' For \code{is.missing}, a logical vector or array of shape equal to \code{x}, indicating whether each value is \code{NA}.
#'
#' @author Aaron Lun
#'
#' @examples
#' anyNA(c(NaN))
#' anyNA(c(NA))
#' anyMissing(c(NaN))
#' anyMissing(c(NA))
#'
#' is.na(c(NA, NaN))
#' is.missing(c(NA, NaN))
#' @export
anyMissing <- function(x) {
    if (is.double(x)) {
        any_actually_numeric_na(x)
    } else {
        anyNA(x)
    }
}

#' @export
#' @rdname anyMissing
is.missing <- function(x) {
    if (is.double(x)) {
        out <- is_actually_numeric_na(x)
        if (!is.null(dim(x))) {
            dim(out) <- dim(x)
        }
        out
    } else {
        is.na(x)
    }
}

# This checks the anyMissing() function.
# library(testthat); library(alabaster.base); source("test-anyMissing.R")

test_that("anyMissing works correctly", {
    expect_true(anyNA(c(NaN)))
    expect_true(anyNA(c(NA)))
    expect_false(anyMissing(c(NaN)))
    expect_true(anyMissing(c(NA)))
})

test_that("is.missing works correctly", {
    expect_identical(is.na(c(NA, NaN)), c(TRUE, TRUE))
    expect_identical(is.missing(c(NA, NaN)), c(TRUE, FALSE))
})

#' Save atomic vectors to disk
#'
#' Save vectors containing atomic elements (or values that can be cast as such, e.g., dates and times) to an on-disk representation.
#'
#' @param x Any of the atomic vector types, or \link{Date} objects, or time objects, e.g., \link{POSIXct}.
#' @inheritParams saveObject
#' @param character.vls Logical scalar indicating whether to save character vectors in the custom variable length string (VLS) array format.
#' If \code{NULL}, this is determined based on a comparison of the expected storage against a fixed length array.
#' @param ... Further arguments that are ignored.
#' 
#' @return
#' \code{x} is saved inside \code{path}.
#' \code{NULL} is invisibly returned.
#'
#' @author Aaron Lun
#' 
#' @seealso
#' \code{\link{readAtomicVector}}, to read the files back into the session.
#'
#' @examples
#' tmp <- tempfile()
#' dir.create(tmp)
#' saveObject(LETTERS, file.path(tmp, "foo"))
#' saveObject(setNames(runif(26), letters), file.path(tmp, "bar"))
#' list.files(tmp, recursive=TRUE)
#' 
#' @name saveAtomicVector
#' @aliases
#' stageObject,integer-method
#' stageObject,numeric-method
#' stageObject,logical-method
#' stageObject,character-method
#' stageObject,double-method
#' stageObject,POSIXct-method
#' stageObject,POSIXlt-method
#' stageObject,Date-method
NULL

.save_atomic_vector <- function(x, path, character.vls=FALSE, ...) {
    dir.create(path)
    ofile <- file.path(path, "contents.h5")

    if (.is_datetime(x)) {
        type <- "string"
        format <- "date-time"
        contents <- .sanitize_datetime(x)

    } else if (is(x, "Date")) {
        type <- "string"
        format <- "date"
        contents <- .sanitize_date(x)

    } else {
        stopifnot(is.atomic(x))
        remapped <- .remap_atomic_type(x)
        type <- remapped$type
        contents <- remapped$values
        format <- NULL
    }

    fhandle <- H5Fcreate(ofile, "H5F_ACC_TRUNC")
    on.exit(.H5Fclose_null(fhandle), add=TRUE, after=FALSE)
    ghandle <- H5Gcreate(fhandle, "atomic_vector")
    on.exit(.H5Gclose_null(ghandle), add=TRUE, after=FALSE)

    transformed <- transformVectorForHdf5(contents)
    current <- transformed$transformed
    missing.placeholder <- transformed$placeholder

    saved.vls <- FALSE
    if (type == "string" && is.null(format) && !isFALSE(character.vls)) {
        if (is.null(character.vls)) {
            character.vls <- h5_use_vls(current)
        }
        if (character.vls) {
            # Need to do this tedious song and dance to get an exclusive file handle.
            ghandle <- .H5Gclose_null(ghandle)
            fhandle <- .H5Fclose_null(fhandle)

            h5_write_vls_array(ofile, "atomic_vector", "pointers", "heap", current)
            saved.vls <- TRUE
            type <- "vls"

            # Reopening this for downstream operations.
            fhandle <- H5Fopen(ofile, "H5F_ACC_RDWR")
            ghandle <- H5Gopen(fhandle, "atomic_vector")
        }
    }

    if (saved.vls) {
        dhandle <- H5Dopen(ghandle, "pointers")
    } else {
        dhandle <- h5_write_vector(ghandle, "values", current, emit=TRUE)
    }
    on.exit(H5Dclose(dhandle), add=TRUE, after=FALSE)

    if (!is.null(missing.placeholder)) {
        h5_write_attribute(dhandle, missingPlaceholderName, missing.placeholder, scalar=TRUE)
    }

    h5_write_attribute(ghandle, "type", type, scalar=TRUE)
    if (!is.null(format)) {
        h5_write_attribute(ghandle, "format", format, scalar=TRUE)
    }

    if (!is.null(names(x))) {
        h5_write_vector(ghandle, "names", names(x))
    }

    saveObjectFile(path, "atomic_vector", list(atomic_vector=list(version="1.1")))
    invisible(NULL)
}

#' @export
#' @rdname saveAtomicVector
setMethod("saveObject", "integer", .save_atomic_vector)

#' @export
#' @rdname saveAtomicVector
setMethod("saveObject", "character", .save_atomic_vector)

#' @export
#' @rdname saveAtomicVector
setMethod("saveObject", "logical", .save_atomic_vector)

#' @export
#' @rdname saveAtomicVector
setMethod("saveObject", "double", .save_atomic_vector)

#' @export
#' @rdname saveAtomicVector
setMethod("saveObject", "numeric", .save_atomic_vector)

#' @export
#' @rdname saveAtomicVector
setMethod("saveObject", "Date", .save_atomic_vector)

#' @export
#' @rdname saveAtomicVector
setMethod("saveObject", "POSIXlt", .save_atomic_vector)

#' @export
#' @rdname saveAtomicVector
setMethod("saveObject", "POSIXct", .save_atomic_vector)

setOldClass(c("package_version", "numeric_version"))

#' @export
#' @rdname saveAtomicVector
setMethod("saveObject", "numeric_version", function(x, path, ...) .save_atomic_vector(as.character(x), path, ...))

#######################################
########### OLD STUFF HERE ############
#######################################

#' @importFrom S4Vectors DataFrame
.stage_atomic_vector <- function(x, dir, path, child=FALSE, ...) {
    dir.create(file.path(dir, path), showWarnings=FALSE)

    if (.is_datetime(x)) {
        type <- "string"
        format <- "date-time"
        contents <- .sanitize_datetime(x)

    } else if (is(x, "Date")) {
        type <- "string"
        format <- "date"
        contents <- .sanitize_date(x)

    } else {
        stopifnot(is.atomic(x))
        remapped <- .remap_atomic_type(x)
        type <- remapped$type
        contents <- remapped$values
        format <- NULL
    }

    new_path <- paste0(path, "/simple.txt.gz")
    mock <- DataFrame(values=contents)
    if (!is.null(names(x))) {
        mock <- cbind(names=names(x), mock)
    }
    quickWriteCsv(mock, file.path(dir, new_path), row.names=FALSE, compression="gzip")

    list(
        `$schema` = "atomic_vector/v1.json",
        path = new_path,
        is_child = child,
        atomic_vector = list(
            type = type,
            length = length(contents),
            names = !is.null(names(x)),
            format = format,
            compression="gzip"
        )
    )
}


#' @export
setMethod("stageObject", "integer", .stage_atomic_vector)

#' @export
setMethod("stageObject", "character", .stage_atomic_vector)

#' @export
setMethod("stageObject", "logical", .stage_atomic_vector)

#' @export
setMethod("stageObject", "double", .stage_atomic_vector)

#' @export
setMethod("stageObject", "numeric", .stage_atomic_vector)

#' @export
setMethod("stageObject", "Date", .stage_atomic_vector)

#' @export
setMethod("stageObject", "POSIXlt", .stage_atomic_vector)

#' @export
setMethod("stageObject", "POSIXct", .stage_atomic_vector)

#' Read a factor from disk
#'
#' Read a base R \link{factor} from its on-disk representation.
#' This is usually not directly called by users, but is instead called by dispatch in \code{\link{readObject}}.
#'
#' @param path String containing a path to a directory, itself created with the \code{\link{saveObject}} method for factors.
#' @param metadata Named list containing metadata for the object, see \code{\link{readObjectFile}} for details.
#' @param ... Further arguments, ignored.
#'
#' @return 
#' The vector described by \code{info}. 
#'
#' @seealso
#' \code{"\link{saveObject,factor-method}"}, for the staging method.
#'
#' @author Aaron Lun
#' 
#' @examples
#' tmp <- tempfile()
#' saveObject(factor(letters[1:10], letters), tmp)
#' readObject(tmp)
#' 
#' @export
#' @aliases loadBaseFactor
readBaseFactor <- function(path, metadata, ...) {
    fpath <- file.path(path, "contents.h5")
    fhandle <- H5Fopen(fpath, flags="H5F_ACC_RDONLY")
    on.exit(H5Fclose(fhandle), add=TRUE, after=FALSE)

    host <- "string_factor"
    ghandle <- H5Gopen(fhandle, host)
    on.exit(H5Gclose(ghandle), add=TRUE, after=FALSE)

    codes <- .simple_read_codes(ghandle)
    levels <- h5_read_vector(ghandle, "levels")
    ordered <- h5_read_attribute(ghandle, "ordered", check=TRUE, default=NULL)
    output <- factor(levels[codes], levels=levels, ordered=isTRUE(ordered > 0L))

    if (h5_object_exists(ghandle, "names")) {
        names(output) <- h5_read_vector(ghandle, "names")
    }
    output 
}

.simple_read_codes <- function(handle, name="codes") {
    chandle <- H5Dopen(handle, name)
    on.exit(H5Dclose(chandle), add=TRUE, after=FALSE)
    codes <- H5Dread(chandle, drop=TRUE)
    missing.placeholder <- h5_read_attribute(chandle, missingPlaceholderName, check=TRUE, default=NULL)
    codes <- h5_cast(codes, expected.type="integer", missing.placeholder=missing.placeholder)
    codes + 1L
}

#######################################
########### OLD STUFF HERE ############
#######################################

#' @export
loadBaseFactor <- function(info, project, ...) {
    fpath <- acquireFile(project, info$path)
    meta <- info$factor

    df <- read.csv3(fpath, compression=meta$compression, nrows=meta$length)
    codes <- df[,ncol(df)] + 1L

    smeta <- info$string_factor
    level_meta <- acquireMetadata(project, smeta$levels$resource$path)
    levels <- altLoadObject(level_meta, project=project)

    output <- factor(levels[codes], levels=levels, ordered=isTRUE(smeta$ordered))
    if (isTRUE(meta$names)) {
        names(output) <- df[,1]
    }
    output 
}

# Test stageObject on factors.
# library(testthat); library(alabaster.base); source("test-factor.R")

test_that("factors work correctly without names", {
    tmp <- tempfile()
    dir.create(tmp, recursive=TRUE)

    input <- factor(LETTERS)
    meta <- stageObject(input, tmp, path="foo")
    writeMetadata(meta, tmp)
    expect_identical(loadBaseFactor(meta, tmp), input)

    vals <- factor(LETTERS[5:20], LETTERS)
    meta <- stageObject(vals, tmp, path="bar")
    writeMetadata(meta, tmp)
    expect_identical(loadBaseFactor(meta, tmp), vals)

    vals <- factor(LETTERS, LETTERS[2:24])
    meta <- stageObject(vals, tmp, path="stuff")
    writeMetadata(meta, tmp)
    expect_identical(loadBaseFactor(meta, tmp), vals)

    vals <- factor(LETTERS, rev(LETTERS), ordered=TRUE)
    meta <- stageObject(vals, tmp, path="whee")
    writeMetadata(meta, tmp)
    expect_identical(loadBaseFactor(meta, tmp), vals)
})

test_that("factors work correctly without names in the new world", {
    tmp <- tempfile()
    dir.create(tmp, recursive=TRUE)

    input <- factor(LETTERS)
    saveObject(input, file.path(tmp, "foo"))
    expect_identical(readBaseFactor(file.path(tmp, "foo")), input)

    vals <- factor(LETTERS[5:20], LETTERS)
    saveObject(vals, file.path(tmp, "bar"))
    expect_identical(readBaseFactor(file.path(tmp, "bar")), vals)

    vals <- factor(LETTERS, LETTERS[2:24])
    saveObject(vals, file.path(tmp, "stuff"))
    expect_identical(readBaseFactor(file.path(tmp, "stuff")), vals)

    vals <- factor(LETTERS, rev(LETTERS), ordered=TRUE)
    saveObject(vals, file.path(tmp, "whee"))
    expect_identical(readBaseFactor(file.path(tmp, "whee")), vals)
})

test_that("factors work correctly with names", {
    tmp <- tempfile()
    dir.create(tmp, recursive=TRUE)

    vals <- setNames(factor(LETTERS, rev(LETTERS)), letters)
    meta <- stageObject(vals, tmp, path="bar")
    writeMetadata(meta, tmp)
    expect_identical(loadBaseFactor(meta, tmp), vals)

    saveObject(vals, file.path(tmp, "whee"))
    expect_identical(readBaseFactor(file.path(tmp, "whee")), vals)
})

#' Move a non-child object in the staging directory
#'
#' \emph{WARNING: this function is deprecated, as directories of non-child objects can just be moved with regular methods (e.g., \code{\link{file.rename}}) in the latest version of \pkg{alabaster}.}
#' Pretty much as it says in the title.
#' This only works with non-child objects as children are referenced by their parents and cannot be safely moved in this manner.
#'
#' @param dir String containing the path to the staging directory.
#' @param from String containing the path to a non-child object inside \code{dir}, as used in \code{\link{acquireMetadata}}.
#' This can also be a redirection to such an object.
#' @param to String containing the new path inside \code{dir}.
#' @param rename.redirections Logical scalar specifying whether redirections pointing to \code{from} should be renamed as \code{to}.
#' 
#' @author Aaron Lun
#'
#' @return
#' The object represented by \code{path} is moved, along with any redirections to it.
#' A \code{NULL} is invisibly returned.
#'
#' @details
#' This function will look around \code{path} for JSON files containing redirections to \code{from}, and update them to point to \code{to}.
#' More specifically, if \code{path} is a subdirectory, it will search in the same directory containing \code{path};
#' otherwise, it will search in the directory containing \code{dirname(path)}.
#' Redirections in other locations will not be removed automatically - these will be caught by \code{\link{checkValidDirectory}} and should be manually updated.
#'
#' If \code{rename.redirections=TRUE}, this function will additionally move the redirection files so that they are named as \code{to}.
#' In the unusual case where \code{from} is the target of multiple redirection files, the renaming process will clobber all of them such that only one of them will be present after the move.
#'
#' @section Safety of moving operations:
#' In general, \pkg{alabaster.*} representations are safe to move as only the parent object's \code{resource.path} metadata properties will contain links to the children's paths.
#' These links are updated with the new \code{to} path after running \code{moveObject} on the parent \code{from}.
#'
#' However, alabaster applications may define custom data structures where the paths are present elsewhere, e.g., in the data file itself or in other metadata properties.
#' If so, applications are reponsible for updating those paths to reflect the naming to \code{to}.
#' 
#' @examples
#' tmp <- tempfile()
#' dir.create(tmp)
#'
#' library(S4Vectors)
#' df <- DataFrame(A=1:10, B=LETTERS[1:10])
#' meta <- stageObject(df, tmp, path="whee")
#' writeMetadata(meta, tmp)
#'
#' ll <- list(A=1, B=LETTERS, C=DataFrame(X=1:5))
#' meta <- stageObject(ll, tmp, path="stuff")
#' writeMetadata(meta, tmp)
#'
#' redirect <- createRedirection(tmp, "whoop", "whee/simple.csv.gz")
#' writeMetadata(redirect, tmp)
#'
#' list.files(tmp, recursive=TRUE)
#' moveObject(tmp, "whoop", "YAY")
#' list.files(tmp, recursive=TRUE)
#'
#' @export
moveObject <- function(dir, from, to, rename.redirections = TRUE) {
    meta <- acquireMetadata(dir, from)

    if (isTRUE(meta$is_child)) {
        stop("cannot move a child object without moving the parent")
    }

    refpath <- meta$path
    old <- dirname(refpath)
    new.refpath <- .recursive_move(dir, old, to)

    # Searching for redirections.
    searchpath <- file.path(dir, dirname(dirname(refpath)))
    potential <- list.files(searchpath, pattern="\\.json$")

    for (x in potential) {
        redpath <- file.path(searchpath, x)
        meta <- fromJSON(redpath, simplifyVector=FALSE)

        if (dirname(meta[["$schema"]]) == "redirection") {
            survivors <- meta[["redirection"]][["targets"]]
            renamed <- FALSE
            for (i in seq_along(survivors)) {
                x <- survivors[[i]]
                if (x$type == "local" && x$location == refpath) {
                    renamed <- TRUE
                    survivors[[i]]$location <- new.refpath
                    break
                }
            }

            if (renamed) {
                if (rename.redirections) {
                    meta$path <- to
                    unlink(redpath)
                }
                meta[["redirection"]][["targets"]] <- survivors
                writeMetadata(meta, dir)
            }
        }
    }

    invisible(NULL)
}

.replace_path <- function(path, from_slash, to_slash) {
    if (!startsWith(path, from_slash)) {
        NULL
    } else {
        paste0(to_slash, substr(path, nchar(from_slash) + 1, nchar(path)))
    }
}

#' @importFrom jsonlite fromJSON toJSON
.recursive_move <- function(dir, from, to) {
    location <- file.path(dir, from)
    target <- file.path(dir, to)
    dir.create(target, showWarnings=FALSE)
    contents <- list.files(location, all.files=TRUE, no..=TRUE)

    from_slash <- paste0(from, "/")
    to_slash <- paste0(to, "/")
    new.ref <- NULL

    for (x in contents) {
        full <- file.path(location, x)
        if (file.info(full)$isdir) {
            nested.ref <- .recursive_move(dir, paste0(from_slash, x), paste0(to_slash, x))

        } else if (endsWith(x, ".json")) {
            meta <- fromJSON(full, simplifyVector=FALSE)
            meta$path <- .replace_path(meta$path, from_slash, to_slash)
            if (is.null(meta$path)) {
                stop("'path' in metadata is expected to start with '", from_slash, "'")
            }

            updated <- .update_resource_paths(meta, from_slash, to_slash)
            write(file=file.path(target, x), toJSON(updated$metadata, pretty=TRUE, auto_unbox=TRUE, digits=NA))
            new.ref <- meta$path

        } else if (!file.rename(full, file.path(target, x))) {
            stop("failed to rename '", x, "' from '", from, "' to '", to, "'")
        }
    }

    unlink(location, recursive=TRUE)
    new.ref
}

.update_resource_paths <- function(meta, from_slash, to_slash) {
    modified <- FALSE
    replace.resource <- FALSE
    resmeta <- NULL

    if (!is.null(names(meta))) {
        if ("resource" %in% names(meta)) {
            resmeta <- meta$resource
            if ("type" %in% names(resmeta) && resmeta$type == "local") {
                new.path <- .replace_path(resmeta$path, from_slash, to_slash)
                if (!is.null(new.path)) {
                    resmeta$path <- new.path
                    modified <- TRUE
                    replace.resource <- TRUE
                    meta$resource <- FALSE # avoid needless recursion below.
                }
            }
        }
    }

    for (i in seq_along(meta)) {
        if (is.list(meta[[i]])) {
            updated <- .update_resource_paths(meta[[i]], from_slash, to_slash) 
            if (updated$modified) {
                modified <- TRUE
                meta[[i]] <- updated$metadata
            }
        }
    }

    if (replace.resource) {
        meta$resource <- resmeta
    }
    list(modified = modified, metadata = meta)
}

# Test stageObject on various bits and pieces.
# library(testthat); library(alabaster.base); source("test-removeObject.R")

library(S4Vectors)
df <- DataFrame(A=1:10, B=LETTERS[1:10])
ll <- list(A=1, B=LETTERS, C=DataFrame(X=1:5))

populate <- function() {
    tmp <- tempfile()
    dir.create(tmp)

    meta <- stageObject(df, tmp, path="whee")
    writeMetadata(meta, tmp)

    meta <- stageObject(ll, tmp, path="stuff")
    writeMetadata(meta, tmp)

    redirect <- createRedirection(tmp, "whoop", "whee/simple.csv.gz")
    writeMetadata(redirect, tmp)

    tmp
}

test_that("removeObject works correctly for direct calls", {
    tmp <- populate()
    expect_true(file.exists(file.path(tmp, "stuff/list.json.gz")))
    expect_true(file.exists(file.path(tmp, "whee/simple.csv.gz")))
    expect_true(file.exists(file.path(tmp, "whee/simple.csv.gz.json")))
    expect_true(file.exists(file.path(tmp, "whoop.json")))

    removeObject(tmp, "whee/simple.csv.gz")
    expect_true(file.exists(file.path(tmp, "stuff/list.json.gz")))
    expect_false(file.exists(file.path(tmp, "whee/simple.csv.gz")))
    expect_false(file.exists(file.path(tmp, "whee/simple.csv.gz.json")))
    expect_false(file.exists(file.path(tmp, "whoop.json")))
})

test_that("removeObject works correctly for redirected calls", {
    tmp <- populate()
    expect_true(file.exists(file.path(tmp, "stuff/list.json.gz")))
    expect_true(file.exists(file.path(tmp, "whee/simple.csv.gz")))
    expect_true(file.exists(file.path(tmp, "whee/simple.csv.gz.json")))
    expect_true(file.exists(file.path(tmp, "whoop.json")))

    removeObject(tmp, "whoop")
    expect_true(file.exists(file.path(tmp, "stuff/list.json.gz")))
    expect_false(file.exists(file.path(tmp, "whee/simple.csv.gz")))
    expect_false(file.exists(file.path(tmp, "whee/simple.csv.gz.json")))
    expect_false(file.exists(file.path(tmp, "whoop.json")))
})

test_that("moveObject works correctly for children", {
    tmp <- populate()
    expect_true(file.exists(file.path(tmp, "stuff/list.json.gz")))
    expect_true(file.exists(file.path(tmp, "stuff/child-1/simple.csv.gz")))

    moveObject(tmp, "stuff/list.json.gz", "mikasa")
    expect_false(file.exists(file.path(tmp, "stuff/list.json.gz")))
    expect_false(file.exists(file.path(tmp, "stuff/child-1/simple.csv.gz")))
    expect_true(file.exists(file.path(tmp, "mikasa/list.json.gz")))
    expect_true(file.exists(file.path(tmp, "mikasa/child-1/simple.csv.gz")))

    meta <- acquireMetadata(tmp, "mikasa/list.json.gz")
    out <- loadObject(meta, tmp)
    expect_identical(out, ll)
})

test_that("moveObject works correctly for direct calls", {
    tmp <- populate()
    expect_true(file.exists(file.path(tmp, "stuff/list.json.gz")))
    expect_true(file.exists(file.path(tmp, "whee/simple.csv.gz")))
    expect_true(file.exists(file.path(tmp, "whee/simple.csv.gz.json")))
    expect_true(file.exists(file.path(tmp, "whoop.json")))

    moveObject(tmp, "whee/simple.csv.gz", "YAY")
    expect_true(file.exists(file.path(tmp, "stuff/list.json.gz")))
    expect_false(file.exists(file.path(tmp, "whee/simple.csv.gz")))
    expect_false(file.exists(file.path(tmp, "whee/simple.csv.gz.json")))
    expect_false(file.exists(file.path(tmp, "whoop.json")))
    expect_true(file.exists(file.path(tmp, "YAY/simple.csv.gz")))
    expect_true(file.exists(file.path(tmp, "YAY/simple.csv.gz.json")))
    expect_true(file.exists(file.path(tmp, "YAY.json")))

    meta <- acquireMetadata(tmp, "YAY")
    out <- loadObject(meta, tmp)
    expect_identical(out, df)
})

test_that("moveObject works correctly for redirected calls", {
    tmp <- populate()
    expect_true(file.exists(file.path(tmp, "stuff/list.json.gz")))
    expect_true(file.exists(file.path(tmp, "whee/simple.csv.gz")))
    expect_true(file.exists(file.path(tmp, "whee/simple.csv.gz.json")))
    expect_true(file.exists(file.path(tmp, "whoop.json")))

    moveObject(tmp, "whoop", "YAY")
    expect_true(file.exists(file.path(tmp, "stuff/list.json.gz")))
    expect_false(file.exists(file.path(tmp, "whee/simple.csv.gz")))
    expect_false(file.exists(file.path(tmp, "whee/simple.csv.gz.json")))
    expect_false(file.exists(file.path(tmp, "whoop.json")))
    expect_true(file.exists(file.path(tmp, "YAY/simple.csv.gz")))
    expect_true(file.exists(file.path(tmp, "YAY/simple.csv.gz.json")))
    expect_true(file.exists(file.path(tmp, "YAY.json")))

    meta <- acquireMetadata(tmp, "YAY")
    out <- loadObject(meta, tmp)
    expect_identical(out, df)
})

#' Validate an object's on-disk representation
#'
#' Validate an object's on-disk representation against the \pkg{takane} specifications.
#' This is done by dispatching to an appropriate validation function based on the type in the \code{OBJECT} file.
#'
#' @param path String containing a path to a directory, itself created with a \code{\link{saveObject}} method.
#' @param metadata List containing metadata for the object.
#' If this is not supplied, it is automatically read from the \code{OBJECT} file inside \code{path}.
#' @param type String specifying the name of type of the object.
#' @param fun 
#' For \code{registerValidateObjectFunction}, a function that accepts \code{path} and \code{metadata}, and raises an error if the object at \code{path} is invalid.
#' It can be assumed that \code{metadata} is a list created by reading \code{OBJECT}.
#'
#' For \code{registerValidateObjectHeightFunction}, a function that accepts \code{path} and \code{metadata}, and returns an integer specifying the \dQuote{height} of the object.
#' This is usually the length for vector-like or 1-dimensional objects, and the extent of the first dimension for higher-dimensional objects.
#' 
#' For \code{registerValidateObjectDimensionsFunction}, a function that accepts \code{path} and \code{metadata}, and returns an integer vector specifying the dimensions of the object.
#'
#' This may also be \code{NULL} to delete an existing registry from any of the functions mentioned above.
#' @param existing Logical scalar indicating the action to take if a function has already been registered for \code{type} -
#' keep the old or new function, or throw an error.
#' @param interface String specifying the name of the interface that is represented by \code{type}.
#' @param parent String specifying the parent object from which \code{type} is derived.
#' @param action String specifying whether to add or remove \code{type} from the list of types that implements \code{interface} or is derived from \code{parent}.
#' 
#' @return 
#' For \code{validateObject}, \code{NULL} is returned invisibly upon success, otherwise an error is raised.
#'
#' For the \code{registerValidObject*Function} functions, the supplied \code{fun} is added to the corresponding registry for \code{type}.
#' If \code{fun = NULL}, any existing entry for \code{type} is removed; a logical scalar is returned indicating whether removal was performed.
#'
#' For the \code{registerValidateObjectSatisfiesInterface} and \code{registerValidateObjectDerivedFrom} functions, \code{type} is added to or removed from relevant list of types.
#' A logical scalar is returned indicating whether the \code{type} was added or removed - this may be \code{FALSE} if \code{type} was already present or absent, respectively.
#'
#' @seealso
#' \url{https://github.com/ArtifactDB/takane}, for detailed specifications of the on-disk representation for various Bioconductor objects.
#'
#' @author Aaron Lun
#' @examples
#' library(S4Vectors)
#' df <- DataFrame(A=1:10, B=LETTERS[1:10])
#'
#' tmp <- tempfile()
#' saveObject(df, tmp)
#' validateObject(tmp)
#' 
#' @export
validateObject <- function(path, metadata=NULL) {
    path <- path.expand(path) # protect C code from ~/.
    validate(path, metadata)
    invisible(NULL)
}

#' @export
#' @rdname validateObject
registerValidateObjectFunction <- function(type, fun, existing=c("old", "new", "error")) {
    if (!is.null(fun)) {
        register_validate_function(type, fun, match.arg(existing))
    } else {
        deregister_validate_function(type);
    }
}

#' @export
#' @rdname validateObject
registerValidateObjectHeightFunction <- function(type, fun, existing=c("old", "new", "error")) {
    if (!is.null(fun)) {
        register_height_function(type, fun, match.arg(existing))
    } else {
        deregister_height_function(type);
    }
}

#' @export
#' @rdname validateObject
registerValidateObjectDimensionsFunction <- function(type, fun, existing=c("old", "new", "error")) {
    if (!is.null(fun)) {
        register_dimensions_function(type, fun, match.arg(existing))
    } else {
        deregister_dimensions_function(type);
    }
}

#' @export
#' @rdname validateObject
registerValidateObjectSatisfiesInterface <- function(type, interface, action=c("add", "remove")) {
    action <- match.arg(action)
    if (action == "add") {
        register_satisfies_interface(type, interface)
    } else {
        deregister_satisfies_interface(type, interface)
    }
}

#' @export
#' @rdname validateObject
registerValidateObjectDerivedFrom <- function(type, parent, action=c("add", "remove")) {
    action <- match.arg(action)
    if (action == "add") {
        register_derived_from(type, parent)
    } else {
        deregister_derived_from(type, parent)
    }
}

# This checks that the registration functions for validate() work correctly.
# library(alabaster.base); library(testthat); source("test-validate.R")

test_that("validation registration works as expected", {
    tmp <- tempfile()
    dir.create(tmp)
    saveObjectFile(tmp, "foobar")
    expect_error(validateObject(tmp), "foobar");

    registerValidateObjectFunction("foobar", function(path, metadata) {})
    expect_error(validateObject(tmp), NA);

    registerValidateObjectFunction("foobar", function(path, metadata) { stop("YAY") }, existing="old")
    expect_error(validateObject(tmp), NA);

    registerValidateObjectFunction("foobar", function(path, metadata) { stop("YAY") }, existing="new")
    expect_error(validateObject(tmp), "YAY");

    expect_error(registerValidateObjectFunction("foobar", function(path, metadata) { stop("YAY") }, existing="error"), "already been registered")

    registerValidateObjectFunction("foobar", NULL)
    expect_error(validateObject(tmp), "foobar");
})

test_that("height registration works as expected", {
    library(S4Vectors)
    X <- DataFrame(X=S4Vectors::I(DataFrame(Y=1:10)))
    tmp <- tempfile()
    saveObject(X, tmp)

    saveObjectFile(file.path(tmp, "other_columns", "0"), "foobar", list())
    registerValidateObjectFunction("foobar", function(path, metadata) {})
    on.exit(registerValidateObjectFunction("foobar", NULL))

    expect_error(validateObject(tmp), "no registered 'height'");

    registerValidateObjectHeightFunction("foobar", function(path, metadata) { nrow(X) })
    expect_error(validateObject(tmp), NA);

    registerValidateObjectHeightFunction("foobar", NULL)
    expect_error(validateObject(tmp), "no registered 'height'");
})

test_that("dimensions registration works as expected", {
    # Don't have an object that calls dimensions() at the C++ level, so we just
    # check that the registration works correctly.
    registerValidateObjectDimensionsFunction("foobar", function(path, metadata) c(1L, 2L))
    expect_true(registerValidateObjectDimensionsFunction("foobar", NULL))
})

test_that("conversion from R list to C++ JSON during validation works as expected", {
    ncols <- 123
    df <- DataFrame(
        stuff = rep(LETTERS[1:3], length.out=ncols),
        whee = as.numeric(10 + seq_len(ncols))
    )

    tmp <- tempfile()
    saveObject(df, tmp)
    expect_error(validateObject(tmp), NA)

    meta <- readObjectFile(tmp)
    expect_error(validateObject(tmp, metadata=meta), NA)

    meta$type <- "FOO"
    expect_error(validateObject(tmp, metadata=meta), "no registered 'validate'")
})

test_that("conversion from C++ JSON to R list during validation works as expected", {
    registerValidateObjectFunction("foobar", function(path, metadata) { 
        stopifnot(metadata$type == "foobar")
        if (metadata$foobar==2) {
            stop("ARGGGGH")
        }
    })
    on.exit(registerValidateObjectFunction("foobar", NULL))

    tmp <- tempfile()
    dir.create(tmp)
    saveObjectFile(tmp, "foobar", list(foobar=3))
    expect_error(validateObject(tmp), NA);

    saveObjectFile(tmp, "foobar", list(foobar=2))
    expect_error(validateObject(tmp), "ARGGGGH");
})

test_that("interface registration works as expected", {
    library(S4Vectors)
    X <- DataFrame(X=S4Vectors::I(DataFrame(Y=1:10)))
    tmp <- tempfile()
    saveObject(X, tmp)

    mtmp <- file.path(tmp, "other_annotations")
    dir.create(mtmp)
    saveObjectFile(mtmp, "foobar")

    expect_error(validateObject(tmp), "'SIMPLE_LIST' interface");
    registerValidateObjectSatisfiesInterface("foobar", "SIMPLE_LIST")
    on.exit(registerValidateObjectSatisfiesInterface("foobar", "SIMPLE_LIST", action="remove"), add=TRUE, after=FALSE)

    expect_error(validateObject(tmp), "no registered 'validate'");
    registerValidateObjectFunction("foobar", function(path, metadata) {})
    on.exit(registerValidateObjectFunction("foobar", NULL), add=TRUE, after=FALSE)

    expect_error(validateObject(tmp), NA)

    registerValidateObjectSatisfiesInterface("foobar", "SIMPLE_LIST", action="remove")
    expect_error(validateObject(tmp), "'SIMPLE_LIST' interface");
})

#' Load all non-child objects in a directory
#'
#' \emph{WARNING: this function is deprecated, use \code{\link{listObjects}} and loop over entries with \code{\link{readObject}} instead.}
#' As the title suggests, this function loads all non-child objects in a staging directory.
#' All loading is performed using \code{\link{altLoadObject}} to respect any application-specific overrides.
#' Children are used to assemble their parent objects and are not reported here.
#'
#' @param dir String containing a path to a staging directory.
#' @param redirect.action String specifying how redirects should be handled:
#' \itemize{
#' \item \code{"to"} will report an object at the redirection destination, not the redirection source.
#' \item \code{"from"} will report an object at the redirection source(s), not the destination.
#' \item \code{"both"} will report an object at both the redirection source(s) and destination.
#' }
#'
#' @return 
#' A named list is returned containing all (non-child) R objects in \code{dir}.
#'
#' @author Aaron Lun
#' @examples
#' tmp <- tempfile()
#' dir.create(tmp)
#'
#' library(S4Vectors)
#' df <- DataFrame(A=1:10, B=LETTERS[1:10])
#' meta <- stageObject(df, tmp, path="whee")
#' writeMetadata(meta, tmp)
#'
#' ll <- list(A=1, B=LETTERS, C=DataFrame(X=1:5))
#' meta <- stageObject(ll, tmp, path="stuff")
#' writeMetadata(meta, tmp)
#'
#' redirect <- createRedirection(tmp, "whoop", "whee/simple.csv.gz")
#' writeMetadata(redirect, tmp)
#' 
#' all.meta <- loadDirectory(tmp)
#' str(all.meta) 
#'
#' @export
loadDirectory <- function(dir, redirect.action = c("from", "to", "both")) {
    all.meta <- listDirectory(dir, ignore.children=TRUE)

    collected <- list()
    redirects <- list()

    for (m in all.meta) {
        if (startsWith(m[["$schema"]], "redirection/")) {
            redirects[[m$path]] <- m$redirection$targets[[1]]$location
        } else if (!isTRUE(m$is_child)) {
            collected[[m$path]] <- altLoadObject(m, dir)
        }
    }

    redirect.action <- match.arg(redirect.action)
    if (redirect.action == "to") {
        return(collected)
    }

    host <- names(redirects)
    targets <- unlist(redirects, use.names=FALSE)

    m <- match(targets, names(collected))
    keep <- !is.na(m)
    m <- m[keep]
    host <- host[keep]

    if (length(m) == 0) {
        return(collected)
    }

    copies <- collected[m]
    names(copies) <- host

    if (redirect.action == "from") {
        collected <- collected[-m]
    }
    return(c(collected, copies))
}

# Test loadDirectory on various bits and pieces.
# library(testthat); library(alabaster.base); source("test-loadDirectory.R")

tmp <- tempfile()
dir.create(tmp)

library(S4Vectors)
df <- DataFrame(A=1:10, B=LETTERS[1:10])
meta <- stageObject(df, tmp, path="whee")
writeMetadata(meta, tmp)

ll <- list(A=1, B=LETTERS, C=DataFrame(X=1:5))
meta <- stageObject(ll, tmp, path="stuff")
writeMetadata(meta, tmp)

redirect <- createRedirection(tmp, "whoop", "whee/simple.csv.gz")
writeMetadata(redirect, tmp)

test_that("listDirectory works as expected", {
    all.meta <- listDirectory(tmp, ignore.children=FALSE)
    paths <- vapply(all.meta, function(x) x$path, "")
    is_child <- vapply(all.meta, function(x) isTRUE(x$is_child), TRUE)
    expect_identical(unname(paths), names(all.meta))
    expect_true(any(is_child))

    child.meta <- listDirectory(tmp, ignore.children=TRUE)
    all.meta <- all.meta[!is_child]
    expect_identical(child.meta, all.meta)
    expect_true(length(child.meta) > 0)
})

test_that("loadDirectory works as expected", {
    all.obj <- loadDirectory(tmp, redirect.action="both")
    expect_identical(all.obj[["whoop"]], df)
    expect_identical(all.obj[["stuff/list.json.gz"]], ll)
    expect_identical(all.obj[["whee/simple.csv.gz"]], df)

    to.obj <- loadDirectory(tmp, redirect.action="to")
    expect_identical(to.obj, all.obj[setdiff(names(all.obj), "whoop")])

    from.obj <- loadDirectory(tmp, redirect.action="from")
    expect_identical(from.obj, all.obj[setdiff(names(all.obj), "whee/simple.csv.gz")])
})

#' Make an absolute file path
#'
#' Create an absolute file path from a relative file path.
#' All processing is purely lexical; the path itself does not have to exist on the filesystem.
#'
#' @param path String containing an absolute or relative file path.
#'
#' @return An absolute file path corresponding to \code{path}.
#' This is cleaned to remove \code{..}, \code{.} and \code{~} components.
#'
#' @author Aaron Lun
#'
#' @examples
#' absolutizePath("alpha")
#' absolutizePath("../alpha")
#' absolutizePath("../../alpha/./bravo")
#' absolutizePath("/alpha/bravo")
#' 
#' @export
absolutizePath <- function(path) {
    tmp <- path
    decomposed <- decompose_path(path)

    if (decomposed$relative) {
        # getwd() always returns an absolute path,
        # so the combined components will also be absolute.
        wd <- decompose_path(getwd())
        root <- wd$root
        comp <- c(wd$components, decomposed$components)
    } else {
        root <- decomposed$root
        comp <- decomposed$components
    }

    # Cleaning the path.
    cleaned <- character()
    for (x in comp) {
        if (x == "..") {
            cleaned <- head(cleaned, -1)
        } else if (x != ".") {
            cleaned <- c(cleaned, x)
        }
    }

    paste0(root, do.call(file.path, as.list(cleaned)))
}

# library(testthat); library(alabaster.base); source('test-cloneFile.R')

test_that("cloneFile works with copies", {
    src <- tempfile()
    dir.create(src)
    write(file=file.path(src, "foobar.txt"), LETTERS)

    dest <- tempfile()
    cloneFile(file.path(src, "foobar.txt"), dest, action="copy")
    expect_identical(readLines(dest), LETTERS) 

    # These are real copies; modifications do not affect the original.
    write(file=dest, letters, append=TRUE)
    expect_identical(readLines(dest), c(LETTERS, letters)) 
    expect_identical(readLines(file.path(src, "foobar.txt")), LETTERS)
})

test_that("cloneFile works with links", {
    src <- tempfile()
    dir.create(src)
    write(file=file.path(src, "foobar.txt"), LETTERS)

    dest <- tempfile()
    cloneFile(file.path(src, "foobar.txt"), dest, action="link")
    expect_identical(readLines(dest), LETTERS) 

    # These are now linked copies; modifications do affect the original!
    write(file=dest, letters, append=TRUE)
    expect_identical(readLines(dest), c(LETTERS, letters)) 
    expect_identical(readLines(file.path(src, "foobar.txt")), c(LETTERS, letters)) 
})

test_that("cloneFile works with symlinks", {
    skip_on_os("windows")

    src <- tempfile()
    dir.create(src)
    write(file=file.path(src, "foobar.txt"), LETTERS)

    dest <- tempfile()
    cloneFile(file.path(src, "foobar.txt"), dest, action="symlink")
    expect_identical(readLines(dest), LETTERS) 

    cleaned <- absolutizePath(src)
    expect_identical(Sys.readlink(dest), file.path(cleaned, "foobar.txt"))

    # Check that it still works if we provide a relative path to the target.
    pwd <- getwd()
    setwd(src)
    on.exit(setwd(pwd))

    dest <- tempfile()
    cloneFile("foobar.txt", dest, action="symlink")
    expect_identical(readLines(dest), LETTERS) 
    expect_identical(Sys.readlink(dest), file.path(cleaned, "foobar.txt"))
})

test_that("cloneFile symlinks and copies/hardlinks interact correctly", {
    skip_on_os("windows")

    src0 <- tempfile()
    dir.create(src0)
    write(file=file.path(src0, "foobar.txt"), LETTERS)

    src <- tempfile()
    dir.create(src)
    file.symlink(file.path(src0, "foobar.txt"), file.path(src, "foobar.txt"))

    dest1 <- tempfile()
    cloneFile(file.path(src, "foobar.txt"), dest1, action="link")
    expect_identical(readLines(dest1), LETTERS) 
    expect_identical(Sys.readlink(dest1), "")

    dest2 <- tempfile()
    cloneFile(file.path(src, "foobar.txt"), dest2, action="copy")
    expect_identical(readLines(dest2), LETTERS) 
    expect_identical(Sys.readlink(dest2), "")

    # Checking what happens if the test directory has relative symlinks.
    src2 <- tempfile()
    dir.create(file.path(src2, "stuff", "blah"), recursive=TRUE)
    write(file=file.path(src2, "foobar.txt"), LETTERS)
    file.symlink(file.path("..", "..", "foobar.txt"), file.path(src2, "stuff", "blah", "kanon.txt"))

    dest3 <- tempfile()
    cloneFile(file.path(src2, "stuff", "blah", "kanon.txt"), dest3, action="link")
    expect_identical(readLines(dest3), LETTERS) 
    expect_identical(Sys.readlink(dest3), "")
})

test_that("cloneFile works with relative symlinks", {
    skip_on_os("windows")

    workspace <- tempfile()
    dir.create(workspace)
    src <- file.path(workspace, "A")
    dir.create(src)
    write(file=file.path(src, "foobar.txt"), LETTERS)

    destdir <- file.path(workspace, "B")
    dest <- file.path(destdir, "foobar.txt")
    cloneFile(file.path(src, "foobar.txt"), dest, action="relsymlink")
    expect_identical(readLines(dest), LETTERS) 
    expect_identical(Sys.readlink(dest), file.path("..", "A", "foobar.txt"))
})

# library(alabaster.base); library(testthat); source("test-absolutizePath.R")

test_that("absolutizePath cleans the path", {
    expect_false(grepl("~", absolutizePath("~")))

    tmp <- tempfile()
    write(file=tmp, letters)

    path <- absolutizePath(file.path(dirname(tmp), ".", basename(tmp)))
    expect_false(grepl("/\\./", path))
    expect_identical(readLines(path), letters)
    if (.Platform$OS.type == "unix") {
        expect_true(startsWith(path, "/"))
    }

    path <- absolutizePath(file.path(dirname(tmp), "super", "..", basename(tmp)))
    expect_false(grepl("/\\.\\./", path))
    expect_identical(readLines(path), letters)
    if (.Platform$OS.type == "unix") {
        expect_true(startsWith(path, "/"))
    }
})

test_that("absolutizePath resolves relative paths", {
    pwd <- getwd()
    on.exit(setwd(pwd))
    tmp <- tempfile()
    setwd(dirname(tmp))

    path <- absolutizePath(".")
    expect_false(path == ".")
    expect_identical(normalizePath(path), normalizePath(dirname(tmp)))

    write(file=tmp, letters)
    path <- absolutizePath(basename(tmp))
    expect_false(path == basename(tmp))
    expect_identical(readLines(path), letters)
    if (.Platform$OS.type == "unix") {
        expect_true(startsWith(path, "/"))
    }

    # Works with leading '..' references.
    tmp2 <- tempfile(tmpdir=dirname(tmp))
    dir.create(basename(tmp2), showWarnings=FALSE)
    setwd(basename(tmp2))
    path2 <- absolutizePath(file.path("..", basename(tmp)))
    expect_false(startsWith(path2, ".."))
    expect_identical(path, path2)
})

#' Save R-level metadata to disk
#'
#' Save \code{\link[S4Vectors]{metadata}} and \code{\link[S4Vectors]{mcols}} for \link[S4Vectors]{Annotated} or \link[S4Vectors]{Vector} objects, respectively, to disk.
#' These are typically used inside \code{\link{saveObject}} methods for concrete subclasses.
#'
#' @param x A \link[S4Vectors]{Vector} or \link[S4Vectors]{Annotated} object.
#' @param metadata.path String containing the path in which to save the \code{metadata}.
#' If \code{NULL}, no \code{\link[S4Vectors]{metadata}} is saved.
#' @param mcols.path String containing the path in which to save the \code{mcols}.
#' If \code{NULL}, no \code{\link[S4Vectors]{mcols}} is saved.
#' @param ... Further arguments to be passed to \code{\link{altSaveObject}}.
#'
#' @author Aaron Lun
#'
#' @return 
#' The metadata for \code{x} is saved to \code{metadata.path}, and similarly for the \code{mcols}.
#'
#' @details
#' If \code{mcols(x)} has no columns, nothing is saved by \code{saveMcols}.
#' Similarly, if \code{metadata(x)} is an empty list, nothing is saved by \code{saveMetadata}.
#' This avoids creating unnecessary files with no meaningful content.
#'
#' If \code{mcols(x)} has non-\code{NULL} row names, these are removed prior to staging.
#' These names are usually redundant with the names associated with elements of \code{x} itself.
#'
#' @seealso
#' \code{\link{readMetadata}}, which restores metadata to the object.
#' 
#' @export
#' @aliases .processMetadata .processMcols processMetadata processMcols
#' @importFrom S4Vectors metadata
saveMetadata <- function(x, metadata.path, mcols.path, ...) {
    if (!is.null(metadata.path)) {
        mm <- metadata(x)
        if (!is.null(mm) && length(mm)) {
            tryCatch({
                altSaveObject(mm, metadata.path, ...)
            }, error=function(e) stop("failed to stage 'metadata(<", class(x)[1], ">)'\n  - ", e$message))
        }
    }

    if (!is.null(mcols.path)) {
        mc <- mcols(x, use.names=FALSE)
        if (!is.null(mc) && ncol(mc)) {
            rownames(mc) <- NULL # stripping out unnecessary row names.
            output <- tryCatch({
                altSaveObject(mc, mcols.path, ...)
            }, error=function(e) stop("failed to stage 'mcols(<", class(x)[1], ">)'\n  - ", e$message))
        }
    }
}

#######################################
########### OLD STUFF HERE ############
#######################################

#' @export
#' @importFrom S4Vectors metadata
processMetadata <- function(x, dir, path, meta.name) {
    if (!is.null(meta.name) && length(metadata(x))) {
        tryCatch({
            meta <- altStageObject(metadata(x), dir, paste0(path, "/", meta.name), child=TRUE) 
            list(resource=writeMetadata(meta, dir=dir))
        }, error=function(e) stop("failed to stage 'metadata(<", class(x)[1], ">)'\n  - ", e$message))
    } else { 
        NULL
    }
}

#' @export
#' @importFrom S4Vectors mcols
processMcols <- function(x, dir, path, mcols.name) {
    output <- NULL

    if (!is.null(mcols.name)) {
        mc <- mcols(x, use.names=FALSE)
        if (!is.null(mc) && ncol(mc)) {
            rownames(mc) <- NULL # stripping out unnecessary row names.
            output <- tryCatch({
                meta <- altStageObject(mc, dir, paste0(path, "/", mcols.name), child=TRUE) 
                list(resource=writeMetadata(meta, dir=dir))
            }, error=function(e) stop("failed to stage 'mcols(<", class(x)[1], ">)'\n  - ", e$message))
        }
    }

    return(output)
}

# Soft-deprecated back-compatibility fixes

#' @export
.processMetadata <- function(...) processMetadata(...)

#' @export
.processMcols <- function(...) processMcols(...)

#' Validate a directory of objects
#'
#' Check whether each object in a directory is valid by calling \code{\link{validateObject}} on each non-child object.
#'
#' @param dir String containing the path to a directory with subdirectories populated by \code{\link{saveObject}}.
#' @param legacy Logical scalar indicating whether to validate a directory with legacy objects (created by the old \code{stageObject}).
#' If \code{NULL}, this is auto-detected from the contents of \code{dir}.
#' @param ... Further arguments to use when \code{legacy=TRUE}, for back-compatibility only.
#'
#' @return Character vector of the paths inside \code{dir} that were validated, invisibly.
#' If any validation failed, an error is raised.
#'
#' @details
#' We assume that the process of validating an object will call \code{\link{validateObject}} on any child objects.
#' This allows us to skip explicit calls to \code{\link{validateObject}} on each component of a complex object. 
#'
#' @author Aaron Lun
#' @examples
#' # Mocking up an object:
#' library(S4Vectors)
#' ncols <- 123
#' df <- DataFrame(
#'     X = rep(LETTERS[1:3], length.out=ncols),
#'     Y = runif(ncols)
#' )
#' df$Z <- DataFrame(AA = sample(ncols))
#'
#' # Mocking up the directory:
#' tmp <- tempfile()
#' dir.create(tmp, recursive=TRUE)
#' saveObject(df, file.path(tmp, "foo"))
#' 
#' # Checking that it's valid:
#' validateDirectory(tmp)
#'
#' # Adding an invalid object:
#' dir.create(file.path(tmp, "bar"))
#' write(file=file.path(tmp, "bar", "OBJECT"), '[ "WHEEE" ]')
#' try(validateDirectory(tmp))
#'
#' @aliases checkValidDirectory
#' @export
validateDirectory <- function(dir, legacy=NULL, ...) {
    if (is.null(legacy)) {
        legacy <- length(list.files(dir, recursive=TRUE, pattern="^OBJECT$")) == 0L
    }

    if (!legacy) {
        objects <- listObjects(dir)
        for (x in objects$path) {
            tryCatch(validateObject(file.path(dir, x)), error=function(e) stop("failed to validate '", x, "'; ", e$message))
        }
        invisible(objects$path)
    } else {
        legacy.validateDirectory(dir, ...)
    }
}

legacy.validateDirectory <- function(dir, validate.metadata = TRUE, schema.locations = NULL, attempt.load = FALSE) {
    all.files <- list.files(dir, recursive=TRUE)
    is.json <- endsWith(all.files, ".json")
    meta.files <- all.files[is.json]
    other.files <- all.files[!is.json]

    schema.paths <- list()
    if (is.null(schema.locations)) {
        schema.locations <- .default_schema_locations()
    }

    # Opening all the metadata files.
    am.child <- character(0)
    not.child <- character(0)
    expected.child <- character(0)
    redirects <- character(0)

    for (metapath in meta.files) {
        jpath <- file.path(dir, metapath)
        meta <- fromJSON(jpath, simplifyVector=TRUE, simplifyMatrix=FALSE, simplifyDataFrame=FALSE)

        schema.id <- meta[["$schema"]]
        if (validate.metadata) {
            if (!(schema.id %in% schema.paths)) {
                schema.path <- .hunt_for_schemas(meta[["$schema"]], schema.locations)
                schema.paths[[schema.id]] <- schema.path
            } 
            schema.path <- schema.paths[[schema.id]]

            tryCatch(
                jsonvalidate::json_validate(jpath, schema.path, error=TRUE, engine="ajv"), 
                error=function(e) {
                    stop("failed to validate metadata at '", jpath, "'\n  - ", e$message)
                }
            )
        }

        # Special case for redirections
        if (startsWith(schema.id, "redirection/")) {
            if (paste0(meta$path, ".json") != metapath) {
                stop("metadata in '", metapath, "' references an unexpected path '", meta$path, "'")
            }
            if (meta$path %in% all.files) {
                stop("metadata in '", metapath, "' contains a redirection from existing path '", meta$path, "'")
            }
            for (target in meta[["redirection"]][["targets"]]) {
                if (target$type == "local") {
                    redirects <- c(redirects, target$location)
                }
            }
            next
        }

        # Checking the path.
        if (!(meta$path %in% all.files)) {
            stop("metadata in '", metapath, "' references a non-existent path '", meta$path, "'")
        }
        if (meta$path != metapath && paste0(meta$path, ".json") != metapath) {
            stop("metadata in '", metapath, "' references an unexpected path '", meta$path, "'")
        }

        if (!isTRUE(meta$is_child)) {
            not.child <- c(not.child, meta$path)
            if (attempt.load) {
                tryCatch(
                    altLoadObject(meta, dir),
                    error=function(e) {
                        stop("failed to load non-child object at '", meta$path, "'\n  - ", e$message)
                    }
                )
            }
        } else {
            am.child <- c(am.child, meta$path)
        }

        # Checking that all children live in subdirectories of metapath's directory, not at the top level.
        children <- .fetch_resource_paths(meta)
        subdir.prefix <- paste0(dirname(metapath), "/")
        if (any(nonnest <- !startsWith(dirname(children), subdir.prefix))) { 
            stop("metadata in '", metapath, "' references non-nested child '", children[nonnest][1], "'") 
        }

        expected.child <- c(expected.child, children)
    }

    # Checking that all children are not marked as non-children.
    conflicts <- intersect(expected.child, not.child)
    if (length(conflicts)) {
        stop("non-child object in '", conflicts[1], "' is referenced by another object")
    }

    if (dup <- anyDuplicated(expected.child)) {
        stop("multiple references to child at '", expected.child[dup], "'")
    }

    missing.child <- setdiff(expected.child, am.child)
    if (length(missing.child)) {
        stop("missing child object '", missing.child[1], "'")
    }

    extra.child <- setdiff(am.child, expected.child)
    if (length(extra.child)) {
        stop("non-referenced child object in '", extra.child[1], "'")
    }

    extra.other <- setdiff(other.files, c(am.child, not.child))
    if (length(extra.other)) {
        stop("unknown file at '", extra.other[1], "'")
    }

    # Checking that non-children are not nested within each other.
    safe.set <- "."
    offenders <- sort(dirname(not.child))
    for (i in seq_along(offenders)) {
        if (i > 1 && startsWith(offenders[i], paste0(offenders[i-1], "/"))) {
            stop("non-child object at '", offenders[i], "' is nested inside the directory of '", offenders[i-1], "'")
        }
    }

    # Checking that redirects are valid.
    dangling.direct <- !(redirects %in% am.child) & !(redirects %in% not.child)
    if (any(dangling.direct)) {
        stop("invalid redirection to '", dangling.direct[1], "'")
    }
}

.fetch_resource_paths <- function(x) {
    if (!is.list(x)) {
        return(NULL)
    }

    if (!is.null(names(x))) {
        is.res <- which(names(x) == "resource")
        if (length(is.res)) {
            return(x[[is.res[1]]]$path)
        } 
    }

    collected <- character(0)
    for (i in seq_along(x)) {
        collected <- c(collected, .fetch_resource_paths(x[[i]]))
    }
    collected
}

# Soft-deprecated back-compatibility fixes.

#' @export
checkValidDirectory <- function(...) validateDirectory(...)

# This adds some tests for writeMetadata.
# library(testthat); library(alabaster.base); source("test-validateDirectory.R")

library(S4Vectors)
ncols <- 123
df <- DataFrame(
    X = rep(LETTERS[1:3], length.out=ncols),
    Y = runif(ncols)
)
df$Z <- DataFrame(AA = sample(ncols))

test_that("validateDirectory works as expected", {
    tmp <- tempfile()
    dir.create(tmp, recursive=TRUE)

    # Mocking up a directory.
    writeMetadata(stageObject(df, tmp, "foo"), tmp)
    writeMetadata(stageObject(df, tmp, "bar"), tmp)
    dir.create(file.path(tmp, "whee"))
    writeMetadata(stageObject(df, tmp, "whee/stuff"), tmp)
    writeMetadata(createRedirection(tmp, "whee/stuff", "whee/stuff/simple.csv.gz"), tmp)

    expect_error(validateDirectory(tmp), NA)
})

test_that("validateDirectory works as expected in the new world", {
    tmp <- tempfile()
    dir.create(tmp, recursive=TRUE)

    # Mocking up a directory.
    saveObject(df, file.path(tmp, "foo"))
    dir.create(file.path(tmp, "whee"))
    saveObject(df, file.path(tmp, "whee", "stuff"))

    expect_error(validateDirectory(tmp), NA)
})

test_that("validateDirectory throws with invalid metadata", {
    tmp <- tempfile()
    dir.create(tmp, recursive=TRUE)
    info <- stageObject(df, tmp, "foo")

    info2 <- info
    info2$data_frame$YAY <- TRUE
    write(file=file.path(tmp, paste0(info$path, ".json")), jsonlite::toJSON(info2, pretty=TRUE, auto_unbox=TRUE, digits=NA))

    expect_error(validateDirectory(tmp), "data_frame")
    expect_error(validateDirectory(tmp, validate.metadata=FALSE), NA)
})

test_that("validateDirectory throws with invalid objects", {
    tmp <- tempfile()
    dir.create(tmp, recursive=TRUE)
    info <- stageObject(df, tmp, "foo")
    writeMetadata(info, tmp)
    write(file=file.path(tmp, info$path), "YAAAA")

    expect_error(validateDirectory(tmp), NA)
    expect_error(validateDirectory(tmp, attempt.load=TRUE), "foo/simple.csv.gz")
})

test_that("validateDirectory throws in the new world", {
    tmp <- tempfile()
    dir.create(tmp, recursive=TRUE)

    # Mocking up a directory.
    saveObject(df, file.path(tmp, "foo"))
    dir.create(file.path(tmp, "bar"))
    write(file=file.path(tmp, "bar", "OBJECT"), '[ "WHEEE" ]')

    expect_error(validateDirectory(tmp), "JSON object")
})

test_that("validateDirectory throws with inconsistent paths", {
    {
        tmp <- tempfile()
        dir.create(tmp, recursive=TRUE)

        # Path does not match the JSON file name.
        writeMetadata(stageObject(df, tmp, "foo"), tmp)
        file.rename(file.path(tmp, "foo/simple.csv.gz.json"), file.path(tmp, "foo/simple2.csv.gz.json"))

        expect_error(validateDirectory(tmp), "unexpected path")
    }

    {
        tmp <- tempfile()
        dir.create(tmp, recursive=TRUE)

        # Path does not exist.
        writeMetadata(stageObject(df, tmp, "foo"), tmp)
        file.remove(file.path(tmp, "foo/simple.csv.gz"))

        expect_error(validateDirectory(tmp), "non-existent path")
    }
})

test_that("validateDirectory throws with non-nested children", {
    {
        tmp <- tempfile()
        dir.create(tmp, recursive=TRUE)

        meta <- stageObject(df, tmp, "foo")
        oldnest <- meta$data_frame$columns[[3]]$resource$path

        newnest <- file.path("whee", basename(oldnest))
        meta$data_frame$columns[[3]]$resource$path <- newnest
        file.rename(file.path(tmp, dirname(oldnest)), file.path(tmp, "whee"))

        writeMetadata(meta, tmp)

        expect_error(validateDirectory(tmp), "references non-nested child")
    }

    # This time, a more subtle error because it doesn't belong in a subdirectory.
    {
        tmp <- tempfile()
        dir.create(tmp, recursive=TRUE)

        meta <- stageObject(df, tmp, "foo")
        oldnest <- meta$data_frame$columns[[3]]$resource$path

        newnest <- "foo/zzzz.csv.gz"
        meta$data_frame$columns[[3]]$resource$path <- newnest
        file.rename(file.path(tmp, oldnest), file.path(tmp, newnest))
        file.rename(file.path(tmp, paste0(oldnest, ".json")), file.path(tmp, paste0(newnest, '.json')))

        writeMetadata(meta, tmp)

        expect_error(validateDirectory(tmp), "references non-nested child")
    }
})

test_that("validateDirectory throws with non-child references", {
    tmp <- tempfile()
    dir.create(tmp, recursive=TRUE)

    meta <- stageObject(df, tmp, "foo")
    writeMetadata(meta, tmp)

    child <- meta$data_frame$columns[[3]]$resource$path
    target <- file.path(tmp, paste0(child, ".json"))
    writeLines(sub("\"is_child\": true", "\"is_child\": false", readLines(target)), con=target)

    expect_error(validateDirectory(tmp), "non-child object.*is referenced")
})

test_that("validateDirectory throws with multiple child references", {
    tmp <- tempfile()
    dir.create(tmp, recursive=TRUE)

    meta <- stageObject(df, tmp, "foo")
    meta$data_frame$columns <- meta$data_frame$columns[c(1,2,3,3)]
    writeMetadata(meta, tmp)

    expect_error(validateDirectory(tmp), "multiple references to child at")
})

test_that("validateDirectory throws with missing child object", {
    tmp <- tempfile()
    dir.create(tmp, recursive=TRUE)

    meta <- stageObject(df, tmp, "foo")
    writeMetadata(meta, tmp)

    file.remove(file.path(tmp, paste0(meta$data_frame$columns[[3]]$resource$path, ".json")))
    expect_error(validateDirectory(tmp), "missing child object")
})

test_that("validateDirectory throws with extra child object", {
    tmp <- tempfile()
    dir.create(tmp, recursive=TRUE)

    meta <- stageObject(df, tmp, "foo")
    meta$data_frame$columns <- meta$data_frame$columns[c(1,2)]
    writeMetadata(meta, tmp)

    expect_error(validateDirectory(tmp), "non-referenced child object")
})

test_that("validateDirectory throws with nested non-child object", {
    tmp <- tempfile()
    dir.create(tmp, recursive=TRUE)

    meta <- stageObject(df, tmp, "foo")
    child <- meta$data_frame$columns[[3]]$resource$path
    meta$data_frame$columns <- meta$data_frame$columns[c(1,2)]
    writeMetadata(meta, tmp)

    # Converting it into a non-child.
    target <- file.path(tmp, paste0(child, ".json"))
    writeLines(sub("\"is_child\": true", "\"is_child\": false", readLines(target)), con=target)

    expect_error(validateDirectory(tmp), "non-child object.*is nested")
})

test_that("validateDirectory throws with random extra objects", {
    tmp <- tempfile()
    dir.create(tmp, recursive=TRUE)

    meta <- stageObject(df, tmp, "foo")
    writeMetadata(meta, tmp)
    writeLines(con=file.path(tmp, "foo", "bar.txt"), letters)

    expect_error(validateDirectory(tmp), "unknown file")
})

test_that("validateDirectory handles redirects correctly", {
    {
        tmp <- tempfile()
        dir.create(tmp, recursive=TRUE)

        # Mocking up a directory.
        writeMetadata(stageObject(df, tmp, "foo"), tmp)
        red <- createRedirection(tmp, "foo", "foo/simple.csv.gz")
        red$path <- "whee"
        writeMetadata(red, tmp)
        file.rename(file.path(tmp, "whee.json"), file.path(tmp, "foo.json"))

        expect_error(validateDirectory(tmp), "references an unexpected path")
    }

    {
        tmp <- tempfile()
        dir.create(tmp, recursive=TRUE)

        # Mocking up a directory.
        writeMetadata(stageObject(df, tmp, "foo"), tmp)
        red <- createRedirection(tmp, "foo", "foo/simple.csv.gz")
        red$path <- "foo/simple.csv.gz"
        writeMetadata(red, tmp)

        expect_error(validateDirectory(tmp), "redirection from existing path")
    }

    {
        tmp <- tempfile()
        dir.create(tmp, recursive=TRUE)

        # Mocking up a directory.
        writeMetadata(stageObject(df, tmp, "foo"), tmp)
        red <- createRedirection(tmp, "foo", "foo/whee.csv.gz")
        writeMetadata(red, tmp)

        expect_error(validateDirectory(tmp), "invalid redirection")
    }
})

#' Quickly read and write a CSV file
#'
#' Quickly read and write a CSV file, usually as a part of staging or loading a larger object.
#' This assumes that all files follow the \href{https://github.com/ArtifactDB/comservatory}{comservatory} specification.
#'
#' @param path String containing a path to a CSV to read/write.
#' @param expected.columns Named character vector specifying the type of each column in the CSV (excluding the first column containing row names, if \code{row.names=TRUE}).
#' @param row.names For \code{.quickReadCsv}, a logical scalar indicating whether the CSV contains row names. 
#'
#' For \code{.quickWriteCsv}, a logical scalar indicating whether to save the row names of \code{df}.
#' @param parallel Whether reading and parsing should be performed concurrently.
#' @param expected.nrows Integer scalar specifying the expected number of rows in the CSV.
#' @param compression String specifying the compression that was/will be used.
#' This should be either \code{"none"}, \code{"gzip"}.
#' @param df A \link[S4Vectors]{DFrame} or data.frame object, containing only atomic columns.
#' @param ... Further arguments to pass to \code{\link{write.csv}}.
#' @param validate Whether to double-check that the generated CSV complies with the comservatory specification.
#'
#' @author Aaron Lun
#' 
#' @return For \code{.quickReadCsv}, a \link[S4Vectors]{DFrame} containing the contents of \code{path}.
#'
#' For \code{.quickWriteCsv}, \code{df} is written to \code{path} and a \code{NULL} is invisibly returned.
#'
#' @examples
#' library(S4Vectors)
#' df <- DataFrame(A=1, B="Aaron")
#'
#' temp <- tempfile()
#' .quickWriteCsv(df, path=temp, row.names=FALSE, compression="gzip")
#'
#' .quickReadCsv(temp, c(A="numeric", B="character"), 1, "gzip", FALSE)
#' 
#' @export
#' @aliases .quickReadCsv .quickWriteCsv
#' @importFrom S4Vectors DataFrame
quickReadCsv <- function(path, expected.columns, expected.nrows, compression, row.names, parallel=TRUE) {
    df <- read.csv3(path, compression, expected.nrows, parallel)

    if (row.names) {
        if (ncol(df) < 1) {
            stop("expected at least one column in the CSV for row name retrieval")
        }
        rownames(df) <- df[,1]
        df <- df[,-1,drop=FALSE]
    }

    if (ncol(df) != length(expected.columns)) {
        stop("different number of columns in CSV than expected from metadata (", ncol(df), " vs ", length(expected.columns)) 
    }

    for (i in seq_along(expected.columns)) {
        expected.type <- expected.columns[[i]]
        if (!is(df[[i]], expected.type)) {
            before <- is.na(df[[i]])
            df[[i]] <- as(df[[i]], expected.type)
            after <- is.na(df[[i]])
            if (!identical(before, after)) {
                stop("coercion to ", expected.type, " introduced NAs for column ", i, " in the CSV")
            }
        }
    }

    df <- DataFrame(df, check.names=FALSE)
    colnames(df) <- names(expected.columns)

    df
}

read.csv3 <- function(path, compression, nrows, parallel=TRUE) {
    path <- path.expand(path) # protect C code from '~'.
    df <- load_csv(path, is_compressed=identical(compression, "gzip"), nrecords = nrows, parallel=parallel)
    if (length(df)) {
        df <- data.frame(df, check.names=FALSE)
    } else {
        dummy <- matrix(0, attr(df, "num.records"), 0)
        df <- data.frame(dummy)
    }
    df
}

#' @export
#' @rdname quickReadCsv
#' @importFrom utils write.csv
quickWriteCsv <- function(df, path, ..., row.names=FALSE, compression="gzip", validate=TRUE) {
    .quick_write_csv(df=df, path=path, ..., row.names=row.names, compression=compression)
    if (validate) {
        check_csv(path, is_compressed=identical(compression, "gzip"), parallel=TRUE)
    }
}

.quick_write_csv <- function(df, path, ..., row.names=FALSE, compression="gzip") {
    if (compression == "gzip") {
        handle <- gzfile(path, "wb")
    } else {
        handle <- file(path, "wb")
    }
    on.exit(close(handle))

    if (ncol(df) == 0 && (!row.names || is.null(rownames(df)))) {
        # Avoid creating an empty header.
        writeLines(character(nrow(df) + 1L), sep="\n", con=handle)
    } else {
        to_quote <- !logical(ncol(df))

        # write.table saves NaNs as NA, and setting na= will convert all NA's,
        # so we have to convert to string here and then refuse quoting for those columns.
        for (i in seq_len(ncol(df))) {
            col <- df[[i]]
            if (is.double(col) && anyNA(col) && sum(is.nan(col)) > 0) {
                df[[i]] <- as.character(col)
                to_quote[i] <- FALSE
            }
        }

        if (all(to_quote)) {
            quote <- TRUE
        } else {
            quote <- which(to_quote)
        }
        write.csv(as.data.frame(df), file=handle, row.names=row.names, quote=quote, ..., eol="\n")
    }
}

# Soft-deprecated back-compatibility fixes.

#' @export
.quickReadCsv <- function(...) quickReadCsv(...)

#' @export
.quickWriteCsv <- function(...) quickWriteCsv(...)

# This tests the raw CSV reader in a variety of situations.
# library(testthat); library(alabaster.base); source("test-read.csv.R")

df <- data.frame(
    asdasd = LETTERS[1:10], 
    qwerty = runif(10), 
    stuff = rbinom(10, 1, 0.5) == 1,
    compx = rnorm(10) + rnorm(10) * 1i
)

write.csv2 <- function(file, ...) {
    handle <- file(file, "wb")
    write.csv(file=handle, ..., eol="\n")
    close(handle)
}

test_that("read.csv3 handles the different types correctly", {
    path <- tempfile(fileext=".csv")
    write.csv2(file=path, df, row.names=FALSE)
    out <- alabaster.base:::read.csv3(path, compression="none", nrows=nrow(df))
    expect_equal(df, out)
})

test_that("read.csv3 handles weird names", {
    colnames(df) <- c("asdasd asdasd", "qwerty\nasdasd", "stuff,\"asdasd\"", "compx,5\n\"")
    path <- tempfile(fileext=".csv")
    write.csv2(file=path, df, row.names=FALSE)
    out <- alabaster.base:::read.csv3(path, compression="none", nrows=nrow(df))
    expect_equal(df, data.frame(out, check.names=FALSE))
})

test_that("read.csv3 handles missing values correctly", {
    df[1,1] <- NA
    df[2,2] <- NA
    df[3,3] <- NA
    df[4,4] <- NA

    path <- tempfile(fileext=".csv")
    write.csv2(file=path, df, row.names=FALSE)
    out <- alabaster.base:::read.csv3(path, compression="none", nrows=nrow(df))
    expect_equal(df, data.frame(out, check.names=FALSE))
})

test_that("read.csv3 handles all-missing columns correctly", {
    df$asdasd <- NA
    path <- tempfile(fileext=".csv")
    write.csv2(file=path, df, row.names=FALSE)
    out <- alabaster.base:::read.csv3(path, compression="none", nrows=nrow(df))
    expect_equal(df, data.frame(out, check.names=FALSE))
})

test_that("read.csv3 handles empty DFs correctly", {
    df <- df[0,]

    path <- tempfile(fileext=".csv")
    write.csv2(file=path, df, row.names=FALSE)

    out <- alabaster.base:::read.csv3(path, compression="none", nrows=nrow(df))
    expect_identical(nrow(out), 0L)
    expect_identical(colnames(df), colnames(out))
})

test_that("read.csv3 handles single- and no-column DFs correctly", {
    df <- data.frame(asdasd = 1:10)
    path <- tempfile(fileext=".csv")
    write.csv2(file=path, df, row.names=FALSE)
    out <- alabaster.base:::read.csv3(path, compression="none", nrows=nrow(df))
    expect_equal(df, data.frame(out, check.names=FALSE))

    handle <- file(path, open="wb") # Avoid problems with \r on windows.
    write(character(11), file=handle)
    close(handle)
    out <- alabaster.base:::read.csv3(path, compression="none", nrows=nrow(df))
    expect_equal(df[,0], data.frame(out, check.names=FALSE))
})

test_that("read.csv3 handles gzip'd files correctly", {
    path <- tempfile(fileext=".csv.gz")
    write.csv(file=gzfile(path), df, row.names=FALSE)
    out <- alabaster.base:::read.csv3(path, compression="gzip", nrows=nrow(df))
    expect_equal(df, out)
})

#' Read an object from disk
#'
#' Read an object from its on-disk representation.
#' This is done by dispatching to an appropriate loading function based on the type in the \code{OBJECT} file.
#'
#' @param path String containing a path to a directory, itself created with a \code{\link{saveObject}} method.
#' @param ... Further arguments to pass to individual methods.
#' @param metadata Named list containing metadata for the object - most importantly, the \code{type} field that controls dispatch to the correct loading function.
#' If \code{NULL}, this is automatically read by \code{\link{readObjectFile}(path)}.
#' @param type String specifying the name of type of the object.
#' @param fun A loading function that accepts \code{path}, \code{metadata} and \code{...} (in that order), and returns the associated object.
#' This may also be \code{NULL} to delete an existing entry in the registry.
#' @param existing Logical scalar indicating the action to take if a function has already been registered for \code{type} -
#' keep the old or new function, or throw an error.
#' 
#' @return 
#' For \code{readObject}, an object created from the on-disk representation in \code{path}.
#'
#' For \code{readObjectFunctionRegistry}, a named list of functions used to load each object type.
#'
#' For \code{registerReadObjectFunction}, the function is added to the registry.
#'
#' @section Comments for extension developers:
#' \code{readObject} uses an internal registry of functions to decide how an object should be loaded into memory.
#' Developers of alabaster extensions can add extra functions to this registry, usually in the \code{\link{.onLoad}} function of their packages.
#' Alternatively, extension developers can request the addition of their packages to default registry.
#'
#' If a loading function makes use of additional arguments in \code{...}, 
#' those arguments should be prefixed by the name of the object type for each method, e.g., \code{simple_list.parallel}.
#' This avoids problems with conflicts in the interpretation of identically named arguments between different functions.
#' Unlike the \code{...} arguments in \code{\link{saveObject}}, we prefix by the object type instead of the output class, as the former is used for dispatch here.
#'
#' When writing loading functions for complex classes, extension developers may need to load child objects to compose the output object.
#' In such cases, developers should use \code{\link{altReadObject}} on the child subdirectories, rather than calling \code{readObject} directly.
#' This ensures that any application-level overrides of the loading functions are respected. 
#' It is also expected that arguments in \code{...} are forwarded to internal \code{\link{altReadObject}} calls.
#'
#' Developers can manually control \code{readObject} dispatch by suppling a \code{metadata} list where \code{metadata$type} is set to the desired object type.
#' This pattern is commonly used inside the loading function for a subclass -
#' an instance of the base class is first constructed by an internal \code{readObject} call with the modified \code{metadata$type}, after which the subclass-specific slots are added.
#' (In practice, base construction should be done using \code{\link{altReadObject}} so as to respect application-specific overrides.)
#'
#' @section Comments for application developers:
#' Application developers can override \code{readObject} by specifying a custom function in \code{\link{altReadObject}}.
#' This can be used to point to a different registry of reading functions, to perform pre- or post-reading actions, etc.
#' If customization is type-specific, the custom \code{altReadObject} function can read the type from the \code{OBJECT} file to determine the most appropriate course of action;
#' the \code{OBJECT} metadata can then be passed to the \code{metadata} argument of any internal \code{readObject} calls to avoid a redundant read from the same file.
#'
#' @author Aaron Lun
#' @examples
#' library(S4Vectors)
#' df <- DataFrame(A=1:10, B=LETTERS[1:10])
#'
#' tmp <- tempfile()
#' saveObject(df, tmp)
#' readObject(tmp)
#' 
#' @export
#' @aliases loadObject schemaLocations customloadObjectHelper .loadObjectInternal 
readObject <- function(path, metadata=NULL, ...) {
    if (is.null(metadata)) {
        metadata <- readObjectFile(path)
    }
    type <- metadata$type

    meth <- read.registry$registry[[type]]
    if (is.null(meth)) {
        stop("cannot read unknown object type '", type, "'")
    } else if (is.character(meth)) {
        meth <- eval(parse(text=meth))
        read.registry$registry[[type]] <- meth
    }

    # Setting up the save environment.
    lfun <- loadSaveEnvironment(path)
    on.exit(lfun(), add=TRUE, after=FALSE)

    meth(path, metadata=metadata, ...)
}

read.registry <- new.env()
read.registry$registry <- list(
    atomic_vector="alabaster.base::readAtomicVector",
    string_factor="alabaster.base::readBaseFactor",
    simple_list="alabaster.base::readBaseList",
    data_frame="alabaster.base::readDataFrame",
    data_frame_factor="alabaster.base::readDataFrameFactor",
    dense_array="alabaster.matrix::readArray",
    compressed_sparse_matrix="alabaster.matrix::readSparseMatrix",
    summarized_experiment="alabaster.se::readSummarizedExperiment",
    ranged_summarized_experiment="alabaster.se::readRangedSummarizedExperiment",
    single_cell_experiment="alabaster.sce::readSingleCellExperiment",
    genomic_ranges="alabaster.ranges::readGRanges",
    genomic_ranges_list="alabaster.ranges::readGRangesList",
    data_frame_list="alabaster.ranges::readDataFrameList",
    atomic_vector_list="alabaster.ranges::readAtomicVectorList",
    sequence_information="alabaster.ranges::readSeqinfo",
    multi_sample_dataset="alabaster.mae::readMultiAssayExperiment",
    sequence_string_set="alabaster.string::readXStringSet",
    spatial_experiment="alabaster.spatial::readSpatialExperiment",
    bam_file="alabaster.files::readBamFileReference",
    bcf_file="alabaster.files::readBcfFileReference",
    bigbed_file="alabaster.files::readBigBedFileReference",
    bigwig_file="alabaster.files::readBigWigFileReference",
    bed_file="alabaster.files::readBedFileReference",
    gff_file="alabaster.files::readGffFileReference",
    gmt_file="alabaster.files::readGmtFileReference",
    fasta_file="alabaster.files::readFastaFileReference",
    fastq_file="alabaster.files::readFastqFileReference",
    bumpy_data_frame_array="alabaster.bumpy::readBumpyDataFrameMatrix"
)

#' @export
#' @rdname readObject
readObjectFunctionRegistry <- function() {
    read.registry$registry
}

#' @export
#' @rdname readObject
registerReadObjectFunction <- function(type, fun, existing=c("old", "new", "error")) {
    if (!is.null(fun)) {
        if (!is.null(read.registry$registry[[type]])) {
            existing <- match.arg(existing)
            if (existing == "old") {
                return(invisible(NULL))
            } else if (existing == "error") {
                stop("function has already been registered for object type '", type, "'")
            }
        }
    }
    read.registry$registry[[type]] <- fun
    invisible(NULL)
}

#######################################
########### OLD STUFF HERE ############
#######################################

#' @export
loadObject <- function(info, project, ...) {
    customloadObjectHelper(info, 
        project, 
        ...,
        .locations=.default_schema_locations(),
        .memory=restore.memory
    )
}

restore.memory <- new.env()
restore.memory$cache <- list()

#' @export
#' @importFrom jsonlite fromJSON
customloadObjectHelper <- function(info, project, ..., .locations, .memory, .fallback=NULL) {
    schema <- info[["$schema"]]

    if (is.null(FUN <- .memory$cache[[schema]])) {
        schema.path <- .hunt_for_schemas(schema, .locations, .fallback=.fallback)

        schema.data <- fromJSON(schema.path, simplifyVector=TRUE, simplifyMatrix=FALSE, simplifyDataFrame=FALSE)
        restore <- schema.data[["_attributes"]][["restore"]][["R"]]
        if (is.null(restore)) {
            stop("could not find an R context to restore '", schema, "'")
        }

        FUN <- eval(parse(text=restore))
        .memory$cache[[schema]] <- FUN
    }

    FUN(info, project, ...)
}

#' @export
schemaLocations <- function() {
    .Defunct()
}

#' @import alabaster.schemas
.default_schema_locations <- function() c(getOption("alabaster.schema.locations"), "alabaster.schemas")

.hunt_for_schemas <- function(schema, .locations, .fallback=NULL) {
    schema.path <- "" 
    for (pkg in .locations) {
        schema.path <- system.file("schemas", schema, package=pkg)
        if (schema.path != "") {
            break
        }
    }

    if (schema.path == "") {
        if (is.null(.fallback)) {
            stop("couldn't find the '", schema, "' schema")
        }
        schema.path <- .fallback(schema)
    }

    schema.path
}

# Soft-deprecated backwards compatibility fixes.

#' @export
.loadObjectInternal <- function(...) customloadObjectHelper(...)

# This checks the readObject function and its related registration.
# library(testthat); library(alabaster.base); source("test-readObject.R")

test_that("registerReadObjectFunction works as expected", {
    old <- readObjectFunctionRegistry()$data_frame
    expect_false(is.null(old))
    on.exit(registerReadObjectFunction("data_frame", old, existing="new"))

    # No-op.
    registerReadObjectFunction("data_frame", 2)
    expect_identical(readObjectFunctionRegistry()$data_frame, old)

    # Replacement.
    registerReadObjectFunction("data_frame", "FOOBAR", existing="new")
    expect_identical(readObjectFunctionRegistry()$data_frame, "FOOBAR")

    # Error.
    expect_error(registerReadObjectFunction("data_frame", "YAY", existing="error"), "already been registered")
})

#' Deduplicate objects when saving
#'
#' Utilities for deduplicating objects inside \code{\link{saveObject}} to save time and/or storage space.
#'
#' @param x Some object, typically S4.
#' @param session Session object created by \code{\link{createDedupSession}}.
#' @param path String containing the absolute path to the directory in which \code{x} is to be saved.
#' This will be used for deduplication if another object is identified as a duplicate of \code{x}.
#' If a relative path is provided, it will be converted to an absolute path.
#'
#' @return 
#' \code{createDedupSession} will return a deduplication session that can be modified in-place.
#'
#' If \code{x} is a duplicate of an object in \code{session}, \code{checkObjectInDedupSession} will return a string containing the absolute path to a directory representing that object.
#' Otherwise, it will return \code{NULL}.
#'
#' \code{addObjectToDedupSession} will add \code{x} to \code{session} with the supplied \code{path}.
#' It returns \code{NULL} invisibly.
#'
#' @author Aaron Lun
#'
#' @details
#' These utilities allow extension developers to support deduplication of objects in a top-level call to \code{\link{saveObject}}.
#' For a given \code{saveObject} method, we can:
#' \enumerate{
#' \item Accept a session object in an optional \code{<PREFIX>.dedup.session=} argument.
#' We may also accept a \code{<PREFIX>.dedup.action=} argument to specify how any deduplication should be performed.
#' Some \code{<PREFIX>} prefix should be chosen to avoid conflicts between multiple deduplication sessions.
#' \item If a session argument is provided, we call \code{checkObjectInDedupSession(x, session)} to see if the \code{x} is a duplicate of an existing object in the session.
#' If a path is returned, we call \code{\link{cloneDirectory}} and return.
#' \item Otherwise, we save this object to disk, possibly passing the session argument as \code{<PREFIX>.dedup.session=} in further calls to \code{saveObject} for child objects.
#' We call \code{addObjectToDedupSession} to add the current object to the session.
#' }
#' A user can enable deduplication by passing the output of \code{createDedupSession} to \code{<PREFIX>.dedup.session=} in the top-level call to \code{saveObject}.
#' This is most typically performed when saving SummarizedExperiment objects with multiple assays, where one assay consists of delayed operations on another assay.
#' 
#' @examples
#' test <- function(x, path, test.dedup.session=NULL, test.dedup.action="link") {
#'    if (!is.null(test.dedup.session)) {
#'        original <- checkObjectInDedupSession(x, test.dedup.session)
#'        if (!is.null(original)) {
#'            cloneDirectory(original, path, test.dedup.action)
#'            return(invisible(NULL))
#'        }
#'    }
#'    dir.create(path)
#'    saveRDS(x, file.path(path, "whee.rds")) # replace this with actual saving code.
#'    if (!is.null(test.dedup.session)) {
#'        addObjectToDedupSession(x, test.dedup.session, path)
#'    }
#' }
#'
#' library(S4Vectors)
#' y <- DataFrame(A=1:10, B=1:10)
#' tmp <- tempfile()
#' dir.create(tmp)
#'
#' # Saving the first instance of the object, which is now stored in the session.
#' session <- createDedupSession()
#' checkObjectInDedupSession(y, session) # no duplicates yet.
#' test(y, file.path(tmp, "first"), test.dedup.session=session)
#' 
#' # Saving it again will trigger the deduplication.
#' checkObjectInDedupSession(y, session)
#' test(y, file.path(tmp, "duplicate"), test.dedup.session=session)
#'
#' list.files(tmp, recursive=TRUE)
#'
#' @export
createDedupSession <- function() {
    output <- new.env()
    output$known <- list()
    output
}

#' @export
#' @rdname createDedupSession
checkObjectInDedupSession <- function(x, session) {
    if (is.null(session)) {
        return(NULL)
    }

    cls <- as.character(class(x))[1]
    if (!(cls %in% names(session$known))) {
        return(NULL)
    }

    candidates <- session$known[[cls]]
    for (y in candidates) {
        if (identical(x, y$value)) {
            return(y$path)
        }
    }

    return(NULL)
}

#' @export
#' @rdname createDedupSession
addObjectToDedupSession <- function(x, session, path) {
    cls <- as.character(class(x))[1]
    if (!(cls %in% names(session$known))) {
        session$known[[cls]] <- list()
    }

    # Convert into an absolute path to protect against changes in the working directory.
    path <- absolutizePath(path) 

    session$known[[cls]] <- c(session$known[[cls]], list(list(value=x, path=path)))
    invisible(NULL)
}

# library(testthat); library(alabaster.base); source('test-createDedupSession.R')

library(S4Vectors)
test_that("deduplication utilities work as expected", {
    y <- DataFrame(A=1:10, B=1:10)

    # Saving the first instance of the object, which is now stored in the session.
    session <- createDedupSession()
    expect_null(checkObjectInDedupSession(y, session))

    tmp <- tempfile()
    dir.create(tmp)
    addObjectToDedupSession(y, session, tmp)
    expect_identical(checkObjectInDedupSession(y, session), absolutizePath(tmp)) # need to clean the path for a valid comparison.

    # Doesn't respond this way for different objects.
    z <- y
    z$A <- z$A + 1
    expect_null(checkObjectInDedupSession(z, session))

    tmp2 <- tempfile()
    dir.create(tmp2)
    addObjectToDedupSession(z, session, tmp2)
    expect_identical(checkObjectInDedupSession(y, session), absolutizePath(tmp))
    expect_identical(checkObjectInDedupSession(z, session), absolutizePath(tmp2))

    # Doesn't respond this way for a different session.
    session2 <- createDedupSession()
    expect_null(checkObjectInDedupSession(y, session2))
    expect_null(checkObjectInDedupSession(z, session2))
})

.sanitize_date <- function(x) {
    format(x, "%Y-%m-%d")
}

.is_datetime <- function(x) {
    is(x, "POSIXct") || is(x, "POSIXlt") || is.Rfc3339(x)
}

.sanitize_datetime <- function(x) {
    sub("([0-9]{2})$", ":\\1", strftime(x, "%Y-%m-%dT%H:%M:%S%z"))
}

.remap_atomic_type <- function(x) {
    y <- typeof(x)

    # Forcibly coercing the types, just to make sure that
    # we don't get tricked by classes that might do something
    # different inside write.csv or whatever.
    switch(y,
        integer=list(type="integer", values=as.integer(x)),
        double=list(type="number", values=as.double(x)),
        numeric=list(type="number", values=as.double(x)),
        character=list(type="string", values=as.character(x)),
        logical=list(type="boolean", values=as.logical(x)),
        stop("type '", y, "' is not supported")
    )
}

.atomics <- c(integer="integer", number="double", string="character", boolean="logical")

.is_atomic <- function(type) {
    type %in% names(.atomics)
}

.cast_atomic <- function(x, type) {
    as(x, as.character(.atomics[type]))
}

#' @import rhdf5
.H5Fclose_null <- function(handle) {
    if (!is.null(handle)) {
        H5Fclose(handle)
    }
    NULL
}

#' @import rhdf5
.H5Gclose_null <- function(handle) {
    if (!is.null(handle)) {
        H5Gclose(handle)
    }
    NULL
}

#' @import rhdf5
.H5Dclose_null <- function(handle) {
    if (!is.null(handle)) {
        H5Dclose(handle)
    }
    NULL
}

#' Representing Internet date/times
#'
#' The Rfc3339 class is a character vector that stores Internet Date/time timestamps, formatted as described in RFC3339.
#' It provides a faithful representation of any RFC3339-compliant string in an R session.
#'
#' @param x For \code{as.Rfc3339} methods, object to be coerced to an Rfc3339 instance.
#'
#' For the subset and combining methods, an Rfc3339 instance.
#'
#' For \code{as.character}, \code{as.POSIXlt} and \code{as.POSIXct} methods, an Rfc3339 instance.
#'
#' For \code{is.Rfc3339}, any object to be tested for Rfc3339-ness.
#' @param i Indices specifying elements to extract or replace.
#' @param value Replacement values, either as another Rfc3339 instance, a character vector or something that can be coerced into one.
#' @param tz,recursive,... Further arguments to be passed to individual methods.
#' @param path String containing the path to a directory in which to save \code{x}.
#'
#' @return
#' For \code{as.Rfc3339}, the subset and combining methods, an Rfc3339 instance is returned.
#'
#' For the other \code{as.*} methods, an instance of the corresponding type generated from an Rfc3339 instance.
#'
#' @details
#' This class is motivated by the difficulty in using the various \link{POSIXt} classes to faithfully represent any RFC3339-compliant string.
#' In particular:
#' \itemize{
#' \item The POSIXt classes do not automatically capture the string's timezone offset, instead converting all times to the local timezone.
#' This is problematic as it discards information about the original timezone.
#' Technically, the \link{POSIXlt} class is capable of holding this information in the \code{gmtoff} field but it is not clear how to set this.
#' \item There is no way to distinguish between the timezones \code{Z} and \code{+00:00}.
#' These are functionally the same but will introduce differences in the checksums of saved files
#' and thus interfere with deduplication mechanisms in storage backends.
#' \item Coercion of POSIXt classes to strings may print more or fewer digits in the fractional seconds than what was present in the original string.
#' Functionally, this is probably unimportant but will still introduce differences in the checksums.
#' }
#'
#' By comparison, the Rfc3339 class preserves all information in the original string,
#' avoiding unexpected modifications from a roundtrip through \code{\link{readObject}} and \code{\link{saveObject}}.
#' This is especially relevant for strings that were created from other languages, 
#' e.g., Node.js Date's ISO string conversion uses \code{Z} by default.
#'
#' That said, users should not expect too much from this class.
#' It is only used to provide a faithful representation of RFC3339 strings, and does not support any time-related arithmetic.
#' Users are advised to convert to \link{POSIXct} or similar if such operations are required.
#' 
#' @author Aaron Lun
#' @examples
#' out <- as.Rfc3339(Sys.time() + 1:10)
#' out
#'
#' out[2:5]
#' out[2] <- "2"
#' c(out, out)
#'
#' as.character(out)
#' as.POSIXct(out)
#' @name Rfc3339
NULL

Rfc3339 <- function(x) {
    class(x) <- "Rfc3339"
    x
}

#' @export
#' @rdname Rfc3339
as.Rfc3339 <- function(x) UseMethod("as.Rfc3339")

#' @export
#' @rdname Rfc3339
as.Rfc3339.character <- function(x) {
    fail <- not_rfc3339(x)
    if (any(fail)) {
        x[fail] <- NA_character_
    }
    Rfc3339(x)
}

#' @export
#' @rdname Rfc3339
as.Rfc3339.default <- function(x) {
    if (is.Rfc3339(x)) {
        x
    } else {
        as.Rfc3339.character(as.character(x))
    }
}

#' @export
#' @rdname Rfc3339
as.Rfc3339.POSIXt <- function(x) as.Rfc3339.character(.sanitize_datetime(x))

#' @export
#' @rdname Rfc3339
as.character.Rfc3339 <- function(x, ...) {
    unclass(x)
}

#' @export
#' @rdname Rfc3339
is.Rfc3339 <- function(x) {
    inherits(x, "Rfc3339")
}

.cast_datetime <- function(x, output=as.POSIXct, ...) {
    zend <- endsWith(x, "Z")

    if (any(zend, na.rm=TRUE)) {
        # strptime doesn't know how to handle 'Z' offsets.
        ziend <- which(zend)
        xz <- x[ziend]
        x[ziend] <- sprintf("%s+0000", substr(xz, 1L, nchar(xz)-1L))
    }

    if (!all(zend, na.rm=TRUE)) {
        # Remove colon in the timezone, which confuses as.POSIXct().
        nzend <- which(!zend)
        x[nzend] <- sub(":([0-9]{2})$", "\\1", x[nzend])
    }

    # Remove fractional seconds.
    x <- sub("\\.[0-9]+", "", x)

    output(x, format="%Y-%m-%dT%H:%M:%S%z", ...)
}

#' @export
#' @rdname Rfc3339
as.POSIXct.Rfc3339 <- function(x, tz="", ...) .cast_datetime(unclass(x), tz=tz, output=as.POSIXct, ...)

#' @export
#' @rdname Rfc3339
as.POSIXlt.Rfc3339 <- function(x, tz="", ...) .cast_datetime(unclass(x), tz=tz, output=as.POSIXlt, ...)

#' @export
#' @rdname Rfc3339
`[.Rfc3339` <- function(x, i) Rfc3339(as.character(x)[i])

#' @export
#' @rdname Rfc3339
`[[.Rfc3339` <- function(x, i) Rfc3339(as.character(x)[[i]])

#' @export
#' @rdname Rfc3339
`[<-.Rfc3339` <- function(x, i, value) {
    y <- unclass(x)
    y[i] <- unclass(as.Rfc3339(value))
    Rfc3339(y)
}

#' @export
#' @rdname Rfc3339
`[[<-.Rfc3339` <- function(x, i, value) {
    y <- unclass(x)
    y[[i]] <- unclass(as.Rfc3339(value))
    Rfc3339(y)
}

#' @export
#' @rdname Rfc3339
c.Rfc3339 <- function(..., recursive=TRUE) {
    combined <- list(...)
    for (i in seq_along(combined)) {
        combined[[i]] <- unclass(as.Rfc3339(combined[[i]]))
    }
    combined <- do.call(c, combined)
    Rfc3339(combined)
}

#' @export
setOldClass("Rfc3339")

#' @export
#' @rdname Rfc3339
setMethod("saveObject", "Rfc3339", function(x, path, ...) .save_atomic_vector(x, path, ...)) 
# Put it here to ensure Rfc3339 is defined... we wrap the .save_atomic_vector call
# in a function so it doesn't get evaluated before saveAtomicVector.R is collated.

# This tests the functions around the Rfc3339 class.
# library(testthat); library(alabaster.base); source("test-Rfc3339.R")

test_that("casting of datetimes works as expected", {
    out <- alabaster.base:::.cast_datetime("2023-12-04T14:41:19+01:00")
    expect_false(is.na(out))

    # Behaves with fractional seconds.
    out <- alabaster.base:::.cast_datetime("2023-12-04T14:41:19.21323+01:00")
    expect_false(is.na(out))

    # Behaves with 'Z'.
    out <- alabaster.base:::.cast_datetime("2023-12-04T14:41:19Z")
    expect_false(is.na(out))
})

test_that("Coercion to Rfc3339 works as expected", {
    out <- as.Rfc3339(c("2022-01-02T02:03:05.22Z", "blah", "2023-12-04T14:41:19.21323+01:00"))
    expect_identical(is.na(out), c(FALSE, TRUE, FALSE))
    expect_true(is.Rfc3339(out))

    out <- as.Rfc3339(Sys.time() + 1:10)
    expect_identical(length(out), 10L)
    expect_false(anyNA(out))

    out <- as.Rfc3339(as.POSIXlt(Sys.time() + 1:10))
    expect_identical(length(out), 10L)
    expect_false(anyNA(out))

    out2 <- as.Rfc3339(out)
    expect_identical(out, out2)

    out <- as.Rfc3339(1:10)
    expect_identical(sum(is.na(out)), 10L)

    out <- as.Rfc3339(c(NA_character_, "2022-01-02T02:03:05.22Z")) 
    expect_identical(is.na(out), c(TRUE, FALSE))

    # Preserves names.
    out <- as.Rfc3339(c(A="2022-01-02T02:03:05.22Z", B="blah", C="2023-12-04T14:41:19.21323+01:00"))
    expect_identical(names(out), LETTERS[1:3])
})

test_that("Coercion from Rfc339 works as expected", {
    rfc <- as.Rfc3339(Sys.time() + 1:10)
    coerced <- as.character(rfc)
    expect_identical(sum(!is.na(coerced)), 10L)

    coerced <- as.POSIXct(rfc)
    expect_s3_class(coerced, "POSIXct")
    expect_false(anyNA(coerced))

    coerced <- as.POSIXlt(rfc)
    expect_s3_class(coerced, "POSIXlt")
    expect_false(anyNA(coerced))

    # Respects names.
    names(rfc) <- rev(LETTERS[1:10])
    coerced <- as.POSIXlt(rfc)
    expect_identical(names(coerced), rev(LETTERS[1:10]))
})

test_that("Rfc3339 subset methods works as expected", {
    rfc <- as.Rfc3339(Sys.time() + 1:10)
    sub <- rfc[2:6]
    expect_s3_class(sub, "Rfc3339")
    expect_identical(unclass(sub), unclass(rfc)[2:6])

    sub <- rfc[[10]]
    expect_s3_class(sub, "Rfc3339")
    expect_identical(unclass(sub), unclass(rfc)[10])

    copy <- rfc
    val <- as.Rfc3339(Sys.time() + 10000 + 6:10)
    copy[1:5] <- val
    expect_s3_class(sub, "Rfc3339")
    expected <- unclass(rfc)
    expected[1:5] <- unclass(val)
    expect_identical(unclass(expected), unclass(copy))

    copy <- rfc
    val <- as.Rfc3339(Sys.time() + 10000)
    copy[[5]] <- val
    expect_s3_class(sub, "Rfc3339")
    expected <- unclass(rfc)
    expected[[5]] <- unclass(val)
    expect_identical(unclass(expected), unclass(copy))

    # Assignment fails if the things are stupid.
    copy <- rfc
    copy[1:2] <- c("aaron", "bravo")
    copy[[10]] <- "charlie"
    expect_identical(which(is.na(copy)), c(1L, 2L, 10L))

    # Respects names.
    copy <- rfc
    names(copy) <- letters[1:10]
    expect_identical(names(copy), letters[1:10])
    sub <- copy[c("a", "b", "c")]
    expect_s3_class(sub, "Rfc3339")
    expect_identical(unclass(sub), unclass(copy)[1:3])
})

test_that("Rfc3339 combining methods works as expected", {
    rfc <- as.Rfc3339(Sys.time() + 1:10)
    val <- as.Rfc3339(Sys.time() + 10000 + 6:10)
    combined <- c(rfc, val)
    expect_s3_class(combined, "Rfc3339")
    expect_identical(unclass(combined), c(unclass(rfc), unclass(val)))

    combined <- c(rfc, LETTERS, val)
    expect_s3_class(combined, "Rfc3339")
    expect_identical(unclass(combined), c(unclass(rfc), rep(NA, length(LETTERS)), unclass(val)))
})

test_that("Rfc3339 behaves nicely with AsIs", {
    rfc <- I(as.Rfc3339(Sys.time()))
    expect_true(is(rfc, "Rfc3339"))
    expect_true(is(rfc, "AsIs"))

    y <- rfc[1]
    expect_true(is(y, "Rfc3339"))
    y <- c(rfc, rfc)
    expect_true(is(y, "Rfc3339"))

    z <- as.POSIXct(rfc)
    expect_true(is(z, "POSIXct"))
})

#' Read a DataFrame factor from disk
#'
#' Read a \link[S4Vectors]{DataFrameFactor} from its on-disk representation.
#' This is usually not directly called by users, but is instead called by dispatch in \code{\link{readObject}}.
#'
#' @param path String containing a path to a directory, itself created with the \code{\link{saveObject}} method for \link[S4Vectors]{DataFrameFactor}s.
#' @param metadata Named list containing metadata for the object, see \code{\link{readObjectFile}} for details.
#' @param ... Further arguments to pass to internal \code{\link{altSaveObject}} calls.
#'
#' @return A \link[S4Vectors]{DataFrameFactor} represented by \code{path}.
#'
#' @author Aaron Lun
#'
#' @seealso
#' \code{"\link{saveObject,DataFrameFactor-method}"}, for the staging method.
#'
#' @examples
#' library(S4Vectors)
#' df <- DataFrame(X=LETTERS[1:5], Y=1:5)
#' out <- DataFrameFactor(df[sample(5, 100, replace=TRUE),,drop=FALSE])
#' 
#' tmp <- tempfile()
#' saveObject(out, tmp)
#' readObject(tmp)
#'
#' @export
#' @aliases loadDataFrameFactor
#' @importFrom S4Vectors DataFrameFactor
readDataFrameFactor <- function(path, metadata, ...) {
    fpath <- file.path(path, "contents.h5")
    fhandle <- H5Fopen(fpath, flags="H5F_ACC_RDONLY")
    on.exit(H5Fclose(fhandle), add=TRUE, after=FALSE)

    host <- "data_frame_factor"
    ghandle <- H5Gopen(fhandle, host)
    on.exit(H5Gclose(ghandle), add=TRUE, after=FALSE)

    codes <- .simple_read_codes(ghandle)
    levels <- altReadObject(file.path(path, "levels"), ...)
    output <- DataFrameFactor(index=codes, levels=levels)

    if (h5_object_exists(ghandle, "names")) {
        names(output) <- h5_read_vector(ghandle, "names")
    }

    readMetadata(
        output,
        metadata.path=file.path(path, "other_annotations"),
        mcols.path=file.path(path, "element_annotations"),
        ...
    )
}

#######################################
########### OLD STUFF HERE ############
#######################################

#' @export
loadDataFrameFactor <- function(info, project, ...) {
    lev.info <- acquireMetadata(project, info$data_frame_factor$levels$resource$path)
    levels <- altLoadObject(lev.info, project=project)

    path <- acquireFile(project, info$path)
    has.names <- isTRUE(info$factor$names)
    idx <- .quickReadCsv(path, 
         c(index="integer"), 
         row.names=has.names, 
         compression=info$factor$compression,
         expected.nrows=info$factor$length
    )

    indexes <- idx$index
    if (has.names) {
        names(indexes) <- rownames(idx)
    }

    DataFrameFactor(index=indexes, levels=levels)
}

# Test staging and loading of DataFrameFactors.
# library(testthat); library(alabaster.base); source("test-DataFrameFactor.R")

library(S4Vectors)

test_that("staging and loading of data frame factors work as expected", {
    tmp <- tempfile()
    dir.create(tmp)

    df <- DataFrame(A=sample(3, 100, replace=TRUE), B=sample(letters[1:3], 100, replace=TRUE))
    X <- DataFrameFactor(x=df)
    staged <- stageObject(X, tmp, path="test1")
    expect_error(writeMetadata(staged, tmp), NA)

    expect_true(file.exists(file.path(tmp, staged$path)))
    expect_true(file.exists(file.path(tmp, staged$data_frame_factor$levels$resource$path)))
    expect_identical(staged$factor$compression, "gzip")

    Y <- loadDataFrameFactor(staged, project=tmp)
    expect_identical(X, Y)

    # Works with factor names.
    rownames(df) <- 1:100
    X <- DataFrameFactor(x=df)
    expect_identical(rownames(X), as.character(1:100))

    staged <- stageObject(X, tmp, path="test2")
    expect_error(writeMetadata(staged, tmp), NA)

    Y <- loadDataFrameFactor(staged, project=tmp)
    expect_identical(X, Y)

    # Works with internal rownames.
    rownames(X@levels) <- paste0("INTERNAL_", seq_len(nrow(X@levels)))

    staged <- stageObject(X, tmp, path="test3")
    expect_error(writeMetadata(staged, tmp), NA)

    Y <- loadDataFrameFactor(staged, project=tmp)
    expect_identical(X, Y)
})

test_that("staging and loading of data frame factors work in the new world", {
    tmp <- tempfile()
    dir.create(tmp)

    df <- DataFrame(A=sample(3, 100, replace=TRUE), B=sample(letters[1:3], 100, replace=TRUE))
    X <- DataFrameFactor(x=df)
    saveObject(X, file.path(tmp, "test1"))
    Y <- readObject(file.path(tmp, "test1"))
    expect_identical(X, Y)

    # Works with factor names.
    rownames(df) <- 1:100
    X <- DataFrameFactor(x=df)
    saveObject(X, file.path(tmp, "test2"))
    Y <- readDataFrameFactor(file.path(tmp, "test2"))
    expect_identical(X, Y)

    # Works with internal rownames.
    rownames(X@levels) <- paste0("INTERNAL_", seq_len(nrow(X@levels)))
    saveObject(X, file.path(tmp, "test3"))
    Y <- readDataFrameFactor(file.path(tmp, "test3"))
    expect_identical(X, Y)
})

test_that("validation of data frame factors catches non-unique levels", {
    tmp <- tempfile()

    df <- DataFrame(A=sample(3, 100, replace=TRUE), B=sample(letters[1:3], 100, replace=TRUE))
    X <- DataFrameFactor(x=df)
    saveObject(X, tmp)

    leveldir <- file.path(tmp, "levels")
    unlink(leveldir, recursive=TRUE)
    saveObject(rbind(levels(X), levels(X)), leveldir)
    expect_error(validateObject(tmp), "duplicated rows")
})

#' Remove a non-child object from the staging directory
#'
#' \emph{WARNING: this function is deprecated, as directories of non-child objects can just be deleted with regular methods (e.g., \code{\link{file.rename}}) in the latest version of \pkg{alabaster}.}
#' Pretty much as it says in the title.
#' This only works with non-child objects as children are referenced by their parents and cannot be safely removed in this manner.
#'
#' @param dir String containing the path to the staging directory.
#' @param path String containing the path to a non-child object inside \code{dir}, as used in \code{\link{acquireMetadata}}.
#' This can also be a redirection to such an object.
#' 
#' @author Aaron Lun
#'
#' @return
#' The object represented by \code{path} is removed, along with any redirections to it.
#' A \code{NULL} is invisibly returned.
#'
#' @details
#' This function will search around \code{path} for JSON files containing redirections to \code{path}, and remove them.
#' More specifically, if \code{path} is a subdirectory, it will search in the same directory containing \code{path};
#' otherwise, it will search in the directory containing \code{dirname(path)}.
#' Redirections in other locations will not be removed automatically - these will be caught by \code{\link{checkValidDirectory}} and should be manually removed.
#' 
#' @examples
#' tmp <- tempfile()
#' dir.create(tmp)
#'
#' library(S4Vectors)
#' df <- DataFrame(A=1:10, B=LETTERS[1:10])
#' meta <- stageObject(df, tmp, path="whee")
#' writeMetadata(meta, tmp)
#'
#' ll <- list(A=1, B=LETTERS, C=DataFrame(X=1:5))
#' meta <- stageObject(ll, tmp, path="stuff")
#' writeMetadata(meta, tmp)
#'
#' redirect <- createRedirection(tmp, "whoop", "whee/simple.csv.gz")
#' writeMetadata(redirect, tmp)
#'
#' list.files(tmp, recursive=TRUE)
#' removeObject(tmp, "whoop")
#' list.files(tmp, recursive=TRUE)
#'
#' @export
removeObject <- function(dir, path) {
    meta <- acquireMetadata(dir, path)

    if (isTRUE(meta$is_child)) {
        stop("cannot remove a child object without removing the parent")
    }

    refpath <- meta$path
    unlink(file.path(dir, dirname(refpath)), recursive=TRUE)

    # Searching for redirections.
    searchpath <- file.path(dir, dirname(dirname(refpath)))
    potential <- list.files(searchpath, pattern="\\.json$")

    for (x in potential) {
        redpath <- file.path(searchpath, x)
        meta <- fromJSON(redpath, simplifyVector=FALSE)

        if (dirname(meta[["$schema"]]) == "redirection") {
            survivors <- list()
            for (x in meta[["redirection"]][["targets"]]) {
                if (x$type != "local" || x$location != refpath) {
                    survivors <- c(survivors, list(x))
                }
            }

            if (length(survivors)) {
                meta[["redirection"]][["targets"]] <- survivors
                writeMetadata(meta, dir)
            } else {
                unlink(redpath)
            }
        }
    }

    invisible(NULL)
}

#' Alter the reading function
#'
#' Allow alabaster applications to specify an alternative reading function in \code{\link{altReadObject}}.
#' 
#' @param path,... Further arguments to pass to \code{\link{readObject}} or its equivalent.
#' @param fun Function that can serve as a drop-in replacement for \code{\link{readObject}}. 
#'
#' @return
#' For \code{altReadObject}, any R object similar to those returned by \code{\link{readObject}}.
#'
#' For \code{altReadObjectFunction}, the alternative function (if any) is returned if \code{fun} is missing.
#' If \code{fun} is provided, it is used to define the alternative, and the previous alternative is returned.
#'
#' @details
#' By default, \code{altReadObject} is just a wrapper around \code{\link{readObject}}.
#' However, if \code{altReadObjectFunction} is called, \code{altReadObject} calls the replacement \code{fun} instead.
#' This allows alabaster applications to inject wholesale or class-specific customizations into the reading process,
#' e.g., to add more metadata whenever an instance of a particular class is encountered.
#' Developers of alabaster extensions should use \code{altReadObject} (instead of \code{readObject}) to read child objects when writing their own reading functions,
#' to ensure that application-specific customizations are respected for the children.
#'
#' To motivate the use of \code{altReadObject}, consider the following scenario.
#' \enumerate{
#' \item We have created a reading function \code{readX} function to read an instance of class X in an alabaster extension.
#' This function may be called by \code{\link{readObject}} if instances of X are children of other objects.
#' \item An alabaster application Y requires the addition of some custom metadata during the reading process for X.
#' It defines an alternative reading function \code{readObject2} that, upon encountering a schema for X, redirects to a application-specific reader \code{readX2}.
#' An example implementation for \code{readX2} would involve calling \code{readX} and decorating the result with the extra metadata.
#' \item When operating in the context of application Y, the \code{readObject2} generic is used to set \code{altReadObjectFunction}.
#' Any calls to \code{altReadObject} in Y's context will subsequently call \code{readObject2}.
#' \item So, when writing a reading function in an alabaster extension for a class that might contain instances of X as children, 
#' we use \code{\link{altReadObject}} instead of directly using \code{\link{readObject}}. 
#' This ensures that, if a child instance of X is encountered \emph{and} we are operating in the context of application Y, 
#' we correctly call \code{readObject2} and then ultimately \code{readX2}.
#' }
#'
#' The application-specific \code{fun} is free to do anything it wants as long as it understands the representation.
#' It is usually most convenient to leverage the existing functionality in \code{\link{readObject}},
#' but if the application-specific saver in \code{\link{altSaveObject}} does something unusual,
#' then \code{fun} is responsible for the correct interpretation of any custom representation.
#'
#' @author Aaron Lun
#' @examples
#' old <- altReadObjectFunction()
#'
#' # Setting it to something.
#' altReadObjectFunction(function(...) {
#'     print("YAY")
#'     readObject(...) 
#' })
#'
#' # Staging an example DataFrame:
#' library(S4Vectors)
#' df <- DataFrame(A=1:10, B=LETTERS[1:10])
#' tmp <- tempfile()
#' saveObject(df, tmp)
#'
#' # And now reading it - this should print our message.
#' altReadObject(tmp)
#' 
#' # Restoring the old reader:
#' altReadObjectFunction(old)
#'
#' @export
#' @aliases .altLoadObject .loadObject altLoadObject altLoadObjectFunction
altReadObject <- function(path, ...) {
    FUN <- altReadObjectFunction()

    if (is.null(FUN)) {
        FUN <- readObject
    } else {
        # Setting up the save environment.
        lfun <- loadSaveEnvironment(path)
        on.exit(lfun(), add=TRUE, after=FALSE)
    }

    FUN(path, ...)
}

#' @export
#' @rdname altReadObject
altReadObjectFunction <- (function() {
    cur.env <- new.env()
    cur.env$reader <- NULL
    function(fun) {
        prev <- cur.env$reader
        if (missing(fun)) {
            prev
        } else {
            cur.env$reader <- fun
            invisible(prev)
        }
    }
})()

#######################################
########### OLD STUFF HERE ############
#######################################

#' @export
altLoadObject <- function(...) {
    FUN <- altLoadObjectFunction()
    if (is.null(FUN)) {
        FUN <- loadObject
    }
    FUN(...)
}

#' @export
altLoadObjectFunction <- (function() {
    cur.env <- new.env()
    cur.env$loader <- NULL
    function(load) {
        prev <- cur.env$loader
        if (missing(load)) {
            prev
        } else {
            cur.env$loader <- load
            invisible(prev)
        }
    }
})()


# Soft-deprecated back-compatibility fixes. 

#' @export
.loadObject <- function(...) altLoadObject(...)

#' @export
.altLoadObject <- function(...) altLoadObjectFunction(...)

#' Saving the metadata
#'
#' \emph{WARNING: this function is deprecated as newer versions of \pkg{alabaster} do not need to write metadata.}
#' Helper function to write metadata from a named list to a JSON file.
#' This is commonly used inside \code{\link{stageObject}} methods to create the metadata file for a child object.
#'
#' @param meta A named list containing metadata.
#' This should contain at least the \code{"$schema"} and \code{"path"} elements.
#' @param dir String containing a path to the staging directory.
#' @param ignore.null Logical scalar indicating whether \code{NULL} values should be ignored during coercion to JSON.
#'
#' @details
#' Any \code{NULL} values in \code{meta} are pruned out prior to writing when \code{ignore.null=TRUE}.
#' This is done recursively so any \code{NULL} values in sub-lists of \code{meta} are also ignored.
#'
#' Any scalars are automatically unboxed so array values should be explicitly specified as such with \code{\link{I}()}.
#'
#' Any starting \code{"./"} in \code{meta$path} will be automatically removed.
#' This allows staging methods to save in the current directory by setting \code{path="."},
#' without the need to pollute the paths with a \code{"./"} prefix.
#'
#' The JSON-formatted metadata is validated against the schema in \code{meta[["$schema"]]} using \pkg{jsonvalidate}.
#' The location of the schema is taken from the \code{package} attribute in that string, if one exists;
#' otherwise, it is assumed to be in the \pkg{alabaster.schemas} package.
#' (All schemas are assumed to live in the \code{inst/schemas} subdirectory of their indicated packages.)
#'
#' We also use the schema to determine whether \code{meta} refers to an actual artifact or is a metadata-only document.
#' If it refers to an actual file, we compute its MD5 sum and store it in the metadata for saving.
#' We also save its associated metadata into a JSON file at a location obtained by appending \code{".json"} to \code{meta$path}.
#'
#' For artifacts, the MD5 sum calculation will be skipped if the \code{meta} already contains a \code{md5sum} field.
#' This can be useful on some occasions, e.g., to improve efficiency when the MD5 sum was already computed during staging,
#' or if the artifact does not actually exist in its full form on the file system.
#'
#' @return A JSON file containing the metadata is created at \code{path}.
#' A list of resource metadata is returned, e.g., for inclusion as the \code{"resource"} property in parent schemas.
#'
#' @author Aaron Lun
#' @examples
#' library(S4Vectors)
#' df <- DataFrame(A=1:10, B=LETTERS[1:10])
#'
#' tmp <- tempfile()
#' dir.create(tmp)
#' info <- stageObject(df, tmp, path="coldata")
#' writeMetadata(info, tmp)
#' cat(readLines(file.path(tmp, "coldata/simple.csv.gz.json")), sep="\n")
#'
#' @export
#' @aliases .writeMetadata
#' @importFrom jsonlite toJSON fromJSON
writeMetadata <- function(meta, dir, ignore.null=TRUE) { 
    if (ignore.null) {
        meta <- .strip_null_from_list(meta)
    }

    schema.id <- meta[["$schema"]]
    pkg <- attr(schema.id, "package")
    if (is.null(pkg)) {
        pkg <- "alabaster.schemas"
    }

    schema.path <- system.file("schemas", schema.id, package=pkg)
    if (schema.path == "") {
        stop("failed to find '", schema.id, "' in package '", pkg, "'")
    }

    # Avoid an extra look-up from file.
    if (schema.path %in% names(schema.details$is.meta)) {
        meta.only <- schema.details$is.meta[[schema.path]]
    } else {
        meta.only <- isTRUE(fromJSON(schema.path)[["_attributes"]][["metadata_only"]])
        schema.details$is.meta[[schema.path]] <- meta.only
    }

    meta$path <- gsub("^\\./", "", meta$path) # stripping this out for convenience.

    jpath <- meta$path
    if (!meta.only) {
        jpath <- paste0(jpath, ".json")
        if (is.null(meta$md5sum) && dirname(schema.id) != "redirection") {
            meta$md5sum <- digest::digest(file=file.path(dir, meta$path))
        }
    }

    jpath <- file.path(dir, jpath)
    write(file=jpath, toJSON(meta, pretty=TRUE, auto_unbox=TRUE, digits=NA))
    jsonvalidate::json_validate(jpath, schema.path, error=TRUE, engine="ajv") 

    list(type="local", path=meta$path)
}

.strip_null_from_list <- function(x) {
    keep <- !logical(length(x))
    for (i in seq_along(x)) {
        current <- x[[i]]
        if (is.list(current)) {
            x[[i]] <- .strip_null_from_list(current)
        } else if (is.null(current)) {
            keep[i] <- FALSE
        }
    }
    x[keep]
}

schema.details <- new.env()
schema.details$is.meta <- list()

# Soft-deprecated back-compatibility fixes. 

#' @export
.writeMetadata <- function(...) writeMetadata(...)

# This tests the staging hints in stageObject's ANY method.
# library(alabaster.base); library(testthat); source("test-stageANY.R")

test_that("stageObject redirects to an appropriate hint with name checks", {
    a <- matrix(runif(100), 10, 10)
    tmp <- tempfile()
    dir.create(tmp) 

    if (alabaster.base:::package.exists("alabaster.matrix")) {
        expect_error(info <- stageObject(a, tmp, "foo"), NA)
        expect_identical(as.character(info[["$schema"]]), "hdf5_dense_array/v1.json")
    } else {
        expect_error(expect_warning(stageObject(a, tmp, "foo"), "alabaster.matrix"), "signature 'matrix'")
    }
})

test_that("stageObject redirects to an appropriate hint via is()", {
    library(Matrix)
    x <- rsparsematrix(100, 10, 0.05)
    tmp <- tempfile()
    dir.create(tmp) 

    if (alabaster.base:::package.exists("alabaster.matrix")) {
        expect_error(info <- stageObject(x, tmp, "foo"), NA)
        expect_identical(as.character(info[["$schema"]]), "hdf5_sparse_matrix/v1.json")
    } else {
        expect_error(expect_warning(stageObject(x, tmp, "foo"), "alabaster.matrix"), "signature 'dgCMatrix'")
    }
})

test_that("stageObject fails for unknown classes", {
    setClass("MyClass", slots=c(x = "integer"))
    a <- new("MyClass", x = 1L)

    tmp <- tempfile()
    dir.create(tmp) 
    expect_error(stageObject(a, tmp, "foo"), "MyClass")

    tmp <- tempfile()
    expect_error(saveObject(a, tmp), "MyClass")
})

test_that("stageObject fails for existing paths", {
    a <- S4Vectors::DataFrame(X = 1L)

    tmp <- tempfile()
    dir.create(tmp) 
    stageObject(a, tmp, "foo")
    expect_error(stageObject(a, tmp, "foo"), "existing path")

    tmp <- tempfile()
    dir.create(tmp) 
    expect_error(info <- stageObject(a, tmp, "."), NA)
    expect_identical(info$path, "./simple.csv.gz")

    # Fails with the new world.
    tmp <- tempfile()
    dir.create(tmp) 
    expect_error(saveObject(a, tmp), "existing path")
})

test_that("stageObject fails for saving non-child objects in other object's subdirectories", {
    a <- S4Vectors::DataFrame(X = 1L)

    tmp <- tempfile()
    dir.create(tmp) 
    meta <- stageObject(a, tmp, "foo")
    writeMetadata(meta, tmp)

    expect_error(stageObject(a, tmp, "foo/bar"), "non-child object")
})

# Test the acquireMetadata handling of the redirection.
# library(testthat); library(alabaster.base); source("test-acquireMetadata.R")

library(S4Vectors)
df <- DataFrame(A = 1:5, B = LETTERS[1:5])

test_that("acquireMetadata works correctly in simple cases", {
    tmp <- tempfile()
    dir.create(tmp, recursive=TRUE)
    info <- stageObject(df, tmp, "rnaseq")
    writeMetadata(info, tmp)

    expect_identical(acquireFile(tmp, info$path), file.path(tmp, info$path))
    meta <- acquireMetadata(tmp, info$path)
    expect_identical(meta$`$schema`, info$`$schema`)
    expect_identical(meta$path, info$path)

    # Works if we pass the JSON path directly.
    meta2 <- acquireMetadata(tmp, paste0(info$path, ".json"))
    expect_identical(meta, meta2)
})

test_that("acquireMetadata correctly redirects to other things", {
    tmp <- tempfile()
    dir.create(tmp, recursive=TRUE)
    info <- stageObject(df, tmp, "rnaseq")
    writeMetadata(info, tmp)

    redirect <- createRedirection(tmp, "rnaseq", "rnaseq/simple.csv.gz")
    writeMetadata(redirect, tmp)

    check <- jsonlite::fromJSON(file.path(tmp, "rnaseq.json"), simplifyVector=FALSE)
    expect_identical(check$path, "rnaseq")
    expect_identical(check$redirection$targets[[1]]$location, "rnaseq/simple.csv.gz")

    # Redirects automatically.
    meta <- acquireMetadata(tmp, "rnaseq")
    expect_identical(meta$`$schema`, info$`$schema`)
    expect_identical(meta$path, info$path)
})

# This adds some tests for writeMetadata.
# library(testthat); library(alabaster.base); source("test-writeMetadata.R")

library(S4Vectors)

ncols <- 123
df <- DataFrame(
    stuff = rep(LETTERS[1:3], length.out=ncols),
    blah = 0, # placeholder
    foo = seq_len(ncols),
    whee = as.numeric(10 + seq_len(ncols)),
    rabbit = 1,
    birthday = rep(Sys.Date(), ncols) - sample(100, ncols, replace=TRUE)
)
df$blah <- factor(df$stuff, LETTERS[10:1])
df$rabbit <- factor(df$stuff, LETTERS[1:3], ordered=TRUE)

test_that("writing saves the MD5 sums", {
    tmp <- tempfile()
    dir.create(tmp)

    info <- stageObject(df, tmp, "rnaseq")
    out <- writeMetadata(info, tmp)

    expect_identical(out$path, info$path) 
    round <- jsonlite::fromJSON(file.path(tmp, paste0(out$path, ".json")))
    expect_identical(round$md5sum, digest::digest(file=file.path(tmp, out$path)))

    # ... unless the MD5sum was already available, in which case it's just used.
    info$md5sum <- "WHEE"
    out <- writeMetadata(info, tmp)
    round <- jsonlite::fromJSON(file.path(tmp, paste0(out$path, ".json")))
    expect_identical(round$md5sum, "WHEE")
})

test_that("writing strips the dots", {
    tmp <- tempfile()
    dir.create(tmp)

    info <- stageObject(df, tmp, "./whee")
    out <- writeMetadata(info, tmp)

    round <- jsonlite::fromJSON(file.path(tmp, paste0(out$path, ".json")))
    expect_identical(round$path, "whee/simple.csv.gz")
})

test_that("writing doesn't allow windows-style separators", {
    tmp <- tempfile()
    dir.create(tmp)
    expect_error(stageObject(df, tmp, "whee\\asdasd"), "Windows-style")
})

test_that("writing respects the package attribute", {
    tmp <- tempfile()
    dir.create(tmp)

    info <- stageObject(df, tmp, "./whee")
    attr(info[["$schema"]], "package") <- "FOOBAR"
    expect_error(writeMetadata(info, tmp), "failed to find")
})

# Make sure to put derived classes before base classes,
# otherwise the subclass look-up might not find the most appropriate method.
implementers <- list(
    SpatialExperiment = "alabaster.spatial", 

    SingleCellExperiment = "alabaster.sce",

    VCF = "alabaster.vcf",

    SummarizedExperiment = "alabaster.se",

    BumpyDataFrameMatrix = "alabaster.bumpy",

    GRanges = "alabaster.ranges",
    GRangesList = "alabaster.ranges",
    AtomicVectorList = "alabaster.ranges",
    DataFrameList = "alabaster.ranges",

    matrix = "alabaster.matrix",
    array = "alabaster.matrix",
    Matrix = "alabaster.matrix",
    DelayedArray = "alabaster.matrix",

    MultiAssayExperiment = "alabaster.mae",

    DNAStringSet = "alabaster.string"
)

package.lookup <- new.env()
package.lookup$found <- character(0)

package.exists <- function(pkg) {
    length(find.package(pkg, quiet=TRUE)) > 0
}

warn.package.exists <- function(pkg, cls) {
    warning("consider installing ", pkg, " for a more appropriate stageObject method for '", cls, "' objects")
}

.search_methods <- function(x) {
    searchForMethods(x, package.lookup, implementers)
}

#' @export
#' @import methods
searchForMethods <- function(x, lookup, implements) {
    cls <- class(x)[1]
    ok <- FALSE

    if (!(cls %in% lookup$found)) {
        found <- NULL
        if (cls %in% names(implements)) {
            found <- implements[[cls]]
            if (!package.exists(found)) {
                warn.package.exists(found, cls)
                found <- NULL
            }
        } 

        if (is.null(found)) {
            for (y in names(implements)) {
                if (is(x, y)) {
                    if (package.exists(implements[[y]])) {
                        found <- implements[[y]]
                        break
                    } else {
                        warn.package.exists(implements[[y]], cls)
                    }
                }
            }
        }

        if (!is.null(found) && !isNamespaceLoaded(found)) {
            loadNamespace(found)
            ok <- TRUE
        }

        # Regardless of whether it was successful, we add the class,
        # so as to short-circuit any attempts in the future.
        lookup$found <- c(lookup$found, cls)
    }

    ok 
}

#' @export
setMethod("stageObject", "ANY", function(x, dir, path, child=FALSE, ...) {
    # The logic is that .searchMethods should have run in the generic before
    # hitting this method. If that's the case, we must have failed to find a 
    # suitable method, so we just throw an error here. We still need to define
    # an ANY method, though, because otherwise the generic won't even run. 
    stop("no known method for 'stageObject' function with signature '", class(x)[1], "'")
})

# Soft-deprecated back-compatibility fix.

#' @export
.searchForMethods <- function(...) searchForMethods(...)

#' Read an atomic vector from disk
#'
#' Read a vector consisting of atomic elements from its on-disk representation.
#' This is usually not directly called by users, but is instead called by dispatch in \code{\link{readObject}}.
#'
#' @param path Path to a directory created with any of the vector methods for \code{\link{saveObject}}.
#' @param metadata Named list containing metadata for the object, see \code{\link{readObjectFile}} for details.
#' @param ... Further arguments, ignored.
#'
#' @return 
#' The vector described by \code{info}.
#'
#' @seealso
#' \code{"\link{saveObject,integer-method}"}, for one of the staging methods.
#'
#' @author Aaron Lun
#' 
#' @examples
#' tmp <- tempfile()
#' saveObject(setNames(runif(26), letters), tmp)
#' readObject(tmp)
#' 
#' @export
#' @aliases loadAtomicVector
readAtomicVector <- function(path, metadata, ...) {
    fpath <- file.path(path, "contents.h5")
    fhandle <- H5Fopen(fpath, flags="H5F_ACC_RDONLY")
    on.exit(.H5Fclose_null(fhandle), add=TRUE, after=FALSE)

    host <- "atomic_vector"
    ghandle <- H5Gopen(fhandle, host)
    on.exit(.H5Gclose_null(ghandle), add=TRUE, after=FALSE)

    expected.type <- h5_read_attribute(ghandle, "type")
    if (expected.type == "vls") {
        vhandle <- H5Dopen(ghandle, "pointers")
        on.exit(.H5Dclose_null(vhandle), add=TRUE, after=FALSE)
        missing.placeholder <- h5_read_attribute(vhandle, missingPlaceholderName, check=TRUE, default=NULL)

        # Need to do this tedious song and dance to get an exclusive file handle.
        vhandle <- .H5Dclose_null(vhandle)
        ghandle <- .H5Gclose_null(ghandle)
        fhandle <- .H5Fclose_null(fhandle)

        contents <- h5_read_vls_array(fpath, paste0(host, "/pointers"), paste0(host, "/heap"), missing.placeholder=missing.placeholder)
        contents <- as.vector(contents)

        # Reopening this for downstream operations.
        fhandle <- H5Fopen(fpath, "H5F_ACC_RDONLY")
        ghandle <- H5Gopen(fhandle, "atomic_vector")

    } else {
        vhandle <- H5Dopen(ghandle, "values")
        on.exit(H5Dclose(vhandle), add=TRUE, after=FALSE)
        contents <- H5Dread(vhandle, drop=TRUE)
        missing.placeholder <- h5_read_attribute(vhandle, missingPlaceholderName, check=TRUE, default=NULL)

        contents <- h5_cast(contents, expected.type=expected.type, missing.placeholder=missing.placeholder)
        if (expected.type == "string") {
            if (H5Aexists(ghandle, "format")) {
                format <- h5_read_attribute(ghandle, "format")
                if (format == "date") {
                    contents <- as.Date(contents)
                } else if (format == "date-time") {
                    contents <- as.Rfc3339(contents)
                }
            }
        }
    }

    if (h5_object_exists(ghandle, "names")) {
        names(contents) <- h5_read_vector(ghandle, "names")
    }

    contents
}

#######################################
########### OLD STUFF HERE ############
#######################################

#' @export
loadAtomicVector <- function(info, project, ...) {
    fpath <- acquireFile(project, info$path)
    meta <- info$atomic_vector

    df <- read.csv3(fpath, compression=meta$compression, nrows=meta$length)
    output <- df[,ncol(df)]
    type <- meta$type

    if (type == "string") {
        format <- meta$format
        if (!is.null(format)) {
            if (format == "date") {
                output <- as.Date(output)
            } else if (format == "date-time") {
                output <- .cast_datetime(output)
            } else {
                output <- as.character(output)
            }
        }
    } else {
        stopifnot(.is_atomic(type))
        output <- .cast_atomic(output, type)
    }

    if (isTRUE(meta$names)) {
        names(output) <- df[,1]
    }
    output 
}

# Test stageObject on simple vectors.
# library(testthat); library(alabaster.base); source("test-vector.R")

test_that("vectors work correctly without names", {
    tmp <- tempfile()
    dir.create(tmp, recursive=TRUE)

    input <- LETTERS
    meta <- stageObject(input, tmp, path="foo")
    expect_identical(meta$atomic_vector$type, "string")
    writeMetadata(meta, tmp)
    expect_identical(loadAtomicVector(meta, tmp), input)

    vals <- runif(25)
    meta <- stageObject(vals, tmp, path="bar")
    expect_identical(meta$atomic_vector$type, "number")
    writeMetadata(meta, tmp)
    expect_equal(loadAtomicVector(meta, tmp), vals)

    vals <- as.integer(rpois(99, 10))
    meta <- stageObject(vals, tmp, path="whee")
    expect_identical(meta$atomic_vector$type, "integer")
    writeMetadata(meta, tmp)
    expect_identical(loadAtomicVector(meta, tmp), vals)

    vals <- rbinom(1000, 1, 0.5) > 0
    meta <- stageObject(vals, tmp, path="stuff")
    expect_identical(meta$atomic_vector$type, "boolean")
    writeMetadata(meta, tmp)
    expect_identical(loadAtomicVector(meta, tmp), vals)

    vals <- c(Sys.Date(), Sys.Date() + 100, Sys.Date() - 100)
    meta <- stageObject(vals, tmp, path="blah")
    expect_identical(meta$atomic_vector$type, "string")
    expect_identical(meta$atomic_vector$format, "date")
    writeMetadata(meta, tmp)
    expect_identical(loadAtomicVector(meta, tmp), vals)

    vals <- c(Sys.time(), Sys.time() + 100, Sys.time() - 100)
    meta <- stageObject(vals, tmp, path="gunk")
    expect_identical(meta$atomic_vector$type, "string")
    expect_identical(meta$atomic_vector$format, "date-time")
    writeMetadata(meta, tmp)
    expect_true(all(abs(loadAtomicVector(meta, tmp) - vals) < 1)) # sub-second resolution on the strings.
})

test_that("vectors work correctly without names in the new world", {
    tmp <- tempfile()
    dir.create(tmp, recursive=TRUE)

    input <- LETTERS
    saveObject(input, file.path(tmp, "foo"))
    expect_identical(readAtomicVector(file.path(tmp, "foo")), input)

    vals <- runif(25)
    saveObject(vals, file.path(tmp, "bar"))
    expect_equal(readAtomicVector(file.path(tmp, "bar")), vals)

    vals <- as.integer(rpois(99, 10))
    saveObject(vals, file.path(tmp, "whee"))
    expect_identical(readAtomicVector(file.path(tmp, "whee")), vals)

    vals <- rbinom(1000, 1, 0.5) > 0
    saveObject(vals, file.path(tmp, "stuff"))
    expect_identical(readAtomicVector(file.path(tmp, "stuff")), vals)

    vals <- c(Sys.Date(), Sys.Date() + 100, Sys.Date() - 100)
    saveObject(vals, file.path(tmp, "blah"))
    expect_identical(readAtomicVector(file.path(tmp, "blah")), vals)
})

test_that("vectors work correctly with names", {
    tmp <- tempfile()
    dir.create(tmp, recursive=TRUE)

    vals <- setNames(runif(26), LETTERS)
    meta <- stageObject(vals, tmp, path="bar")
    expect_identical(meta$atomic_vector$type, "number")
    writeMetadata(meta, tmp)
    expect_equal(loadAtomicVector(meta, tmp), vals)

    saveObject(vals, file.path(tmp, "foo"))
    expect_equal(readAtomicVector(file.path(tmp, "foo")), vals)
})

test_that("vectors preserve date-times as strings", {
    vals <- c(Sys.time(), Sys.time() + 100, Sys.time() - 100)

    tmp <- tempfile()
    dir.create(tmp)

    saveObject(vals, file.path(tmp, "gunk"))
    reloaded <- readAtomicVector(file.path(tmp, "gunk"))
    expect_s3_class(reloaded, "Rfc3339")
    expect_true(all(abs(as.POSIXct(reloaded) - vals) < 1)) # sub-second resolution on the strings.

    saveObject(reloaded, file.path(tmp, "foo"))
    expect_identical(readAtomicVector(file.path(tmp, "foo")), reloaded)
})

test_that("vectors convert package versions to strings", {
    vals <- as.package_version(c("1.0", "1.0.0", "1.2.1"))

    tmp <- tempfile()
    dir.create(tmp)

    saveObject(vals, file.path(tmp, "gunk"))
    reloaded <- readAtomicVector(file.path(tmp, "gunk"))
    expect_identical(reloaded, as.character(vals))
})

test_that("vectors work in VLS mode", {
    tmp <- tempfile()
    dir.create(tmp)

    x <- c("A", "BC", "DEFG", "HIJKL", "MNOP", "QRS", "TU", "V")
    saveObject(x, file.path(tmp, "basic"), character.vls=TRUE)
    reloaded <- readAtomicVector(file.path(tmp, "basic")) 
    expect_identical(x, reloaded)

    y <- x
    y[2] <- NA
    saveObject(y, file.path(tmp, "with_missing"), character.vls=TRUE)
    reloaded <- readAtomicVector(file.path(tmp, "with_missing")) 
    expect_identical(y, reloaded)

    y <- x
    names(y) <- seq_along(y)
    saveObject(y, file.path(tmp, "named"), character.vls=TRUE)
    reloaded <- readAtomicVector(file.path(tmp, "named")) 
    expect_identical(y, reloaded)

    y <- x
    y[4] <- strrep("HIJKL", 100)
    saveObject(y, file.path(tmp, "auto"), character.vls=NULL)
    reloaded <- readAtomicVector(file.path(tmp, "auto")) 
    expect_identical(y, reloaded)
})

#' Track the environment used for saving objects
#'
#' Utilities to write, load and access the R environment used by \code{\link{saveObject}} for any given object.
#'
#' @param path String containing the path to a directory representing an object,
#' same as that used by \code{\link{saveObject}} and \code{\link{readObject}}.
#' @param info Named list containing information about the environment used to save each object.
#' If \code{NULL}, this is created by calling \code{formatSaveEnvironment}.
#' @param use Logical scalar specifying whether to use a save environment during reading/saving of objects.
#' 
#' @return
#' \code{getSaveEnvironment} returns a named list describing the environment used to save the \dQuote{current} object (see Details).
#' The list should have a \code{type} field specifying the type of environment, e.g., \code{"R"}.
#' For objects created by \code{\link{saveObject}}, this will typically have the same format as the list returned by \code{formatSaveEnvironment}.
#' Alternatively, \code{NULL} is returned if \code{useSaveEnvironment} is set to \code{FALSE} or no environment information was recorded for the current object.
#'
#' \code{formatSaveEnvironment} returns a named list containing the current R environment, derived from the \code{\link[utils]{sessionInfo}}.
#' This records the R \code{version}, the \code{platform} in which R is running, and the versions of all \code{packages} as a named list.
#'
#' If \code{use} is not supplied, \code{useSaveEnvironment} returns a logical scalar indicating whether to use the save environment information.
#' If \code{use} is supplied, it is used to define the save environment usage policy, and the previous setting of this value is invisibly returned.
#'
#' \code{registerSaveEnvironment} registers the current environment information in memory so that it can be returned by \code{getSaveEnvironment}.
#' It returns a list containing a \code{restore} function that should be called \code{\link{on.exit}} to (i) restore the previous environment information;
#' and a \code{write} function that accepts a \code{path} to a directory in which to create an \code{_environment.json} file with the environment information.
#' Both functions are no-ops if \code{useSaveEnvironment} is set to \code{FALSE} or if a save environment has already been registered.
#'
#' \code{loadSaveEnvironment} loads the environment information from a \code{_environment.json} file in \code{path}.
#' It also registers the environment information in memory so that it is returned when \code{getSaveEnvironment} is called.
#' It returns a function that should be called \code{\link{on.exit}} to restore the previous environment information. 
#' This function is a no-op if \code{useSaveEnvironment} is set to \code{FALSE}, or if the environment information is not parsable (in which case a warning will be emitted).
#'
#' @details
#' When saving an object, \pkg{\link{saveObject}} will automatically record some details about the current R environment. 
#' This facilitates trouble-shooting and provides some opportunities for corrective measures if any bugs are found in older \code{saveObject} methods.
#' Information about the save environment is stored in an \code{_environment.json} file inside the directory containing the object.
#' Subdirectories for child objects may also have separate \code{_environment.json} files (e.g., if they were created in a different environment),
#' otherwise it is assumed that they inherit the save environment from the parent object.
#'
#' Application or extension developers are expected to call \code{getSaveEnvironment} from inside a loading function used by \code{\link{readObject}} or \code{\link{altReadObject}}.
#' This wil return the save environment that was used for the \dQuote{current} object, i.e., the object that was previously saved at \code{path}.
#' By accessing the historical save environment, developers can check if buggy versions of the corresponding \code{saveObject} or \code{altSaveObject} methods were used.
#' Appropriate corrective measures can then be applied to recover the correct object, warn users, etc.
#' \code{getSaveEnvironment} can also be called inside \code{saveObject} or \code{altSaveObject} methods, in which case the current object is the one being saved.
#' 
#' In most cases, \code{registerSaveEnvironment} does not need to be explicitly called by end-users or developers.
#' It is automatically executed by the top-level calls to the \code{\link{saveObject}} or \code{\link{altSaveObject}} generics.
#' Methods can simply call \code{\link{getSaveEnvironment}} to access the save environment information.
#' Similarly, \code{loadSaveEnvironment} does not usually need to be explicitly called by end-users or developers,
#' as it is automatically executed by each \code{\link{readObject}} or \code{\link{altReadObject}} call.
#' Individual reader functions can simply call \code{\link{getSaveEnvironment}} to access the save environment information.
#'
#' Tracking of the save environment can be disabled by setting \code{useSaveEnvironment(FALSE)}.
#'
#' @author Aaron Lun
#'
#' @examples
#' str(formatSaveEnvironment())
#'
#' prev <- useSaveEnvironment(TRUE)
#' tmp <- tempfile()
#' dir.create(tmp)
#'
#' wfun <- registerSaveEnvironment(tmp)
#' getSaveEnvironment()
#' wfun$restore()
#'
#' useSaveEnvironment(prev)
#'
#' @export
getSaveEnvironment <- function() {
    if (useSaveEnvironment()) {
        save.env$environment
    } else {
        NULL
    }
}

save.env <- new.env()
save.env$use <- TRUE
save.env$environment <- NULL

#' @export
#' @rdname getSaveEnvironment
#' @importFrom utils sessionInfo
formatSaveEnvironment <- function() {
    info <- sessionInfo()
    list(
        type="R",
        version=paste0(info$R.version$major, ".", info$R.version$minor),
        platform=info$platform,
        packages=c(
            lapply(info$otherPkgs, function(x) x$Version),
            lapply(info$loadedOnly, function(x) x$Version)
        )
    )
}

#' @export
#' @rdname getSaveEnvironment
useSaveEnvironment <- function(use) {
    old <- save.env$use
    if (missing(use)) {
        return(old)
    } else {
        save.env$use <- use
        return(invisible(old))
    }
}

#' @export
#' @rdname getSaveEnvironment
#' @importFrom jsonlite toJSON
registerSaveEnvironment <- function(info=NULL) {
    if (!is.null(getSaveEnvironment()) || !useSaveEnvironment()) {
        return(list(
            restore = function() {},
            write = function(path) {}
        ))
    }

    if (is.null(info)) {
        info <- formatSaveEnvironment()
    }

    previous <- save.env$environment
    save.env$environment <- info
    list(
        restore = function() {
            save.env$environment <- previous
        },
        write = function(path) {
            # We do this here as 'path' isn't created yet.
            write(file=.get_environment_path(path), toJSON(info, pretty=4, auto_unbox=TRUE))
        }
    )
}

.get_environment_path <- function(path) {
    file.path(path, "_environment.json")
}

#' @export
#' @rdname getSaveEnvironment
#' @importFrom jsonlite fromJSON
loadSaveEnvironment <- function(path) {
    candidate <- .get_environment_path(path)
    if (!useSaveEnvironment() || !file.exists(candidate)) {
        return(function(){})
    }

    current <- try(fromJSON(candidate, simplifyVector=FALSE), silent=TRUE)
    if (is(current, "try-error")) {
        warning("failed to read environment information at '", path, "', ", attr(current, "condition")$message)
        return(function(){})
    }

    previous <- save.env$environment
    save.env$environment <- current
    function() {
        save.env$environment <- previous
    }
}

# library(testthat); library(alabaster.base); source("test-getSaveEnvironment.R")

test_that("formatSaveEnvironment works correctly", {
    env <- formatSaveEnvironment()
    expect_identical(env$type, "R")
    expect_type(env$platform, "character")
    expect_type(env$version, "character")
    expect_identical(env$packages$alabaster.base, as.character(packageVersion("alabaster.base")))

    expect_identical(env$packages$jsonlite, as.character(packageVersion("jsonlite")))
})

test_that("useSaveEnvironment works correctly", {
    prev <- useSaveEnvironment(TRUE)
    on.exit(useSaveEnvironment(prev), add=TRUE, after=FALSE)
    expect_true(useSaveEnvironment())
    useSaveEnvironment(FALSE)
    expect_false(useSaveEnvironment())
})

test_that("registerSaveEnvironment works correctly", {
    prev <- useSaveEnvironment(TRUE)
    on.exit(useSaveEnvironment(prev), add=TRUE, after=FALSE)
    expect_null(getSaveEnvironment())

    wfuns <- registerSaveEnvironment(info=list(type="TEST"))
    on.exit(wfuns$restore(), add=TRUE, after=FALSE)
    expect_identical(getSaveEnvironment()$type, "TEST")

    tmp <- tempfile()
    dir.create(tmp)
    wfuns$write(tmp)
    expect_true(file.exists(alabaster.base:::.get_environment_path(tmp)))
    expect_identical(jsonlite::fromJSON(alabaster.base:::.get_environment_path(tmp), simplifyVector=FALSE)$type, "TEST")

    # Further calls are no-ops.
    wfuns2 <- registerSaveEnvironment(info=list(type="TEST2"))
    on.exit(wfuns2$restore(), add=TRUE, after=FALSE)
    expect_identical(getSaveEnvironment()$type, "TEST")
})

test_that("registerSaveEnvironment uses the default info", {
    prev <- useSaveEnvironment(TRUE)
    on.exit(useSaveEnvironment(prev), add=TRUE, after=FALSE)
    expect_null(getSaveEnvironment())

    wfuns <- registerSaveEnvironment()
    on.exit(wfuns$restore(), add=TRUE, after=FALSE)
    expect_identical(getSaveEnvironment()$type, "R")
})

test_that("registerSaveEnvironment can be disabled", {
    prev <- useSaveEnvironment(FALSE)
    on.exit(useSaveEnvironment(prev), add=TRUE, after=FALSE)
    expect_null(getSaveEnvironment())

    wfuns <- registerSaveEnvironment()
    on.exit(wfuns$restore(), add=TRUE, after=FALSE)
    expect_null(getSaveEnvironment())
})

test_that("loadSaveEnvironment works correctly", {
    prev <- useSaveEnvironment(TRUE)
    on.exit(useSaveEnvironment(prev), add=TRUE, after=FALSE)
    expect_null(getSaveEnvironment())

    tmp <- tempfile()
    dir.create(tmp)
    write(file=alabaster.base:::.get_environment_path(tmp), '{ "type": "TEST" }')

    lfun <- loadSaveEnvironment(tmp)
    on.exit(lfun(), add=TRUE, after=FALSE)
    expect_identical(getSaveEnvironment()$type, "TEST")

    # Further calls are NOT no-ops.
    write(file=alabaster.base:::.get_environment_path(tmp), '{ "type": "TEST2" }')
    lfun2 <- loadSaveEnvironment(tmp)
    on.exit(lfun2(), add=TRUE, after=FALSE)
    expect_identical(getSaveEnvironment()$type, "TEST2")
})

test_that("loadSaveEnvironment warns correctly for invalid files", {
    prev <- useSaveEnvironment(TRUE)
    on.exit(useSaveEnvironment(prev), add=TRUE, after=FALSE)
    expect_null(getSaveEnvironment())

    tmp <- tempfile()
    dir.create(tmp)
    write(file=alabaster.base:::.get_environment_path(tmp), 'adsds')

    expect_warning(lfun2 <- loadSaveEnvironment(tmp), "failed to read")
    on.exit(lfun2(), add=TRUE, after=FALSE)
    expect_null(getSaveEnvironment())
})

test_that("loadSaveEnvironment can be disabled", {
    prev <- useSaveEnvironment(FALSE)
    on.exit(useSaveEnvironment(prev), add=TRUE, after=FALSE)
    expect_null(getSaveEnvironment())

    tmp <- tempfile()
    dir.create(tmp)
    write(file=alabaster.base:::.get_environment_path(tmp), '{ "type": "TEST" }')

    lfun <- loadSaveEnvironment(tmp)
    on.exit(lfun(), add=TRUE, after=FALSE)
    expect_null(getSaveEnvironment())
})

test_that("saving the object tracks its environment", {
    prev <- useSaveEnvironment(TRUE)
    on.exit(useSaveEnvironment(prev), add=TRUE, after=FALSE)
    expect_null(getSaveEnvironment())

    library(S4Vectors)
    df <- DataFrame(A=LETTERS)
    tmp <- tempfile()
    saveObject(df, tmp)
    expect_null(getSaveEnvironment()) # correctly unset at the end of all calls.

    envpath <- alabaster.base:::.get_environment_path(tmp)
    expect_true(file.exists(envpath))
    out <- jsonlite::fromJSON(envpath, simplifyVector=FALSE)
    expect_identical(out$type, "R")

    # Works when we use altSaveObject overrides.
    prevalt <- altSaveObjectFunction(saveObject)
    on.exit(altSaveObjectFunction(prevalt), add=TRUE, after=FALSE)
    tmp <- tempfile()
    altSaveObject(df, tmp)
    expect_null(getSaveEnvironment()) # correctly unset at the end of all calls.
    expect_true(file.exists(alabaster.base:::.get_environment_path(tmp)))

    # Child objects don't get an _environment.json as they inherit it from their parents.
    df$B <- DataFrame(B=runif(nrow(df)))
    tmp <- tempfile()
    saveObject(df, tmp)
    expect_null(getSaveEnvironment()) # correctly unset at the end of all calls.
    expect_true(file.exists(alabaster.base:::.get_environment_path(tmp)))
    expect_true(file.exists(file.path(tmp, "other_columns", "1")))
    expect_false(file.exists(alabaster.base:::.get_environment_path(file.path(tmp, "other_columns", "1"))))
})

test_that("reading the object respects its environment", {
    prev <- useSaveEnvironment(TRUE)
    on.exit(useSaveEnvironment(prev), add=TRUE, after=FALSE)
    expect_null(getSaveEnvironment())

    library(S4Vectors)
    df <- DataFrame(A=LETTERS)
    tmp <- tempfile()
    saveObject(df, tmp)

    # Checking that we correctly read the environment file.
    readObject(tmp) # priming the registry so that the loading function is realized from a string.
    oldfun <- readObjectFunctionRegistry()$data_frame
    registerReadObjectFunction("data_frame", function(...) {
        expect_identical(getSaveEnvironment()$type, "R")
        oldfun(...)
    }, existing="new")
    on.exit(registerReadObjectFunction("data_frame", oldfun, existing="new"), add=TRUE, after=FALSE)

    expect_error(roundtrip <- readObject(tmp), NA)
    expect_null(getSaveEnvironment()) # correctly unset at the end of all calls.
    expect_identical(df, roundtrip)

    # Works when we use altSaveObject overrides.
    prevalt <- altReadObjectFunction(readObject)
    on.exit(altReadObjectFunction(prevalt), add=TRUE, after=FALSE)
    expect_error(df <- altReadObject(tmp), NA)
    expect_null(getSaveEnvironment()) # correctly unset at the end of all calls.
    expect_identical(df, roundtrip)

    # Child objects don't get an _environment.json as they inherit it from their parents.
    df$B <- DataFrame(B=runif(nrow(df)))
    tmp <- tempfile()
    saveObject(df, tmp)
    expect_error(roundtrip <- readObject(tmp), NA)
    expect_null(getSaveEnvironment()) # correctly unset at the end of all calls.
    expect_identical(df, roundtrip)

    # Works when no environment is available.
    registerReadObjectFunction("data_frame", function(...) {
        expect_null(getSaveEnvironment())
        oldfun(...)
    }, existing="new")
    unlink(file.path(alabaster.base:::.get_environment_path(tmp)))
    expect_error(roundtrip <- readObject(tmp), NA)
    expect_null(getSaveEnvironment()) # correctly unset at the end of all calls.
})

#' Stage a DataFrameFactor object
#'
#' Stage a \link[S4Vectors]{DataFrameFactor} object, a generalization of the base factor where each level is a row of a \link[S4Vectors]{DataFrame}.
#'
#' @param x A \link[S4Vectors]{DataFrameFactor} object.
#' @inheritParams saveObject 
#' @param ... Further arguments, to pass to internal \code{\link{altSaveObject}} calls.
#'
#' @return 
#' \code{x} is saved to an on-disk representation inside \code{path}.
#' 
#' @author Aaron Lun
#' @examples
#' library(S4Vectors)
#' df <- DataFrame(X=LETTERS[1:5], Y=1:5)
#' out <- DataFrameFactor(df[sample(5, 100, replace=TRUE),,drop=FALSE])
#' 
#' tmp <- tempfile()
#' saveObject(out, tmp)
#' list.files(tmp, recursive=TRUE)
#'
#' @export
#' @rdname saveDataFrameFactor
#' @aliases stageObject,DataFrameFactor-method
setMethod("saveObject", "DataFrameFactor", function(x, path, ...) {
    dir.create(path)
    ofile <- file.path(path, "contents.h5")

    fhandle <- H5Fcreate(ofile, "H5F_ACC_TRUNC")
    on.exit(H5Fclose(fhandle), add=TRUE, after=FALSE)
    ghandle <- H5Gcreate(fhandle, "data_frame_factor")
    on.exit(H5Gclose(ghandle), add=TRUE, after=FALSE)

    .simple_save_codes(ghandle, x)
    stuff <- levels(x)
    altSaveObject(stuff, file.path(path, "levels"), ...)

    saveMetadata(x, 
        mcols.path=file.path(path, "element_annotations"),
        metadata.path=file.path(path, "other_annotations"),
        ...
    )

    saveObjectFile(path, "data_frame_factor", list(data_frame_factor=list(version="1.0")))
})

.anyDuplicated_fallback <- function(path, ...) {
    anyDuplicated(readObject(path, ...))
}

#######################################
########### OLD STUFF HERE ############
#######################################

#' @export
#' @importFrom utils write.csv
setMethod("stageObject", "DataFrameFactor", function(x, dir, path, child=FALSE, index.name="index", level.name="levels", mcols.name="mcols") {
    dir.create(file.path(dir, path))
    stuff <- levels(x)

    lev.info <- tryCatch({
        info <- altStageObject(stuff, dir, paste0(path, "/", level.name), child=TRUE)
        writeMetadata(info, dir)
    }, error=function(e) stop("failed to stage underlying DataFrame in a DataFrameFactor\n  - ", e$message))

    path2 <- paste0(path, "/", index.name)
    ofile <- file.path(dir, path2)
    rd <- data.frame(index=as.integer(x))
    if (!is.null(names(x))){ 
        rd <- cbind(row_names=names(x), rd)
    }
    .quickWriteCsv(rd, path=ofile, compression="gzip", row.names=FALSE)

    element_data <- .processMcols(x, dir, path, mcols.name) 

    list(
        `$schema`="data_frame_factor/v1.json",
        path=path2,
        is_child=child,
        factor=list(
            length=length(x),
            names=!is.null(names(x)),
            element_data=element_data,
            compression="gzip"
        ),
        data_frame_factor=list(
            levels=list(resource=lev.info)
        )
    )
})

#' Save a base list to disk
#' 
#' Save a \link{list} or \link[S4Vectors]{List} to a JSON or HDF5 file, with extra files created for any of the more complex list elements (e.g., DataFrames, arrays). 
#' This uses the \href{https://github.com/ArtifactDB/uzuki2}{uzuki2} specification to ensure that appropriate types are declared.
#'
#' @param x An ordinary R list, named or unnamed.
#' Alternatively, a \link[S4Vectors]{List} to be coerced into a list.
#' @inheritParams saveObject
#' @param list.format String specifying the format in which to save the list.
#' @param list.character.vls Logical scalar indicating whether to save character vectors in the custom variable length string (VLS) array format.
#' If \code{NULL}, this is determined based on a comparison of the expected storage against a fixed length array.
#' Only used if \code{list.format="hdf5"}.
#' @param ... Further arguments, passed to \code{\link{altSaveObject}} for complex child objects.
#' 
#' @return
#' For the \code{saveObject} method, \code{x} is saved inside \code{dir}.
#' \code{NULL} is invisibly returned.
#'
#' For \code{saveBaseListFormat}; if \code{list.format} is missing, a string containing the current format is returned.
#' If \code{list.format} is supplied, it is used to define the current format, and the \emph{previous} format is returned.
#'
#' @section File formats:
#' If \code{list.format="json.gz"} (default), the list is saved to a Gzip-compressed JSON file (the default).
#' This is an easily parsed format with low storage overhead.
#'
#' If \code{list.format="hdf5"}, \code{x} is saved into a HDF5 file instead.
#' This format is most useful for random access and for preserving the precision of numerical data.
#'
#' @section Storing scalars:
#' The \pkg{uzuki2} specification (see \url{https://github.com/ArtifactDB/uzuki2}) allows length-1 vectors to be stored as-is or as a scalar.
#' If a list element is of length 1, \code{saveBaseList} will store it as a scalar on-disk, effectively \dQuote{unboxing} it for languages with a concept of scalars.
#' Users can override this behavior by adding the \link{AsIs} class to the affected list element, which will force storage as a length-1 vector.
#' This reflects the decisions made by \code{\link{readBaseList}} and mimics the behavior of packages like \pkg{jsonlite}.
#'
#' @author Aaron Lun
#'
#' @seealso
#' \url{https://github.com/ArtifactDB/uzuki2} for the specification.
#'
#' \code{\link{readBaseList}}, to read the list back into the R session.
#'
#' @examples
#' library(S4Vectors)
#' ll <- list(A=1, B=LETTERS, C=DataFrame(X=1:5))
#'
#' tmp <- tempfile()
#' saveObject(ll, tmp)
#' list.files(tmp, recursive=TRUE)
#' 
#' @export
#' @name saveBaseList
#' @aliases 
#' saveObject,list-method
#' stageObject,list-method
#' stageObject,List-method
#' .saveBaseListFormat
#' @importFrom jsonlite toJSON
setMethod("saveObject", "list", function(x, path, list.format=saveBaseListFormat(), list.character.vls=NULL, ...) {
    dir.create(path, showWarnings=FALSE)
    dname <- "simple_list"

    env <- new.env()
    env$collected <- list()
    args <- list(list.format=list.format, ...)

    if (list.format == "hdf5") {
        fpath <- file.path(path, "list_contents.h5")
        handle <- H5Fcreate(fpath, "H5F_ACC_TRUNC")
        on.exit(.H5Fclose_null(handle), add=TRUE, after=FALSE)

        env$vls <- list()
        .transform_list_hdf5(
            x,
            dir=NULL,
            path=path,
            handle=handle,
            name=dname,
            env=env,
            simplified=TRUE,
            .version=3,
            extra=args,
            list.character.vls=list.character.vls,
            path.so.far=""
        )

        # Handling the VLS externally, because it doesn't interop nicely with rhdf5's handles.
        if (length(env$vls)) {
            handle <- .H5Fclose_null(handle)
            for (vls in env$vls) {
                h5_write_vls_array(fpath, vls$path, "data", "heap", vls$values, scalar=vls$scalar)
            }

            handle <- H5Fopen(fpath, "H5F_ACC_RDWR")
            for (vls in env$vls) {
                (function() {
                    ghandle <- H5Gopen(handle, vls$path)
                    on.exit(H5Gclose(ghandle), add=TRUE, after=FALSE)
                    h5_write_attribute(ghandle, "uzuki_type", "vls", scalar=TRUE)
                    if (!is.null(vls$names)) {
                        h5_write_vector(ghandle, "names", vls$names)
                    }

                    dhandle <- H5Dopen(ghandle, "data")
                    on.exit(H5Dclose(dhandle), add=TRUE, after=FALSE)
                    if (!is.null(vls$placeholder)) {
                        h5_write_attribute(dhandle, missingPlaceholderName, vls$placeholder, scalar=TRUE)
                    }
                })()
            }
        }

        ghandle <- H5Gopen(handle, dname)
        on.exit(H5Gclose(ghandle), add=TRUE, after=FALSE)
        h5_write_attribute(ghandle, "uzuki_version", "1.4", scalar=TRUE)

    } else {
        formatted <- .transform_list_json(x, dir=NULL, path=path, env=env, simplified=TRUE, .version=2, extra=args)
        formatted$version <- "1.2"

        str <- toJSON(formatted, auto_unbox=TRUE, ident=4, null="null", na="null", digits=NA)
        fpath <- file.path(path, "list_contents.json.gz")
        con <- gzfile(fpath, open="wb")
        write(file=con, str)
        close(con)
    }

    saveObjectFile(path, dname, list(simple_list=list(version="1.0", format=list.format)))
    invisible(NULL)
})

#' @export
#' @rdname saveBaseList
setMethod("saveObject", "List", function(x, path, list.format=saveBaseListFormat(), ...) {
    saveObject(as.list(x), path, list.format=list.format, ...)
})

#' @export
#' @rdname saveBaseList
saveBaseListFormat <- (function() {
   mode <- "json.gz"    
   function(list.format) {
       previous <- mode 
       if (missing(list.format)) {
           previous
       } else {
           if (is.null(list.format)) {
               list.format <- "json.gz"
           }
           assign("mode", match.arg(list.format, c("json.gz", "hdf5")), envir=parent.env(environment()))
           invisible(previous)
       }
   }
})()

##################################
########### INTERNALS ############
##################################

#' @importFrom S4Vectors DataFrame
.transform_list_hdf5 <- function(x, dir, path, handle, name, env, simplified, .version, extra, list.character.vls, path.so.far) {
    ghandle <- H5Gcreate(handle, name)
    on.exit(H5Gclose(ghandle), add=TRUE, after=FALSE)

    if (is.null(x)) {
        h5_write_attribute(ghandle, "uzuki_object", "nothing", scalar=TRUE)
        return(NULL)
    }

    sltype <- .is_stringlike(x)
    if (is.list(x) && !is.data.frame(x) && is.null(sltype)) {
        h5_write_attribute(ghandle, "uzuki_object", "list", scalar=TRUE)
        gdhandle <- H5Gcreate(ghandle, "data")
        on.exit(H5Gclose(gdhandle), add=TRUE, after=FALSE)

        nn <- names(x)
        if (!is.null(nn)) {
            .check_ok_list_names(nn)
            h5_write_vector(ghandle, "names", nn)
        }

        for (i in seq_along(x)) {
            newname <- as.character(i - 1L)
            tryCatch({
                .transform_list_hdf5(
                    x[[i]],
                    dir=dir,
                    path=path,
                    handle=gdhandle,
                    name=newname,
                    env=env,
                    simplified=simplified,
                    .version=.version,
                    extra=extra,
                    list.character.vls=list.character.vls,
                    path.so.far=paste0(path.so.far, name, "/data/")
                )
            }, error=function(e) {
                s <- if (is.null(nn)) i else paste0("'", nn[i], "'")
                stop("failed to stage list element ", s, "\n  - ", e$message)
            })
        }

        return(NULL)
    }

    if (is.null(dim(x))) {
        if (is.factor(x)) {
            h5_write_attribute(ghandle, "uzuki_object", "vector", scalar=TRUE)
            h5_write_attribute(ghandle, "uzuki_type", if (.version == 1 && is.ordered(x)) "ordered" else "factor", scalar=TRUE)

            codes <- as.integer(x) - 1L
            missing.placeholder <- NULL
            if (.version > 1 && anyNA(codes)) {
                missing.placeholder <- -1L
                codes[is.na(codes)] <- missing.placeholder
            }

            local({
                dhandle <- h5_write_vector(ghandle, "data", codes, emit=TRUE)
                on.exit(H5Dclose(dhandle), add=TRUE, after=FALSE)
                if (!is.null(missing.placeholder)) {
                    h5_write_attribute(dhandle, missingPlaceholderName, missing.placeholder, scalar=TRUE)
                }
            })

            h5_write_vector(ghandle, "levels", levels(x))
            if (.version > 1 && is.ordered(x)) {
                h5_write_vector(ghandle, "ordered", 1L, scalar=TRUE)
            }
            if (!is.null(names(x))) {
                h5_write_vector(ghandle, "names", names(x))
            }
            return(NULL)

        } else if (!is.null(sltype)) {
            h5_write_attribute(ghandle, "uzuki_object", "vector", scalar=TRUE)

            if (.version > 1 && sltype != "string") {
                h5_write_vector(ghandle, "format", sltype, scalar=TRUE)
            }

            scalarize <- length(x) == 1L && !is(x, "AsIs")
            y <- .sanitize_stringlike(x, sltype)

            missing.placeholder <- NULL
            if (.version > 1) {
                transformed <- transformVectorForHdf5(y, .version=.version)
                y <- transformed$transformed
                missing.placeholder <- transformed$placeholder
            } else if (is.character(y)) {
                if (anyNA(y)) {
                    missing.placeholder <- chooseMissingPlaceholderForHdf5(y, .version=.version)
                    y[is.na(y)] <- missing.placeholder
                }
            }

            if (sltype == "string" && !isFALSE(list.character.vls) && .version > 1) {
                if (is.null(list.character.vls)) {
                    list.character.vls <- h5_use_vls(y)
                }
                if (list.character.vls) {
                    env$vls <- append(
                        env$vls,
                        list(
                            list(
                                path = paste0(path.so.far, name),
                                values = y,
                                scalar = scalarize,
                                placeholder = missing.placeholder,
                                names = names(x)
                            )
                        )
                    )
                    return(NULL)
                }
            }

            dhandle <- h5_write_vector(ghandle, "data", y, emit=TRUE, scalar=scalarize)
            on.exit(H5Dclose(dhandle), add=TRUE, after=FALSE)
            if (!is.null(missing.placeholder)) {
                h5_write_attribute(dhandle, missingPlaceholderName, missing.placeholder, scalar=TRUE)
            }

            h5_write_attribute(ghandle, "uzuki_type", if (.version == 1) sltype else "string", scalar=TRUE)
            if (!is.null(names(x))) {
                h5_write_vector(ghandle, "names", names(x))
            }
            return(NULL)

        } else if (is.atomic(x)) {
            coerced <- .remap_atomic_type(x)
            scalarize <- length(x) == 1L && !is(x, "AsIs")
            y <- coerced$values

            h5_write_attribute(ghandle, "uzuki_object", "vector", scalar=TRUE)
            h5_write_attribute(ghandle, "uzuki_type", coerced$type, scalar=TRUE)

            missing.placeholder <- NULL
            if (.version > 1) {
                transformed <- transformVectorForHdf5(y, .version=.version)
                y <- transformed$transformed
                missing.placeholder <- transformed$placeholder
            } else {
                if (is.logical(y) && anyNA(y)) {
                    y <- as.integer(y)
                }
            }

            local({
                dhandle <- h5_write_vector(ghandle, "data", y, emit=TRUE, scalar=scalarize)
                on.exit(H5Dclose(dhandle), add=TRUE, after=FALSE)
                if (!is.null(missing.placeholder)) {
                    h5_write_attribute(dhandle, missingPlaceholderName, missing.placeholder, scalar=TRUE)
                }
            })
            if (!is.null(names(x))) {
                h5_write_vector(ghandle, "names", names(x))
            }
            return(NULL)
       }
    }

    # External object fallback.
    h5_write_attribute(ghandle, "uzuki_object", "external", scalar=TRUE)
    n <- length(env$collected)
    h5_write_vector(ghandle, "index", n, scalar=TRUE)

    if (is.data.frame(x)) {
        x <- DataFrame(x, check.names=FALSE)
    }
    tryCatch({
        if (simplified) {
            other.dir <- file.path(path, "other_contents")
            dir.create(other.dir, showWarnings=FALSE)
            do.call(altSaveObject, c(list(x, file.path(other.dir, n)), extra))
            env$collected[[n + 1L]] <- TRUE
        } else {
            np <- n + 1L
            meta <- altStageObject(x, dir, paste0(path, paste0("/child-", np)), child=TRUE)
            env$collected[[np]] <- list(resource=writeMetadata(meta, dir=dir))
        }
    }, error=function(e) {
        stop("failed to stage '", class(x)[1], "' entry inside a list\n  - ", e$message)
    }) 
}

.is_stringlike <- function(x) {
    if (is(x, "Date")) {
        return("date")
    } else if (.is_datetime(x)) {
        return("date-time")
    } else if (is.character(x)) {
        return("string")
    } else if (is.numeric_version(x)) {
        return("string")
    }
    return(NULL)
}

.sanitize_stringlike <- function(x, type) {
    if (type == "date-time") {
        .sanitize_datetime(x)
    } else {
        as.character(x)
    }
}

.check_ok_list_names <- function(nn) {
    empty <- nn == ""
    if (any(empty)) {
        stop("names of named lists must be non-empty (see element ", which(empty)[1], ")")
    } else if (fail <- anyDuplicated(nn)) {
        stop("names of named lists must be unique (multiple instances of '", nn[fail], "')")
    }
}

.transform_list_json <- function(x, dir, path, env, simplified, .version, extra) {
    if (is.null(x)) {
        return(list(type="nothing"))
    }

    sltype <- .is_stringlike(x)
    if (is.list(x) && !is.data.frame(x) && is.null(sltype)) {
        formatted <- list(type="list")

        nn <- names(x)
        if (!is.null(nn)) {
            .check_ok_list_names(nn)
            formatted$names <- I(nn)
        }

        values <- vector("list", length(x))
        for (i in seq_along(x)) {
            values[[i]] <- tryCatch({
                .transform_list_json(x[[i]], dir=dir, path=path, env=env, simplified=simplified, .version=.version, extra=extra)
            }, error=function(e) {
                s <- if (is.null(nn)) i else paste0("'", nn[i], "'")
                stop("failed to stage list element ", s, "\n  - ", e$message)
            })
        }

        formatted$values <- values
        return(formatted)
    }

    if (is.null(dim(x))) {
        if (is.factor(x)) {
            formatted <- list(
                type=if (.version == 1 && is.ordered(x)) "ordered" else "factor",
                levels=I(levels(x)),
                values=I(as.integer(x) - 1L)
            )

            if (.version > 1 && is.ordered(x)) {
                formatted$ordered <- TRUE
            }

            formatted <- .add_json_names(x, formatted)
            return(formatted)

        } else if (!is.null(sltype)) {
            formatted <- list(
                type=if (.version == 1) sltype else "string",
                values=.sanitize_stringlike(x, sltype)
            )

            if (length(x) == 1L && is(x, "AsIs")) {
                formatted$values <- I(formatted$values)
            }

            if (.version > 1 && sltype != "string") {
                formatted$format <- sltype
            }

            formatted <- .add_json_names(x, formatted)
            return(formatted)

        } else if (is.atomic(x)) {
            formatted <- .remap_atomic_type(x)

            y <- formatted$values
            if (is.numeric(y) && !all(is.finite(y))) {
                nan <- is.nan(y)
                inf <- is.infinite(y)
                pos <- y > 0

                has.nan <- any(nan)
                has.inf <- any(inf)
                if (has.nan || has.inf) {
                    y <- as.list(y)
                    if (has.nan) {
                        y[nan] <- list("NaN")
                    }
                    if (has.inf) {
                        y[inf & pos] <- list("Inf")
                        y[inf & !pos] <- list("-Inf")
                    }
                    formatted$values <- y
                }
            }

            if (length(x) == 1L && is(x, "AsIs")) {
                formatted$values <- I(formatted$values)
            }

            formatted <- .add_json_names(x, formatted)
            return(formatted)
       }
    }

    # External object fallback.
    n <- length(env$collected)
    formatted <- list(
        type="external",
        index=n
    )

    if (is.data.frame(x)) {
        x <- DataFrame(x, check.names=FALSE)
    }
    tryCatch({
        if (simplified) {
            other.dir <- file.path(path, "other_contents")
            dir.create(other.dir, showWarnings=FALSE)
            do.call(altSaveObject, c(list(x, file.path(other.dir, n)), extra))
            env$collected[[n + 1L]] <- TRUE
        } else {
            np <- n + 1L
            meta <- altStageObject(x, dir, paste0(path, paste0("/child-", np)), child=TRUE)
            env$collected[[np]] <- list(resource=writeMetadata(meta, dir=dir))
        }
    }, error=function(e) {
        stop("failed to stage '", class(x)[1], "' entry inside a list\n  - ", e$message)
    }) 

    return(formatted)
}

.add_json_names <- function(x, formatted) {
    if (!is.null(names(x))) {
        formatted$names <- I(names(x))
    }
    formatted
}

#######################################
########### OLD STUFF HERE ############
#######################################

#' @export
setMethod("stageObject", "list", function(x, dir, path, child=FALSE, fname="list", .version=NULL) {
    dir.create(file.path(dir, path), showWarnings=FALSE)

    env <- new.env()
    env$collected <- list()
    meta <- list()

    format <- .saveBaseListFormat()
    if (!is.null(format) && format == "hdf5") {
        target <- paste0(path, "/", fname, ".h5")
        fpath <- file.path(dir, target)

        dname <- "contents"
        meta[["$schema"]] <- "hdf5_simple_list/v1.json"
        meta$hdf5_simple_list <- list(group=dname)

        if (is.null(.version)) {
            .version <- 3
        }

        local({
            handle <- H5Fcreate(fpath, "H5F_ACC_TRUNC")
            on.exit(H5Fclose(handle), add=TRUE, after=FALSE)
            .transform_list_hdf5(
                x,
                dir=dir,
                path=path,
                handle=handle,
                name=dname,
                env=env,
                simplified=FALSE,
                .version=.version,
                extra=NULL,
                list.character.vls=FALSE,
                path.so.far=""
            )

            if (.version > 1) {
                ghandle <- H5Gopen(handle, dname)
                on.exit(H5Gclose(ghandle), add=TRUE, after=FALSE)
                h5_write_attribute(ghandle, "uzuki_version", paste0("1.", .version), scalar=TRUE)
            }
        })

        check_list_hdf5(fpath, dname, length(env$collected)) # Check that we did it correctly.

    } else {
        target <- paste0(path, "/", fname, ".json.gz")

        if (is.null(.version)) {
            .version <- 2
        }

        formatted <- .transform_list_json(x, dir=dir, path=path, env=env, simplified=FALSE, .version=.version)

        if (.version > 1) {
            formatted$version <- paste0("1.", .version)
        }

        meta[["$schema"]] <- "json_simple_list/v1.json"
        meta$json_simple_list <- list(compression="gzip")

        str <- toJSON(formatted, auto_unbox=TRUE, ident=4, null="null", na="null")
        fpath <- file.path(dir, target)
        con <- gzfile(fpath, open="wb")
        write(file=con, str)
        close(con)

        check_list_json(fpath, length(env$collected), parallel=TRUE) # Check that we did it correctly.
    }

    extras <- list(
        path=target,
        is_child=child,
        simple_list=list(
            children=env$collected
        )
    )

    c(extras, meta)
})

#' @export
setMethod("stageObject", "List", function(x, dir, path, child=FALSE, fname="list") {
    stageObject(as.list(x), dir, path, child=child, fname=fname)
})

#' @export
.saveBaseListFormat <- function(...) saveBaseListFormat(...)

#' Transform a vector to save in a HDF5 file
#'
#' This handles type casting and missing placeholder value selection/substitution.
#' It is primarily intended for developers of \pkg{alabaster.*} extensions.
#'
#' @param x An atomic vector to be saved to HDF5.
#' @param .version Internal use only.
#' 
#' @return
#' A list containing:
#' \itemize{
#' \item \code{transformed}, the transformed vector.
#' This may be the same as \code{x} if no \code{NA} values were detected.
#' Note that logical vectors are cast to integers.
#' \item \code{placeholder}, the placeholder value used to represent \code{NA} values.
#' This is \code{NULL} if no \code{NA} values were detected in \code{x},
#' otherwise it is the same as the output of \code{\link{chooseMissingPlaceholderForHdf5}}.
#' }
#'
#' @author Aaron Lun
#' @examples
#' transformVectorForHdf5(c(TRUE, NA, FALSE))
#' transformVectorForHdf5(c(1L, NA, 2L))
#' transformVectorForHdf5(c(1L, NaN, 2L))
#' transformVectorForHdf5(c("FOO", NA, "BAR"))
#' transformVectorForHdf5(c("FOO", NA, "NA"))
#'
#' @export
transformVectorForHdf5 <- function(x, .version=3) {
    placeholder <- NULL
    if (is.logical(x)) {
        storage.mode(x) <- "integer"
        if (anyNA(x)) {
            placeholder <- -1L
            x[is.na(x)] <- placeholder
        }

    } else if (is.character(x)) {
        x <- enc2utf8(x) # avoid mis-encoding multi-byte characters from Latin-1.
        if (anyNA(x)) {
            placeholder <- chooseMissingPlaceholderForHdf5(x)
            x[is.na(x)] <- placeholder
        }

    } else if (is.double(x)) {
        if (any_actually_numeric_na(x)) {
            placeholder <- chooseMissingPlaceholderForHdf5(x, .version=.version)
            if (!any_actually_numeric_na(placeholder)) {
                x[is_actually_numeric_na(x)] <- placeholder
            }
        }

    } else {
        if (anyNA(x)) {
            placeholder <- as(NA, storage.mode(x))
        }
    }

    list(transformed = x, placeholder = placeholder)
}

# This tests the exported HDF5-related utilities.
# library(testthat); library(alabaster.base); source("test-hdf5.R")

test_that("transformations work as expected", {
    # Logical.
    out <- transformVectorForHdf5(c(TRUE, FALSE, FALSE))
    expect_identical(out$transformed, c(1L, 0L, 0L))
    expect_null(out$placeholder)

    out <- transformVectorForHdf5(c(TRUE, NA, FALSE))
    expect_identical(out$transformed, c(1L, -1L, 0L))
    expect_identical(out$placeholder, -1L)
    expect_identical(chooseMissingPlaceholderForHdf5(TRUE), -1L)

    # Integer.
    input <- c(1L, NA, 2L)
    out <- transformVectorForHdf5(input)
    expect_identical(out$transformed, input)
    expect_identical(out$placeholder, NA_integer_)
    expect_identical(chooseMissingPlaceholderForHdf5(1L), NA_integer_)

    input <- 1:3
    out <- transformVectorForHdf5(input)
    expect_identical(out$transformed, input)
    expect_null(out$placeholder)

    # Double.
    input <- c(1, NaN, 2)
    out <- transformVectorForHdf5(input)
    expect_identical(out$transformed, input)
    expect_null(out$placeholder)

    input <- c(1, NA, 2)
    out <- transformVectorForHdf5(input)
    expect_identical(out$transformed, input)
    expect_identical(out$placeholder, NA_real_)
    expect_identical(chooseMissingPlaceholderForHdf5(1), NA_real_)

    input <- c(1, NA, NaN)
    out <- transformVectorForHdf5(input, .version=2)
    expect_identical(out$transformed, input)
    expect_identical(out$placeholder, NA_real_)

    out <- transformVectorForHdf5(input, .version=3)
    expect_identical(out$transformed, c(1, Inf, NaN))
    expect_identical(out$placeholder, Inf)

    # String.
    out <- transformVectorForHdf5(c("FOO", "NA", "BAR"))
    expect_identical(out$transformed, c("FOO", "NA", "BAR"))
    expect_null(out$placeholder)

    out <- transformVectorForHdf5(c("FOO", NA, "BAR"))
    expect_identical(out$transformed, c("FOO", "NA", "BAR"))
    expect_identical(out$placeholder, "NA")
    expect_identical(chooseMissingPlaceholderForHdf5("foobar"), "NA")

    out <- transformVectorForHdf5(c("FOO", NA, "NA"))
    expect_identical(out$transformed, c("FOO", "_NA", "NA"))
    expect_identical(out$placeholder, "_NA")
    expect_identical(chooseMissingPlaceholderForHdf5(c("NA", "foobar")), "_NA")
})

#' VLS saving utilities
#'
#' Utilities for saving our custom variable length string array format in HDF5.
#' Intended for \pkg{alabaster.*} developers only.
#'
#' @name vls
#' @aliases 
#' h5_use_vls
#' h5_write_vls_array
#' h5_read_vls_array
NULL

#' @export
h5_use_vls <- function(x) {
    use_vls(x)
}

#' @export
h5_write_vls_array <- function(file, group, pointers, heap, x, compress=6, chunks=NULL, buffer.size=1e6, scalar=FALSE) {
    d <- dim(x)
    if (is.null(d)) {
        d <- length(x)
        if (is.null(chunks)) {
            chunks <- h5_guess_vector_chunks(d)
        }
    } else {
        if (is.null(chunks)) {
            stop("'chunks=' must be specified for high-dimensional 'x'")
        }
    }

    dump_vls(
        file,
        group,
        pointers,
        heap,
        x,
        raw_dims=d,
        raw_chunks=chunks,
        compress=compress,
        scalar=scalar,
        buffer_size=buffer.size
    )
}

#' @export
h5_read_vls_array <- function(file, pointers, heap, missing.placeholder=NULL, buffer.size=1e6, native=FALSE) {
    parse_vls(
        file,
        pointers,
        heap,
        buffer_size=buffer.size,
        placeholder=missing.placeholder,
        native=native
    )
}

# library(testthat); library(alabaster.base); source("test-vls.R")

test_that("h5_use_vls behaves as expected", {
    expect_false(h5_use_vls(LETTERS))
    expect_true(h5_use_vls(c(LETTERS, strrep("Z", 100))))
})

library(rhdf5)
test_that("VLS writing works for arrays", {
    N <- as.integer(runif(1200, 1, 100))
    collection <- strrep(sample(LETTERS, length(N), replace=TRUE), N)

    for (buffer.size in c(200, 500, 1000, 2000)) {
        temp <- tempfile(fileext=".h5")
        h5createFile(temp)
        h5createGroup(temp, "FOO")
        h5_write_vls_array(temp, "FOO", "pointers", "heap", collection, chunk=31, buffer.size=buffer.size)

        roundtrip <- h5_read_vls_array(temp, "FOO/pointers", "FOO/heap", buffer.size=buffer.size, native=FALSE)
        expect_identical(as.vector(roundtrip), collection)
        nroundtrip <- h5_read_vls_array(temp, "FOO/pointers", "FOO/heap", buffer.size=buffer.size, native=TRUE)
        expect_identical(as.vector(nroundtrip), collection)
    }
})

test_that("VLS writing works for matrices", {
    N <- as.integer(runif(1200, 1, 100))
    collection <- strrep(sample(LETTERS, length(N), replace=TRUE), N)
    mat <- matrix(collection, 40, 30)

    for (buffer.size in c(200, 500, 1000, 2000)) {
        temp <- tempfile(fileext=".h5")
        h5createFile(temp)
        h5createGroup(temp, "FOO")
        h5_write_vls_array(temp, "FOO", "pointers", "heap", mat, chunk=c(9, 11), buffer.size=buffer.size)

        roundtrip <- h5_read_vls_array(temp, "FOO/pointers", "FOO/heap", buffer.size=buffer.size, native=FALSE)
        expect_identical(roundtrip, mat)
        nroundtrip <- h5_read_vls_array(temp, "FOO/pointers", "FOO/heap", buffer.size=buffer.size, native=TRUE)
        expect_identical(t(nroundtrip), mat)
    }
})

test_that("VLS writing works for arrays", {
    N <- as.integer(runif(30000, 1, 100))
    collection <- strrep(sample(LETTERS, length(N), replace=TRUE), N)
    arr <- array(collection, c(20, 30, 50))

    for (buffer.size in c(200, 500, 1000, 2000)) {
        temp <- tempfile(fileext=".h5")
        h5createFile(temp)
        h5createGroup(temp, "FOO")
        h5_write_vls_array(temp, "FOO", "pointers", "heap", arr, chunk=c(8, 6, 11), buffer.size=buffer.size)

        roundtrip <- h5_read_vls_array(temp, "FOO/pointers", "FOO/heap", buffer.size=buffer.size, native=FALSE)
        expect_identical(roundtrip, arr)
        nroundtrip <- h5_read_vls_array(temp, "FOO/pointers", "FOO/heap", buffer.size=buffer.size, native=TRUE)
        expect_identical(aperm(nroundtrip, 3:1), arr)
    }
})

#' Create a redirection file
#'
#' \emph{WARNING: this function is deprecated. 
#' Redirection is no longer supported in the latest \pkg{alabaster} framework.}
#' Create a redirection to another path in the same staging directory.
#' This is useful for creating short-hand aliases for resources that have inconveniently long paths.
#'
#' @param dir String containing the path to the staging directory.
#' @param src String containing the source path relative to \code{dir}.
#' @param dest String containing the destination path relative to \code{dir}.
#' This may be any path that can also be used in \code{\link{acquireMetadata}}.
#'
#' @return A list of metadata that can be processed by \code{\link{writeMetadata}}.
#' 
#' @details
#' \code{src} should not correspond to an existing file inside \code{dir}.
#' This avoids ambiguity when attempting to load \code{src} via \code{\link{acquireMetadata}}.
#' Otherwise, it would be unclear as to whether the user wants the file at \code{src} or the redirection target \code{dest}.
#' 
#' \code{src} may correspond to existing directories.
#' This is because directories cannot be used in \code{acquireMetadata}, so no such ambiguity exists.
#'
#' @author Aaron Lun
#' @examples
#' # Staging an example DataFrame:
#' library(S4Vectors)
#' df <- DataFrame(A=1:10, B=LETTERS[1:10])
#' tmp <- tempfile()
#' dir.create(tmp)
#' info <- stageObject(df, tmp, path="coldata")
#'writeMetadata(info, tmp)
#'
#' # Creating a redirection:
#' redirect <- createRedirection(tmp, "foobar", "coldata/simple.csv.gz")
#'writeMetadata(redirect, tmp)
#'
#' # We can then use this redirect to pull out metadata:
#' info2 <- acquireMetadata(tmp, "foobar")
#' str(info2)
#'
#' @export
#' @aliases .createRedirection
createRedirection <- function(dir, src, dest) {
    json <- paste0(src, ".json")
    if (file.exists(file.path(dir, json))) {
        stop("cannot create a short-hand link over existing file '", json, "'")
    } 

    list(
        path = src,
        `$schema` = "redirection/v1.json",
        redirection = list(
            targets = list(
                list(
                    type = "local",
                    location = dest
                )
            )
        )
    )
}

# Soft-deprecated back-compatibility fixes.

#' @export
.createRedirection <- function(...) createRedirection(...)

#' Clone an existing directory
#'
#' Clone an existing directory to a new location.
#' This is typically performed inside \code{\link{saveObject}} after detecting duplicated objects,
#' see \code{?\link{createDedupSession}} for an example use case.
#'
#' @param src String containing the path to the source directory, typically generated by a prior \code{\link{saveObject}} call.
#' @param dest String containing the path to the destination directory, typically the \code{path} in a subsequent \code{\link{saveObject}} call. 
#' @param action String specifying the action to use when cloning files from \code{src} to \code{dest}.
#' \itemize{
#' \item \code{"copy"}: copy all files within \code{src} to their corresponding locations in \code{dest}.
#' \item \code{"link"}: create a hard link from each file in \code{src} to its corresponding location in \code{dest}.
#' If this fails, we silently fall back to a copy.
#' \item \code{"symlink"}: create a symbolic link from each file in \code{src} to its corresponding location in \code{dest}.
#' Each symbolic link contains the absolute path in the corresponding file in its original directory,
#' which is useful when the contents of \code{dest} might be moved (but the original directory will not).
#' \item \code{"relsymlink"}: create a symbolic link from each file in \code{src} to its corresponding location in \code{dest}.
#' Each symbolic link contains the minimal relative path to the corresponding file in the original directory,
#' which is useful when both \code{src} and \code{dest} are moved together, e.g., as they are part of the same parent object like a SummarizedExperiment.
#' }
#' 
#' @return A new directory is created at \code{dest} with the contents of \code{src}, either copied or linked.
#' \code{NULL} is invisibly returned.
#' 
#' @author Aaron Lun
#'
#' @examples
#' tmp <- tempfile()
#' dir.create(tmp)
#' 
#' src <- file.path(tmp, "A")
#' dir.create(src)
#' write(file=file.path(src, "foobar"), LETTERS)
#' 
#' dest <- file.path(tmp, "B")
#' cloneDirectory(src, dest)
#' list.files(dest, recursive=TRUE)
#'
#' @seealso
#' \code{\link{cloneFile}}, to clone individual files.
#' 
#' @export
#' @importFrom utils head tail
cloneDirectory <- function(src, dest, action=c("link", "copy", "symlink", "relsymlink")) {
    action <- match.arg(action)
    dir.create(dest)
    manifest <- list.files(src, recursive=TRUE)

    if (action == "relsymlink") {
        base2base <- relative_path_to_src(src, dest)
        pwd <- getwd()

        for (y in manifest) {
            ydir <- dirname(y)
            ybase <- basename(y)
            ywd <- file.path(dest, ydir)
            dir.create(ywd, recursive=TRUE, showWarnings=FALSE)

            ycounter <- 0L
            while (ydir != ".") {
                ydir <- dirname(ydir)
                ycounter <- ycounter + 1L
            }
            ycomponents <- c(rep("..", ycounter), base2base, y)
            ytarget <- do.call(file.path, as.list(ycomponents))

            (function() { # wrapping this in a function so that the on.exit is called in a timely manner.
                on.exit(setwd(pwd))
                setwd(ywd)
                if (!file.symlink(ytarget, ybase)) {
                    stop("failed to link '", y, "' from '", src, "' to '", dest, "'")
                }
            })()
        }

    } else if (action == "link") {
        for (y in manifest) {
            to <- file.path(dest, y)
            dir.create(dirname(to), recursive=TRUE, showWarnings=FALSE)
            from <- file.path(src, y)
            from <- resolve_symlinks(from) # Resolving any symlinks so that we hard link to the original file.
            if (!suppressWarnings(file.link(from, to)) && !file.copy(from, to)) {
                stop("failed to copy or link '", y, "' from '", src, "' to '", dest, "'")
            }
        }

    } else if (action == "copy") {
        for (y in manifest) {
            to <- file.path(dest, y)
            dir.create(dirname(to), recursive=TRUE, showWarnings=FALSE)
            from <- file.path(src, y)
            if (!file.copy(from, to)) { # file.copy() follows symbolic links, so no need for special treatment here.
                stop("failed to copy '", y, "' from '", src, "' to '", dest, "'")
            }
        }

    } else if (action == "symlink") {
        for (y in manifest) {
            to <- file.path(dest, y)
            dir.create(dirname(to), recursive=TRUE, showWarnings=FALSE)
            from <- absolutizePath(file.path(src, y))
            if (!file.symlink(from, to)) {
                stop("failed to symlink '", y, "' from '", src, "' to '", dest, "'")
            }
        }
    }
}

relative_path_to_src <- function(src, dest) {
    src <- normalizePath(src, mustWork=TRUE)
    src.comp <- decompose_path(src)$components
    src.len <- length(src.comp)

    dest <- normalizePath(dest, mustWork=TRUE)
    dest.comp <- decompose_path(dest)$components
    dest.len <- length(dest.comp)

    counter <- 0L
    for (i in seq_len(min(src.len, dest.len))) {
        if (src.comp[i] != dest.comp[i]) {
            counter <- i - 1L
            break
        }
    }

    components <- c(rep("..", dest.len - counter), src.comp[(counter+1):src.len])
    do.call(file.path, as.list(components))
}

decompose_path <- function(path) {
    output <- character()
    repeat {
        base <- basename(path)
        dpath <- dirname(path)
        if (dpath == path && dpath != ".") {
            return(list(relative=FALSE, root=dpath, components=output))
        }
        output <- c(base, output)
        if (dpath == ".") {
            return(list(relative=TRUE, root=NULL, components=output))
        }
        path <- dpath
    }
}

resolve_symlinks <- function(from) {
    while (1) {
        ll <- Sys.readlink(from)
        if (ll == "") {
            break
        }

        decomposed <- decompose_path(ll)
        if (decomposed$relative) {
            from <- file.path(dirname(from), ll)
        } else {
            from <- ll
        }
    }

    from
}

# library(testthat); library(alabaster.base); source('test-cloneDirectory.R')

create_test_directory <- function(src) {
    dir.create(src)
    write(file=file.path(src, "foobar.txt"), LETTERS)
    dir.create(file.path(src, "stuff"))
    write(file=file.path(src, "stuff", "whee.txt"), as.character(1:10))
    dir.create(file.path(src, "stuff", "blah"))
    write(file=file.path(src, "stuff", "blah", "kanon.txt"), "air")
}

test_that("cloneDirectory works with copies", {
    src <- tempfile()
    create_test_directory(src)

    dest <- tempfile()
    cloneDirectory(src, dest, action="copy")
    expect_identical(readLines(file.path(dest, "foobar.txt")), LETTERS) 
    expect_identical(readLines(file.path(dest, "stuff", "whee.txt")), as.character(1:10))
    expect_identical(readLines(file.path(dest, "stuff", "blah", "kanon.txt")), "air")

    # These are real copies; modifications do not affect the original.
    write(file=file.path(dest, "foobar.txt"), letters, append=TRUE)
    expect_identical(readLines(file.path(dest, "foobar.txt")), c(LETTERS, letters)) 
    expect_identical(readLines(file.path(src, "foobar.txt")), LETTERS)
})

test_that("cloneDirectory works with links", {
    src <- tempfile()
    create_test_directory(src)

    dest <- tempfile()
    cloneDirectory(src, dest, action="link")
    expect_identical(readLines(file.path(dest, "foobar.txt")), LETTERS) 
    expect_identical(readLines(file.path(dest, "stuff", "whee.txt")), as.character(1:10))
    expect_identical(readLines(file.path(dest, "stuff", "blah", "kanon.txt")), "air")

    # These are now linked copies; modifications do affect the original!
    write(file=file.path(dest, "foobar.txt"), letters, append=TRUE)
    expect_identical(readLines(file.path(dest, "foobar.txt")), c(LETTERS, letters)) 
    expect_identical(readLines(file.path(src, "foobar.txt")), c(LETTERS, letters)) 
})

test_that("cloneDirectory works with symlinks", {
    skip_on_os("windows")

    src <- tempfile()
    create_test_directory(src)

    dest <- tempfile()
    cloneDirectory(src, dest, action="symlink")
    expect_identical(readLines(file.path(dest, "foobar.txt")), LETTERS) 
    expect_identical(readLines(file.path(dest, "stuff", "whee.txt")), as.character(1:10))
    expect_identical(readLines(file.path(dest, "stuff", "blah", "kanon.txt")), "air")

    cleaned <- absolutizePath(src)
    expect_identical(Sys.readlink(file.path(dest, "foobar.txt")), file.path(cleaned, "foobar.txt"))
    expect_identical(Sys.readlink(file.path(dest, "stuff", "whee.txt")), file.path(cleaned, "stuff", "whee.txt"))
    expect_identical(Sys.readlink(file.path(dest, "stuff", "blah", "kanon.txt")), file.path(cleaned, "stuff", "blah", "kanon.txt"))

    # Checking that we save absolute paths, even if the input 'src' is relative.
    pwd <- getwd()
    setwd(dirname(src))
    on.exit(setwd(pwd))

    dest <- tempfile()
    cloneDirectory(basename(src), dest, action="symlink")
    expect_identical(readLines(file.path(dest, "foobar.txt")), LETTERS) 
    expect_identical(readLines(file.path(dest, "stuff", "whee.txt")), as.character(1:10))
    expect_identical(readLines(file.path(dest, "stuff", "blah", "kanon.txt")), "air")

    expect_identical(Sys.readlink(file.path(dest, "foobar.txt")), file.path(cleaned, "foobar.txt"))
    expect_identical(Sys.readlink(file.path(dest, "stuff", "whee.txt")), file.path(cleaned, "stuff", "whee.txt"))
    expect_identical(Sys.readlink(file.path(dest, "stuff", "blah", "kanon.txt")), file.path(cleaned, "stuff", "blah", "kanon.txt"))
})

test_that("cloneDirectory symlinks and copies/hardlinks interact correctly", {
    skip_on_os("windows")

    src0 <- tempfile()
    create_test_directory(src0)
    src <- tempfile()
    cloneDirectory(src0, src, action="symlink")

    expect_identical(alabaster.base:::resolve_symlinks(file.path(src, "foobar.txt")), file.path(src0, "foobar.txt"))
    expect_identical(alabaster.base:::resolve_symlinks(file.path(src, "stuff", "whee.txt")), file.path(src0, "stuff", "whee.txt"))
    expect_identical(alabaster.base:::resolve_symlinks(file.path(src, "stuff", "blah", "kanon.txt")), file.path(src0, "stuff", "blah", "kanon.txt"))

    dest1 <- tempfile()
    cloneDirectory(src, dest1, action="link")
    expect_identical(readLines(file.path(dest1, "foobar.txt")), LETTERS) 
    expect_identical(readLines(file.path(dest1, "stuff", "whee.txt")), as.character(1:10))
    expect_identical(readLines(file.path(dest1, "stuff", "blah", "kanon.txt")), "air")
    expect_identical(Sys.readlink(file.path(dest1, "foobar.txt")), "")
    expect_identical(Sys.readlink(file.path(dest1, "stuff", "whee.txt")), "")
    expect_identical(Sys.readlink(file.path(dest1, "stuff", "blah", "kanon.txt")), "")

    dest2 <- tempfile()
    cloneDirectory(src, dest2, action="copy")
    expect_identical(readLines(file.path(dest2, "foobar.txt")), LETTERS) 
    expect_identical(readLines(file.path(dest2, "stuff", "whee.txt")), as.character(1:10))
    expect_identical(readLines(file.path(dest2, "stuff", "blah", "kanon.txt")), "air")
    expect_identical(Sys.readlink(file.path(dest2, "foobar.txt")), "")
    expect_identical(Sys.readlink(file.path(dest2, "stuff", "whee.txt")), "")
    expect_identical(Sys.readlink(file.path(dest2, "stuff", "blah", "kanon.txt")), "")

    # Checking what happens if the test directory has relative symlinks.
    src2 <- tempfile()
    dir.create(file.path(src2, "stuff", "blah"), recursive=TRUE)
    write(file=file.path(src2, "foobar.txt"), LETTERS)
    file.symlink(file.path("..", "..", "foobar.txt"), file.path(src2, "stuff", "blah", "kanon.txt"))
    file.symlink(file.path("blah", "kanon.txt"), file.path(src2, "stuff", "whee.txt")) # recursive symlink
    alt <- tempfile(tmpdir=dirname(src2))
    write(file=alt, "ayu")
    file.symlink(file.path("..", "..", "..", basename(alt)), file.path(src2, "stuff", "blah", "tsukimiya.txt"))

    expect_identical(absolutizePath(alabaster.base:::resolve_symlinks(file.path(src2, "stuff", "whee.txt"))), absolutizePath(file.path(src2, "foobar.txt")))
    expect_identical(absolutizePath(alabaster.base:::resolve_symlinks(file.path(src2, "stuff", "blah", "tsukimiya.txt"))), absolutizePath(alt))

    dest3 <- tempfile()
    cloneDirectory(src2, dest3, action="link")
    expect_identical(readLines(file.path(dest3, "foobar.txt")), LETTERS) 
    expect_identical(readLines(file.path(dest3, "stuff", "whee.txt")), LETTERS)
    expect_identical(readLines(file.path(dest3, "stuff", "blah", "kanon.txt")), LETTERS)
    expect_identical(readLines(file.path(dest3, "stuff", "blah", "tsukimiya.txt")), "ayu")
    expect_identical(Sys.readlink(file.path(dest3, "foobar.txt")), "")
    expect_identical(Sys.readlink(file.path(dest3, "stuff", "whee.txt")), "")
    expect_identical(Sys.readlink(file.path(dest3, "stuff", "blah", "kanon.txt")), "")
})

test_that("cloneDirectory works with relative symlinks", {
    skip_on_os("windows")

    workspace <- tempfile()
    dir.create(workspace)
    src <- file.path(workspace, "A")
    create_test_directory(src)

    dest <- file.path(workspace, "B")
    cloneDirectory(src, dest, action="relsymlink")
    expect_identical(readLines(file.path(dest, "foobar.txt")), LETTERS) 
    expect_identical(readLines(file.path(dest, "stuff", "whee.txt")), as.character(1:10))
    expect_identical(readLines(file.path(dest, "stuff", "blah", "kanon.txt")), "air")

    expect_identical(Sys.readlink(file.path(dest, "foobar.txt")), file.path("..", "A", "foobar.txt"))
    expect_identical(Sys.readlink(file.path(dest, "stuff", "whee.txt")), file.path("..", "..", "A", "stuff", "whee.txt"))
    expect_identical(Sys.readlink(file.path(dest, "stuff", "blah", "kanon.txt")), file.path("..", "..", "..", "A", "stuff", "blah", "kanon.txt"))

    # Checking that the relative path discovery works as expected.
    test <- file.path(workspace, "C", "D")
    dir.create(test, recursive=TRUE)
    expect_identical(alabaster.base:::relative_path_to_src(src, test), "../../A")
    expect_identical(alabaster.base:::relative_path_to_src(test, dest), "../C/D")
})

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

check_csv <- function(path, is_compressed, parallel) {
    .Call(`_alabaster_base_check_csv`, path, is_compressed, parallel)
}

check_list_hdf5 <- function(file, name, num_external) {
    .Call(`_alabaster_base_check_list_hdf5`, file, name, num_external)
}

check_list_json <- function(file, num_external, parallel) {
    .Call(`_alabaster_base_check_list_json`, file, num_external, parallel)
}

any_actually_numeric_na <- function(x) {
    .Call(`_alabaster_base_any_actually_numeric_na`, x)
}

is_actually_numeric_na <- function(x) {
    .Call(`_alabaster_base_is_actually_numeric_na`, x)
}

choose_numeric_missing_placeholder <- function(x) {
    .Call(`_alabaster_base_choose_numeric_missing_placeholder`, x)
}

not_rfc3339 <- function(x) {
    .Call(`_alabaster_base_not_rfc3339`, x)
}

load_csv <- function(path, is_compressed, nrecords, parallel) {
    .Call(`_alabaster_base_load_csv`, path, is_compressed, nrecords, parallel)
}

load_list_hdf5 <- function(file, name, obj) {
    .Call(`_alabaster_base_load_list_hdf5`, file, name, obj)
}

load_list_json <- function(file, obj, parallel) {
    .Call(`_alabaster_base_load_list_json`, file, obj, parallel)
}

validate <- function(path, metadata) {
    .Call(`_alabaster_base_validate`, path, metadata)
}

register_validate_function <- function(type, fun, existing) {
    .Call(`_alabaster_base_register_validate_function`, type, fun, existing)
}

deregister_validate_function <- function(type) {
    .Call(`_alabaster_base_deregister_validate_function`, type)
}

register_height_function <- function(type, fun, existing) {
    .Call(`_alabaster_base_register_height_function`, type, fun, existing)
}

deregister_height_function <- function(type) {
    .Call(`_alabaster_base_deregister_height_function`, type)
}

register_dimensions_function <- function(type, fun, existing) {
    .Call(`_alabaster_base_register_dimensions_function`, type, fun, existing)
}

deregister_dimensions_function <- function(type) {
    .Call(`_alabaster_base_deregister_dimensions_function`, type)
}

register_any_duplicated <- function(set) {
    .Call(`_alabaster_base_register_any_duplicated`, set)
}

register_satisfies_interface <- function(type, interface) {
    .Call(`_alabaster_base_register_satisfies_interface`, type, interface)
}

deregister_satisfies_interface <- function(type, interface) {
    .Call(`_alabaster_base_deregister_satisfies_interface`, type, interface)
}

register_derived_from <- function(type, parent) {
    .Call(`_alabaster_base_register_derived_from`, type, parent)
}

deregister_derived_from <- function(type, parent) {
    .Call(`_alabaster_base_deregister_derived_from`, type, parent)
}

use_vls <- function(x) {
    .Call(`_alabaster_base_use_vls`, x)
}

dump_vls <- function(file, group, pointers, heap, x, raw_dims, raw_chunks, compress, scalar, buffer_size) {
    .Call(`_alabaster_base_dump_vls`, file, group, pointers, heap, x, raw_dims, raw_chunks, compress, scalar, buffer_size)
}

parse_vls <- function(file, pointers, heap, buffer_size, placeholder, native) {
    .Call(`_alabaster_base_parse_vls`, file, pointers, heap, buffer_size, placeholder, native)
}

#' @export
#' @rdname acquireFile
setMethod("acquireFile", "character", function(project, path) file.path(project, path))

#' @export
#' @rdname acquireFile
#' @importFrom jsonlite fromJSON
setMethod("acquireMetadata", "character", function(project, path) {
    full.path <- file.path(project, path)

    # Obtaining the path to the actual metadata file. This may not exist for
    # metadata-only documents, which point to themselves (and should end be
    # JSON files and end with '.json')
    meta.path <- paste0(full.path, ".json")
    if (file.exists(meta.path)) {
        full.path <- meta.path
    } else if (!grepl("\\.json$", full.path)) {
        stop("'", path, "' has no accompanying JSON metadata file")
    }

    fromJSON(full.path, simplifyVector=FALSE)
})

#' Utilities to read and save the object file
#'
#' The OBJECT file inside each directory provides some high-level metadata of the object represented by that directory.
#' It is guaranteed to have a \code{type} property that specifies the object type;
#' individual objects may add their own information to this file.
#' These methods are intended for developers to easily read and load information in the OBJECT file.
#'
#' @param path Path to the directory representing an object.
#' @param type String specifying the type of the object.
#' @param extra Named list containing extra metadata to be written to the OBJECT file in \code{path}.
#' Names should be unique, and any element named \code{"type"} will be overwritten by \code{type}.
#'
#' @return \code{readObjectFile} returns a named list of metadata for \code{path}.
#'
#' \code{saveObjectFile} saves \code{metadata} to the OBJECT file inside \code{path}
#'
#' @author Aaron Lun
#' 
#' @examples
#' tmp <- tempfile()
#' dir.create(tmp)
#' saveObjectFile(tmp, "foo", list(bar=list(version="1.0")))
#' readObjectFile(tmp)
#' 
#' @export
#' @importFrom jsonlite fromJSON
readObjectFile <- function(path) {
    fromJSON(file.path(path, "OBJECT"), simplifyVector=FALSE)
}

#' @export
#' @rdname readObjectFile
#' @importFrom jsonlite toJSON
saveObjectFile <- function(path, type, extra=list()) {
    extra$type <- type
    stopifnot(anyDuplicated(names(extra)) == 0L)
    write(toJSON(extra, auto_unbox=TRUE, pretty=4), file=file.path(path, "OBJECT"))
}

#' Save objects to disk
#'
#' Generic to save assorted R objects into appropriate on-disk representations.
#' More methods may be defined by other packages to extend the \pkg{alabaster.base} framework to new classes.
#'
#' @param x A Bioconductor object of the specified class.
#' @param path String containing the path to a directory in which to save \code{x}.
#' @param ... Additional named arguments to pass to specific methods.
#'
#' @return 
#' \code{dir} is created and populated with files containing the contents of \code{x}.
#' \code{NULL} should be invisibly returned.
#'
#' @section Comments for extension developers:
#' Methods for the \code{saveObject} generic should create a directory at \code{path} in which the contents of \code{x} are to be saved.
#' The files may consist of any format, though language-agnostic formats like HDF5, CSV, JSON are preferred.
#' For more complex objects, multiple files and subdirectories may be created within \code{path}. 
#' The only strict requirements are:
#' \itemize{
#' \item There must be an \code{OBJECT} file inside \code{path}, 
#' containing a JSON object with a \code{"type"} string property that specifies the class of the object, e.g., \code{"data_frame"}, \code{"summarized_experiment"}.
#' This will be used by loading functions to determine how to load the files into memory.
#' \item The names of files and subdirectories should not start with \code{_} or \code{.}.
#' These are reserved for applications, e.g., to build manifests or to store additional metadata.
#' }
#'
#' Callers can pass optional parameters to specific \code{saveObject} methods via \code{...}.
#' Any options recognized by a method should be prefixed by the name of the class used in the method's signature,
#' e.g., any options for \code{\link{saveObject,DataFrame-method}} should start with \code{DataFrame.}.
#' This scoping avoids conflicts between otherwise identically-named options of different methods.
#'
#' When developing \code{saveObject} methods of complex objects, a simple approach is to decompose \code{x} into its \dQuote{child} components.
#' Each component can then be saved into a subdirectory of \code{path}, levering the existing \code{saveObject} methods for the component classes.
#' In such cases, extension developers should actually call \code{\link{altSaveObject}} on each child component, rather than calling \link{saveObject} directly.
#' This ensures that any application-level overrides of the loading functions are respected. 
#' It is expected that each method will forward \code{...} (possibly after modification) to any internal \code{\link{altSaveObject}} calls.
#'
#' @section Comments for application developers:
#' Application developers can override \code{saveObject} by specifying a custom function in \code{\link{altSaveObject}}.
#' This can be used to point to a different function to handle the saving process for each class.
#' The custom function can be as simple as a wrapper around \code{saveObject} with some additional actions (e.g., to save more metadata),
#' or may be as complex as a full-fledged generic with its own methods for class-specific customizations.
#'
#' @author Aaron Lun
#' @examples
#' library(S4Vectors)
#' X <- DataFrame(X=LETTERS, Y=sample(3, 26, replace=TRUE))
#' 
#' tmp <- tempfile()
#' saveObject(X, tmp)
#' list.files(tmp, recursive=TRUE)
#'
#' @export
#' @aliases 
#' stageObject stageObject,ANY-method
#' searchForMethods .searchForMethods
#' @import methods
#' @importFrom jsonlite fromJSON
setGeneric("saveObject", function(x, path, ...) {
    if (file.exists(path)) {
        stop("cannot save ", class(x)[1], " at existing path '", path, "'")
    }

    # Need to search here to pick up any subclasses that might have better
    # saveObject methods in yet-to-be-loaded packages.
    if (.search_methods(x)) {
        fun <- selectMethod("saveObject", class(x)[1], optional=TRUE)
        if (!is.null(fun)) {
            return(fun(x, path, ...))
        }
    }

    # Only validate once we're outside of nested calls, as each parent should
    # validate its children; separate validation of each child is redundant.
    do_validate <- !is_nested$status
    if (do_validate) {
        is_nested$status <- TRUE
        on.exit({ is_nested$status <- FALSE }, add=TRUE, after=FALSE)
    }

    # Setting up the save environment.
    sfuns <- registerSaveEnvironment()
    on.exit(sfuns$restore(), add=TRUE, after=FALSE)

    standardGeneric("saveObject")

    if (do_validate) {
        validateObject(path)
    }

    sfuns$write(path)
    invisible(NULL)
})

is_nested <- new.env()
is_nested$status <- FALSE

#######################################
########### OLD STUFF HERE ############
#######################################

#' @export
setGeneric("stageObject", function(x, dir, path, child=FALSE, ...) {
    if (path != "." && file.exists(full.path <- file.path(dir, path))) {
        stop("cannot stage ", class(x)[1], " at existing path '", full.path, "'")
    }
    if (grepl("\\\\", path)) {
        stop("Windows-style path separators are not allowed")
    }

    if (!child) {
        parent <- dirname(path)
        while (parent != ".") {
            ppath <- file.path(dir, parent)
            candidates <- list.files(ppath, pattern="\\.json$")
            for (can in candidates) {
                schema <- fromJSON(file.path(ppath, can), simplifyVector=FALSE)[["$schema"]]
                if (!startsWith(schema, "redirection/")) {
                    stop("cannot save a non-child object inside another object's subdirectory at '", parent, "'")
                }
            }
            parent <- dirname(parent)
        }
    }

    # Need to search here to pick up any subclasses that might have better
    # stageObject methods in yet-to-be-loaded packages.
    if (.search_methods(x)) {
        fun <- selectMethod("stageObject", class(x)[1], optional=TRUE)
        if (!is.null(fun)) {
            return(fun(x, dir, path, child=child, ...))
        }
    }

    standardGeneric("stageObject")
})

#' Acquire file or metadata
#'
#' \emph{WARNING: these functions are deprecated. 
#' Applications are expected to handle acquisition of files before loaders are called.}
#' Acquire a file or metadata for loading.
#' As one might expect, these are typically used inside a \code{load*} function.
#'
#' @param project Any value specifying the project of interest.
#' The default methods expect a string containing a path to a staging directory,
#' but other objects can be used to control dispatch.
#' @param path String containing a relative path to a resource inside the staging directory.
#'
#' @return
#' \code{acquireFile} methods return a local path to the file corresponding to the requested resource.
#'
#' \code{acquireMetadata} methods return a named list of metadata for the requested resource.
#' 
#' @details
#' By default, files and metadata are loaded from the same staging directory that is written to by \code{\link{stageObject}}.
#' alabaster applications can define custom methods to obtain the files and metadata from a different location, e.g., remote databases.
#' This is achieved by dispatching on a different class of \code{project}.
#'
#' Each custom acquisition method should take two arguments.
#' The first argument is an R object representing some concept of a \dQuote{project}.
#' In the default case, this is a string containing a path to the staging directory representing the project.
#' However, it can be anything, e.g., a number containing a database identifier, a list of identifiers and versions, and so on -
#' as long as the custom acquisition method is capable of understanding it, the \code{load*} functions don't care.
#'
#' The second argument is a string containing the relative path to the resource inside that project.
#' This should be the path to a specific file inside the project, not the subdirectory containing the file.
#' More concretely, it should be equivalent to the \code{path} in the \emph{output} of \code{\link{stageObject}},
#' not the path to the subdirectory used as the input to the same function.
#'
#' The return value for each custom acquisition function should be the same as their local counterparts.
#' That is, any custom file acquisition function should return a file path,
#' and any custom metadata acquisition function should return a naamed list of metadata.
#'
#' @author Aaron Lun
#' @examples
#' # Staging an example DataFrame:
#' library(S4Vectors)
#' df <- DataFrame(A=1:10, B=LETTERS[1:10])
#' tmp <- tempfile()
#' dir.create(tmp)
#' info <- stageObject(df, tmp, path="coldata")
#' writeMetadata(info, tmp)
#'
#' # Retrieving the metadata:
#' meta <- acquireMetadata(tmp, "coldata/simple.csv.gz")
#' str(meta)
#'
#' # Retrieving the file:
#' acquireFile(tmp, "coldata/simple.csv.gz")
#'
#' @export
#' @name acquireFile
setGeneric("acquireFile", function(project, path) standardGeneric("acquireFile"))

#' @export
#' @rdname acquireFile
setGeneric("acquireMetadata", function(project, path) {
    ans <- standardGeneric("acquireMetadata")

    # Handling redirections. Applications that want to support different redirection
    # types should implement the relevant logic in their acquireMetadata method.
    if (dirname(ans[["$schema"]]) == "redirection") {
        first <- ans[["redirection"]][["targets"]][[1]]
        if (first$type != "local") {
            stop("unknown redirection type '", first$type, "' to '", first$location, "'")
        }
        ans <- acquireMetadata(project, first$location)
    }

    ans
})

#' List objects in a directory
#'
#' List all objects in a directory, along with their types.
#' 
#' @param dir String containing a path to a directory containing objects saved by \code{\link{saveObject}}, possibly in separate subdirectories.
#' @param include.children Logical scalar indicating whether to include child objects.
#' 
#' @return A \link[S4Vectors]{DFrame} where each row corresponds to an object.
#' It contains the following columns:
#' \itemize{
#' \item \code{path}, the relative path to the object's subdirectory inside \code{dir}.
#' \item \code{type}, the type of the object based on its \code{OBJECT} file (see \code{?\link{readObjectFile}}).
#' \item \code{child}, whether the object is a child of another object.
#' }
#'
#' If \code{include.children=FALSE}, metadata is only returned for non-child objects. 
#'
#' @author Aaron Lun
#'
#' @examples
#' tmp <- tempfile()
#' dir.create(tmp)
#'
#' library(S4Vectors)
#' df <- DataFrame(A=1:10, B=LETTERS[1:10])
#' saveObject(df, file.path(tmp, "whee"))
#'
#' ll <- list(A=1, B=LETTERS, C=DataFrame(X=1:5))
#' saveObject(ll, file.path(tmp, "stuff"))
#'
#' listObjects(tmp)
#' listObjects(tmp, include.children=TRUE)
#'
#' @export
#' @aliases listLocalObjects listDirectory
#' @importFrom S4Vectors DataFrame
listObjects <- function(dir, include.children=FALSE) {
    DataFrame(.traverse_directory_listing(dir, ".", include.children=include.children))
}

.traverse_directory_listing <- function(root, dir, already.child=FALSE, include.children=FALSE) {
    full <- file.path(root, dir)
    is.obj <- file.exists(file.path(full, "OBJECT"))
    if (is.obj) {
        paths <- dir
        types <- readObjectFile(full)$type
        childs <- already.child
    } else {
        paths <- character(0)
        types <- character(0)
        childs <- logical(0)
    }

    if (include.children || !is.obj) {
        more.dirs <- list.dirs(full, recursive=FALSE, full.names=FALSE)
        for (k in more.dirs) {
            if (dir != ".") {
                subdir <- file.path(dir, k)
            } else {
                subdir <- k
            }

            sub <- .traverse_directory_listing(root, subdir, already.child=(already.child || is.obj), include.children=include.children)
            paths <- c(paths, sub$path)
            types <- c(types, sub$type)
            childs <- c(childs, sub$child)
        }
    }

    list(path=paths, type=types, child=childs)
}


#######################################
########### OLD STUFF HERE ############
#######################################

#' @export
#' @importFrom jsonlite fromJSON
listDirectory <- function(dir, ignore.children = TRUE) {
    all.json <- list.files(dir, pattern="\\.json$", recursive=TRUE)
    out <- lapply(file.path(dir, all.json), fromJSON, simplifyVector=FALSE)
    names(out) <- vapply(out, function(x) x$path, "")

    if (ignore.children) {
        child <- vapply(out, function(x) isTRUE(x$is_child), TRUE)
        out <- out[!child]
    }

    out
}


# Soft-deprecated back-compatibility fixes.

#' @export
listLocalObjects <- function(..., ignoreChildren = TRUE) listDirectory(..., ignore.children = ignoreChildren)

# library(testthat); library(alabaster.base); source("test-listObjects.R")

test_that("listObjects works as expected", {
    tmp <- tempfile()
    dir.create(tmp)

    library(S4Vectors)
    df <- DataFrame(A=1:10, B=LETTERS[1:10])
    saveObject(df, file.path(tmp, "whee"))

    ll <- list(A=1, B=LETTERS, C=DataFrame(X=1:5))
    saveObject(ll, file.path(tmp, "stuff"))

    out <- listObjects(tmp)
    expect_identical(nrow(out), 2L)
    m <- match(c("whee", "stuff"), out$path)
    expect_true(!anyNA(m))
    expect_identical(out$type[m], c("data_frame", "simple_list"))
    expect_false(any(out$child[m]))

    out <- listObjects(tmp, include.children=TRUE)
    m <- match(c("whee", "stuff", "stuff/other_contents/0"), out$path)
    expect_identical(out$type[m], c("data_frame", "simple_list", "data_frame"))
    expect_identical(out$child[m], c(FALSE, FALSE, TRUE))
})

#' Choose a missing value placeholder
#'
#' In the \pkg{alabaster.*} framework, we mark missing entries inside HDF5 datasets with placeholder values.
#' This function chooses a value for the placeholder that does not overlap with anything else in a vector.
#'
#' @param x An atomic vector to be saved to HDF5.
#' @param .version Internal use only.
#' 
#' @return
#' A placeholder value for missing values in \code{x},
#' guaranteed to not be equal to any non-missing value in \code{x}.
#'
#' @details
#' For floating-point datasets, the placeholder will not be NA if there are mixtures of NAs and NaNs.
#' We do not rely on the NaN payload to distinguish between these two values.
#'
#' Placeholder values are typically saved as scalar attributes on the HDF5 dataset that they are used in.
#' The usual name of this attribute is \code{"missing-value-placeholder"}, as encoding by \code{missingPlaceholderName}.
#'
#' @examples
#' chooseMissingPlaceholderForHdf5(c(TRUE, NA, FALSE))
#' chooseMissingPlaceholderForHdf5(c(1L, NA, 2L))
#' chooseMissingPlaceholderForHdf5(c("aaron", NA, "barry"))
#' chooseMissingPlaceholderForHdf5(c("aaron", NA, "barry", "NA"))
#' chooseMissingPlaceholderForHdf5(c(1.5, NA, 2.6))
#' chooseMissingPlaceholderForHdf5(c(1.5, NaN, NA, 2.6))
#'
#' @aliases
#' missingPlaceholderName
#' addMissingPlaceholderAttributeForHdf5
#' .addMissingStringPlaceholderAttribute
#' .chooseMissingStringPlaceholder
#
#' @export
chooseMissingPlaceholderForHdf5 <- function(x, .version=3) {
    missing.placeholder <- NULL

    if (is.logical(x)) {
        missing.placeholder <- -1L

    } else if (is.character(x)) {
        missing.placeholder <- "NA"
        search <- unique(x)
        while (missing.placeholder %in% search) {
            missing.placeholder <- paste0("_", missing.placeholder)
        }

    } else if (is.double(x)) {
        if (.version < 3) {
            missing.placeholder <- NA_real_
        } else {
            missing.placeholder <- choose_numeric_missing_placeholder(x)
        }

    } else {
        missing.placeholder <- as(NA, storage.mode(x))
    }

    missing.placeholder
}

#' @export
missingPlaceholderName <- "missing-value-placeholder"

# Soft-deprecated back-compatibility fixes.

#' @export
addMissingPlaceholderAttributeForHdf5 <- function(file, name, placeholder) {
    if (is.character(file)) {
        file <- H5Fopen(file)
        on.exit(H5Fclose(file), add=TRUE)
    }
    dhandle <- H5Dopen(file, name)
    on.exit(H5Dclose(dhandle), add=TRUE)
    h5writeAttribute(placeholder, h5obj=dhandle, name=missingPlaceholderName, asScalar=TRUE)
}

#' @export
.chooseMissingStringPlaceholder <- function(...) chooseMissingPlaceholderForHdf5(...)

#' @export
.addMissingStringPlaceholderAttribute <- function(...) addMissingPlaceholderAttributeForHdf5(...)

#' Read a DataFrame from disk
#'
#' Read a \link[S4Vectors]{DFrame} from its on-disk representation.
#' This is usually not directly called by users, but is instead called by dispatch in \code{\link{readObject}}.
#'
#' @param path String containing a path to the directory, itself created with \code{\link{saveObject}} method for \link[S4Vectors]{DFrame}s.
#' @param metadata Named list containing metadata for the object, see \code{\link{readObjectFile}} for details.
#' @param ... Further arguments, passed to \code{\link{altLoadObject}} for complex nested columns.
#'
#' @return The \link[S4Vectors]{DFrame} represented by \code{path}.
#'
#' @seealso
#' \code{"\link{saveObject,DataFrame-method}"}, for the staging method.
#'
#' @author Aaron Lun
#'
#' @examples
#' library(S4Vectors)
#' df <- DataFrame(A=1:10, B=LETTERS[1:10])
#'
#' tmp <- tempfile()
#' saveObject(df, tmp)
#' readObject(tmp)
#'
#' @export
#' @aliases loadDataFrame
#' @importFrom S4Vectors DataFrame make_zero_col_DFrame
readDataFrame <- function(path, metadata, ...) {
    fpath <- file.path(path, "basic_columns.h5")
    fhandle <- H5Fopen(fpath, flags="H5F_ACC_RDONLY")
    on.exit(.H5Fclose_null(fhandle), add=TRUE, after=FALSE)

    host <- "data_frame"
    ghandle <- H5Gopen(fhandle, host)
    on.exit(.H5Gclose_null(ghandle), add=TRUE, after=FALSE)

    nrows <- h5_read_attribute(ghandle, "row-count")
    colnames <- h5_read_vector(ghandle, "column_names")
    rownames <- NULL
    if (h5_object_exists(ghandle, "row_names")) {
        rownames <- h5_read_vector(ghandle, "row_names")
    }

    gdhandle <- H5Gopen(ghandle, "data")
    on.exit(.H5Gclose_null(gdhandle), add=TRUE, after=FALSE)
    all.children <- h5ls(gdhandle, recursive=FALSE, datasetinfo=FALSE)$name

    columns <- vector("list", length(colnames))
    for (col in seq_along(colnames)) {
        expected <- as.character(col - 1L)

        if (expected %in% all.children) {
            type <- local({
                precolhandle <- H5Oopen(gdhandle, expected)
                on.exit(H5Oclose(precolhandle), add=TRUE, after=FALSE)
                h5_read_attribute(precolhandle, "type")
            })

            if (type == "factor") {
                columns[[col]] <- local({
                    colhandle <- H5Gopen(gdhandle, expected)
                    on.exit(H5Gclose(colhandle), add=TRUE, after=FALSE)
                    codes <- .simple_read_codes(colhandle)
                    levels <- h5_read_vector(colhandle, "levels")
                    ordered <- h5_read_attribute(colhandle, "ordered", check=TRUE, default=NULL)
                    factor(levels[codes], levels=levels, ordered=isTRUE(ordered > 0L))
                })

            } else if (type == "vls") {
                missing.placeholder <- (function() {
                    colhandle <- H5Gopen(gdhandle, expected)
                    on.exit(H5Gclose(colhandle), add=TRUE, after=FALSE)
                    phandle <- H5Dopen(colhandle, "pointers")
                    on.exit(H5Dclose(phandle), add=TRUE, after=FALSE)
                    h5_read_attribute(phandle, missingPlaceholderName, check=TRUE, default=NULL)
                })()

                # Need to do this tedious song and dance to get an exclusive file handle.
                gdhandle <- .H5Gclose_null(gdhandle)
                ghandle <- .H5Gclose_null(ghandle)
                fhandle <- .H5Fclose_null(fhandle)

                contents <- h5_read_vls_array(
                    fpath,
                    paste0("data_frame/data/", expected, "/pointers"),
                    paste0("data_frame/data/", expected, "/heap"),
                    missing.placeholder=missing.placeholder
                )
                columns[[col]] <- as.vector(contents)

                # Reopening this for downstream operations.
                fhandle <- H5Fopen(fpath, "H5F_ACC_RDONLY")
                ghandle <- H5Gopen(fhandle, "data_frame")
                gdhandle <- H5Gopen(ghandle, "data")

            } else {
                columns[[col]] <- local({
                    colhandle <- H5Dopen(gdhandle, expected)
                    on.exit(H5Dclose(colhandle), add=TRUE, after=FALSE)
                    contents <- H5Dread(colhandle, drop=TRUE)

                    missing.placeholder <- h5_read_attribute(colhandle, missingPlaceholderName, check=TRUE, default=NULL)
                    contents <- h5_cast(contents, expected.type=type, missing.placeholder=missing.placeholder)

                    if (type == "string") {
                        if (H5Aexists(colhandle, "format")) {
                            format <- h5_read_attribute(colhandle, "format")
                            if (format == "date") {
                                contents <- as.Date(contents)
                            } else if (format == "date-time") {
                                contents <- as.Rfc3339(contents)
                            }
                        }
                    }

                    contents
                })
            }

        } else {
            columns[[col]] <- S4Vectors::I(altReadObject(file.path(path, "other_columns", expected), ...))
        }
    }
   
    names(columns) <- colnames
    if (length(columns) || !is.null(rownames)) {
        output <- DataFrame(columns, check.names=FALSE, row.names=rownames)
    } else {
        output <- make_zero_col_DFrame(nrow=nrows)
    }

    readMetadata(
        output,
        metadata.path=file.path(path, "other_annotations"),
        mcols.path=file.path(path, "column_annotations"),
        ...
    )
}

#######################################
########### OLD STUFF HERE ############
#######################################

#' @export
loadDataFrame <- function(info, project, include.nested=TRUE, parallel=TRUE) {
    has.rownames <- isTRUE(info$data_frame$row_names)
    col.info <- info$data_frame$columns
    has.columns <- length(col.info) > 0
    nrows <- as.integer(info$data_frame$dimensions[[1]])
    if (!has.rownames && !has.columns) {
        return(make_zero_col_DFrame(nrow=nrows))
    }

    # Reading the file into a data frame.
    path <- acquireFile(project, info$path)
    if ("hdf5_data_frame" %in% names(info)) {
        prefix <- function(x) paste0(info$hdf5_data_frame$group, "/", x)
        if (!has.columns) {
            df <- make_zero_col_DFrame(nrow=nrows)
        } else {
            raw <- h5read(path, prefix("data"))
            df <- vector("list", length(col.info))

            for (i in seq_along(col.info)) {
                curinfo <- col.info[[i]]
                d <- as.character(i - 1L) # -1 to get back to 0-based indices.
                current <- raw[[d]]

                if (!is.null(current)) {
                    attrs <- h5readAttributes(path, prefix(paste0("data/", d)))
                    current <- h5_cast(current, expected.type=NULL, missing.placeholder=attrs[[missingPlaceholderName]], respect.nan.payload=TRUE)
                    df[[i]] <- as.vector(current) # remove 1d arrays.

                } else {
                    df[[i]] <- logical(nrows) # placeholders
                }
            }

            names(df) <- as.vector(h5read(path, prefix("column_names")))
            df <- DataFrame(df, check.names=FALSE)
        }
        if (has.rownames) {
            rownames(df) <- as.vector(h5read(path, prefix("row_names")))
        }
    } else {
        df <- read.csv3(path, compression=info$csv_data_frame$compression, nrows=nrows)
        df <- DataFrame(df)
        if (has.rownames) {
            rownames(df) <- df[,1]
            df <- df[,-1,drop=FALSE]
        } else {
            rownames(df) <- NULL
        } 
    }

    df <- .coerce_df_column_type(df, col.info, project, include.nested=include.nested)
    .restoreMetadata(df, mcol.data=info$data_frame$column_data, meta.data=info$data_frame$other_data, project=project)
}

.coerce_df_column_type <- function(df, col.info, project, include.nested) {
    stopifnot(length(df) == length(col.info))
    true.names <- character(length(col.info))

    for (i in seq_along(col.info)) {
        current.info <- col.info[[i]]
        true.names[i] <- current.info$name
        col.type <- current.info$type 
        col <- df[[i]]

        if (col.type=="factor" || col.type=="ordered") {
            if (!is.factor(col)) { # we may have already transformed the column to a factor, in which case we can skip this.
                level.info <- acquireMetadata(project, current.info$levels$resource$path)
                levels <- altLoadObject(level.info, project=project)
                if (is(levels, "DataFrame")) { # account for old objects that store levels as a DF.
                    levels <- levels[,1]
                }
                if (is.numeric(col)) {
                    col <- levels[col + 1L]
                }
                ordered <- col.type == "ordered" || isTRUE(current.info$ordered)
                col <- factor(col, levels=levels, ordered=ordered)
            }

        } else if (col.type=="date") {
            col <- as.Date(col)

        } else if (col.type=="date-time") {
            col <- .cast_datetime(col)

        } else if (.is_atomic(col.type)) {
            if (col.type == "integer") {
                if (is.double(col) && any(col == -2^31, na.rm=TRUE)) {
                    # Don't cast to an integer if there's the special -2^31 value.
                } else {
                    col <- .cast_atomic(col, col.type)
                }
            } else if (col.type == "string") {
                f <- current.info$format
                if (identical(f, "date")) {
                    col <- as.Date(col)
                } else if (identical(f, "date-time")) {
                    col <- .cast_datetime(col)
                }
            } else {
                col <- .cast_atomic(col, col.type)
            }

        } else if (col.type == "other") {
            current <- acquireMetadata(project, current.info$resource$path)
            if (include.nested || !("data_frame" %in% names(current))) {
                col <- altLoadObject(current, project=project)
            } else {
                true.names[i] <- NA_character_
            }
        } else {
            stop("unsupported column type '", col.type, "'")
        }

        df[[i]] <- col
    }

    # Removing nested DFs.
    if (!all(keep <- !is.na(true.names))) {
        df <- df[,keep,drop=FALSE]
        true.names <- true.names[keep]
    }

    colnames(df) <- true.names

    df
}

# Test stageObject on DataFrames.
# library(testthat); library(alabaster.base); source("test-DataFrame.R")

library(S4Vectors)
old <- saveDataFrameFormat("csv.gz")

test_that("DFs handle their column types correctly", {
    tmp <- tempfile()
    dir.create(tmp, recursive=TRUE)

    ncols <- 123
    df <- DataFrame(
        stuff = rep(LETTERS[1:3], length.out=ncols),
        blah = 0, # placeholder
        foo = seq_len(ncols),
        whee = as.numeric(10 + seq_len(ncols)),
        rabbit = 1,
        birthday = rep(Sys.Date(), ncols) - sample(100, ncols, replace=TRUE)
    )
    df$blah <- factor(df$stuff, LETTERS[10:1])
    df$rabbit <- factor(df$stuff, LETTERS[1:3], ordered=TRUE)

    for (version in 1:2) {
        info <- stageObject(df, tmp, paste0("rnaseq", version), .version.df=version)
        expect_match(info$path, ".csv.gz$")
        expect_identical(info$`$schema`, "csv_data_frame/v1.json")
        expect_identical(info$csv_data_frame$compression, "gzip")
        expect_false(is.null(info$csv_data_frame))

        # Should write without errors.
        resource <- writeMetadata(info, tmp)
        expect_true(file.exists(file.path(tmp, resource$path)))

        meta <- info$data_frame
        expect_identical(meta$columns[[1]]$type, "string")
        expect_identical(read.csv(file.path(tmp, meta$columns[[2]]$levels$resource$path))[,1], LETTERS[10:1])
        expect_null(meta$columns[[2]]$ordered)
        expect_identical(meta$columns[[3]]$type, "integer")
        expect_identical(meta$columns[[4]]$type, "number")

        if (version >= 2) {
            expect_identical(meta$columns[[5]]$type, "factor")
            expect_true(meta$columns[[5]]$ordered)
            expect_identical(read.csv(file.path(tmp, meta$columns[[5]]$levels$resource$path))[,1], LETTERS[1:3])
            expect_identical(meta$columns[[6]]$type, "string")
            expect_identical(meta$columns[[6]]$format, "date")
        } else {
            expect_identical(meta$columns[[5]]$type, "ordered")
            expect_identical(meta$columns[[6]]$type, "date")
        }

        # Round-tripping to make sure it's okay.
        out <- loadDataFrame(info, tmp)
        expect_identical(out$stuff, df$stuff)
        expect_identical(out$blah, df$blah)
        expect_identical(out$foo, df$foo)
        expect_identical(out$whee, df$whee)
        expect_identical(out$rabbit, df$rabbit)
        expect_identical(out$birthday, df$birthday)
    }

    # Works for HDF5.
    old <- saveDataFrameFormat("hdf5")
    on.exit(saveDataFrameFormat(old))

    for (version in 1:2) {
        meta2 <- stageObject(df, tmp, path=paste0("WHEE-", version), .version.df=version, .version.hdf5=version)
        expect_match(meta2$path, ".h5$")
        expect_identical(meta2$`$schema`, "hdf5_data_frame/v1.json")
        expect_false(is.null(meta2$hdf5_data_frame))

        # Should write without errors.
        resource <- writeMetadata(meta2, tmp)
        expect_true(file.exists(file.path(tmp, resource$path)))

        round2 <- loadDataFrame(meta2, project=tmp)
        expect_identical(round2, df)
    }

    # Works in the new world.
    tmp2 <- tempfile()
    saveObject(df, tmp2)
    expect_identical(readObjectFile(tmp2)$type, "data_frame")
    round2 <- readDataFrame(tmp2)
    expect_identical(round2, df)
})

test_that("staging of weird objects within DFs works correctly", {
    tmp <- tempfile()
    dir.create(tmp)

    df <- DataFrame(A=sample(3, 100, replace=TRUE), B=sample(letters[1:3], 100, replace=TRUE))
    Y <- DataFrameFactor(x=df)

    input <- DataFrame(A=1:3, X=0, B=letters[1:3], Y=0)
    input$X <- df[1:3,] # nested DF.
    input$Y <- Y[1:3] # nested DFFactor.
    input$Z <- DataFrame(whee=4:6) # another nested DF.
    input$AA <- list("AA", "BB", "CC") # nested list
    info <- stageObject(input, tmp, path="WHEE")

    # Should write without errors.
    resource <- writeMetadata(info, tmp)
    expect_true(file.exists(file.path(tmp, resource$path)))

    roundtrip <- loadDataFrame(info, project=tmp)
    expect_identical(roundtrip, input)

    roundtrip2 <- loadDataFrame(info, project=tmp, include.nested=FALSE)
    expect_identical(roundtrip2, input[,c("A", "B", "Y", "AA")])

    # Works for HDF5.
    old <- saveDataFrameFormat("hdf5")
    on.exit(saveDataFrameFormat(old))

    for (version in 1:2) {
        meta <- stageObject(input, tmp, path=paste0("WHEE-", version), .version.df=version, .version.hdf5=version)

        expect_match(meta$path, ".h5$")
        expect_identical(meta$`$schema`, "hdf5_data_frame/v1.json")
        expect_false(is.null(meta$hdf5_data_frame))

        contents <- rhdf5::h5read(file.path(tmp, meta$path), paste0(meta$hdf5_data_frame$group, "/data"))
        expect_identical(names(contents), c("0", "2")) # only simple columns are stored.

        resource <- writeMetadata(meta, tmp)
        round <- loadDataFrame(meta, project=tmp)
        expect_identical(round, input)
    }

    # Works in the new world.
    tmp2 <- tempfile()
    saveObject(input, tmp2)
    expect_identical(readObjectFile(tmp2)$type, "data_frame")
    round2 <- readDataFrame(tmp2)
    expect_identical(round2, input)
})

test_that("staging of uncompressed Gzip works correctly", {
    tmp <- tempfile()
    dir.create(tmp)

    df <- DataFrame(A=sample(3, 100, replace=TRUE), B=sample(letters[1:3], 100, replace=TRUE))

    old <- saveDataFrameFormat("csv")
    on.exit(saveDataFrameFormat(old))
    meta2 <- stageObject(df, tmp, path="WHEE")

    expect_identical(meta2$csv_data_frame$compression, "none")
    expect_match(meta2$path, ".csv$")
    expect_identical(meta2$`$schema`, "csv_data_frame/v1.json")

    # Should write without errors.
    resource <- writeMetadata(meta2, tmp)
    expect_true(file.exists(file.path(tmp, resource$path)))

    round2 <- loadDataFrame(meta2, project=tmp)
    expect_identical(round2, df)
})

test_that("staging with row names works correctly", {
    tmp <- tempfile()
    dir.create(tmp)
    df <- DataFrame(rbind(setNames(1:26, LETTERS)))

    meta <- stageObject(df, tmp, path="FOO")
    round1 <- loadDataFrame(meta, project=tmp)
    expect_identical(round1, df)

    # Works with HDF5.
    old <- saveDataFrameFormat("hdf5")
    on.exit(saveDataFrameFormat(old))

    for (version in 1:2) {
        meta2 <- stageObject(df, tmp, path=paste0("FOO-", version), .version.df=version, .version.hdf5=version)
        round2 <- loadDataFrame(meta2, project=tmp)
        expect_identical(round2, df)
    }

    # Works in the new world.
    tmp2 <- tempfile()
    saveObject(df, tmp2)
    expect_identical(readObjectFile(tmp2)$type, "data_frame")
    round2 <- readDataFrame(tmp2)
    expect_identical(df, round2)
})

test_that("staging of empty objects works correctly", {
    tmp <- tempfile()
    dir.create(tmp)

    # Truly empty.
    df <- DataFrame(matrix(100, 100, 0))
    meta <- stageObject(df, tmp, path="WHEE")
    round <- loadDataFrame(meta, project=tmp)
    expect_identical(round, df)

    # Empty, but has some row names.
    df2 <- df
    rownames(df2) <- sprintf("WHEE_%s", seq_len(nrow(df2)))
    meta <- stageObject(df2, tmp, path="WHEE_rn")
    round <- loadDataFrame(meta, project=tmp)
    expect_identical(round, df2)

    # Works for HDF5 as well.
    old <- saveDataFrameFormat("hdf5")
    on.exit(saveDataFrameFormat(old))

    for (version in 1:2) {
        meta <- stageObject(df, tmp, path=paste0("WHEE_h5", version), .version.df=version, .version.hdf5=version)
        round <- loadDataFrame(meta, project=tmp)
        expect_identical(round, df)

        meta <- stageObject(df2, tmp, path=paste0("FOO_h5", version), .version.df=version, .version.hdf5=version)
        round <- loadDataFrame(meta, project=tmp)
        expect_identical(round, df2)
    }

    # Works in the new world.
    tmp2a <- tempfile()
    saveObject(df, tmp2a)
    round2 <- readDataFrame(tmp2a)
    expect_identical(df, round2)

    tmp2b <- tempfile()
    saveObject(df2, tmp2b)
    round2 <- readDataFrame(tmp2b)
    expect_identical(df2, round2)
})

test_that("handling of NAs works correctly", {
    tmp <- tempfile()
    dir.create(tmp)

    df <- DataFrame(
        a=c("A", "B", NA), 
        b=c("A", "NA", NA), 
        c=factor(c("A", "B", NA)), 
        d=factor(c("A", "B", "NA")),
        e=c(1L,2L,NA),
        f=c(1.5,2.5,NA),
        g=c(TRUE,FALSE,NA),
        h=1:3,
        i=c(TRUE,FALSE,TRUE),
        j=letters[1:3]
    )

    # Staged and validated correctly.
    meta <- stageObject(df, tmp, path="WHEE")
    expect_error(writeMetadata(meta, tmp), NA) 

    # Round trip works.
    round1 <- loadDataFrame(meta, project=tmp)
    expect_identical(df, round1)

    # Works for HDF5-based DFs.
    old <- saveDataFrameFormat("hdf5")
    on.exit(saveDataFrameFormat(old))

    meta2 <- stageObject(df, tmp, path="WHEE2", .version.df=2, .version.hdf5=2)
    expect_match(meta2[["$schema"]], "hdf5_data_frame")

    fpath <- file.path(tmp, meta2$path)
    attrs <- rhdf5::h5readAttributes(fpath, "contents/data/0")
    expect_identical(attrs[["missing-value-placeholder"]], "NA")
    attrs <- rhdf5::h5readAttributes(fpath, "contents/data/1")
    expect_identical(attrs[["missing-value-placeholder"]], "_NA")

    attrs <- rhdf5::h5readAttributes(fpath, "contents/data/2")
    expect_identical(attrs[["missing-value-placeholder"]], NA_integer_)
    attrs <- rhdf5::h5readAttributes(fpath, "contents/data/3")
    expect_null(attrs[["missing-value-placeholder"]])

    attrs <- rhdf5::h5readAttributes(fpath, "contents/data/4")
    expect_true(is.na(attrs[["missing-value-placeholder"]]))
    attrs <- rhdf5::h5readAttributes(fpath, "contents/data/5")
    place <- attrs[["missing-value-placeholder"]]
    expect_true(is.na(place) && !is.nan(place))
    attrs <- rhdf5::h5readAttributes(fpath, "contents/data/6")
    expect_equal(attrs[["missing-value-placeholder"]], -1L)

    attrs <- rhdf5::h5readAttributes(fpath, "contents/data/7")
    expect_null(attrs[["missing-value-placeholder"]])
    attrs <- rhdf5::h5readAttributes(fpath, "contents/data/8")
    expect_null(attrs[["missing-value-placeholder"]])
    attrs <- rhdf5::h5readAttributes(fpath, "contents/data/9")
    expect_null(attrs[["missing-value-placeholder"]])

    round2 <- loadDataFrame(meta2, project=tmp)
    expect_identical(df, round2)

    # Works in the new world.
    tmp2 <- tempfile()
    saveObject(df, tmp2)

    fpath <- file.path(tmp2, "basic_columns.h5")
    attrs <- rhdf5::h5readAttributes(fpath, "data_frame/data/2/codes")
    expect_identical(attrs[["missing-value-placeholder"]], 2L)
    attrs <- rhdf5::h5readAttributes(fpath, "data_frame/data/3/codes")
    expect_null(attrs[["missing-value-placeholder"]])

    round2 <- readDataFrame(tmp2)
    expect_identical(df, round2)
})

test_that("handling of the integer minimum limit works correctly", {
    tmp <- tempfile()
    dir.create(tmp)

    df <- DataFrame(foobar=c(1L,2L,NA))
    actual <- c(1, 2, -2^31)

    # For CSV:
    meta <- stageObject(df, tmp, path="exceptions")
    expect_identical(meta[["$schema"]], "csv_data_frame/v1.json")
    fpath <- file.path(tmp, meta$path)
    write(paste0(c("\"foobar\"", actual), collapse="\n"), file=gzfile(fpath))

    round <- loadDataFrame(meta, project=tmp)
    expect_identical(round$foobar, actual)

    # For HDF5: 
    old <- saveDataFrameFormat("hdf5")
    on.exit(saveDataFrameFormat(old))

    for (version in 1:2) { 
        meta <- stageObject(df, tmp, path=paste0("hdf5-", version), .version.df=version, .version.hdf5=version)
        fpath <- file.path(tmp, meta$path)
        rhdf5::h5deleteAttribute(fpath, "contents/data/0", "missing-value-placeholder")

        round <- loadDataFrame(meta, project=tmp)
        expect_identical(round$foobar, actual)

        # Trying again.
        fhandle <- rhdf5::H5Fopen(fpath)
        dhandle <- rhdf5::H5Dopen(fhandle, "contents/data/0")
        rhdf5::h5writeAttribute(1, dhandle, "missing-value-placeholder", asScalar=TRUE)
        rhdf5::H5Dclose(dhandle)
        rhdf5::H5Fclose(fhandle)

        round <- loadDataFrame(meta, project=tmp)
        expect_identical(round$foobar, c(NA, 2, -2^31))
    }

    # Works in the new world.
    tmp2 <- tempfile()
    saveObject(df, tmp2)

    fpath <- file.path(tmp2, "basic_columns.h5")
    rhdf5::h5deleteAttribute(fpath, "data_frame/data/0", "missing-value-placeholder")
    round2 <- readDataFrame(tmp2)
    expect_identical(round2$foobar, actual)

    fhandle <- rhdf5::H5Fopen(fpath)
    dhandle <- rhdf5::H5Dopen(fhandle, "data_frame/data/0")
    rhdf5::h5writeAttribute(1, dhandle, "missing-value-placeholder", asScalar=TRUE)
    rhdf5::H5Dclose(dhandle)
    rhdf5::H5Fclose(fhandle)

    round <- readDataFrame(tmp2)
    expect_identical(round$foobar, c(NA, 2, -2^31))
})

test_that("handling of IEEE special values work correctly", {
    tmp <- tempfile()
    dir.create(tmp)

    df <- DataFrame(specials=c(NaN, 1, 2.12345678, Inf, NA, -Inf))
    meta <- stageObject(df, tmp, path="FOO1")
    round <- loadDataFrame(meta, project=tmp)
    expect_identical(round, df)

    df2 <- cbind(df, normals=1:6) # check that quoting works
    meta <- stageObject(df2, tmp, path="FOO2")
    round <- loadDataFrame(meta, project=tmp)
    expect_identical(round, df2)

    df3 <- cbind(df2, more_normals=LETTERS[1:6])
    meta <- stageObject(df3, tmp, path="FOO3")
    round <- loadDataFrame(meta, project=tmp)
    expect_identical(round, df3)

    # Works for HDF5.
    old <- saveDataFrameFormat("hdf5")
    on.exit(saveDataFrameFormat(old))

    for (version in 1:2) { 
        meta <- stageObject(df, tmp, path=paste0("hFOO1-", version), .version.df=version, .version.hdf5=version)
        round <- loadDataFrame(meta, project=tmp)
        expect_identical(round, df)

        meta <- stageObject(df2, tmp, path=paste0("hFOO2-", version), .version.df=version, .version.hdf5=version)
        round <- loadDataFrame(meta, project=tmp)
        expect_identical(round, df2)
    }

    # Works in the new world.
    tmp2a <- tempfile()
    saveObject(df, tmp2a)
    expect_identical(readObjectFile(tmp2a)$type, "data_frame")
    round2 <- readDataFrame(tmp2a)
    expect_identical(round2, df)

    tmp2b <- tempfile()
    saveObject(df2, tmp2b)
    expect_identical(readObjectFile(tmp2b)$type, "data_frame")
    round2 <- readDataFrame(tmp2b)
    expect_identical(round2, df2)
})

test_that("loaders work correctly from HDF5 with non-default placeholders", {
    tmp <- tempfile()
    dir.create(tmp)

    df <- DataFrame(
        a=c(1L,2L,3L),
        b=c(1.5,2.5,3.5),
        c=c(1.5,2.5,NaN)
    )

    old <- saveDataFrameFormat("hdf5")
    on.exit(saveDataFrameFormat(old))

    # In the old world.
    meta2 <- stageObject(df, tmp, path="WHEE2", .version.df=2, .version.hdf5=2)

    fpath <- file.path(tmp, meta2$path)
    addMissingPlaceholderAttributeForHdf5(fpath, "contents/data/0", 1L)
    addMissingPlaceholderAttributeForHdf5(fpath, "contents/data/1", 2.5)
    addMissingPlaceholderAttributeForHdf5(fpath, "contents/data/2", NaN)

    round <- loadDataFrame(meta2, project=tmp)
    expect_identical(round$a, c(NA, 2L, 3L))
    expect_identical(round$b, c(1.5, NA, 3.5))
    expect_identical(round$c, c(1.5, 2.5, NA))

    # Works in the new world.
    tmp2 <- tempfile()
    saveObject(df, tmp2)

    fpath <- file.path(tmp2, "basic_columns.h5")
    addMissingPlaceholderAttributeForHdf5(fpath, "data_frame/data/0", 1L)
    addMissingPlaceholderAttributeForHdf5(fpath, "data_frame/data/1", 2.5)
    addMissingPlaceholderAttributeForHdf5(fpath, "data_frame/data/2", NaN)

    round2 <- readDataFrame(tmp2)
    expect_identical(round2$a, c(NA, 2L, 3L))
    expect_identical(round2$b, c(1.5, NA, 3.5))
    expect_identical(round2$c, c(1.5, 2.5, NA))
})

test_that("stageObject works with extra mcols", {
    tmp <- tempfile()
    dir.create(tmp)

    df <- DataFrame(A=sample(3, 100, replace=TRUE), B=sample(letters[1:3], 100, replace=TRUE))
    out <- stageObject(df, tmp, "raw_thing")
    expect_null(out$data_frame$column_data)
    expect_null(out$data_frame$other_data)

    # Ignores it when the mcols have no columns.
    mcols(df) <- make_zero_col_DFrame(2)
    out <- stageObject(df, tmp, "raw_thing2")
    expect_null(out$data_frame$column_data)
    expect_null(out$data_frame$other_data)

    tmp2 <- tempfile()
    saveObject(df, tmp2)
    round2 <- readDataFrame(tmp2)
    expect_null(mcols(round2))
    mcols(round2) <- mcols(df)
    expect_identical(df, round2)

    # Alright, adding some mcols.
    mcols(df)$stuff <- runif(ncol(df))
    mcols(df)$foo <- sample(LETTERS, ncol(df), replace=TRUE)
    metadata(df) <- list(WHEE="foo")

    out <- stageObject(df, tmp, "thing")
    expect_false(is.null(out$data_frame$column_data))
    expect_false(is.null(out$data_frame$other_data))

    resource <- writeMetadata(out, tmp)
    expect_true(file.exists(file.path(tmp, resource$path)))
    df2 <- loadDataFrame(out, tmp)
    expect_equal(df, df2)

    tmp2 <- tempfile()
    saveObject(df, tmp2)
    round2 <- readDataFrame(tmp2)
    expect_identical(df, round2)

    # Eliminates redundant row names.
    mc <- mcols(df)
    rownames(mc) <- c("C", "D")
    mcols(df, use.names=FALSE) <- mc
    out <- stageObject(df, tmp, "thing2")
    resource <- writeMetadata(out, tmp)

    df2 <- loadDataFrame(out, tmp)
    expect_equal(df, df2)
    mc <- mcols(df2, use.names=FALSE)
    expect_null(rownames(mc))

    tmp2 <- tempfile()
    saveObject(df, tmp2)
    round2 <- readDataFrame(tmp2)
    expect_identical(df, round2)
})

test_that("DF staging preserves odd colnames", {
    tmp <- tempfile()
    dir.create(tmp)

    ncols <- 123
    df <- DataFrame(
        `foo bar` = seq_len(ncols),
        `rabbit+2+3/5` = as.numeric(10 + seq_len(ncols)),
        check.names=FALSE
    )

    # Correct in the CSV file:
    meta <- stageObject(df, tmp, path="WHEE")
    resource <- writeMetadata(meta, tmp)
    expect_equal(loadDataFrame(meta, tmp), df)

    fpath <- file.path(tmp, meta$path)
    first <- readLines(fpath, n=1)
    expect_identical(first, "\"foo bar\",\"rabbit+2+3/5\"")

    # Correct in the HDF5 file:
    old <- saveDataFrameFormat("hdf5")
    on.exit(saveDataFrameFormat(old))

    meta <- stageObject(df, tmp, path="WHEE2", .version.df=2, .version.hdf5=2)
    resource <- writeMetadata(meta, tmp)
    expect_identical(loadDataFrame(meta, tmp), df)

    fpath <- file.path(tmp, meta$path)
    expect_identical(as.vector(rhdf5::h5read(fpath, "contents/column_names")), colnames(df))

    # Works in the new world.
    tmp2 <- tempfile()
    saveObject(df, tmp2)
    round2 <- readDataFrame(tmp2)
    expect_identical(df, round2)
})

test_that("DFs fails with duplicate or empty colnames", {
    tmp <- tempfile()
    dir.create(tmp)

    ncols <- 123
    df <- DataFrame(
        foo = seq_len(ncols),
        rabbit = as.numeric(10 + seq_len(ncols)),
        rabbit = factor(sample(LETTERS, ncols, replace=TRUE)),
        check.names=FALSE
    )

    expect_error(info <- stageObject(df, tmp, "rnaseq"), "duplicate")

    unlink(file.path(tmp, "rnaseq"), recursive=TRUE)
    df2 <- df
    colnames(df2)[2] <- ""
    expect_error(info <- stageObject(df2, tmp, "rnaseq"), "empty")

    # Fails in the new world.
#    tmp2 <- tempfile()
#    expect_error(saveObject(df, tmp2), "duplicate")
#    tmp2 <- tempfile()
#    expect_error(saveObject(df2, tmp2), "empty")
})

test_that("DFs handle POSIX times correctly", {
    tmp <- tempfile()
    dir.create(tmp, recursive=TRUE)

    df <- DataFrame(
        foo = as.POSIXct(c(123123, 124235235, 96546546)),
        bar = as.POSIXct(c(123123, 124235235, 96546546)) # TODO: should be POSIXlt, but see Bioconductor/S4Vectors#113
    )

    info <- stageObject(df, tmp, "rnaseq")
    meta <- info$data_frame
    expect_identical(meta$columns[[1]]$type, "string")
    expect_identical(meta$columns[[1]]$format, "date-time")
    expect_identical(meta$columns[[2]]$type, "string")
    expect_identical(meta$columns[[2]]$format, "date-time")

    # Round-tripping to make sure it's okay. Note that this requires some care
    # because on some machines, R doesn't set the timezone properly if you call
    # as.POSIXct with format=.  Dunno why, but it goes away if we just call
    # as.POSIXct again, so we'll just stop fighting and do that.
    out <- loadDataFrame(info, tmp)
    expect_s3_class(out$foo, "POSIXct")
    expect_s3_class(out$bar, "POSIXct")
    expect_identical(df$foo, as.POSIXct(out$foo))
    expect_identical(df$bar, as.POSIXct(out$bar))

    # Same for HDF5.
    old <- saveDataFrameFormat("hdf5")
    on.exit(saveDataFrameFormat(old))

    for (version in 1:2) {
        info <- stageObject(df, tmp, paste0("bar-", version), .version.df=version, .version.hdf5=version)
        out <- loadDataFrame(info, tmp)
        expect_s3_class(out$foo, "POSIXct")
        expect_s3_class(out$bar, "POSIXct")
        expect_identical(df$foo, as.POSIXct(out$foo))
        expect_identical(df$bar, as.POSIXct(out$bar))
    }

    # Works in the new world.
    tmp2 <- tempfile()
    saveObject(df, tmp2)
    round2 <- readDataFrame(tmp2)
    expect_s3_class(round2$foo, "Rfc3339")
    expect_s3_class(round2$bar, "Rfc3339")
    expect_identical(df$foo, as.POSIXct(round2$foo))
    expect_identical(df$bar, as.POSIXct(round2$bar))

    # Rfc3339 objects are also correctly saved.
    tmp3 <- tempfile()
    saveObject(round2, tmp3)
    expect_identical(readDataFrame(tmp3), round2)
})

test_that("staging of arrays within DFs works correctly", {
    skip_if_not_installed("alabaster.matrix")
    tmp <- tempfile()
    dir.create(tmp)

    input <- DataFrame(A=1:3, X=0, Y=0)
    input$X <- array(runif(3)) # 1D array
    input$Y <- cbind(runif(3)) # matrix with 1 column 
    input$Z <- cbind(V=runif(3), Z=rnorm(3)) # matrix with 2 columns.
    info <- stageObject(input, tmp, path="WHEE")

    suppressWarnings(roundtrip <- loadDataFrame(info, project=tmp))
    input$X <- as.numeric(input$X) # strip 1D arrays as these are rarely desirable.
    roundtrip$Y <- as.matrix(roundtrip$Y)
    roundtrip$Z <- as.matrix(roundtrip$Z)
    expect_equal(roundtrip, input)

    # Works in the new world.
    tmp <- tempfile()
    saveObject(input, tmp)
    roundtrip <- readObject(tmp)
    roundtrip$Y <- as.matrix(roundtrip$Y)
    roundtrip$Z <- as.matrix(roundtrip$Z)
    expect_identical(roundtrip, input)
})

test_that("staging of arrays continues to work with character matrices", {
    skip_if_not_installed("alabaster.matrix")
    tmp <- tempfile()
    dir.create(tmp)

    input <- DataFrame(A=1:3, X=0, Y=0)
    input$X <- array(letters[1:3]) # 1D array
    input$Y <- cbind(LETTERS[1:3]) # matrix with 1 column 
    input$Z <- cbind(V=letters[4:6], Z=LETTERS[4:6]) # matrix with 2 columns.
    info <- stageObject(input, tmp, path="WHEE")

    suppressWarnings(roundtrip <- loadDataFrame(info, project=tmp))
    input$X <- as.character(input$X) # strip 1D arrays as these are rarely desirable.
    roundtrip$Y <- as.matrix(roundtrip$Y)
    roundtrip$Z <- as.matrix(roundtrip$Z)
    expect_equal(roundtrip, input)

    # Works in the new world.
    tmp <- tempfile()
    saveObject(input, tmp)
    roundtrip <- readObject(tmp)
    roundtrip$Y <- as.matrix(roundtrip$Y)
    roundtrip$Z <- as.matrix(roundtrip$Z)
    expect_identical(roundtrip, input)
})

test_that("saving works for base data.frames", {
    nrows <- 123
    df <- data.frame(
        stuff = rep(LETTERS[1:3], length.out=nrows),
        foo = seq_len(nrows),
        whee = as.numeric(10 + seq_len(nrows))
    )
    df$blah <- factor(df$stuff, LETTERS[10:1])
    df$rabbit <- factor(df$stuff, LETTERS[1:3], ordered=TRUE)

    tmp <- tempfile()
    saveObject(df, tmp)
    roundtrip <- readObject(tmp)
    expect_null(rownames(roundtrip))
    expect_identical(as.data.frame(roundtrip), df)

    # Respects row names.
    rownames(df) <- sprintf("GENE_%i", seq_len(nrows))
    tmp <- tempfile()
    saveObject(df, tmp)
    roundtrip <- readObject(tmp)
    expect_identical(as.data.frame(roundtrip), df)
})

test_that("saving works for data.frames containing package_version columns", {
    df <- data.frame(
        stuff = as.package_version(c("1.2", "2.3")),
        whee = as.package_version(c("2.3.4", "4.5.6"))
    )

    tmp <- tempfile()
    saveObject(df, tmp)
    roundtrip <- readObject(tmp)

    expect_identical(roundtrip$stuff, as.character(df$stuff))
    expect_identical(roundtrip$whee, as.character(df$whee))
})

test_that("DataFrame character columns work in VLS mode", {
    tmp <- tempfile()
    dir.create(tmp)

    has_vls <- function(file, column) {
        fhandle <- rhdf5::H5Fopen(file, "H5F_ACC_RDONLY")
        on.exit(rhdf5::H5Fclose(fhandle), add=TRUE, after=FALSE)
        dfhandle <- rhdf5::H5Gopen(fhandle, "data_frame")
        on.exit(rhdf5::H5Gclose(dfhandle), add=TRUE, after=FALSE)
        dhandle <- rhdf5::H5Gopen(dfhandle, "data")
        on.exit(rhdf5::H5Gclose(dhandle), add=TRUE, after=FALSE)
        precolhandle <- rhdf5::H5Oopen(dhandle, column)
        on.exit(rhdf5::H5Oclose(precolhandle), add=TRUE, after=FALSE)
        alabaster.base:::h5_read_attribute(precolhandle, "type") == "vls"
    }

    df <- DataFrame(x = runif(8), y = c("A", "BC", "DEFG", "HIJKL", "MNOP", "QRS", "TU", "V"), z = seq_len(8))
    saveObject(df, file.path(tmp, "basic"), DataFrame.character.vls=TRUE)
    reloaded <- readObject(file.path(tmp, "basic")) 
    expect_identical(df, reloaded)
    expect_true(has_vls(file.path(tmp, 'basic', 'basic_columns.h5'), '1'))

    copy <- df
    copy$y[2] <- NA
    saveObject(copy, file.path(tmp, "with_missing"), DataFrame.character.vls=TRUE)
    reloaded <- readObject(file.path(tmp, "with_missing")) 
    expect_identical(copy, reloaded)
    expect_true(has_vls(file.path(tmp, 'with_missing', 'basic_columns.h5'), '1'))

    copy <- df
    copy$aa <- copy$y
    copy$aa[4] <- strrep("HIJKL", 100)
    saveObject(copy, file.path(tmp, "auto"), DataFrame.character.vls=NULL)
    reloaded <- readObject(file.path(tmp, "auto")) 
    expect_identical(copy, reloaded)
    expect_false(has_vls(file.path(tmp, 'auto', 'basic_columns.h5'), '1'))
    expect_true(has_vls(file.path(tmp, 'auto', 'basic_columns.h5'), '3'))
})

#' Save a DataFrame to disk
#'
#' Stage a DataFrame by saving it to a HDF5 file.
#'
#' @param x A \link[S4Vectors]{DataFrame} or data.frame.
#' @inheritParams saveObject
#' @param DataFrame.character.vls Logical scalar indicating whether to save character vectors in the custom variable length string (VLS) array format.
#' If \code{NULL}, this is determined based on a comparison of the expected storage against a fixed length array.
#'
#' @return
#' A named list containing the metadata for \code{x}.
#' \code{x} itself is written to a HDF5 file inside \code{path}.
#' Additional files may also be created inside \code{path} and referenced from the metadata.
#'
#' @details
#' This method creates a \code{basic_columns.h5} file that contains columns for atomic vectors, factors, dates and date-times.
#' Dates and date-times are converted to character vectors and saved as such inside the file.
#' Factors are saved as a HDF5 group with both the codes and the levels as separate datasets.
#'
#' Any non-atomic columns are saved to a \code{other_columns} subdirectory inside \code{path} via \code{\link{saveObject}},
#' named after its zero-based positional index within \code{x}.
#'
#' If \code{\link[S4Vectors]{metadata}} or \code{\link[S4Vectors]{mcols}} are present, 
#' they are saved to the \code{other_annotations} and \code{column_annotations} subdirectories, respectively, via \code{\link{saveObject}}.
#'
#' In the on-disk representation, no distinction is made between \link[S4Vectors]{DataFrame} and data.frame instances of \code{x}.
#' Calling \code{readDataFrame} will always produce a \link[S4Vectors]{DFrame} regardless of the class of \code{x}.
#'
#' @author Aaron Lun
#'
#' @examples
#' library(S4Vectors)
#' df <- DataFrame(A=1:10, B=LETTERS[1:10])
#'
#' tmp <- tempfile()
#' saveObject(df, tmp)
#' list.files(tmp, recursive=TRUE)
#' 
#' @export 
#' @rdname stageDataFrame
#' @aliases stageObject,DataFrame-method
#' @importFrom S4Vectors DataFrame
setMethod("saveObject", "DataFrame", function(x, path, DataFrame.character.vls=NULL, ...) {
    dir.create(path, showWarnings=FALSE)
    .write_hdf5_new(
        x,
        path,
        row.names=rownames(x),
        DataFrame.character.vls=DataFrame.character.vls,
        ...
    )
    saveMetadata(
        x,
        metadata.path=file.path(path, "other_annotations"),
        mcols.path=file.path(path, "column_annotations"),
        ...
    )
    saveObjectFile(path, "data_frame", list(data_frame=list(version="1.1")))
})

#' @importFrom rhdf5 h5write h5createGroup h5createFile H5Gopen H5Gclose H5Acreate H5Aclose H5Awrite H5Fopen H5Fclose H5Dopen H5Dclose
.write_hdf5_new <- function(x, path, row.names, DataFrame.character.vls, ...) {
    subpath <- "basic_columns.h5"
    ofile <- paste0(path, "/", subpath)

    fhandle <- H5Fcreate(ofile, "H5F_ACC_TRUNC")
    on.exit(.H5Fclose_null(fhandle), add=TRUE, after=FALSE)
    ghandle <- H5Gcreate(fhandle, "data_frame")
    on.exit(.H5Gclose_null(ghandle), add=TRUE, after=FALSE)
    h5_write_attribute(ghandle, "row-count", nrow(x), scalar=TRUE, type="H5T_NATIVE_UINT32")

    gdhandle <- H5Gcreate(ghandle, "data")
    on.exit(.H5Gclose_null(gdhandle), add=TRUE, after=FALSE)

    collected <- list()
    for (z in seq_len(ncol(x))) {
        col <- x[[z]]
        data.name <- as.character(z - 1L)
        is.other <- FALSE
        sanitized <- NULL
        coltype <- NULL
        colformat <- NULL

        if (is.factor(col)) {
            # Wrapping in a function to get the on.exits to fire.
            (function() {
                colhandle <- H5Gcreate(gdhandle, data.name)
                on.exit(H5Gclose(colhandle), add=TRUE, after=FALSE)
                h5_write_attribute(colhandle, "type", "factor", scalar=TRUE)
                if (is.ordered(col)) {
                    h5_write_attribute(colhandle, "ordered", 1L, scalar=TRUE)
                }
                .simple_save_codes(colhandle, col, save.names=FALSE)
                h5_write_vector(colhandle, "levels", levels(col))
            })()

        } else if (.is_datetime(col)) {
            coltype <- "string"
            colformat <- "date-time"
            sanitized <- as.character(as.Rfc3339(col))

        } else if (is.numeric_version(col)) {
            coltype <- "string"
            colformat <- NULL
            sanitized <- as.character(col)

        } else if (is(col, "Date")) {
            coltype <- "string"
            colformat <- "date"
            sanitized <- .sanitize_date(col)

        } else if (is.atomic(col)) {
            if (length(dim(col)) > 1) {
                is.other <- TRUE
            } else {
                coerced <- .remap_atomic_type(col)
                coltype <- coerced$type
                sanitized <- coerced$values
            }

        } else {
            is.other <- TRUE
        }

        if (is.other) {
            other.dir <- file.path(path, "other_columns")
            dir.create(other.dir, showWarnings=FALSE)
            tryCatch({
                altSaveObject(x[[z]], file.path(other.dir, data.name), DataFrame.character.vls=DataFrame.character.vls, ...)
            }, error = function(e) stop("failed to stage column '", colnames(x)[z], "'\n  - ", e$message))

        } else if (!is.null(sanitized)) {
            transformed <- transformVectorForHdf5(sanitized)
            current <- transformed$transformed
            missing.placeholder <- transformed$placeholder

            saved.vls <- FALSE
            if (coltype == "string" && is.null(colformat) && !isFALSE(DataFrame.character.vls)) {
                use.vls <- DataFrame.character.vls
                if (is.null(use.vls)) {
                    use.vls <- h5_use_vls(current)
                }
                if (use.vls) {
                    vhandle <- H5Gcreate(gdhandle, data.name)
                    H5Gclose(vhandle)

                    # Need to do this tedious song and dance to get an exclusive file handle.
                    gdhandle <- .H5Gclose_null(gdhandle)
                    ghandle <- .H5Gclose_null(ghandle)
                    fhandle <- .H5Fclose_null(fhandle)

                    h5_write_vls_array(ofile, paste0("data_frame/data/", data.name), "pointers", "heap", current)
                    saved.vls <- TRUE

                    # Reopening this for downstream operations.
                    fhandle <- H5Fopen(ofile, "H5F_ACC_RDWR")
                    ghandle <- H5Gopen(fhandle, "data_frame")
                    gdhandle <- H5Gopen(ghandle, "data")

                    # Wrapping in a function to get the on.exits to fire.
                    (function() {
                        vhandle <- H5Gopen(gdhandle, data.name)
                        on.exit(H5Gclose(vhandle), add=TRUE, after=FALSE)
                        h5_write_attribute(vhandle, "type", "vls", scalar=TRUE)
                        dhandle <- H5Dopen(vhandle, "pointers")
                        on.exit(H5Dclose(dhandle), add=TRUE, after=FALSE)
                        if (!is.null(missing.placeholder)) {
                            h5_write_attribute(dhandle, missingPlaceholderName, missing.placeholder, scalar=TRUE)
                        }
                    })()
                }
            }

            if (!saved.vls) {
                # Wrapping in a function to get the on.exits to fire.
                (function() {
                    dhandle <- h5_write_vector(gdhandle, data.name, current, emit=TRUE)
                    on.exit(H5Dclose(dhandle), add=TRUE, after=FALSE)
                    if (!is.null(missing.placeholder)) {
                        h5_write_attribute(dhandle, missingPlaceholderName, missing.placeholder, scalar=TRUE)
                    }
                    h5_write_attribute(dhandle, "type", coltype, scalar=TRUE)
                    if (!is.null(colformat)) {
                        h5_write_attribute(dhandle, "format", colformat, scalar=TRUE)
                    }
                })()
            }
        }
    }

    h5_write_vector(ghandle, "column_names", colnames(x))
    if (!is.null(row.names)) {
        h5_write_vector(ghandle, "row_names", row.names)
    }
}

#' @export
#' @rdname stageDataFrame
setMethod("saveObject", "data.frame", function(x, path, DataFrame.character.vls=NULL, ...) {
    dir.create(path, showWarnings=FALSE)
    rn <- attr(x, "row.names")
    if (is.integer(rn)) {
        rn <- NULL
    }
    .write_hdf5_new(x, path, row.names=rn, DataFrame.character.vls=DataFrame.character.vls, ...)
    saveObjectFile(path, "data_frame", list(data_frame=list(version="1.0")))
})

#######################################
########### OLD STUFF HERE ############
#######################################

#' @export
#' @importFrom utils write.csv
setMethod("stageObject", "DataFrame", function(x, dir, path, child=FALSE, df.name="simple", mcols.name="mcols", meta.name="other", .version.df=2, .version.hdf5=2) {
    full.path <- file.path(dir, path)
    dir.create(full.path, showWarnings=FALSE)

    true.colnames <- colnames(x)
    if (anyDuplicated(true.colnames)) {
        stop("detected duplicate column names in a ", class(x)[1], " object")
    }
    if (any(true.colnames == "")) {
        stop("detected empty column name in a ", class(x)[1], " object")
    }

    # Saving contents to file.
    format <- .saveDataFrameFormat()
    opath <- paste0(path, "/", df.name)
    extra <- list(list())
    has_row_names = !is.null(rownames(x))

    if (!is.null(format) && format=="hdf5") {
        opath <- paste0(opath, ".h5")
        ofile <- file.path(dir, opath)
        factor.levels <- rep(list(character(0)), ncol(x))

        sanitized <- .sanitize_df_columns(x, dir, path, .version.df)
        meta <- sanitized$metadata
        factor.levels <- sanitized$levels
        .dump_df_to_hdf5(sanitized$x, meta, "contents", ofile, .version.hdf5=.version.hdf5)
        extra[[1]]$version <- min(.version.hdf5, 3)

        schema <- "hdf5_data_frame/v1.json"
        extra[[1]]$group <- "contents"

    } else {
        sanitized <- .sanitize_df_columns(x, dir, path, .version.df)
        meta <- sanitized$metadata
        X <- data.frame(sanitized$x, check.names=FALSE)
        if (has_row_names) {
            # Using the 'row_names' name for back-compatibility.
            X <- cbind(row_names=rownames(sanitized$x), X)
        }
        
        if (!is.null(format) && format=="csv") {
            opath <- paste0(opath, ".csv")
            ofile <- file.path(dir, opath)
            .quickWriteCsv(X, ofile, row.names=FALSE, compression="none", validate=FALSE)
            extra[[1]]$compression <- "none"
        } else {
            opath <- paste0(opath, ".csv.gz")
            ofile <- file.path(dir, opath)
            .quickWriteCsv(X, ofile, row.names=FALSE, compression="gzip", validate=FALSE)
            extra[[1]]$compression <- "gzip"
        }

        schema <- "csv_data_frame/v1.json"
    }

    element_data <- .processMcols(x, dir, path, mcols.name)
    other_data <- .processMetadata(x, dir, path, meta.name)

    meta <- list(
        `$schema`=schema,
        path=opath,
        is_child=child,
        data_frame=list(
            columns=meta,
            row_names=has_row_names,
            column_data=element_data,
            other_data=other_data,
            dimensions=dim(x),
            version=if (.version.df != 1) min(.version.df, 2) else NULL 
        )
    )

    names(extra) <- dirname(schema) 
    c(meta, extra)
})

.sanitize_df_columns <- function(x, dir, path, .version.df) {
    # Fix to ensure that DFs with invalid names are properly saved;
    # otherwise any [[<- will call make.names.
    true.colnames <- colnames(x)
    colnames(x) <- sprintf("V%s", seq_len(ncol(x)))

    meta <- vector("list", ncol(x))
    all.levels <- rep(list(character(0)), ncol(x))

    for (z in seq_along(meta)) {
        col <- x[[z]]
        out <- list(name=true.colnames[z])
        is.other <- FALSE

        if (length(dim(col)) > 1) {
            is.other <- TRUE
        } else if (is.factor(col)) {
            if (.version.df == 1) {
                if (is.ordered(col)) {
                    out$type <- "ordered"
                } else { 
                    out$type <- "factor"
                }

                tryCatch({
                     lev.info <- altStageObject(DataFrame(levels=levels(col)), dir, paste0(path, "/column", z), df.name="levels", child=TRUE)
                     out$levels <- list(resource=writeMetadata(lev.info, dir=dir))
                 }, error = function(e) stop("failed to stage levels of factor column '", out$name, "'\n  - ", e$message))

                x[[z]] <- as.character(col)

            } else {
                out$type <- "factor"
                if (is.ordered(col)) {
                    out$ordered <- TRUE
                }

                tryCatch({
                     lev.info <- altStageObject(levels(col), dir, paste0(path, "/column", z), df.name="levels", child=TRUE)
                     out$levels <- list(resource=writeMetadata(lev.info, dir=dir))
                 }, error = function(e) stop("failed to stage levels of factor column '", out$name, "'\n  - ", e$message))

                x[[z]] <- as.integer(col) - 1L
            }

            all.levels[[z]] <- levels(col)

        } else if (.is_datetime(col)) {
            if (.version.df == 1) {
                out$type <- "date-time"
            } else {
                out$type <- "string"
                out$format <- "date-time"
            }
            x[[z]] <- as.character(as.Rfc3339(col))

        } else if (is(col, "Date")) {
            if (.version.df == 1) {
                out$type <- "date"
            } else {
                out$type <- "string"
                out$format <- "date"
            }
            x[[z]] <- .sanitize_date(col)

        } else if (is.atomic(col)) {
            coerced <- .remap_atomic_type(col)
            out$type <- coerced$type
            x[[z]] <- coerced$values

        } else {
            is.other <- TRUE
        }

        if (is.other) {
            out$type <- "other"

            tryCatch({
                other.info <- altStageObject(x[[z]], dir, paste0(path, "/column", z), child=TRUE)
                out$resource <- writeMetadata(other.info, dir=dir)
            }, error = function(e) stop("failed to stage column '", out$name, "'\n  - ", e$message))

            x[[z]] <- integer(nrow(x))
        }

        meta[[z]] <- out
    }

    # Restoring the true colnames.
    colnames(x) <- true.colnames

    list(x=x, metadata=meta, levels=all.levels)
}

#' @importFrom rhdf5 h5write h5createGroup h5createFile
.dump_df_to_hdf5 <- function(x, column.meta, host, ofile, .version.hdf5) {
    h5createFile(ofile)
    prefix <- function(x) paste0(host, "/", x)
    h5createGroup(ofile, host)
    h5createGroup(ofile, prefix("data"))

    for (i in seq_along(x)) {
        curmeta <- column.meta[[i]]
        if (curmeta$type == "other") {
            next
        }
        current <- x[[i]]

        missing.placeholder <- NULL
        if (.version.hdf5 > 1) {
            transformed <- transformVectorForHdf5(current, .version=.version.hdf5)
            current <- transformed$transformed
            missing.placeholder <- transformed$placeholder
        } else {
            if (is.character(current)) {
                if (anyNA(current)) {
                    missing.placeholder <- chooseMissingPlaceholderForHdf5(current)
                    current[is.na(current)] <- missing.placeholder
                }
            } else if (is.logical(current)) {
                # The logical'ness of this column is preserved in the metadata,
                # so we can always convert it back later.
                current <- as.integer(current) 
            } 
        }

        data.name <- as.character(i - 1L)
        full.data.name <- prefix(paste0("data/", data.name))
        h5write(current, ofile, full.data.name)
        if (!is.null(missing.placeholder)) {
            addMissingPlaceholderAttributeForHdf5(ofile, full.data.name, missing.placeholder)
        }
    }

    h5write(colnames(x), ofile, prefix("column_names"))
    if (!is.null(rownames(x))) {
        h5write(rownames(x), ofile, prefix("row_names"))
    }
}

#' Clone an existing file
#'
#' Clone an existing file to a new location.
#' This is typically performed inside \code{\link{saveObject}} methods for objects that contain a reference to a file. 
#'
#' @param src String containing the path to the source file.
#' @param dest String containing the destination file path, typically within the \code{path} supplied to \code{\link{saveObject}}. 
#' @param action String specifying the action to use when cloning \code{src} to \code{dest}.
#' \itemize{
#' \item \code{"copy"}: copy \code{src} to \code{dest}.
#' \item \code{"link"}: create a hard link from \code{src} to \code{dest}.
#' If this fails, we silently fall back to a copy.
#' \item \code{"symlink"}: create a symbolic link from \code{src} to \code{dest}.
#' The symbolic link contains the absolute path to \code{src}, which is useful when \code{dest} might be moved but \code{src} will not.
#' \item \code{"relsymlink"}: create a symbolic link from \code{src} to \code{dest}.
#' Each symbolic link contains the minimal relative path to \code{src},
#' which is useful when both \code{src} and \code{dest} are moved together, e.g., as they are part of the same parent object like a SummarizedExperiment.
#' }
#'
#' @return A new file/link is created at \code{dest}.
#' \code{NULL} is invisibly returned.
#'
#' @author Aaron Lun
#'
#' @examples
#' tmp <- tempfile()
#' write(file=tmp, LETTERS)
#'
#' dest <- tempfile()
#' cloneFile(tmp, dest)
#' readLines(dest)
#'
#' @seealso
#' \code{\link{cloneDirectory}}, to clone entire directories.
#'
#' @export
cloneFile <- function(src, dest, action=c("link", "copy", "symlink", "relsymlink")) {
    action <- match.arg(action)
    destdir <- dirname(dest)
    dir.create(destdir, recursive=TRUE, showWarnings=FALSE)

    if (action == "relsymlink") {
        newtarget <- relative_path_to_src(src, destdir)
        pwd <- getwd()
        on.exit(setwd(pwd))
        setwd(destdir)
        if (!file.symlink(newtarget, basename(dest))) {
            stop("failed to link from '", src, "' to '", dest, "'")
        }

    } else if (action == "link") {
        src <- resolve_symlinks(src) # Resolving any symlinks so that we hard link to the original file.
        if (!suppressWarnings(file.link(src, dest)) && !file.copy(src, dest)) {
            stop("failed to copy or link '", src, "' to '", dest, "'")
        }

    } else if (action == "copy") {
        if (!file.copy(src, dest)) { # file.copy() follows symbolic links, so no need for special treatment here.
            stop("failed to copy '", src, "' to '", dest, "'")
        }

    } else if (action == "symlink") {
        src <- absolutizePath(src)
        if (!file.symlink(src, dest)) {
            stop("failed to symlink '", src, "' to '", dest, "'")
        }
    }
}

format.env <- new.env()
format.env$DataFrame <- NULL

#' Choose the format for certain objects
#'
#' Alter the format used to save DataFrames in its \code{\link{stageObject}} methods.
#'
#' @param format String containing the format to use.
#' Tbe \code{"csv"}, \code{"csv.gz"} (default) or \code{"hdf5"}.
#' Alternatively \code{NULL}, to use the default format.
#' 
#' @return 
#' If \code{format} is missing, a string containing the current format is returned, or \code{NULL} to use the default format.
#'
#' If \code{format} is supplied, it is used to define the current format, and the \emph{previous} format is returned.
#'
#' @details
#' \code{\link{stageObject}} methods will treat a \code{format=NULL} in the same manner as the default format.
#' The distinction exists to allow downstream applications to set their own defaults while still responding to user specification.
#' For example, an application can detect if the existing format is \code{NULL}, and if so, apply another default via \code{.saveDataFrameFormat}.
#' On the other hand, if the format is not \code{NULL}, this is presumably specified by the user explicitly and should be respected by the application.
#'
#' @author Aaron Lun
#'
#' @examples
#' (old <- .saveDataFrameFormat())
#'
#' .saveDataFrameFormat("hdf5")
#' .saveDataFrameFormat()
#'
#' # Setting it back.
#' .saveDataFrameFormat(old)
#'
#' @name saveFormats
#' @aliases .saveDataFrameFormat 
NULL

#' @export
#' @rdname saveFormats
saveDataFrameFormat <- function(format) {
    .save_format(format, "DataFrame", c("csv", "csv.gz", "hdf5"))
}

.save_format <- function(format, mode, choices) {
   previous <- format.env[[mode]]
   if (missing(format)) {
       previous
   } else {
       if (!is.null(format)) {
           format <- match.arg(format, choices)
       }
       format.env[[mode]] <- format
       invisible(previous)
   }
}

# Soft-deprecated back-compatibility fixes.

#' @export
.saveDataFrameFormat <- function(...) saveDataFrameFormat(...)

#' Save a factor to disk
#'
#' Pretty much as it says, let's save a base R \link{factor} to an on-disk representation.
#'
#' @param x A factor.
#' @inheritParams saveObject
#' @param ... Further arguments that are ignored.
#'
#' @return
#' \code{x} is saved inside \code{path}.
#' \code{NULL} is invisibly returned.
#'
#' @seealso
#' \code{\link{readBaseFactor}}, to read the files back into the session.
#'
#' @author Aaron Lun
#' 
#' @examples
#' tmp <- tempfile()
#' saveObject(factor(1:10, 1:30), tmp)
#' list.files(tmp, recursive=TRUE)
#' 
#' @export
#' @name saveBaseFactor
#' @aliases 
#' saveObject,factor-method
#' stageObject,factor-method
setMethod("saveObject", "factor", function(x, path, ...) {
    dir.create(path, showWarnings=FALSE)
    ofile <- file.path(path, "contents.h5")

    fhandle <- H5Fcreate(ofile, "H5F_ACC_TRUNC")
    on.exit(H5Fclose(fhandle), add=TRUE, after=FALSE)
    ghandle <- H5Gcreate(fhandle, "string_factor")
    on.exit(H5Gclose(ghandle), add=TRUE, after=FALSE)

    if (is.ordered(x)) {
        h5_write_attribute(ghandle, "ordered", 1L, scalar=TRUE)
    }

    .simple_save_codes(ghandle, x)
    h5_write_vector(ghandle, "levels", levels(x))

    saveObjectFile(path, "string_factor", list(string_factor=list(version="1.0")))
    invisible(NULL)
})

.simple_save_codes <- function(ghandle, x, save.names=TRUE) {
    codes <- as.integer(x) - 1L

    missing.placeholder <- NULL
    if (anyNA(codes)) {
        missing.placeholder <- nlevels(x)
        codes[is.na(codes)] <- missing.placeholder
    }

    dhandle <- h5_write_vector(ghandle, "codes", codes, type="H5T_NATIVE_UINT32", emit=TRUE)
    on.exit(H5Dclose(dhandle), add=TRUE, after=FALSE)

    if (!is.null(missing.placeholder)) {
        h5_write_attribute(dhandle, missingPlaceholderName, missing.placeholder, type="H5T_NATIVE_UINT32", scalar=TRUE)
    }

    if (save.names && !is.null(names(x))) {
        h5_write_vector(ghandle, "names", names(x))
    }
}

#######################################
########### OLD STUFF HERE ############
#######################################

#' @export
#' @importFrom S4Vectors DataFrame
setMethod("stageObject", "factor", function(x, dir, path, child = FALSE, ...) {
    dir.create(file.path(dir, path), showWarnings=FALSE)

    contents <- as.integer(x) - 1L
    mock <- DataFrame(values=contents)
    if (!is.null(names(x))) {
        mock <- cbind(names=names(x), mock)
    }

    new_path <- paste0(path, "/indices.txt.gz")
    ofile <- file.path(dir, new_path)
    quickWriteCsv(mock, ofile, row.names=FALSE, compression="gzip", validate=FALSE)

    level_meta <- stageObject(levels(x), dir, paste0(path, "/levels"), child=TRUE)
    level_stub <- writeMetadata(level_meta, dir)

    list(
        `$schema` = "string_factor/v1.json",
        path = new_path,
        is_child = child,
        factor = list(
            length = length(x),
            names = !is.null(names(x)),
            compression = "gzip"
        ),
        string_factor = list(
            levels = list(resource = level_stub),
            ordered = is.ordered(x)
        )
    )
})

#' Read R-level metadata
#'
#' Read \code{\link[S4Vectors]{metadata}} and \code{\link[S4Vectors]{mcols}} for a \link[S4Vectors]{Annotated} or \link[S4Vectors]{Vector} object, respectively.
#' This is typically used inside loading functions for concrete subclasses.
#'
#' @param x An \link[S4Vectors]{Vector} or \link[S4Vectors]{Annotated} object.
#' @param mcols.path String containing a path to a directory, itself containing an on-disk representation of a \link[S4Vectors]{DataFrame} to be used as the \code{\link[S4Vectors]{mcols}}.
#' Alternatively \code{NULL} to skip loading.
#' @param metadata.path String containing a path to a directory, itself containing an on-disk representation of a base R list to be used as the \code{\link[S4Vectors]{metadata}}.
#' Alternatively \code{NULL} to skip loading. 
#' @param ... Further arguments to be passed to \code{\link{altReadObject}}.
#'
#' @author Aaron Lun
#'
#' @return \code{x} is returned, possibly with \code{mcols} and \code{metadata} added to it.
#'
#' @seealso
#' \code{\link{saveMetadata}}, which does the staging.
#'
#' @export
#' @aliases restoreMetadata .restoreMetadata
#' @importFrom S4Vectors mcols<- metadata<-
readMetadata <- function(x, metadata.path, mcols.path, ...) {
    if (!is.null(metadata.path) && file.exists(metadata.path)) {
        metadata(x) <- altReadObject(metadata.path, ...)
    }

    if (!is.null(mcols.path) && file.exists(mcols.path)) {
        mcols(x) <- altReadObject(mcols.path, ...)
    }

    x
}

#######################################
########### OLD STUFF HERE ############
#######################################

#' @export
restoreMetadata <- function(x, mcol.data, meta.data, project) { 
    if (!is.null(mcol.data)) {
        rd.info <- acquireMetadata(project, mcol.data$resource$path)
        mcols(x) <- altLoadObject(rd.info, project)
    }

    if (!is.null(meta.data)) {
        meta.info <- acquireMetadata(project, meta.data$resource$path)
        metadata(x) <- altLoadObject(meta.info, project)
    }

    x
}

# Soft-deprecated back-compatibility fixes

#' @export
.restoreMetadata <- function(...) restoreMetadata(...)

#' HDF5 utilities
#'
#' Basically just better versions of those in \pkg{rhdf5}, dedicated to \pkg{alabaster.base} and its dependents.
#' Intended for \pkg{alabaster.*} developers only.
#'
#' @name hdf5
#' @import rhdf5
#' @aliases 
#' h5_guess_vector_chunks 
#' h5_create_vector
#' h5_write_vector
#' h5_write_attribute
#' h5_read_vector
#' h5_read_attribute
#' h5_object_exists
#' h5_cast
NULL

.choose_type <- function(x) {
    if (is.integer(x)) {
        type <- "H5T_NATIVE_INT32"
    } else if (is.double(x)) {
        type <- "H5T_NATIVE_DOUBLE"
    } else if (is.character(x)) {
        tid <- H5Tcopy("H5T_C_S1")
        H5Tset_strpad(tid, strpad = "NULLPAD")
        H5Tset_size(tid, max(nchar(x, type="bytes"), 1L, na.rm=TRUE))

        enc <- unique(Encoding(x))
        if ("UTF-8" %in% enc) {
            H5Tset_cset(tid, "UTF8")
        } else {
            H5Tset_cset(tid, "ASCII")
        }

        tid
    } else {
        stop("unsupported type '", typeof(x), "'")
    }
}

#' @export
h5_guess_vector_chunks <- function(len) {
    # Some reasonable number between 10000 and 100000, depending on the size. 
    chunks <- sqrt(len)
    if (chunks < 10000) {
        chunks <- min(len, 10000)
    } else if (chunks > 100000) {
        chunks <- 100000
    }
    return(chunks)
}

#' @export
h5_create_vector <- function(handle, name, len, type, compress=6, chunks=NULL, scalar=FALSE, emit=FALSE) {
    if (len == 1 && scalar) {
        shandle <- H5Screate("H5S_SCALAR")
        compress <- 0
    } else {
        shandle <- H5Screate_simple(len)
    }
    on.exit(H5Sclose(shandle), add=TRUE, after=FALSE)

    phandle <- H5Pcreate("H5P_DATASET_CREATE")
    on.exit(H5Pclose(phandle), add=TRUE, after=FALSE)
    H5Pset_fill_time(phandle, "H5D_FILL_TIME_NEVER")
    H5Pset_obj_track_times(phandle, FALSE)

    if (compress > 0 && len) {
        H5Pset_shuffle(phandle)
        H5Pset_deflate(phandle, level=compress)
        if (is.null(chunks)) {
            chunks <- h5_guess_vector_chunks(len)
        }
        H5Pset_chunk(phandle, chunks)
    }

    H5Dcreate(handle, name, dtype_id=type, h5space=shandle, dcpl=phandle)
}

#' @export
h5_write_vector <- function(handle, name, x, type=NULL, compress=6, chunks=NULL, scalar=FALSE, emit=FALSE) {
    if (is.null(type)) {
        if (is.character(x)) {
            x <- enc2utf8(x) # avoid mis-encoding multi-byte characters from Latin-1.
        }
        type <- .choose_type(x)
    }

    dhandle <- h5_create_vector(handle, name, length(x), type=type, compress=compress, chunks=chunks, scalar=scalar, emit=emit)
    if (!emit) {
        on.exit(H5Dclose(dhandle), add=TRUE, after=FALSE)
    }

    H5Dwrite(dhandle, x)

    if (emit) {
        return(dhandle)
    } else {
        return(invisible(NULL))
    }
}

#' @export
h5_write_attribute <- function(handle, name, x, type=NULL, scalar=FALSE) {
    if (is.null(type)) {
        if (is.character(x)) {
            x <- enc2utf8(x) # avoid mis-encoding multi-byte characters from Latin-1.
        }
        type <- .choose_type(x)
    }

    if (length(x) == 1 && scalar) {
        shandle <- H5Screate("H5S_SCALAR")
    } else {
        shandle <- H5Screate_simple(length(x))
    }
    on.exit(H5Sclose(shandle), add=TRUE, after=FALSE)

    ahandle <- H5Acreate(handle, name, dtype_id=type, h5space=shandle)
    on.exit(H5Aclose(ahandle), add=TRUE, after=FALSE)
    H5Awrite(ahandle, x)

    invisible(NULL)
}

#' @export
h5_object_exists <- function(handle, name) {
    name %in% h5ls(handle, datasetinfo=FALSE, recursive=FALSE)$name
}

#' @export
h5_read_vector <- function(handle, name, check=FALSE, default=NULL, bit64conversion = "int") {
    if (check) {
        if (!h5_object_exists(handle, name)) {
            return(default)
        }
    }

    dhandle <- H5Dopen(handle, name)
    on.exit(H5Dclose(dhandle), add=TRUE, after=FALSE)
    output <- H5Dread(dhandle, bit64conversion=bit64conversion, drop=TRUE)

    if (is.raw(output)) {
        storage.mode(output) <- "integer"
    } else if (is.character(output) && H5Tget_cset(H5Dget_type(dhandle)) == 1L) {
        Encoding(output) <- "UTF-8"
    }

    output
}

#' @export
h5_read_attribute <- function(handle, name, check=FALSE, default=NULL, bit64conversion = "int") {
    if (check) {
        if (!H5Aexists(handle, name)) {
            return(default)
        }
    }

    ahandle <- H5Aopen_by_name(handle, name=name)
    on.exit(H5Aclose(ahandle), add=TRUE, after=FALSE)
    output <- H5Aread(ahandle, bit64conversion=bit64conversion)

    if (is.raw(output)) {
        storage.mode(output) <- "integer"
    } else if (is.character(output) && H5Tget_cset(H5Aget_type(ahandle)) == 1L) {
        Encoding(output) <- "UTF-8"
    }

    output
}

#' @export
h5_cast <- function(current, expected.type, missing.placeholder, respect.nan.payload=FALSE) {
    restore_min_integer <- function(y) {
        z <- FALSE
        if (is.integer(y) && anyNA(y)) { # promote integer NAs back to the actual number.
            y <- as.double(y)
            y[is.na(y)] <- -2^31
            z <- TRUE
        }
        list(y=y, converted=z)
    }

    converted <- FALSE
    if (is.null(missing.placeholder)) {
        out <- restore_min_integer(current)
        current <- out$y
        converted <- out$converted
    } else if (is.na(missing.placeholder)) {
        if (!is.double(current)) {
            # No-op as the placeholder is already R's NA of the relevant type.
        } else {
            if (respect.nan.payload && !is.nan(missing.placeholder)) {
                # No-op as we're considering the NaN payload and the placeholder
                # is not NaN (and thus must be an R NA).
            } else { 
                # We set all NaN values to missing, regardless of their payloads.
                # This is possible because is.na(), despite its name, calls the
                # C isnan() under the hood, which just returns TRUE for all NaNs.
                current[is.na(current)] <- NA 
            }
        }
    } else {
        out <- restore_min_integer(current)
        current <- out$y
        converted <- out$converted
        if (is.raw(current)) {
            current <- as.integer(current) # doing this here as raw vectors cannot contain NAs.
        }
        current[which(current == missing.placeholder)] <- NA # Using which() to avoid problems with existing NAs.
    }

    if (!converted && !is.null(expected.type)) {
        target.type <- as.character(.atomics[expected.type])
        if (target.type != typeof(current)) {
            storage.mode(current) <- target.type
        }
    }

    current
}

#' Alter the saving generic
#'
#' Allow alabaster applications to divert to a different saving generic instead of \code{\link{saveObject}}.
#'
#' @param x,path,... Further arguments to pass to \code{\link{saveObject}} or an equivalent generic.
#' @param generic Generic function that can serve as a drop-in replacement for \code{\link{saveObject}}. 
#'
#' @return 
#' For \code{altSaveObject}, files are created at the specified location, see \code{\link{saveObject}} for details.
#'
#' For \code{altSaveObjectFunction}, the alternative generic (if any) is returned if \code{generic} is missing.
#' If \code{generic} is provided, it is used to define the alternative, and the previous alternative is returned.
#'
#' @details
#' By default, \code{altSaveObject} is just a wrapper around \code{\link{saveObject}}.
#' However, if \code{altSaveObjectFunction} is called, \code{altSaveObject} calls the replacement \code{generic} instead.
#' This allows alabaster applications to inject wholesale or class-specific customizations into the saving process,
#' e.g., to save more metadata whenever an instance of a particular class is encountered.
#' Developers of alabaster extensions should use \code{altSaveObject} to save child objects when implementing \code{saveObject} methods,
#' to ensure that application-specific customizations are respected for the children.
#'
#' To motivate the use of \code{altSaveObject}, consider the following scenario.
#' \enumerate{
#' \item We have created a staging method for class X, defined for the \code{\link{saveObject}} generic.
#' \item An alabaster application Y requires the addition of some custom metadata during the staging process for X.
#' It defines an alternative staging generic \code{saveObject2} that, upon encountering an instance of X, redirects to an application-specific method (i.e., \code{saveObject2,X-method}).
#' For example, the \code{saveObject2} method for X could call X's \code{saveObject} method and add the necessary metadata to the result.
#' \item When operating in the context of application Y, the \code{saveObject2} generic is used to set \code{altSaveObjectFunction}.
#' Any calls to \code{altSaveObject} in Y's context will subsequently call \code{saveObject2}.
#' \item So, when writing a \code{saveObject} method for any objects that might contain an instance of X as a child, 
#' we call \code{\link{altSaveObject}} on that X object instead of directly using \code{\link{saveObject}}. 
#' This ensures that, if a child instance of X is encountered \emph{and} we are operating in the context of application Y, 
#' we correctly call \code{saveObject2} and then ultimately the application-specific method.
#' }
#'
#' The application-specific \code{generic} is free to do anything it wants as long as the custom representation is understood by the application-specific reader in \code{\link{altReadObject}}.
#' However, it is usually most convenient to re-use the existing representations created by \code{\link{saveObject}}.
#' This means that any customizations should not interfere with the validity of those representations, as defined by the \pkg{takane} specifications and enforced by \code{\link{validateObject}}.
#' We recommend that any customizations should manifest as new files starting with an underscore, as this will not interfere by any \pkg{takane} file specification.
#' 
#' @author Aaron Lun
#' @examples
#' old <- altSaveObjectFunction()
#'
#' # Creating a new generic for demonstration purposes:
#' setGeneric("superSaveObject", function(x, path, ...)
#'     standardGeneric("superSaveObject"))
#'
#' setMethod("superSaveObject", "ANY", function(x, path, ...) {
#'     print("Falling back to the base method!")
#'     saveObject(x, path, ...)
#' })
#' 
#' altSaveObjectFunction(superSaveObject)
#'
#' # Staging an example DataFrame. This should print our message.
#' library(S4Vectors)
#' df <- DataFrame(A=1:10, B=LETTERS[1:10])
#' tmp <- tempfile()
#' altSaveObject(df, tmp)
#'
#' # Restoring the old loader:
#' altSaveObjectFunction(old)
#'
#' @export
#' @aliases .stageObject .altStageObject altStageObject altStageObjectFunction
altSaveObject <- function(x, path, ...) {
    FUN <- altSaveObjectFunction()

    if (is.null(FUN)) {
        FUN <- saveObject
    } else {
        # Setting up the save environment.
        sfuns <- registerSaveEnvironment()
        on.exit({ 
            sfuns$write(path)
            sfuns$restore()
        }, add=TRUE, after=FALSE)
    }

    FUN(x, path, ...)
}

#' @export
#' @rdname altSaveObject
altSaveObjectFunction <- (function() {
    cur.env <- new.env()
    cur.env$generic <- NULL
    function(generic) {
        prev <- cur.env$generic
        if (missing(generic)) {
            prev
        } else {
            cur.env$generic <- generic
            invisible(prev)
        }
    }
})()

#######################################
########### OLD STUFF HERE ############
#######################################

#' @export
altStageObject <- function(...) {
    FUN <- altStageObjectFunction()
    if (is.null(FUN)) {
        FUN <- stageObject
    }
    FUN(...)
}

#' @export
altStageObjectFunction <- (function() {
    cur.env <- new.env()
    cur.env$generic <- NULL
    function(generic) {
        prev <- cur.env$generic
        if (missing(generic)) {
            prev
        } else {
            cur.env$generic <- generic
            invisible(prev)
        }
    }
})()

# Soft-deprecated back-compatibility fixes.

#' @export
.stageObject <- function(...) altStageObject(...)

#' @export
.altStageObject <- function(...) altStageObjectFunction(...)

#' Convenience helpers for handling local directories
#'
#' \emph{WARNING: these functions are deprecated as the saving/reading functions are already simple enough in the newer versions of the \pkg{alabaster} framework.}
#' Read and write objects from a local staging directory.
#' These are just convenience wrappers around functions like \code{\link{loadObject}}, \code{\link{stageObject}} and \code{\link{writeMetadata}}.
#'
#' @param x Object to be saved.
#' @param dir String containing a path to the directory.
#' @param path String containing a relative path to the object of interest inside \code{dir}.
#' @param ... Further arguments to pass to \code{\link{loadObject}} (for \code{quickLoadObject}) or \code{\link{stageObject}} (for \code{quickStageObject}).
#'
#' @return For \code{quickLoadObject}, the object at \code{path}.
#'
#' For \code{quickStageObject}, the object is saved to \code{path} inside \code{dir}.
#' All necessary directories are created if they are not already present.
#' A \code{NULL} is returned invisibly.
#'
#' @author Aaron Lun
#'
#' @examples
#' local <- tempfile()
#'
#' # Creating a slightly complicated object:
#' library(S4Vectors)
#' df <- DataFrame(A=1:10, B=LETTERS[1:10])
#' df$C <- DataFrame(D=letters[1:10], E=runif(10))
#'
#' # Saving it:
#' quickStageObject(df, local, "FOOBAR")
#'
#' # Reading it back:
#' quickLoadObject(local, "FOOBAR")
#'
#' @export
#' @aliases readLocalObject saveLocalObject
quickLoadObject <- function(dir, path, ...) {
    meta <- acquireMetadata(dir, path)
    loadObject(meta, dir, ...)
}

#' @export
#' @rdname quickLoadObject
quickStageObject <- function(x, dir, path, ...) {
    dir.create(file.path(dir, dirname(path)), recursive=TRUE, showWarnings=FALSE)
    meta <- stageObject(x, dir, path, ...)
    info <- writeMetadata(meta, dir)
    writeMetadata(.createRedirection(dir, path, info$path), dir)
    invisible(NULL)
}

# Soft-deprecated back-compatibility fixes.

#' @export
readLocalObject <- function(...) quickLoadObject(...)

#' @export
saveLocalObject <- function(...) quickStageObject(...)

## ----echo=FALSE---------------------------------------------------------------
library(BiocStyle)
self <- Biocpkg("alabaster.base");
knitr::opts_chunk$set(error=FALSE, warning=FALSE, message=FALSE)

## -----------------------------------------------------------------------------
library(S4Vectors)
df <- DataFrame(X=1:10, Y=letters[1:10])
df

## -----------------------------------------------------------------------------
tmp <- tempfile()
library(alabaster.base)
saveObject(df, tmp)

## -----------------------------------------------------------------------------
readObject(tmp)

## -----------------------------------------------------------------------------
tmp <- tempfile()
saveObject(df, tmp)
list.files(tmp, recursive=TRUE)

## -----------------------------------------------------------------------------
readObject(tmp)

## -----------------------------------------------------------------------------
validateObject(tmp)

## -----------------------------------------------------------------------------
tmp <- tempfile()
saveObject(df, tmp)

tmp2 <- tempfile()
file.rename(tmp, tmp2)
readObject(tmp2)

## -----------------------------------------------------------------------------
# Creating a nested DF to be a little spicy:
df2 <- DataFrame(Z=factor(1:5), AA=I(DataFrame(B=runif(5), C=rnorm(5))))
tmp <- tempfile()
meta2 <- saveObject(df2, tmp)

# Now reading in the nested DF:
list.files(tmp, recursive=TRUE)
readObject(file.path(tmp, "other_columns/1"))

## -----------------------------------------------------------------------------
library(Matrix)
setMethod("saveObject", "dgTMatrix", function(x, path, ...) {
    # Create a directory to stash our contents.
    dir.create(path)

    # Saving a DataFrame with the triplet data.
    df <- DataFrame(i = x@i, j = x@j, x = x@x)
    write.csv(df, file.path(path, "matrix.csv"), row.names=FALSE)

    # Adding some more information.
    write(dim(x), file=file.path(path, "dimensions.txt"), ncol=1)

    # Creating an object file.
    saveObjectFile(path, "triplet_sparse_matrix")
})

## -----------------------------------------------------------------------------
readSparseTripletMatrix <- function(path, metadata, ...) {
    df <- read.table(file.path(path, "matrix.csv"), header=TRUE, sep=",")
    dims <- readLines(file.path(path, "dimensions.txt"))
    sparseMatrix(
         i=df$i + 1L, 
         j=df$j + 1L, 
         x=df$x, 
         dims=as.integer(dims),
         repr="T"
    )
}
registerReadObjectFunction("triplet_sparse_matrix", readSparseTripletMatrix)

validateSparseTripletMatrix <- function(path, metadata) {
    df <- read.table(file.path(path, "matrix.csv"), header=TRUE, sep=",")
    dims <- as.integer(readLines(file.path(path, "dimensions.txt")))
    stopifnot(is.integer(df$i), all(df$i >= 0 & df$i < dims[1]))
    stopifnot(is.integer(df$j), all(df$j >= 0 & df$j < dims[2]))
    stopifnot(is.numeric(df$x))
}
registerValidateObjectFunction("triplet_sparse_matrix", validateSparseTripletMatrix)

## -----------------------------------------------------------------------------
x <- sparseMatrix(
    i=c(1,2,3,5,6), 
    j=c(3,6,1,3,8), 
    x=runif(5), 
    dims=c(10, 10), 
    repr="T"
)
x

tmp <- tempfile()
saveObject(x, tmp)
list.files(tmp, recursive=TRUE)
readObject(tmp)

## -----------------------------------------------------------------------------
setGeneric("appSaveObject", function(x, path, ...) {
    ans <- standardGeneric("appSaveObject")

    # File names with leading underscores are reserved for application-specific
    # use, so they won't clash with anything produced by saveObject.
    metapath <- file.path(path, "_metadata.json")
    write(jsonlite::toJSON(ans, auto_unbox=TRUE), file=metapath)
})

setMethod("appSaveObject", "ANY", function(x, path, ...) {
    saveObject(x, path, ...) # does the real work
    list(authors=I(Sys.info()[["user"]])) # adds the desired metadata
})

# We can specialize the behavior for specific classes like DataFrames.
setMethod("appSaveObject", "DFrame", function(x, path, ...) {
    ans <- callNextMethod()
    ans$columns <- I(colnames(x))
    ans
})

## -----------------------------------------------------------------------------
# Create a friendly user-visible function to handle the generic override; this
# is reversed on function exit to avoid interfering with other applications. 
saveForApplication <- function(x, path, ...) { 
    old <- altSaveObjectFunction(appSaveObject)
    on.exit(altSaveObjectFunction(old)) 
    altSaveObject(x, path, ...)
}

# Saving our mocked up DataFrame with our overrides active.
df2 <- DataFrame(Z=factor(1:5), AA=I(DataFrame(B=runif(5), C=rnorm(5))))
tmp <- tempfile()
saveForApplication(df2, tmp)

# Both the parent and child DataFrames have new metadata.
cat(readLines(file.path(tmp, "_metadata.json")), sep="\n")
cat(readLines(file.path(tmp, "other_columns/1/_metadata.json")), sep="\n")

## -----------------------------------------------------------------------------
# Defining the override for altReadObject().
appReadObject <- function(path, metadata=NULL, ...) {
    if (is.null(metadata)) {
        metadata <- readObjectFile(path)
    }

    # Print custom message based on the type and application-specific metadata.
    appmeta <- jsonlite::fromJSON(file.path(path, "_metadata.json"))
    cat("I am a ", metadata$type, " created by ", appmeta$authors[1], ".\n", sep="")
    if (metadata$type == "data_frame") {
        all.cols <- paste(appmeta$columns, collapse=", ")
        cat("I have the following columns: ", all.cols, ".\n", sep="")
    }

    readObject(path, metadata=metadata, ...)
}

# Creating a user-friendly function to set the override before the read.
readForApplication <- function(path, metadata=NULL, ...) {
    old <- altReadObjectFunction(appReadObject)
    on.exit(altReadObjectFunction(old))
    altReadObject(path, metadata, ...)
}

# This diverts to the override with printing of custom messages.
readForApplication(tmp)

## -----------------------------------------------------------------------------
sessionInfo()

#!/bin/bash

set -e
set -u

# Fetches all of the header files. We vendor it inside the package so that
# downstream packages can simply use LinkingTo to get access to them.

harvester() {
    local name=$1
    local url=$2
    local version=$3

    local tmpname=source-${name}
    if [ ! -e $tmpname ]
    then 
        git clone $url $tmpname
    else 
        cd $tmpname
        git checkout master
        git pull
        cd -
    fi

    cd $tmpname
    git checkout $version
    rm -rf ../$name
    cp -r include/$name ../$name
    cd -
}

harvester comservatory https://github.com/ArtifactDB/comservatory v2.1.0

---
title: Saving objects to artifacts and back again
author:
- name: Aaron Lun
  email: infinite.monkeys.with.keyboards@gmail.com
package: alabaster.base
date: "Revised: February 1, 2024"
output:
  BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{Saving and loading artifacts}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, echo=FALSE}
library(BiocStyle)
self <- Biocpkg("alabaster.base");
knitr::opts_chunk$set(error=FALSE, warning=FALSE, message=FALSE)
```

# Introduction

The `r self` package (and its family) implements methods to save common Bioconductor objects to file artifacts and load them back into R.
This aims to provide a functional equivalent to RDS-based serialization that is:

- More stable to changes in the class definition.
  Such changes would typically require costly `updateObject()` operations at best, or invalidate RDS files at worst.
- More interoperable with other analysis frameworks.
  All artifacts are saved in standard formats (e.g., JSON, HDF5) and can be easily parsed by applications in other languages by following the [relevant specifications](https://github.com/ArtifactDB/takane).
- More modular, with each object split into multiple artifacts. 
  This enables parts of the object to be loaded into memory according to each application's needs.
  Parts can also be updated cheaply on disk without rewriting all files.

# Quick start

To demonstrate, let's mock up a `DataFrame` object from the `r Biocpkg("S4Vectors")` package.

```{r}
library(S4Vectors)
df <- DataFrame(X=1:10, Y=letters[1:10])
df
```

We'll save this `DataFrame` to a directory:

```{r}
tmp <- tempfile()
library(alabaster.base)
saveObject(df, tmp)
```

And read it back in:

```{r}
readObject(tmp)
```

# Class-specific methods

Each class implements a saving and reading method for use by the _alabaster_ framework.
The saving method (for the `saveObject()` generic) will save the object to one or more files inside a user-specified directory:

```{r}
tmp <- tempfile()
saveObject(df, tmp)
list.files(tmp, recursive=TRUE)
```

Conversely, the reading function will - as the name suggests - load the object back into memory, given the path to its directory. 
The correct loading function for each class is automatically called by the `readObject()` function:

```{r}
readObject(tmp)
```

`r self` also provides a `validateObject()` function, which checks that each object's on-disk representation follows its associated specification.
For all **alabaster**-supported objects, this validates the file contents against the [**takane** specifications](https://github.com/ArtifactDB/takane) -
successful validation provides guarantees for readers like `readObject()` and [**dolomite-base**](https://github.com/ArtifactDB/dolomite-base) (for Python).
In fact, `saveObject()` will automatically run `validateObject()` on the directory to ensure compliance. 

```{r}
validateObject(tmp)
```

`r self` itself supports a small set of classes from the `r Biocpkg("S4Vectors")` packages;
support for additional classes can be found in other packages like `r Biocpkg("alabaster.ranges")` and `r Biocpkg("alabaster.se")`.
Third-party developers can also add support for their own classes by defining new methods, see [below](#extending-to-new-classes) for details.

# Operating on directories

Users can move freely rename or relocate directories and `readObject()` function will still work.
For example, we can easily copy the entire directory to a new file system and everything will still be correctly referenced within the directory.
The simplest way to share objects is to just `zip` or `tar` the staging directory for _ad hoc_ distribution.
For more serious applications, `r self` can be used in conjunction with storage systems like AWS S3 for large-scale distribution.

```{r}
tmp <- tempfile()
saveObject(df, tmp)

tmp2 <- tempfile()
file.rename(tmp, tmp2)
readObject(tmp2)
```

That said, it is unwise to manipulate the files inside the directory created by `saveObject()`.
Reading functions will usually depend on specific file names or subdirectory structures within the directory, and fiddling with them may cause unexpected results.
Advanced users can exploit this by loading components from subdirectories if only the full object is not required:

```{r}
# Creating a nested DF to be a little spicy:
df2 <- DataFrame(Z=factor(1:5), AA=I(DataFrame(B=runif(5), C=rnorm(5))))
tmp <- tempfile()
meta2 <- saveObject(df2, tmp)

# Now reading in the nested DF:
list.files(tmp, recursive=TRUE)
readObject(file.path(tmp, "other_columns/1"))
```

# Extending to new classes

The _alabaster_ framework is easily extended to new classes by:

1. Writing a method for `saveObject()`.
   This should accept an instance of the object and a path to a directory, and save the contents of the object inside the directory.
   It should also produce an `OBJECT` file that specifies the type of the object, e.g., `data_frame`, `hdf5_sparse_matrix`.
2. Writing a function for `readObject()` and registering it with `registerReadObjectFunction()` (or, for core Bioconductor classes, by requesting a change to the default registry in `r self`).
   This should accept a path to a directory and read its contents to reconstruct the object.
   The registered type should be the same as that used in the `OBJECT` file.
3. Writing a function for `validateObject()` and registering it with `registerValidateObjectFunction()`.
   This should accept a path to a directory and read its contents to determine if it is a valid on-disk representation.
   The registered type should be the same as that used in the `OBJECT` file.
   - (optional) Devleopers can alternatively formalize the on-disk representation by adding a specification to the [**takane**](https://github.com/ArtifactDB/takane) repository.
     This aims to provide C++-based validators for each representation, allowing us to enforce consistency across multiple languages (e.g., Python).
     Any **takane** validator is automatically used by `validateObject()` so no registration is required.

To illustrate, let's extend _alabaster_ to the `dgTMatrix` from the `r CRANpkg("Matrix")` package.
First, the saving method:

```{r}
library(Matrix)
setMethod("saveObject", "dgTMatrix", function(x, path, ...) {
    # Create a directory to stash our contents.
    dir.create(path)

    # Saving a DataFrame with the triplet data.
    df <- DataFrame(i = x@i, j = x@j, x = x@x)
    write.csv(df, file.path(path, "matrix.csv"), row.names=FALSE)

    # Adding some more information.
    write(dim(x), file=file.path(path, "dimensions.txt"), ncol=1)

    # Creating an object file.
    saveObjectFile(path, "triplet_sparse_matrix")
})
```

And now the reading and validation methods.
The registration is usually done in the extension package's `onLoad()` function.

```{r}
readSparseTripletMatrix <- function(path, metadata, ...) {
    df <- read.table(file.path(path, "matrix.csv"), header=TRUE, sep=",")
    dims <- readLines(file.path(path, "dimensions.txt"))
    sparseMatrix(
         i=df$i + 1L, 
         j=df$j + 1L, 
         x=df$x, 
         dims=as.integer(dims),
         repr="T"
    )
}
registerReadObjectFunction("triplet_sparse_matrix", readSparseTripletMatrix)

validateSparseTripletMatrix <- function(path, metadata) {
    df <- read.table(file.path(path, "matrix.csv"), header=TRUE, sep=",")
    dims <- as.integer(readLines(file.path(path, "dimensions.txt")))
    stopifnot(is.integer(df$i), all(df$i >= 0 & df$i < dims[1]))
    stopifnot(is.integer(df$j), all(df$j >= 0 & df$j < dims[2]))
    stopifnot(is.numeric(df$x))
}
registerValidateObjectFunction("triplet_sparse_matrix", validateSparseTripletMatrix)
```

Let's run them and see how it works:

```{r}
x <- sparseMatrix(
    i=c(1,2,3,5,6), 
    j=c(3,6,1,3,8), 
    x=runif(5), 
    dims=c(10, 10), 
    repr="T"
)
x

tmp <- tempfile()
saveObject(x, tmp)
list.files(tmp, recursive=TRUE)
readObject(tmp)
```

For more complex objects that are composed of multiple smaller "child" objects, developers should consider saving each of their children in subdirectories of `path`.
This can be achieved by calling `altSaveObject()` and `altReadObject()` in the saving and reading functions, respectively.
(We use the `alt*` versions of these functions to respect application overrides, see below.)

# Creating applications

Developers can also create applications that customize the machinery of the _alabaster_ framework for specific needs.
In most cases, this involves storing more metadata to describe the object in more detail.
For example, we might want to remember the identity of the author for each object.
This is achieved by creating an application-specific saving generic with the same signature as `saveObject()`:

```{r}
setGeneric("appSaveObject", function(x, path, ...) {
    ans <- standardGeneric("appSaveObject")

    # File names with leading underscores are reserved for application-specific
    # use, so they won't clash with anything produced by saveObject.
    metapath <- file.path(path, "_metadata.json")
    write(jsonlite::toJSON(ans, auto_unbox=TRUE), file=metapath)
})

setMethod("appSaveObject", "ANY", function(x, path, ...) {
    saveObject(x, path, ...) # does the real work
    list(authors=I(Sys.info()[["user"]])) # adds the desired metadata
})

# We can specialize the behavior for specific classes like DataFrames.
setMethod("appSaveObject", "DFrame", function(x, path, ...) {
    ans <- callNextMethod()
    ans$columns <- I(colnames(x))
    ans
})
```

Applications should call `altSaveObjectFunction()` to instruct `altSaveObject()` to use this new generic.
This ensures that the customizations are applied to all child objects, such as the nested `DataFrame` below.

```{r}
# Create a friendly user-visible function to handle the generic override; this
# is reversed on function exit to avoid interfering with other applications. 
saveForApplication <- function(x, path, ...) { 
    old <- altSaveObjectFunction(appSaveObject)
    on.exit(altSaveObjectFunction(old)) 
    altSaveObject(x, path, ...)
}

# Saving our mocked up DataFrame with our overrides active.
df2 <- DataFrame(Z=factor(1:5), AA=I(DataFrame(B=runif(5), C=rnorm(5))))
tmp <- tempfile()
saveForApplication(df2, tmp)

# Both the parent and child DataFrames have new metadata.
cat(readLines(file.path(tmp, "_metadata.json")), sep="\n")
cat(readLines(file.path(tmp, "other_columns/1/_metadata.json")), sep="\n")
```

The reading function can be similarly overridden by setting `altReadObjectFunction()` to instruct all `altReadObject()` calls to use the override.
This allows applications to, e.g., do something with the metadata that we just added.

```{r}
# Defining the override for altReadObject().
appReadObject <- function(path, metadata=NULL, ...) {
    if (is.null(metadata)) {
        metadata <- readObjectFile(path)
    }

    # Print custom message based on the type and application-specific metadata.
    appmeta <- jsonlite::fromJSON(file.path(path, "_metadata.json"))
    cat("I am a ", metadata$type, " created by ", appmeta$authors[1], ".\n", sep="")
    if (metadata$type == "data_frame") {
        all.cols <- paste(appmeta$columns, collapse=", ")
        cat("I have the following columns: ", all.cols, ".\n", sep="")
    }

    readObject(path, metadata=metadata, ...)
}

# Creating a user-friendly function to set the override before the read.
readForApplication <- function(path, metadata=NULL, ...) {
    old <- altReadObjectFunction(appReadObject)
    on.exit(altReadObjectFunction(old))
    altReadObject(path, metadata, ...)
}

# This diverts to the override with printing of custom messages.
readForApplication(tmp)
```

By overriding the saving and reading process for one or more classes, each application can customize the behavior of _alabaster_ to their own needs.

# Session information {-}

```{r}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hdf5.R
\name{hdf5}
\alias{hdf5}
\alias{h5_guess_vector_chunks}
\alias{h5_create_vector}
\alias{h5_write_vector}
\alias{h5_write_attribute}
\alias{h5_read_vector}
\alias{h5_read_attribute}
\alias{h5_object_exists}
\alias{h5_cast}
\title{HDF5 utilities}
\description{
Basically just better versions of those in \pkg{rhdf5}, dedicated to \pkg{alabaster.base} and its dependents.
Intended for \pkg{alabaster.*} developers only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/absolutizePath.R
\name{absolutizePath}
\alias{absolutizePath}
\title{Make an absolute file path}
\usage{
absolutizePath(path)
}
\arguments{
\item{path}{String containing an absolute or relative file path.}
}
\value{
An absolute file path corresponding to \code{path}.
This is cleaned to remove \code{..}, \code{.} and \code{~} components.
}
\description{
Create an absolute file path from a relative file path.
All processing is purely lexical; the path itself does not have to exist on the filesystem.
}
\examples{
absolutizePath("alpha")
absolutizePath("../alpha")
absolutizePath("../../alpha/./bravo")
absolutizePath("/alpha/bravo")

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/anyMissing.R
\name{anyMissing}
\alias{anyMissing}
\alias{is.missing}
\title{Find missing values}
\usage{
anyMissing(x)

is.missing(x)
}
\arguments{
\item{x}{Vector or array of atomic values.}
}
\value{
For \code{anyMissing}, a logical scalar indicating whether any \code{NA} values were present in \code{x}.

For \code{is.missing}, a logical vector or array of shape equal to \code{x}, indicating whether each value is \code{NA}.
}
\description{
Find missing (\code{NA}) values.
This is smart enough to distinguish them from NaN values in numeric \code{x}.
For all other types, it just calls \code{\link{is.na}} or \code{\link{anyNA}}.
}
\examples{
anyNA(c(NaN))
anyNA(c(NA))
anyMissing(c(NaN))
anyMissing(c(NA))

is.na(c(NA, NaN))
is.missing(c(NA, NaN))
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/saveBaseList.R
\name{saveBaseList}
\alias{saveBaseList}
\alias{saveObject,list-method}
\alias{stageObject,list-method}
\alias{stageObject,List-method}
\alias{.saveBaseListFormat}
\alias{saveObject,List-method}
\alias{saveBaseListFormat}
\title{Save a base list to disk}
\usage{
\S4method{saveObject}{list}(
  x,
  path,
  list.format = saveBaseListFormat(),
  list.character.vls = NULL,
  ...
)

\S4method{saveObject}{List}(x, path, list.format = saveBaseListFormat(), ...)

saveBaseListFormat(list.format)
}
\arguments{
\item{x}{An ordinary R list, named or unnamed.
Alternatively, a \link[S4Vectors]{List} to be coerced into a list.}

\item{path}{String containing the path to a directory in which to save \code{x}.}

\item{list.format}{String specifying the format in which to save the list.}

\item{list.character.vls}{Logical scalar indicating whether to save character vectors in the custom variable length string (VLS) array format.
If \code{NULL}, this is determined based on a comparison of the expected storage against a fixed length array.
Only used if \code{list.format="hdf5"}.}

\item{...}{Further arguments, passed to \code{\link{altSaveObject}} for complex child objects.}
}
\value{
For the \code{saveObject} method, \code{x} is saved inside \code{dir}.
\code{NULL} is invisibly returned.

For \code{saveBaseListFormat}; if \code{list.format} is missing, a string containing the current format is returned.
If \code{list.format} is supplied, it is used to define the current format, and the \emph{previous} format is returned.
}
\description{
Save a \link{list} or \link[S4Vectors]{List} to a JSON or HDF5 file, with extra files created for any of the more complex list elements (e.g., DataFrames, arrays). 
This uses the \href{https://github.com/ArtifactDB/uzuki2}{uzuki2} specification to ensure that appropriate types are declared.
}
\section{File formats}{

If \code{list.format="json.gz"} (default), the list is saved to a Gzip-compressed JSON file (the default).
This is an easily parsed format with low storage overhead.

If \code{list.format="hdf5"}, \code{x} is saved into a HDF5 file instead.
This format is most useful for random access and for preserving the precision of numerical data.
}

\section{Storing scalars}{

The \pkg{uzuki2} specification (see \url{https://github.com/ArtifactDB/uzuki2}) allows length-1 vectors to be stored as-is or as a scalar.
If a list element is of length 1, \code{saveBaseList} will store it as a scalar on-disk, effectively \dQuote{unboxing} it for languages with a concept of scalars.
Users can override this behavior by adding the \link{AsIs} class to the affected list element, which will force storage as a length-1 vector.
This reflects the decisions made by \code{\link{readBaseList}} and mimics the behavior of packages like \pkg{jsonlite}.
}

\examples{
library(S4Vectors)
ll <- list(A=1, B=LETTERS, C=DataFrame(X=1:5))

tmp <- tempfile()
saveObject(ll, tmp)
list.files(tmp, recursive=TRUE)

}
\seealso{
\url{https://github.com/ArtifactDB/uzuki2} for the specification.

\code{\link{readBaseList}}, to read the list back into the R session.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/altSaveObject.R
\name{altSaveObject}
\alias{altSaveObject}
\alias{.stageObject}
\alias{.altStageObject}
\alias{altStageObject}
\alias{altStageObjectFunction}
\alias{altSaveObjectFunction}
\title{Alter the saving generic}
\usage{
altSaveObject(x, path, ...)

altSaveObjectFunction(generic)
}
\arguments{
\item{x, path, ...}{Further arguments to pass to \code{\link{saveObject}} or an equivalent generic.}

\item{generic}{Generic function that can serve as a drop-in replacement for \code{\link{saveObject}}.}
}
\value{
For \code{altSaveObject}, files are created at the specified location, see \code{\link{saveObject}} for details.

For \code{altSaveObjectFunction}, the alternative generic (if any) is returned if \code{generic} is missing.
If \code{generic} is provided, it is used to define the alternative, and the previous alternative is returned.
}
\description{
Allow alabaster applications to divert to a different saving generic instead of \code{\link{saveObject}}.
}
\details{
By default, \code{altSaveObject} is just a wrapper around \code{\link{saveObject}}.
However, if \code{altSaveObjectFunction} is called, \code{altSaveObject} calls the replacement \code{generic} instead.
This allows alabaster applications to inject wholesale or class-specific customizations into the saving process,
e.g., to save more metadata whenever an instance of a particular class is encountered.
Developers of alabaster extensions should use \code{altSaveObject} to save child objects when implementing \code{saveObject} methods,
to ensure that application-specific customizations are respected for the children.

To motivate the use of \code{altSaveObject}, consider the following scenario.
\enumerate{
\item We have created a staging method for class X, defined for the \code{\link{saveObject}} generic.
\item An alabaster application Y requires the addition of some custom metadata during the staging process for X.
It defines an alternative staging generic \code{saveObject2} that, upon encountering an instance of X, redirects to an application-specific method (i.e., \code{saveObject2,X-method}).
For example, the \code{saveObject2} method for X could call X's \code{saveObject} method and add the necessary metadata to the result.
\item When operating in the context of application Y, the \code{saveObject2} generic is used to set \code{altSaveObjectFunction}.
Any calls to \code{altSaveObject} in Y's context will subsequently call \code{saveObject2}.
\item So, when writing a \code{saveObject} method for any objects that might contain an instance of X as a child, 
we call \code{\link{altSaveObject}} on that X object instead of directly using \code{\link{saveObject}}. 
This ensures that, if a child instance of X is encountered \emph{and} we are operating in the context of application Y, 
we correctly call \code{saveObject2} and then ultimately the application-specific method.
}

The application-specific \code{generic} is free to do anything it wants as long as the custom representation is understood by the application-specific reader in \code{\link{altReadObject}}.
However, it is usually most convenient to re-use the existing representations created by \code{\link{saveObject}}.
This means that any customizations should not interfere with the validity of those representations, as defined by the \pkg{takane} specifications and enforced by \code{\link{validateObject}}.
We recommend that any customizations should manifest as new files starting with an underscore, as this will not interfere by any \pkg{takane} file specification.
}
\examples{
old <- altSaveObjectFunction()

# Creating a new generic for demonstration purposes:
setGeneric("superSaveObject", function(x, path, ...)
    standardGeneric("superSaveObject"))

setMethod("superSaveObject", "ANY", function(x, path, ...) {
    print("Falling back to the base method!")
    saveObject(x, path, ...)
})

altSaveObjectFunction(superSaveObject)

# Staging an example DataFrame. This should print our message.
library(S4Vectors)
df <- DataFrame(A=1:10, B=LETTERS[1:10])
tmp <- tempfile()
altSaveObject(df, tmp)

# Restoring the old loader:
altSaveObjectFunction(old)

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/saveBaseFactor.R
\name{saveBaseFactor}
\alias{saveBaseFactor}
\alias{saveObject,factor-method}
\alias{stageObject,factor-method}
\title{Save a factor to disk}
\usage{
\S4method{saveObject}{factor}(x, path, ...)
}
\arguments{
\item{x}{A factor.}

\item{path}{String containing the path to a directory in which to save \code{x}.}

\item{...}{Further arguments that are ignored.}
}
\value{
\code{x} is saved inside \code{path}.
\code{NULL} is invisibly returned.
}
\description{
Pretty much as it says, let's save a base R \link{factor} to an on-disk representation.
}
\examples{
tmp <- tempfile()
saveObject(factor(1:10, 1:30), tmp)
list.files(tmp, recursive=TRUE)

}
\seealso{
\code{\link{readBaseFactor}}, to read the files back into the session.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getSaveEnrivonment.R
\name{getSaveEnvironment}
\alias{getSaveEnvironment}
\alias{formatSaveEnvironment}
\alias{useSaveEnvironment}
\alias{registerSaveEnvironment}
\alias{loadSaveEnvironment}
\title{Track the environment used for saving objects}
\usage{
getSaveEnvironment()

formatSaveEnvironment()

useSaveEnvironment(use)

registerSaveEnvironment(info = NULL)

loadSaveEnvironment(path)
}
\arguments{
\item{use}{Logical scalar specifying whether to use a save environment during reading/saving of objects.}

\item{info}{Named list containing information about the environment used to save each object.
If \code{NULL}, this is created by calling \code{formatSaveEnvironment}.}

\item{path}{String containing the path to a directory representing an object,
same as that used by \code{\link{saveObject}} and \code{\link{readObject}}.}
}
\value{
\code{getSaveEnvironment} returns a named list describing the environment used to save the \dQuote{current} object (see Details).
The list should have a \code{type} field specifying the type of environment, e.g., \code{"R"}.
For objects created by \code{\link{saveObject}}, this will typically have the same format as the list returned by \code{formatSaveEnvironment}.
Alternatively, \code{NULL} is returned if \code{useSaveEnvironment} is set to \code{FALSE} or no environment information was recorded for the current object.

\code{formatSaveEnvironment} returns a named list containing the current R environment, derived from the \code{\link[utils]{sessionInfo}}.
This records the R \code{version}, the \code{platform} in which R is running, and the versions of all \code{packages} as a named list.

If \code{use} is not supplied, \code{useSaveEnvironment} returns a logical scalar indicating whether to use the save environment information.
If \code{use} is supplied, it is used to define the save environment usage policy, and the previous setting of this value is invisibly returned.

\code{registerSaveEnvironment} registers the current environment information in memory so that it can be returned by \code{getSaveEnvironment}.
It returns a list containing a \code{restore} function that should be called \code{\link{on.exit}} to (i) restore the previous environment information;
and a \code{write} function that accepts a \code{path} to a directory in which to create an \code{_environment.json} file with the environment information.
Both functions are no-ops if \code{useSaveEnvironment} is set to \code{FALSE} or if a save environment has already been registered.

\code{loadSaveEnvironment} loads the environment information from a \code{_environment.json} file in \code{path}.
It also registers the environment information in memory so that it is returned when \code{getSaveEnvironment} is called.
It returns a function that should be called \code{\link{on.exit}} to restore the previous environment information. 
This function is a no-op if \code{useSaveEnvironment} is set to \code{FALSE}, or if the environment information is not parsable (in which case a warning will be emitted).
}
\description{
Utilities to write, load and access the R environment used by \code{\link{saveObject}} for any given object.
}
\details{
When saving an object, \pkg{\link{saveObject}} will automatically record some details about the current R environment. 
This facilitates trouble-shooting and provides some opportunities for corrective measures if any bugs are found in older \code{saveObject} methods.
Information about the save environment is stored in an \code{_environment.json} file inside the directory containing the object.
Subdirectories for child objects may also have separate \code{_environment.json} files (e.g., if they were created in a different environment),
otherwise it is assumed that they inherit the save environment from the parent object.

Application or extension developers are expected to call \code{getSaveEnvironment} from inside a loading function used by \code{\link{readObject}} or \code{\link{altReadObject}}.
This wil return the save environment that was used for the \dQuote{current} object, i.e., the object that was previously saved at \code{path}.
By accessing the historical save environment, developers can check if buggy versions of the corresponding \code{saveObject} or \code{altSaveObject} methods were used.
Appropriate corrective measures can then be applied to recover the correct object, warn users, etc.
\code{getSaveEnvironment} can also be called inside \code{saveObject} or \code{altSaveObject} methods, in which case the current object is the one being saved.

In most cases, \code{registerSaveEnvironment} does not need to be explicitly called by end-users or developers.
It is automatically executed by the top-level calls to the \code{\link{saveObject}} or \code{\link{altSaveObject}} generics.
Methods can simply call \code{\link{getSaveEnvironment}} to access the save environment information.
Similarly, \code{loadSaveEnvironment} does not usually need to be explicitly called by end-users or developers,
as it is automatically executed by each \code{\link{readObject}} or \code{\link{altReadObject}} call.
Individual reader functions can simply call \code{\link{getSaveEnvironment}} to access the save environment information.

Tracking of the save environment can be disabled by setting \code{useSaveEnvironment(FALSE)}.
}
\examples{
str(formatSaveEnvironment())

prev <- useSaveEnvironment(TRUE)
tmp <- tempfile()
dir.create(tmp)

wfun <- registerSaveEnvironment(tmp)
getSaveEnvironment()
wfun$restore()

useSaveEnvironment(prev)

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/quickReadCsv.R
\name{quickReadCsv}
\alias{quickReadCsv}
\alias{.quickReadCsv}
\alias{.quickWriteCsv}
\alias{quickWriteCsv}
\title{Quickly read and write a CSV file}
\usage{
quickReadCsv(
  path,
  expected.columns,
  expected.nrows,
  compression,
  row.names,
  parallel = TRUE
)

quickWriteCsv(
  df,
  path,
  ...,
  row.names = FALSE,
  compression = "gzip",
  validate = TRUE
)
}
\arguments{
\item{path}{String containing a path to a CSV to read/write.}

\item{expected.columns}{Named character vector specifying the type of each column in the CSV (excluding the first column containing row names, if \code{row.names=TRUE}).}

\item{expected.nrows}{Integer scalar specifying the expected number of rows in the CSV.}

\item{compression}{String specifying the compression that was/will be used.
This should be either \code{"none"}, \code{"gzip"}.}

\item{row.names}{For \code{.quickReadCsv}, a logical scalar indicating whether the CSV contains row names. 

For \code{.quickWriteCsv}, a logical scalar indicating whether to save the row names of \code{df}.}

\item{parallel}{Whether reading and parsing should be performed concurrently.}

\item{df}{A \link[S4Vectors]{DFrame} or data.frame object, containing only atomic columns.}

\item{...}{Further arguments to pass to \code{\link{write.csv}}.}

\item{validate}{Whether to double-check that the generated CSV complies with the comservatory specification.}
}
\value{
For \code{.quickReadCsv}, a \link[S4Vectors]{DFrame} containing the contents of \code{path}.

For \code{.quickWriteCsv}, \code{df} is written to \code{path} and a \code{NULL} is invisibly returned.
}
\description{
Quickly read and write a CSV file, usually as a part of staging or loading a larger object.
This assumes that all files follow the \href{https://github.com/ArtifactDB/comservatory}{comservatory} specification.
}
\examples{
library(S4Vectors)
df <- DataFrame(A=1, B="Aaron")

temp <- tempfile()
.quickWriteCsv(df, path=temp, row.names=FALSE, compression="gzip")

.quickReadCsv(temp, c(A="numeric", B="character"), 1, "gzip", FALSE)

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/vls.R
\name{vls}
\alias{vls}
\alias{h5_use_vls}
\alias{h5_write_vls_array}
\alias{h5_read_vls_array}
\title{VLS saving utilities}
\description{
Utilities for saving our custom variable length string array format in HDF5.
Intended for \pkg{alabaster.*} developers only.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/saveAtomicVector.R
\name{saveAtomicVector}
\alias{saveAtomicVector}
\alias{stageObject,integer-method}
\alias{stageObject,numeric-method}
\alias{stageObject,logical-method}
\alias{stageObject,character-method}
\alias{stageObject,double-method}
\alias{stageObject,POSIXct-method}
\alias{stageObject,POSIXlt-method}
\alias{stageObject,Date-method}
\alias{saveObject,integer-method}
\alias{saveObject,character-method}
\alias{saveObject,logical-method}
\alias{saveObject,double-method}
\alias{saveObject,numeric-method}
\alias{saveObject,Date-method}
\alias{saveObject,POSIXlt-method}
\alias{saveObject,POSIXct-method}
\alias{saveObject,numeric_version-method}
\title{Save atomic vectors to disk}
\usage{
\S4method{saveObject}{integer}(x, path, character.vls = FALSE, ...)

\S4method{saveObject}{character}(x, path, character.vls = FALSE, ...)

\S4method{saveObject}{logical}(x, path, character.vls = FALSE, ...)

\S4method{saveObject}{double}(x, path, character.vls = FALSE, ...)

\S4method{saveObject}{numeric}(x, path, character.vls = FALSE, ...)

\S4method{saveObject}{Date}(x, path, character.vls = FALSE, ...)

\S4method{saveObject}{POSIXlt}(x, path, character.vls = FALSE, ...)

\S4method{saveObject}{POSIXct}(x, path, character.vls = FALSE, ...)

\S4method{saveObject}{numeric_version}(x, path, ...)
}
\arguments{
\item{x}{Any of the atomic vector types, or \link{Date} objects, or time objects, e.g., \link{POSIXct}.}

\item{path}{String containing the path to a directory in which to save \code{x}.}

\item{character.vls}{Logical scalar indicating whether to save character vectors in the custom variable length string (VLS) array format.
If \code{NULL}, this is determined based on a comparison of the expected storage against a fixed length array.}

\item{...}{Further arguments that are ignored.}
}
\value{
\code{x} is saved inside \code{path}.
\code{NULL} is invisibly returned.
}
\description{
Save vectors containing atomic elements (or values that can be cast as such, e.g., dates and times) to an on-disk representation.
}
\examples{
tmp <- tempfile()
dir.create(tmp)
saveObject(LETTERS, file.path(tmp, "foo"))
saveObject(setNames(runif(26), letters), file.path(tmp, "bar"))
list.files(tmp, recursive=TRUE)

}
\seealso{
\code{\link{readAtomicVector}}, to read the files back into the session.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readBaseList.R
\name{readBaseList}
\alias{readBaseList}
\alias{loadBaseList}
\title{Read a base list from disk}
\usage{
readBaseList(path, metadata, simple_list.parallel = TRUE, ...)
}
\arguments{
\item{path}{String containing a path to a directory, itself created with the list method for \code{\link{stageObject}}.}

\item{metadata}{Named list containing metadata for the object, see \code{\link{readObjectFile}} for details.}

\item{simple_list.parallel}{Whether to perform reading and parsing in parallel for greater speed.
Only relevant for lists stored in the JSON format.}

\item{...}{Further arguments to be passed to \code{\link{altReadObject}} for complex child objects.}
}
\value{
The list represented by \code{path}.
}
\description{
Read a \link{list} from its on-disk representation.
This is usually not directly called by users, but is instead called by dispatch in \code{\link{readObject}}.
}
\details{
The \pkg{uzuki2} specification (see \url{https://github.com/ArtifactDB/uzuki2}) allows length-1 vectors to be stored as-is or as a scalar.
If the file stores a length-1 vector as-is, \code{readBaseList} will read the list element as a length-1 vector with the \link{AsIs} class.
If the file stores a length-1 vector as a scalar, \code{readBaseList} will read the list element as a length-1 vector without this class.
This allows downstream users to distinguish between the storage modes in the rare cases that it is necessary.
}
\examples{
library(S4Vectors)
ll <- list(A=1, B=LETTERS, C=DataFrame(X=letters))

tmp <- tempfile()
saveObject(ll, tmp)
readObject(tmp)

}
\seealso{
\code{"\link{stageObject,list-method}"}, for the staging method.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/saveFormats.R
\name{saveFormats}
\alias{saveFormats}
\alias{.saveDataFrameFormat}
\alias{saveDataFrameFormat}
\title{Choose the format for certain objects}
\usage{
saveDataFrameFormat(format)
}
\arguments{
\item{format}{String containing the format to use.
Tbe \code{"csv"}, \code{"csv.gz"} (default) or \code{"hdf5"}.
Alternatively \code{NULL}, to use the default format.}
}
\value{
If \code{format} is missing, a string containing the current format is returned, or \code{NULL} to use the default format.

If \code{format} is supplied, it is used to define the current format, and the \emph{previous} format is returned.
}
\description{
Alter the format used to save DataFrames in its \code{\link{stageObject}} methods.
}
\details{
\code{\link{stageObject}} methods will treat a \code{format=NULL} in the same manner as the default format.
The distinction exists to allow downstream applications to set their own defaults while still responding to user specification.
For example, an application can detect if the existing format is \code{NULL}, and if so, apply another default via \code{.saveDataFrameFormat}.
On the other hand, if the format is not \code{NULL}, this is presumably specified by the user explicitly and should be respected by the application.
}
\examples{
(old <- .saveDataFrameFormat())

.saveDataFrameFormat("hdf5")
.saveDataFrameFormat()

# Setting it back.
.saveDataFrameFormat(old)

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readObjectFile.R
\name{readObjectFile}
\alias{readObjectFile}
\alias{saveObjectFile}
\title{Utilities to read and save the object file}
\usage{
readObjectFile(path)

saveObjectFile(path, type, extra = list())
}
\arguments{
\item{path}{Path to the directory representing an object.}

\item{type}{String specifying the type of the object.}

\item{extra}{Named list containing extra metadata to be written to the OBJECT file in \code{path}.
Names should be unique, and any element named \code{"type"} will be overwritten by \code{type}.}
}
\value{
\code{readObjectFile} returns a named list of metadata for \code{path}.

\code{saveObjectFile} saves \code{metadata} to the OBJECT file inside \code{path}
}
\description{
The OBJECT file inside each directory provides some high-level metadata of the object represented by that directory.
It is guaranteed to have a \code{type} property that specifies the object type;
individual objects may add their own information to this file.
These methods are intended for developers to easily read and load information in the OBJECT file.
}
\examples{
tmp <- tempfile()
dir.create(tmp)
saveObjectFile(tmp, "foo", list(bar=list(version="1.0")))
readObjectFile(tmp)

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/writeMetadata.R
\name{writeMetadata}
\alias{writeMetadata}
\alias{.writeMetadata}
\title{Saving the metadata}
\usage{
writeMetadata(meta, dir, ignore.null = TRUE)
}
\arguments{
\item{meta}{A named list containing metadata.
This should contain at least the \code{"$schema"} and \code{"path"} elements.}

\item{dir}{String containing a path to the staging directory.}

\item{ignore.null}{Logical scalar indicating whether \code{NULL} values should be ignored during coercion to JSON.}
}
\value{
A JSON file containing the metadata is created at \code{path}.
A list of resource metadata is returned, e.g., for inclusion as the \code{"resource"} property in parent schemas.
}
\description{
\emph{WARNING: this function is deprecated as newer versions of \pkg{alabaster} do not need to write metadata.}
Helper function to write metadata from a named list to a JSON file.
This is commonly used inside \code{\link{stageObject}} methods to create the metadata file for a child object.
}
\details{
Any \code{NULL} values in \code{meta} are pruned out prior to writing when \code{ignore.null=TRUE}.
This is done recursively so any \code{NULL} values in sub-lists of \code{meta} are also ignored.

Any scalars are automatically unboxed so array values should be explicitly specified as such with \code{\link{I}()}.

Any starting \code{"./"} in \code{meta$path} will be automatically removed.
This allows staging methods to save in the current directory by setting \code{path="."},
without the need to pollute the paths with a \code{"./"} prefix.

The JSON-formatted metadata is validated against the schema in \code{meta[["$schema"]]} using \pkg{jsonvalidate}.
The location of the schema is taken from the \code{package} attribute in that string, if one exists;
otherwise, it is assumed to be in the \pkg{alabaster.schemas} package.
(All schemas are assumed to live in the \code{inst/schemas} subdirectory of their indicated packages.)

We also use the schema to determine whether \code{meta} refers to an actual artifact or is a metadata-only document.
If it refers to an actual file, we compute its MD5 sum and store it in the metadata for saving.
We also save its associated metadata into a JSON file at a location obtained by appending \code{".json"} to \code{meta$path}.

For artifacts, the MD5 sum calculation will be skipped if the \code{meta} already contains a \code{md5sum} field.
This can be useful on some occasions, e.g., to improve efficiency when the MD5 sum was already computed during staging,
or if the artifact does not actually exist in its full form on the file system.
}
\examples{
library(S4Vectors)
df <- DataFrame(A=1:10, B=LETTERS[1:10])

tmp <- tempfile()
dir.create(tmp)
info <- stageObject(df, tmp, path="coldata")
writeMetadata(info, tmp)
cat(readLines(file.path(tmp, "coldata/simple.csv.gz.json")), sep="\n")

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readAtomicVector.R
\name{readAtomicVector}
\alias{readAtomicVector}
\alias{loadAtomicVector}
\title{Read an atomic vector from disk}
\usage{
readAtomicVector(path, metadata, ...)
}
\arguments{
\item{path}{Path to a directory created with any of the vector methods for \code{\link{saveObject}}.}

\item{metadata}{Named list containing metadata for the object, see \code{\link{readObjectFile}} for details.}

\item{...}{Further arguments, ignored.}
}
\value{
The vector described by \code{info}.
}
\description{
Read a vector consisting of atomic elements from its on-disk representation.
This is usually not directly called by users, but is instead called by dispatch in \code{\link{readObject}}.
}
\examples{
tmp <- tempfile()
saveObject(setNames(runif(26), letters), tmp)
readObject(tmp)

}
\seealso{
\code{"\link{saveObject,integer-method}"}, for one of the staging methods.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readDataFrame.R
\name{readDataFrame}
\alias{readDataFrame}
\alias{loadDataFrame}
\title{Read a DataFrame from disk}
\usage{
readDataFrame(path, metadata, ...)
}
\arguments{
\item{path}{String containing a path to the directory, itself created with \code{\link{saveObject}} method for \link[S4Vectors]{DFrame}s.}

\item{metadata}{Named list containing metadata for the object, see \code{\link{readObjectFile}} for details.}

\item{...}{Further arguments, passed to \code{\link{altLoadObject}} for complex nested columns.}
}
\value{
The \link[S4Vectors]{DFrame} represented by \code{path}.
}
\description{
Read a \link[S4Vectors]{DFrame} from its on-disk representation.
This is usually not directly called by users, but is instead called by dispatch in \code{\link{readObject}}.
}
\examples{
library(S4Vectors)
df <- DataFrame(A=1:10, B=LETTERS[1:10])

tmp <- tempfile()
saveObject(df, tmp)
readObject(tmp)

}
\seealso{
\code{"\link{saveObject,DataFrame-method}"}, for the staging method.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/altReadObject.R
\name{altReadObject}
\alias{altReadObject}
\alias{.altLoadObject}
\alias{.loadObject}
\alias{altLoadObject}
\alias{altLoadObjectFunction}
\alias{altReadObjectFunction}
\title{Alter the reading function}
\usage{
altReadObject(path, ...)

altReadObjectFunction(fun)
}
\arguments{
\item{path, ...}{Further arguments to pass to \code{\link{readObject}} or its equivalent.}

\item{fun}{Function that can serve as a drop-in replacement for \code{\link{readObject}}.}
}
\value{
For \code{altReadObject}, any R object similar to those returned by \code{\link{readObject}}.

For \code{altReadObjectFunction}, the alternative function (if any) is returned if \code{fun} is missing.
If \code{fun} is provided, it is used to define the alternative, and the previous alternative is returned.
}
\description{
Allow alabaster applications to specify an alternative reading function in \code{\link{altReadObject}}.
}
\details{
By default, \code{altReadObject} is just a wrapper around \code{\link{readObject}}.
However, if \code{altReadObjectFunction} is called, \code{altReadObject} calls the replacement \code{fun} instead.
This allows alabaster applications to inject wholesale or class-specific customizations into the reading process,
e.g., to add more metadata whenever an instance of a particular class is encountered.
Developers of alabaster extensions should use \code{altReadObject} (instead of \code{readObject}) to read child objects when writing their own reading functions,
to ensure that application-specific customizations are respected for the children.

To motivate the use of \code{altReadObject}, consider the following scenario.
\enumerate{
\item We have created a reading function \code{readX} function to read an instance of class X in an alabaster extension.
This function may be called by \code{\link{readObject}} if instances of X are children of other objects.
\item An alabaster application Y requires the addition of some custom metadata during the reading process for X.
It defines an alternative reading function \code{readObject2} that, upon encountering a schema for X, redirects to a application-specific reader \code{readX2}.
An example implementation for \code{readX2} would involve calling \code{readX} and decorating the result with the extra metadata.
\item When operating in the context of application Y, the \code{readObject2} generic is used to set \code{altReadObjectFunction}.
Any calls to \code{altReadObject} in Y's context will subsequently call \code{readObject2}.
\item So, when writing a reading function in an alabaster extension for a class that might contain instances of X as children, 
we use \code{\link{altReadObject}} instead of directly using \code{\link{readObject}}. 
This ensures that, if a child instance of X is encountered \emph{and} we are operating in the context of application Y, 
we correctly call \code{readObject2} and then ultimately \code{readX2}.
}

The application-specific \code{fun} is free to do anything it wants as long as it understands the representation.
It is usually most convenient to leverage the existing functionality in \code{\link{readObject}},
but if the application-specific saver in \code{\link{altSaveObject}} does something unusual,
then \code{fun} is responsible for the correct interpretation of any custom representation.
}
\examples{
old <- altReadObjectFunction()

# Setting it to something.
altReadObjectFunction(function(...) {
    print("YAY")
    readObject(...) 
})

# Staging an example DataFrame:
library(S4Vectors)
df <- DataFrame(A=1:10, B=LETTERS[1:10])
tmp <- tempfile()
saveObject(df, tmp)

# And now reading it - this should print our message.
altReadObject(tmp)

# Restoring the old reader:
altReadObjectFunction(old)

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/transformVectorForHdf5.R
\name{transformVectorForHdf5}
\alias{transformVectorForHdf5}
\title{Transform a vector to save in a HDF5 file}
\usage{
transformVectorForHdf5(x, .version = 3)
}
\arguments{
\item{x}{An atomic vector to be saved to HDF5.}

\item{.version}{Internal use only.}
}
\value{
A list containing:
\itemize{
\item \code{transformed}, the transformed vector.
This may be the same as \code{x} if no \code{NA} values were detected.
Note that logical vectors are cast to integers.
\item \code{placeholder}, the placeholder value used to represent \code{NA} values.
This is \code{NULL} if no \code{NA} values were detected in \code{x},
otherwise it is the same as the output of \code{\link{chooseMissingPlaceholderForHdf5}}.
}
}
\description{
This handles type casting and missing placeholder value selection/substitution.
It is primarily intended for developers of \pkg{alabaster.*} extensions.
}
\examples{
transformVectorForHdf5(c(TRUE, NA, FALSE))
transformVectorForHdf5(c(1L, NA, 2L))
transformVectorForHdf5(c(1L, NaN, 2L))
transformVectorForHdf5(c("FOO", NA, "BAR"))
transformVectorForHdf5(c("FOO", NA, "NA"))

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/acquireFile.R
\name{acquireFile}
\alias{acquireFile}
\alias{acquireMetadata}
\alias{acquireFile,character-method}
\alias{acquireMetadata,character-method}
\title{Acquire file or metadata}
\usage{
acquireFile(project, path)

acquireMetadata(project, path)

\S4method{acquireFile}{character}(project, path)

\S4method{acquireMetadata}{character}(project, path)
}
\arguments{
\item{project}{Any value specifying the project of interest.
The default methods expect a string containing a path to a staging directory,
but other objects can be used to control dispatch.}

\item{path}{String containing a relative path to a resource inside the staging directory.}
}
\value{
\code{acquireFile} methods return a local path to the file corresponding to the requested resource.

\code{acquireMetadata} methods return a named list of metadata for the requested resource.
}
\description{
\emph{WARNING: these functions are deprecated. 
Applications are expected to handle acquisition of files before loaders are called.}
Acquire a file or metadata for loading.
As one might expect, these are typically used inside a \code{load*} function.
}
\details{
By default, files and metadata are loaded from the same staging directory that is written to by \code{\link{stageObject}}.
alabaster applications can define custom methods to obtain the files and metadata from a different location, e.g., remote databases.
This is achieved by dispatching on a different class of \code{project}.

Each custom acquisition method should take two arguments.
The first argument is an R object representing some concept of a \dQuote{project}.
In the default case, this is a string containing a path to the staging directory representing the project.
However, it can be anything, e.g., a number containing a database identifier, a list of identifiers and versions, and so on -
as long as the custom acquisition method is capable of understanding it, the \code{load*} functions don't care.

The second argument is a string containing the relative path to the resource inside that project.
This should be the path to a specific file inside the project, not the subdirectory containing the file.
More concretely, it should be equivalent to the \code{path} in the \emph{output} of \code{\link{stageObject}},
not the path to the subdirectory used as the input to the same function.

The return value for each custom acquisition function should be the same as their local counterparts.
That is, any custom file acquisition function should return a file path,
and any custom metadata acquisition function should return a naamed list of metadata.
}
\examples{
# Staging an example DataFrame:
library(S4Vectors)
df <- DataFrame(A=1:10, B=LETTERS[1:10])
tmp <- tempfile()
dir.create(tmp)
info <- stageObject(df, tmp, path="coldata")
writeMetadata(info, tmp)

# Retrieving the metadata:
meta <- acquireMetadata(tmp, "coldata/simple.csv.gz")
str(meta)

# Retrieving the file:
acquireFile(tmp, "coldata/simple.csv.gz")

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/loadDirectory.R
\name{loadDirectory}
\alias{loadDirectory}
\title{Load all non-child objects in a directory}
\usage{
loadDirectory(dir, redirect.action = c("from", "to", "both"))
}
\arguments{
\item{dir}{String containing a path to a staging directory.}

\item{redirect.action}{String specifying how redirects should be handled:
\itemize{
\item \code{"to"} will report an object at the redirection destination, not the redirection source.
\item \code{"from"} will report an object at the redirection source(s), not the destination.
\item \code{"both"} will report an object at both the redirection source(s) and destination.
}}
}
\value{
A named list is returned containing all (non-child) R objects in \code{dir}.
}
\description{
\emph{WARNING: this function is deprecated, use \code{\link{listObjects}} and loop over entries with \code{\link{readObject}} instead.}
As the title suggests, this function loads all non-child objects in a staging directory.
All loading is performed using \code{\link{altLoadObject}} to respect any application-specific overrides.
Children are used to assemble their parent objects and are not reported here.
}
\examples{
tmp <- tempfile()
dir.create(tmp)

library(S4Vectors)
df <- DataFrame(A=1:10, B=LETTERS[1:10])
meta <- stageObject(df, tmp, path="whee")
writeMetadata(meta, tmp)

ll <- list(A=1, B=LETTERS, C=DataFrame(X=1:5))
meta <- stageObject(ll, tmp, path="stuff")
writeMetadata(meta, tmp)

redirect <- createRedirection(tmp, "whoop", "whee/simple.csv.gz")
writeMetadata(redirect, tmp)

all.meta <- loadDirectory(tmp)
str(all.meta) 

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/listObjects.R
\name{listObjects}
\alias{listObjects}
\alias{listLocalObjects}
\alias{listDirectory}
\title{List objects in a directory}
\usage{
listObjects(dir, include.children = FALSE)
}
\arguments{
\item{dir}{String containing a path to a directory containing objects saved by \code{\link{saveObject}}, possibly in separate subdirectories.}

\item{include.children}{Logical scalar indicating whether to include child objects.}
}
\value{
A \link[S4Vectors]{DFrame} where each row corresponds to an object.
It contains the following columns:
\itemize{
\item \code{path}, the relative path to the object's subdirectory inside \code{dir}.
\item \code{type}, the type of the object based on its \code{OBJECT} file (see \code{?\link{readObjectFile}}).
\item \code{child}, whether the object is a child of another object.
}

If \code{include.children=FALSE}, metadata is only returned for non-child objects.
}
\description{
List all objects in a directory, along with their types.
}
\examples{
tmp <- tempfile()
dir.create(tmp)

library(S4Vectors)
df <- DataFrame(A=1:10, B=LETTERS[1:10])
saveObject(df, file.path(tmp, "whee"))

ll <- list(A=1, B=LETTERS, C=DataFrame(X=1:5))
saveObject(ll, file.path(tmp, "stuff"))

listObjects(tmp)
listObjects(tmp, include.children=TRUE)

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/createRedirection.R
\name{createRedirection}
\alias{createRedirection}
\alias{.createRedirection}
\title{Create a redirection file}
\usage{
createRedirection(dir, src, dest)
}
\arguments{
\item{dir}{String containing the path to the staging directory.}

\item{src}{String containing the source path relative to \code{dir}.}

\item{dest}{String containing the destination path relative to \code{dir}.
This may be any path that can also be used in \code{\link{acquireMetadata}}.}
}
\value{
A list of metadata that can be processed by \code{\link{writeMetadata}}.
}
\description{
\emph{WARNING: this function is deprecated. 
Redirection is no longer supported in the latest \pkg{alabaster} framework.}
Create a redirection to another path in the same staging directory.
This is useful for creating short-hand aliases for resources that have inconveniently long paths.
}
\details{
\code{src} should not correspond to an existing file inside \code{dir}.
This avoids ambiguity when attempting to load \code{src} via \code{\link{acquireMetadata}}.
Otherwise, it would be unclear as to whether the user wants the file at \code{src} or the redirection target \code{dest}.

\code{src} may correspond to existing directories.
This is because directories cannot be used in \code{acquireMetadata}, so no such ambiguity exists.
}
\examples{
# Staging an example DataFrame:
library(S4Vectors)
df <- DataFrame(A=1:10, B=LETTERS[1:10])
tmp <- tempfile()
dir.create(tmp)
info <- stageObject(df, tmp, path="coldata")
writeMetadata(info, tmp)

# Creating a redirection:
redirect <- createRedirection(tmp, "foobar", "coldata/simple.csv.gz")
writeMetadata(redirect, tmp)

# We can then use this redirect to pull out metadata:
info2 <- acquireMetadata(tmp, "foobar")
str(info2)

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/validateObject.R
\name{validateObject}
\alias{validateObject}
\alias{registerValidateObjectFunction}
\alias{registerValidateObjectHeightFunction}
\alias{registerValidateObjectDimensionsFunction}
\alias{registerValidateObjectSatisfiesInterface}
\alias{registerValidateObjectDerivedFrom}
\title{Validate an object's on-disk representation}
\usage{
validateObject(path, metadata = NULL)

registerValidateObjectFunction(type, fun, existing = c("old", "new", "error"))

registerValidateObjectHeightFunction(
  type,
  fun,
  existing = c("old", "new", "error")
)

registerValidateObjectDimensionsFunction(
  type,
  fun,
  existing = c("old", "new", "error")
)

registerValidateObjectSatisfiesInterface(
  type,
  interface,
  action = c("add", "remove")
)

registerValidateObjectDerivedFrom(type, parent, action = c("add", "remove"))
}
\arguments{
\item{path}{String containing a path to a directory, itself created with a \code{\link{saveObject}} method.}

\item{metadata}{List containing metadata for the object.
If this is not supplied, it is automatically read from the \code{OBJECT} file inside \code{path}.}

\item{type}{String specifying the name of type of the object.}

\item{fun}{For \code{registerValidateObjectFunction}, a function that accepts \code{path} and \code{metadata}, and raises an error if the object at \code{path} is invalid.
It can be assumed that \code{metadata} is a list created by reading \code{OBJECT}.

For \code{registerValidateObjectHeightFunction}, a function that accepts \code{path} and \code{metadata}, and returns an integer specifying the \dQuote{height} of the object.
This is usually the length for vector-like or 1-dimensional objects, and the extent of the first dimension for higher-dimensional objects.

For \code{registerValidateObjectDimensionsFunction}, a function that accepts \code{path} and \code{metadata}, and returns an integer vector specifying the dimensions of the object.

This may also be \code{NULL} to delete an existing registry from any of the functions mentioned above.}

\item{existing}{Logical scalar indicating the action to take if a function has already been registered for \code{type} -
keep the old or new function, or throw an error.}

\item{interface}{String specifying the name of the interface that is represented by \code{type}.}

\item{action}{String specifying whether to add or remove \code{type} from the list of types that implements \code{interface} or is derived from \code{parent}.}

\item{parent}{String specifying the parent object from which \code{type} is derived.}
}
\value{
For \code{validateObject}, \code{NULL} is returned invisibly upon success, otherwise an error is raised.

For the \code{registerValidObject*Function} functions, the supplied \code{fun} is added to the corresponding registry for \code{type}.
If \code{fun = NULL}, any existing entry for \code{type} is removed; a logical scalar is returned indicating whether removal was performed.

For the \code{registerValidateObjectSatisfiesInterface} and \code{registerValidateObjectDerivedFrom} functions, \code{type} is added to or removed from relevant list of types.
A logical scalar is returned indicating whether the \code{type} was added or removed - this may be \code{FALSE} if \code{type} was already present or absent, respectively.
}
\description{
Validate an object's on-disk representation against the \pkg{takane} specifications.
This is done by dispatching to an appropriate validation function based on the type in the \code{OBJECT} file.
}
\examples{
library(S4Vectors)
df <- DataFrame(A=1:10, B=LETTERS[1:10])

tmp <- tempfile()
saveObject(df, tmp)
validateObject(tmp)

}
\seealso{
\url{https://github.com/ArtifactDB/takane}, for detailed specifications of the on-disk representation for various Bioconductor objects.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/moveObject.R
\name{moveObject}
\alias{moveObject}
\title{Move a non-child object in the staging directory}
\usage{
moveObject(dir, from, to, rename.redirections = TRUE)
}
\arguments{
\item{dir}{String containing the path to the staging directory.}

\item{from}{String containing the path to a non-child object inside \code{dir}, as used in \code{\link{acquireMetadata}}.
This can also be a redirection to such an object.}

\item{to}{String containing the new path inside \code{dir}.}

\item{rename.redirections}{Logical scalar specifying whether redirections pointing to \code{from} should be renamed as \code{to}.}
}
\value{
The object represented by \code{path} is moved, along with any redirections to it.
A \code{NULL} is invisibly returned.
}
\description{
\emph{WARNING: this function is deprecated, as directories of non-child objects can just be moved with regular methods (e.g., \code{\link{file.rename}}) in the latest version of \pkg{alabaster}.}
Pretty much as it says in the title.
This only works with non-child objects as children are referenced by their parents and cannot be safely moved in this manner.
}
\details{
This function will look around \code{path} for JSON files containing redirections to \code{from}, and update them to point to \code{to}.
More specifically, if \code{path} is a subdirectory, it will search in the same directory containing \code{path};
otherwise, it will search in the directory containing \code{dirname(path)}.
Redirections in other locations will not be removed automatically - these will be caught by \code{\link{checkValidDirectory}} and should be manually updated.

If \code{rename.redirections=TRUE}, this function will additionally move the redirection files so that they are named as \code{to}.
In the unusual case where \code{from} is the target of multiple redirection files, the renaming process will clobber all of them such that only one of them will be present after the move.
}
\section{Safety of moving operations}{

In general, \pkg{alabaster.*} representations are safe to move as only the parent object's \code{resource.path} metadata properties will contain links to the children's paths.
These links are updated with the new \code{to} path after running \code{moveObject} on the parent \code{from}.

However, alabaster applications may define custom data structures where the paths are present elsewhere, e.g., in the data file itself or in other metadata properties.
If so, applications are reponsible for updating those paths to reflect the naming to \code{to}.
}

\examples{
tmp <- tempfile()
dir.create(tmp)

library(S4Vectors)
df <- DataFrame(A=1:10, B=LETTERS[1:10])
meta <- stageObject(df, tmp, path="whee")
writeMetadata(meta, tmp)

ll <- list(A=1, B=LETTERS, C=DataFrame(X=1:5))
meta <- stageObject(ll, tmp, path="stuff")
writeMetadata(meta, tmp)

redirect <- createRedirection(tmp, "whoop", "whee/simple.csv.gz")
writeMetadata(redirect, tmp)

list.files(tmp, recursive=TRUE)
moveObject(tmp, "whoop", "YAY")
list.files(tmp, recursive=TRUE)

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/validateDirectory.R
\name{validateDirectory}
\alias{validateDirectory}
\alias{checkValidDirectory}
\title{Validate a directory of objects}
\usage{
validateDirectory(dir, legacy = NULL, ...)
}
\arguments{
\item{dir}{String containing the path to a directory with subdirectories populated by \code{\link{saveObject}}.}

\item{legacy}{Logical scalar indicating whether to validate a directory with legacy objects (created by the old \code{stageObject}).
If \code{NULL}, this is auto-detected from the contents of \code{dir}.}

\item{...}{Further arguments to use when \code{legacy=TRUE}, for back-compatibility only.}
}
\value{
Character vector of the paths inside \code{dir} that were validated, invisibly.
If any validation failed, an error is raised.
}
\description{
Check whether each object in a directory is valid by calling \code{\link{validateObject}} on each non-child object.
}
\details{
We assume that the process of validating an object will call \code{\link{validateObject}} on any child objects.
This allows us to skip explicit calls to \code{\link{validateObject}} on each component of a complex object.
}
\examples{
# Mocking up an object:
library(S4Vectors)
ncols <- 123
df <- DataFrame(
    X = rep(LETTERS[1:3], length.out=ncols),
    Y = runif(ncols)
)
df$Z <- DataFrame(AA = sample(ncols))

# Mocking up the directory:
tmp <- tempfile()
dir.create(tmp, recursive=TRUE)
saveObject(df, file.path(tmp, "foo"))

# Checking that it's valid:
validateDirectory(tmp)

# Adding an invalid object:
dir.create(file.path(tmp, "bar"))
write(file=file.path(tmp, "bar", "OBJECT"), '[ "WHEEE" ]')
try(validateDirectory(tmp))

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/saveDataFrame.R
\name{saveObject,DataFrame-method}
\alias{saveObject,DataFrame-method}
\alias{stageObject,DataFrame-method}
\alias{saveObject,data.frame-method}
\title{Save a DataFrame to disk}
\usage{
\S4method{saveObject}{DataFrame}(x, path, DataFrame.character.vls = NULL, ...)

\S4method{saveObject}{data.frame}(x, path, DataFrame.character.vls = NULL, ...)
}
\arguments{
\item{x}{A \link[S4Vectors]{DataFrame} or data.frame.}

\item{path}{String containing the path to a directory in which to save \code{x}.}

\item{DataFrame.character.vls}{Logical scalar indicating whether to save character vectors in the custom variable length string (VLS) array format.
If \code{NULL}, this is determined based on a comparison of the expected storage against a fixed length array.}

\item{...}{Additional named arguments to pass to specific methods.}
}
\value{
A named list containing the metadata for \code{x}.
\code{x} itself is written to a HDF5 file inside \code{path}.
Additional files may also be created inside \code{path} and referenced from the metadata.
}
\description{
Stage a DataFrame by saving it to a HDF5 file.
}
\details{
This method creates a \code{basic_columns.h5} file that contains columns for atomic vectors, factors, dates and date-times.
Dates and date-times are converted to character vectors and saved as such inside the file.
Factors are saved as a HDF5 group with both the codes and the levels as separate datasets.

Any non-atomic columns are saved to a \code{other_columns} subdirectory inside \code{path} via \code{\link{saveObject}},
named after its zero-based positional index within \code{x}.

If \code{\link[S4Vectors]{metadata}} or \code{\link[S4Vectors]{mcols}} are present, 
they are saved to the \code{other_annotations} and \code{column_annotations} subdirectories, respectively, via \code{\link{saveObject}}.

In the on-disk representation, no distinction is made between \link[S4Vectors]{DataFrame} and data.frame instances of \code{x}.
Calling \code{readDataFrame} will always produce a \link[S4Vectors]{DFrame} regardless of the class of \code{x}.
}
\examples{
library(S4Vectors)
df <- DataFrame(A=1:10, B=LETTERS[1:10])

tmp <- tempfile()
saveObject(df, tmp)
list.files(tmp, recursive=TRUE)

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cloneDirectory.R
\name{cloneDirectory}
\alias{cloneDirectory}
\title{Clone an existing directory}
\usage{
cloneDirectory(src, dest, action = c("link", "copy", "symlink", "relsymlink"))
}
\arguments{
\item{src}{String containing the path to the source directory, typically generated by a prior \code{\link{saveObject}} call.}

\item{dest}{String containing the path to the destination directory, typically the \code{path} in a subsequent \code{\link{saveObject}} call.}

\item{action}{String specifying the action to use when cloning files from \code{src} to \code{dest}.
\itemize{
\item \code{"copy"}: copy all files within \code{src} to their corresponding locations in \code{dest}.
\item \code{"link"}: create a hard link from each file in \code{src} to its corresponding location in \code{dest}.
If this fails, we silently fall back to a copy.
\item \code{"symlink"}: create a symbolic link from each file in \code{src} to its corresponding location in \code{dest}.
Each symbolic link contains the absolute path in the corresponding file in its original directory,
which is useful when the contents of \code{dest} might be moved (but the original directory will not).
\item \code{"relsymlink"}: create a symbolic link from each file in \code{src} to its corresponding location in \code{dest}.
Each symbolic link contains the minimal relative path to the corresponding file in the original directory,
which is useful when both \code{src} and \code{dest} are moved together, e.g., as they are part of the same parent object like a SummarizedExperiment.
}}
}
\value{
A new directory is created at \code{dest} with the contents of \code{src}, either copied or linked.
\code{NULL} is invisibly returned.
}
\description{
Clone an existing directory to a new location.
This is typically performed inside \code{\link{saveObject}} after detecting duplicated objects,
see \code{?\link{createDedupSession}} for an example use case.
}
\examples{
tmp <- tempfile()
dir.create(tmp)

src <- file.path(tmp, "A")
dir.create(src)
write(file=file.path(src, "foobar"), LETTERS)

dest <- file.path(tmp, "B")
cloneDirectory(src, dest)
list.files(dest, recursive=TRUE)

}
\seealso{
\code{\link{cloneFile}}, to clone individual files.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/saveDataFrameFactor.R
\name{saveObject,DataFrameFactor-method}
\alias{saveObject,DataFrameFactor-method}
\alias{stageObject,DataFrameFactor-method}
\title{Stage a DataFrameFactor object}
\usage{
\S4method{saveObject}{DataFrameFactor}(x, path, ...)
}
\arguments{
\item{x}{A \link[S4Vectors]{DataFrameFactor} object.}

\item{path}{String containing the path to a directory in which to save \code{x}.}

\item{...}{Further arguments, to pass to internal \code{\link{altSaveObject}} calls.}
}
\value{
\code{x} is saved to an on-disk representation inside \code{path}.
}
\description{
Stage a \link[S4Vectors]{DataFrameFactor} object, a generalization of the base factor where each level is a row of a \link[S4Vectors]{DataFrame}.
}
\examples{
library(S4Vectors)
df <- DataFrame(X=LETTERS[1:5], Y=1:5)
out <- DataFrameFactor(df[sample(5, 100, replace=TRUE),,drop=FALSE])

tmp <- tempfile()
saveObject(out, tmp)
list.files(tmp, recursive=TRUE)

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Rfc3339.R
\name{Rfc3339}
\alias{Rfc3339}
\alias{as.Rfc3339}
\alias{as.Rfc3339.character}
\alias{as.Rfc3339.default}
\alias{as.Rfc3339.POSIXt}
\alias{as.character.Rfc3339}
\alias{is.Rfc3339}
\alias{as.POSIXct.Rfc3339}
\alias{as.POSIXlt.Rfc3339}
\alias{[.Rfc3339}
\alias{[[.Rfc3339}
\alias{[<-.Rfc3339}
\alias{[[<-.Rfc3339}
\alias{c.Rfc3339}
\alias{saveObject,Rfc3339-method}
\title{Representing Internet date/times}
\usage{
as.Rfc3339(x)

\method{as.Rfc3339}{character}(x)

\method{as.Rfc3339}{default}(x)

\method{as.Rfc3339}{POSIXt}(x)

\method{as.character}{Rfc3339}(x, ...)

is.Rfc3339(x)

\method{as.POSIXct}{Rfc3339}(x, tz = "", ...)

\method{as.POSIXlt}{Rfc3339}(x, tz = "", ...)

\method{[}{Rfc3339}(x, i)

\method{[[}{Rfc3339}(x, i)

\method{[}{Rfc3339}(x, i) <- value

\method{[[}{Rfc3339}(x, i) <- value

\method{c}{Rfc3339}(..., recursive = TRUE)

\S4method{saveObject}{Rfc3339}(x, path, ...)
}
\arguments{
\item{x}{For \code{as.Rfc3339} methods, object to be coerced to an Rfc3339 instance.

For the subset and combining methods, an Rfc3339 instance.

For \code{as.character}, \code{as.POSIXlt} and \code{as.POSIXct} methods, an Rfc3339 instance.

For \code{is.Rfc3339}, any object to be tested for Rfc3339-ness.}

\item{tz, recursive, ...}{Further arguments to be passed to individual methods.}

\item{i}{Indices specifying elements to extract or replace.}

\item{value}{Replacement values, either as another Rfc3339 instance, a character vector or something that can be coerced into one.}

\item{path}{String containing the path to a directory in which to save \code{x}.}
}
\value{
For \code{as.Rfc3339}, the subset and combining methods, an Rfc3339 instance is returned.

For the other \code{as.*} methods, an instance of the corresponding type generated from an Rfc3339 instance.
}
\description{
The Rfc3339 class is a character vector that stores Internet Date/time timestamps, formatted as described in RFC3339.
It provides a faithful representation of any RFC3339-compliant string in an R session.
}
\details{
This class is motivated by the difficulty in using the various \link{POSIXt} classes to faithfully represent any RFC3339-compliant string.
In particular:
\itemize{
\item The POSIXt classes do not automatically capture the string's timezone offset, instead converting all times to the local timezone.
This is problematic as it discards information about the original timezone.
Technically, the \link{POSIXlt} class is capable of holding this information in the \code{gmtoff} field but it is not clear how to set this.
\item There is no way to distinguish between the timezones \code{Z} and \code{+00:00}.
These are functionally the same but will introduce differences in the checksums of saved files
and thus interfere with deduplication mechanisms in storage backends.
\item Coercion of POSIXt classes to strings may print more or fewer digits in the fractional seconds than what was present in the original string.
Functionally, this is probably unimportant but will still introduce differences in the checksums.
}

By comparison, the Rfc3339 class preserves all information in the original string,
avoiding unexpected modifications from a roundtrip through \code{\link{readObject}} and \code{\link{saveObject}}.
This is especially relevant for strings that were created from other languages, 
e.g., Node.js Date's ISO string conversion uses \code{Z} by default.

That said, users should not expect too much from this class.
It is only used to provide a faithful representation of RFC3339 strings, and does not support any time-related arithmetic.
Users are advised to convert to \link{POSIXct} or similar if such operations are required.
}
\examples{
out <- as.Rfc3339(Sys.time() + 1:10)
out

out[2:5]
out[2] <- "2"
c(out, out)

as.character(out)
as.POSIXct(out)
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readObject.R
\name{readObject}
\alias{readObject}
\alias{loadObject}
\alias{schemaLocations}
\alias{customloadObjectHelper}
\alias{.loadObjectInternal}
\alias{readObjectFunctionRegistry}
\alias{registerReadObjectFunction}
\title{Read an object from disk}
\usage{
readObject(path, metadata = NULL, ...)

readObjectFunctionRegistry()

registerReadObjectFunction(type, fun, existing = c("old", "new", "error"))
}
\arguments{
\item{path}{String containing a path to a directory, itself created with a \code{\link{saveObject}} method.}

\item{metadata}{Named list containing metadata for the object - most importantly, the \code{type} field that controls dispatch to the correct loading function.
If \code{NULL}, this is automatically read by \code{\link{readObjectFile}(path)}.}

\item{...}{Further arguments to pass to individual methods.}

\item{type}{String specifying the name of type of the object.}

\item{fun}{A loading function that accepts \code{path}, \code{metadata} and \code{...} (in that order), and returns the associated object.
This may also be \code{NULL} to delete an existing entry in the registry.}

\item{existing}{Logical scalar indicating the action to take if a function has already been registered for \code{type} -
keep the old or new function, or throw an error.}
}
\value{
For \code{readObject}, an object created from the on-disk representation in \code{path}.

For \code{readObjectFunctionRegistry}, a named list of functions used to load each object type.

For \code{registerReadObjectFunction}, the function is added to the registry.
}
\description{
Read an object from its on-disk representation.
This is done by dispatching to an appropriate loading function based on the type in the \code{OBJECT} file.
}
\section{Comments for extension developers}{

\code{readObject} uses an internal registry of functions to decide how an object should be loaded into memory.
Developers of alabaster extensions can add extra functions to this registry, usually in the \code{\link{.onLoad}} function of their packages.
Alternatively, extension developers can request the addition of their packages to default registry.

If a loading function makes use of additional arguments in \code{...}, 
those arguments should be prefixed by the name of the object type for each method, e.g., \code{simple_list.parallel}.
This avoids problems with conflicts in the interpretation of identically named arguments between different functions.
Unlike the \code{...} arguments in \code{\link{saveObject}}, we prefix by the object type instead of the output class, as the former is used for dispatch here.

When writing loading functions for complex classes, extension developers may need to load child objects to compose the output object.
In such cases, developers should use \code{\link{altReadObject}} on the child subdirectories, rather than calling \code{readObject} directly.
This ensures that any application-level overrides of the loading functions are respected. 
It is also expected that arguments in \code{...} are forwarded to internal \code{\link{altReadObject}} calls.

Developers can manually control \code{readObject} dispatch by suppling a \code{metadata} list where \code{metadata$type} is set to the desired object type.
This pattern is commonly used inside the loading function for a subclass -
an instance of the base class is first constructed by an internal \code{readObject} call with the modified \code{metadata$type}, after which the subclass-specific slots are added.
(In practice, base construction should be done using \code{\link{altReadObject}} so as to respect application-specific overrides.)
}

\section{Comments for application developers}{

Application developers can override \code{readObject} by specifying a custom function in \code{\link{altReadObject}}.
This can be used to point to a different registry of reading functions, to perform pre- or post-reading actions, etc.
If customization is type-specific, the custom \code{altReadObject} function can read the type from the \code{OBJECT} file to determine the most appropriate course of action;
the \code{OBJECT} metadata can then be passed to the \code{metadata} argument of any internal \code{readObject} calls to avoid a redundant read from the same file.
}

\examples{
library(S4Vectors)
df <- DataFrame(A=1:10, B=LETTERS[1:10])

tmp <- tempfile()
saveObject(df, tmp)
readObject(tmp)

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R
\name{saveObject}
\alias{saveObject}
\alias{stageObject}
\alias{stageObject,ANY-method}
\alias{searchForMethods}
\alias{.searchForMethods}
\title{Save objects to disk}
\usage{
saveObject(x, path, ...)
}
\arguments{
\item{x}{A Bioconductor object of the specified class.}

\item{path}{String containing the path to a directory in which to save \code{x}.}

\item{...}{Additional named arguments to pass to specific methods.}
}
\value{
\code{dir} is created and populated with files containing the contents of \code{x}.
\code{NULL} should be invisibly returned.
}
\description{
Generic to save assorted R objects into appropriate on-disk representations.
More methods may be defined by other packages to extend the \pkg{alabaster.base} framework to new classes.
}
\section{Comments for extension developers}{

Methods for the \code{saveObject} generic should create a directory at \code{path} in which the contents of \code{x} are to be saved.
The files may consist of any format, though language-agnostic formats like HDF5, CSV, JSON are preferred.
For more complex objects, multiple files and subdirectories may be created within \code{path}. 
The only strict requirements are:
\itemize{
\item There must be an \code{OBJECT} file inside \code{path}, 
containing a JSON object with a \code{"type"} string property that specifies the class of the object, e.g., \code{"data_frame"}, \code{"summarized_experiment"}.
This will be used by loading functions to determine how to load the files into memory.
\item The names of files and subdirectories should not start with \code{_} or \code{.}.
These are reserved for applications, e.g., to build manifests or to store additional metadata.
}

Callers can pass optional parameters to specific \code{saveObject} methods via \code{...}.
Any options recognized by a method should be prefixed by the name of the class used in the method's signature,
e.g., any options for \code{\link{saveObject,DataFrame-method}} should start with \code{DataFrame.}.
This scoping avoids conflicts between otherwise identically-named options of different methods.

When developing \code{saveObject} methods of complex objects, a simple approach is to decompose \code{x} into its \dQuote{child} components.
Each component can then be saved into a subdirectory of \code{path}, levering the existing \code{saveObject} methods for the component classes.
In such cases, extension developers should actually call \code{\link{altSaveObject}} on each child component, rather than calling \link{saveObject} directly.
This ensures that any application-level overrides of the loading functions are respected. 
It is expected that each method will forward \code{...} (possibly after modification) to any internal \code{\link{altSaveObject}} calls.
}

\section{Comments for application developers}{

Application developers can override \code{saveObject} by specifying a custom function in \code{\link{altSaveObject}}.
This can be used to point to a different function to handle the saving process for each class.
The custom function can be as simple as a wrapper around \code{saveObject} with some additional actions (e.g., to save more metadata),
or may be as complex as a full-fledged generic with its own methods for class-specific customizations.
}

\examples{
library(S4Vectors)
X <- DataFrame(X=LETTERS, Y=sample(3, 26, replace=TRUE))

tmp <- tempfile()
saveObject(X, tmp)
list.files(tmp, recursive=TRUE)

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/quickLoadObject.R
\name{quickLoadObject}
\alias{quickLoadObject}
\alias{readLocalObject}
\alias{saveLocalObject}
\alias{quickStageObject}
\title{Convenience helpers for handling local directories}
\usage{
quickLoadObject(dir, path, ...)

quickStageObject(x, dir, path, ...)
}
\arguments{
\item{dir}{String containing a path to the directory.}

\item{path}{String containing a relative path to the object of interest inside \code{dir}.}

\item{...}{Further arguments to pass to \code{\link{loadObject}} (for \code{quickLoadObject}) or \code{\link{stageObject}} (for \code{quickStageObject}).}

\item{x}{Object to be saved.}
}
\value{
For \code{quickLoadObject}, the object at \code{path}.

For \code{quickStageObject}, the object is saved to \code{path} inside \code{dir}.
All necessary directories are created if they are not already present.
A \code{NULL} is returned invisibly.
}
\description{
\emph{WARNING: these functions are deprecated as the saving/reading functions are already simple enough in the newer versions of the \pkg{alabaster} framework.}
Read and write objects from a local staging directory.
These are just convenience wrappers around functions like \code{\link{loadObject}}, \code{\link{stageObject}} and \code{\link{writeMetadata}}.
}
\examples{
local <- tempfile()

# Creating a slightly complicated object:
library(S4Vectors)
df <- DataFrame(A=1:10, B=LETTERS[1:10])
df$C <- DataFrame(D=letters[1:10], E=runif(10))

# Saving it:
quickStageObject(df, local, "FOOBAR")

# Reading it back:
quickLoadObject(local, "FOOBAR")

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/removeObject.R
\name{removeObject}
\alias{removeObject}
\title{Remove a non-child object from the staging directory}
\usage{
removeObject(dir, path)
}
\arguments{
\item{dir}{String containing the path to the staging directory.}

\item{path}{String containing the path to a non-child object inside \code{dir}, as used in \code{\link{acquireMetadata}}.
This can also be a redirection to such an object.}
}
\value{
The object represented by \code{path} is removed, along with any redirections to it.
A \code{NULL} is invisibly returned.
}
\description{
\emph{WARNING: this function is deprecated, as directories of non-child objects can just be deleted with regular methods (e.g., \code{\link{file.rename}}) in the latest version of \pkg{alabaster}.}
Pretty much as it says in the title.
This only works with non-child objects as children are referenced by their parents and cannot be safely removed in this manner.
}
\details{
This function will search around \code{path} for JSON files containing redirections to \code{path}, and remove them.
More specifically, if \code{path} is a subdirectory, it will search in the same directory containing \code{path};
otherwise, it will search in the directory containing \code{dirname(path)}.
Redirections in other locations will not be removed automatically - these will be caught by \code{\link{checkValidDirectory}} and should be manually removed.
}
\examples{
tmp <- tempfile()
dir.create(tmp)

library(S4Vectors)
df <- DataFrame(A=1:10, B=LETTERS[1:10])
meta <- stageObject(df, tmp, path="whee")
writeMetadata(meta, tmp)

ll <- list(A=1, B=LETTERS, C=DataFrame(X=1:5))
meta <- stageObject(ll, tmp, path="stuff")
writeMetadata(meta, tmp)

redirect <- createRedirection(tmp, "whoop", "whee/simple.csv.gz")
writeMetadata(redirect, tmp)

list.files(tmp, recursive=TRUE)
removeObject(tmp, "whoop")
list.files(tmp, recursive=TRUE)

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/saveMetadata.R
\name{saveMetadata}
\alias{saveMetadata}
\alias{.processMetadata}
\alias{.processMcols}
\alias{processMetadata}
\alias{processMcols}
\title{Save R-level metadata to disk}
\usage{
saveMetadata(x, metadata.path, mcols.path, ...)
}
\arguments{
\item{x}{A \link[S4Vectors]{Vector} or \link[S4Vectors]{Annotated} object.}

\item{metadata.path}{String containing the path in which to save the \code{metadata}.
If \code{NULL}, no \code{\link[S4Vectors]{metadata}} is saved.}

\item{mcols.path}{String containing the path in which to save the \code{mcols}.
If \code{NULL}, no \code{\link[S4Vectors]{mcols}} is saved.}

\item{...}{Further arguments to be passed to \code{\link{altSaveObject}}.}
}
\value{
The metadata for \code{x} is saved to \code{metadata.path}, and similarly for the \code{mcols}.
}
\description{
Save \code{\link[S4Vectors]{metadata}} and \code{\link[S4Vectors]{mcols}} for \link[S4Vectors]{Annotated} or \link[S4Vectors]{Vector} objects, respectively, to disk.
These are typically used inside \code{\link{saveObject}} methods for concrete subclasses.
}
\details{
If \code{mcols(x)} has no columns, nothing is saved by \code{saveMcols}.
Similarly, if \code{metadata(x)} is an empty list, nothing is saved by \code{saveMetadata}.
This avoids creating unnecessary files with no meaningful content.

If \code{mcols(x)} has non-\code{NULL} row names, these are removed prior to staging.
These names are usually redundant with the names associated with elements of \code{x} itself.
}
\seealso{
\code{\link{readMetadata}}, which restores metadata to the object.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cloneFile.R
\name{cloneFile}
\alias{cloneFile}
\title{Clone an existing file}
\usage{
cloneFile(src, dest, action = c("link", "copy", "symlink", "relsymlink"))
}
\arguments{
\item{src}{String containing the path to the source file.}

\item{dest}{String containing the destination file path, typically within the \code{path} supplied to \code{\link{saveObject}}.}

\item{action}{String specifying the action to use when cloning \code{src} to \code{dest}.
\itemize{
\item \code{"copy"}: copy \code{src} to \code{dest}.
\item \code{"link"}: create a hard link from \code{src} to \code{dest}.
If this fails, we silently fall back to a copy.
\item \code{"symlink"}: create a symbolic link from \code{src} to \code{dest}.
The symbolic link contains the absolute path to \code{src}, which is useful when \code{dest} might be moved but \code{src} will not.
\item \code{"relsymlink"}: create a symbolic link from \code{src} to \code{dest}.
Each symbolic link contains the minimal relative path to \code{src},
which is useful when both \code{src} and \code{dest} are moved together, e.g., as they are part of the same parent object like a SummarizedExperiment.
}}
}
\value{
A new file/link is created at \code{dest}.
\code{NULL} is invisibly returned.
}
\description{
Clone an existing file to a new location.
This is typically performed inside \code{\link{saveObject}} methods for objects that contain a reference to a file.
}
\examples{
tmp <- tempfile()
write(file=tmp, LETTERS)

dest <- tempfile()
cloneFile(tmp, dest)
readLines(dest)

}
\seealso{
\code{\link{cloneDirectory}}, to clone entire directories.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readBaseFactor.R
\name{readBaseFactor}
\alias{readBaseFactor}
\alias{loadBaseFactor}
\title{Read a factor from disk}
\usage{
readBaseFactor(path, metadata, ...)
}
\arguments{
\item{path}{String containing a path to a directory, itself created with the \code{\link{saveObject}} method for factors.}

\item{metadata}{Named list containing metadata for the object, see \code{\link{readObjectFile}} for details.}

\item{...}{Further arguments, ignored.}
}
\value{
The vector described by \code{info}.
}
\description{
Read a base R \link{factor} from its on-disk representation.
This is usually not directly called by users, but is instead called by dispatch in \code{\link{readObject}}.
}
\examples{
tmp <- tempfile()
saveObject(factor(letters[1:10], letters), tmp)
readObject(tmp)

}
\seealso{
\code{"\link{saveObject,factor-method}"}, for the staging method.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readMetadata.R
\name{readMetadata}
\alias{readMetadata}
\alias{restoreMetadata}
\alias{.restoreMetadata}
\title{Read R-level metadata}
\usage{
readMetadata(x, metadata.path, mcols.path, ...)
}
\arguments{
\item{x}{An \link[S4Vectors]{Vector} or \link[S4Vectors]{Annotated} object.}

\item{metadata.path}{String containing a path to a directory, itself containing an on-disk representation of a base R list to be used as the \code{\link[S4Vectors]{metadata}}.
Alternatively \code{NULL} to skip loading.}

\item{mcols.path}{String containing a path to a directory, itself containing an on-disk representation of a \link[S4Vectors]{DataFrame} to be used as the \code{\link[S4Vectors]{mcols}}.
Alternatively \code{NULL} to skip loading.}

\item{...}{Further arguments to be passed to \code{\link{altReadObject}}.}
}
\value{
\code{x} is returned, possibly with \code{mcols} and \code{metadata} added to it.
}
\description{
Read \code{\link[S4Vectors]{metadata}} and \code{\link[S4Vectors]{mcols}} for a \link[S4Vectors]{Annotated} or \link[S4Vectors]{Vector} object, respectively.
This is typically used inside loading functions for concrete subclasses.
}
\seealso{
\code{\link{saveMetadata}}, which does the staging.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/createDedupSession.R
\name{createDedupSession}
\alias{createDedupSession}
\alias{checkObjectInDedupSession}
\alias{addObjectToDedupSession}
\title{Deduplicate objects when saving}
\usage{
createDedupSession()

checkObjectInDedupSession(x, session)

addObjectToDedupSession(x, session, path)
}
\arguments{
\item{x}{Some object, typically S4.}

\item{session}{Session object created by \code{\link{createDedupSession}}.}

\item{path}{String containing the absolute path to the directory in which \code{x} is to be saved.
This will be used for deduplication if another object is identified as a duplicate of \code{x}.
If a relative path is provided, it will be converted to an absolute path.}
}
\value{
\code{createDedupSession} will return a deduplication session that can be modified in-place.

If \code{x} is a duplicate of an object in \code{session}, \code{checkObjectInDedupSession} will return a string containing the absolute path to a directory representing that object.
Otherwise, it will return \code{NULL}.

\code{addObjectToDedupSession} will add \code{x} to \code{session} with the supplied \code{path}.
It returns \code{NULL} invisibly.
}
\description{
Utilities for deduplicating objects inside \code{\link{saveObject}} to save time and/or storage space.
}
\details{
These utilities allow extension developers to support deduplication of objects in a top-level call to \code{\link{saveObject}}.
For a given \code{saveObject} method, we can:
\enumerate{
\item Accept a session object in an optional \code{<PREFIX>.dedup.session=} argument.
We may also accept a \code{<PREFIX>.dedup.action=} argument to specify how any deduplication should be performed.
Some \code{<PREFIX>} prefix should be chosen to avoid conflicts between multiple deduplication sessions.
\item If a session argument is provided, we call \code{checkObjectInDedupSession(x, session)} to see if the \code{x} is a duplicate of an existing object in the session.
If a path is returned, we call \code{\link{cloneDirectory}} and return.
\item Otherwise, we save this object to disk, possibly passing the session argument as \code{<PREFIX>.dedup.session=} in further calls to \code{saveObject} for child objects.
We call \code{addObjectToDedupSession} to add the current object to the session.
}
A user can enable deduplication by passing the output of \code{createDedupSession} to \code{<PREFIX>.dedup.session=} in the top-level call to \code{saveObject}.
This is most typically performed when saving SummarizedExperiment objects with multiple assays, where one assay consists of delayed operations on another assay.
}
\examples{
test <- function(x, path, test.dedup.session=NULL, test.dedup.action="link") {
   if (!is.null(test.dedup.session)) {
       original <- checkObjectInDedupSession(x, test.dedup.session)
       if (!is.null(original)) {
           cloneDirectory(original, path, test.dedup.action)
           return(invisible(NULL))
       }
   }
   dir.create(path)
   saveRDS(x, file.path(path, "whee.rds")) # replace this with actual saving code.
   if (!is.null(test.dedup.session)) {
       addObjectToDedupSession(x, test.dedup.session, path)
   }
}

library(S4Vectors)
y <- DataFrame(A=1:10, B=1:10)
tmp <- tempfile()
dir.create(tmp)

# Saving the first instance of the object, which is now stored in the session.
session <- createDedupSession()
checkObjectInDedupSession(y, session) # no duplicates yet.
test(y, file.path(tmp, "first"), test.dedup.session=session)

# Saving it again will trigger the deduplication.
checkObjectInDedupSession(y, session)
test(y, file.path(tmp, "duplicate"), test.dedup.session=session)

list.files(tmp, recursive=TRUE)

}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readDataFrameFactor.R
\name{readDataFrameFactor}
\alias{readDataFrameFactor}
\alias{loadDataFrameFactor}
\title{Read a DataFrame factor from disk}
\usage{
readDataFrameFactor(path, metadata, ...)
}
\arguments{
\item{path}{String containing a path to a directory, itself created with the \code{\link{saveObject}} method for \link[S4Vectors]{DataFrameFactor}s.}

\item{metadata}{Named list containing metadata for the object, see \code{\link{readObjectFile}} for details.}

\item{...}{Further arguments to pass to internal \code{\link{altSaveObject}} calls.}
}
\value{
A \link[S4Vectors]{DataFrameFactor} represented by \code{path}.
}
\description{
Read a \link[S4Vectors]{DataFrameFactor} from its on-disk representation.
This is usually not directly called by users, but is instead called by dispatch in \code{\link{readObject}}.
}
\examples{
library(S4Vectors)
df <- DataFrame(X=LETTERS[1:5], Y=1:5)
out <- DataFrameFactor(df[sample(5, 100, replace=TRUE),,drop=FALSE])

tmp <- tempfile()
saveObject(out, tmp)
readObject(tmp)

}
\seealso{
\code{"\link{saveObject,DataFrameFactor-method}"}, for the staging method.
}
\author{
Aaron Lun
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chooseMissingPlaceholderForHdf5.R
\name{chooseMissingPlaceholderForHdf5}
\alias{chooseMissingPlaceholderForHdf5}
\alias{missingPlaceholderName}
\alias{addMissingPlaceholderAttributeForHdf5}
\alias{.addMissingStringPlaceholderAttribute}
\alias{.chooseMissingStringPlaceholder}
\title{Choose a missing value placeholder}
\usage{
chooseMissingPlaceholderForHdf5(x, .version = 3)
}
\arguments{
\item{x}{An atomic vector to be saved to HDF5.}

\item{.version}{Internal use only.}
}
\value{
A placeholder value for missing values in \code{x},
guaranteed to not be equal to any non-missing value in \code{x}.
}
\description{
In the \pkg{alabaster.*} framework, we mark missing entries inside HDF5 datasets with placeholder values.
This function chooses a value for the placeholder that does not overlap with anything else in a vector.
}
\details{
For floating-point datasets, the placeholder will not be NA if there are mixtures of NAs and NaNs.
We do not rely on the NaN payload to distinguish between these two values.

Placeholder values are typically saved as scalar attributes on the HDF5 dataset that they are used in.
The usual name of this attribute is \code{"missing-value-placeholder"}, as encoding by \code{missingPlaceholderName}.
}
\examples{
chooseMissingPlaceholderForHdf5(c(TRUE, NA, FALSE))
chooseMissingPlaceholderForHdf5(c(1L, NA, 2L))
chooseMissingPlaceholderForHdf5(c("aaron", NA, "barry"))
chooseMissingPlaceholderForHdf5(c("aaron", NA, "barry", "NA"))
chooseMissingPlaceholderForHdf5(c(1.5, NA, 2.6))
chooseMissingPlaceholderForHdf5(c(1.5, NaN, NA, 2.6))

}
